
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRES SQL YACC rules/actions
 *
 * Portions Copyright (c) 1996-2009, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.665.2.1 2009/07/06 02:58:48 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "security/sepgsql.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

extern List *parsetree;			/* final parse result is delivered here */

static bool QueryIsRule = FALSE;

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/*
 * If you need access to certain yacc-generated variables and find that
 * they're static by default, uncomment the next line.  (this is not a
 * problem, yet.)
 */
/*#define __YYSCLASS*/

static Node *makeColumnRef(char *colname, List *indirection, int location);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs, int location);
static void check_qualified_name(List *names);
static List *check_func_name(List *names);
static List *check_indirection(List *indirection);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);



/* Line 189 of yacc.c  */
#line 225 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ABORT_P = 258,
     ABSOLUTE_P = 259,
     ACCESS = 260,
     ACTION = 261,
     ADD_P = 262,
     ADMIN = 263,
     AFTER = 264,
     AGGREGATE = 265,
     ALL = 266,
     ALSO = 267,
     ALTER = 268,
     ALWAYS = 269,
     ANALYSE = 270,
     ANALYZE = 271,
     AND = 272,
     ANY = 273,
     ARRAY = 274,
     AS = 275,
     ASC = 276,
     ASSERTION = 277,
     ASSIGNMENT = 278,
     ASYMMETRIC = 279,
     AT = 280,
     AUTHORIZATION = 281,
     BACKWARD = 282,
     BEFORE = 283,
     BEGIN_P = 284,
     BETWEEN = 285,
     BIGINT = 286,
     BINARY = 287,
     BIT = 288,
     BOOLEAN_P = 289,
     BOTH = 290,
     BY = 291,
     CACHE = 292,
     CALLED = 293,
     CASCADE = 294,
     CASCADED = 295,
     CASE = 296,
     CAST = 297,
     CATALOG_P = 298,
     CHAIN = 299,
     CHAR_P = 300,
     CHARACTER = 301,
     CHARACTERISTICS = 302,
     CHECK = 303,
     CHECKPOINT = 304,
     CLASS = 305,
     CLOSE = 306,
     CLUSTER = 307,
     COALESCE = 308,
     COLLATE = 309,
     COLUMN = 310,
     COMMENT = 311,
     COMMIT = 312,
     COMMITTED = 313,
     CONCURRENTLY = 314,
     CONFIGURATION = 315,
     CONNECTION = 316,
     CONSTRAINT = 317,
     CONSTRAINTS = 318,
     CONTENT_P = 319,
     CONTEXT_P = 320,
     CONTINUE_P = 321,
     CONVERSION_P = 322,
     COPY = 323,
     COST = 324,
     CREATE = 325,
     CREATEDB = 326,
     CREATEROLE = 327,
     CREATEUSER = 328,
     CROSS = 329,
     CSV = 330,
     CURRENT_P = 331,
     CURRENT_CATALOG = 332,
     CURRENT_DATE = 333,
     CURRENT_ROLE = 334,
     CURRENT_SCHEMA = 335,
     CURRENT_TIME = 336,
     CURRENT_TIMESTAMP = 337,
     CURRENT_USER = 338,
     CURSOR = 339,
     CYCLE = 340,
     DATA_P = 341,
     DATABASE = 342,
     DAY_P = 343,
     DEALLOCATE = 344,
     DEC = 345,
     DECIMAL_P = 346,
     DECLARE = 347,
     DEFAULT = 348,
     DEFAULTS = 349,
     DEFERRABLE = 350,
     DEFERRED = 351,
     DEFINER = 352,
     DELETE_P = 353,
     DELIMITER = 354,
     DELIMITERS = 355,
     DESC = 356,
     DICTIONARY = 357,
     DISABLE_P = 358,
     DISCARD = 359,
     DISTINCT = 360,
     DO = 361,
     DOCUMENT_P = 362,
     DOMAIN_P = 363,
     DOUBLE_P = 364,
     DROP = 365,
     EACH = 366,
     ELSE = 367,
     ENABLE_P = 368,
     ENCODING = 369,
     ENCRYPTED = 370,
     END_P = 371,
     ENUM_P = 372,
     ESCAPE = 373,
     EXCEPT = 374,
     EXCLUDING = 375,
     EXCLUSIVE = 376,
     EXECUTE = 377,
     EXISTS = 378,
     EXPLAIN = 379,
     EXTERNAL = 380,
     EXTRACT = 381,
     FALSE_P = 382,
     FAMILY = 383,
     FETCH = 384,
     FIRST_P = 385,
     FLOAT_P = 386,
     FOLLOWING = 387,
     FOR = 388,
     FORCE = 389,
     FOREIGN = 390,
     FORWARD = 391,
     FREEZE = 392,
     FROM = 393,
     FULL = 394,
     FUNCTION = 395,
     GLOBAL = 396,
     GRANT = 397,
     GRANTED = 398,
     GREATEST = 399,
     GROUP_P = 400,
     HANDLER = 401,
     HAVING = 402,
     HEADER_P = 403,
     HOLD = 404,
     HOUR_P = 405,
     IDENTITY_P = 406,
     IF_P = 407,
     ILIKE = 408,
     IMMEDIATE = 409,
     IMMUTABLE = 410,
     IMPLICIT_P = 411,
     IN_P = 412,
     INCLUDING = 413,
     INCREMENT = 414,
     INDEX = 415,
     INDEXES = 416,
     INHERIT = 417,
     INHERITS = 418,
     INITIALLY = 419,
     INNER_P = 420,
     INOUT = 421,
     INPUT_P = 422,
     INSENSITIVE = 423,
     INSERT = 424,
     INSTEAD = 425,
     INT_P = 426,
     INTEGER = 427,
     INTERSECT = 428,
     INTERVAL = 429,
     INTO = 430,
     INVOKER = 431,
     IS = 432,
     ISNULL = 433,
     ISOLATION = 434,
     JOIN = 435,
     KEY = 436,
     LANCOMPILER = 437,
     LANGUAGE = 438,
     LARGE_P = 439,
     LAST_P = 440,
     LC_COLLATE_P = 441,
     LC_CTYPE_P = 442,
     LEADING = 443,
     LEAST = 444,
     LEFT = 445,
     LEVEL = 446,
     LIKE = 447,
     LIMIT = 448,
     LISTEN = 449,
     LOAD = 450,
     LOCAL = 451,
     LOCALTIME = 452,
     LOCALTIMESTAMP = 453,
     LOCATION = 454,
     LOCK_P = 455,
     LOGIN_P = 456,
     MAPPING = 457,
     MATCH = 458,
     MAXVALUE = 459,
     MINUTE_P = 460,
     MINVALUE = 461,
     MODE = 462,
     MONTH_P = 463,
     MOVE = 464,
     NAME_P = 465,
     NAMES = 466,
     NATIONAL = 467,
     NATURAL = 468,
     NCHAR = 469,
     NEW = 470,
     NEXT = 471,
     NO = 472,
     NOCREATEDB = 473,
     NOCREATEROLE = 474,
     NOCREATEUSER = 475,
     NOINHERIT = 476,
     NOLOGIN_P = 477,
     NONE = 478,
     NOSUPERUSER = 479,
     NOT = 480,
     NOTHING = 481,
     NOTIFY = 482,
     NOTNULL = 483,
     NOWAIT = 484,
     NULL_P = 485,
     NULLIF = 486,
     NULLS_P = 487,
     NUMERIC = 488,
     OBJECT_P = 489,
     OF = 490,
     OFF = 491,
     OFFSET = 492,
     OIDS = 493,
     OLD = 494,
     ON = 495,
     ONLY = 496,
     OPERATOR = 497,
     OPTION = 498,
     OPTIONS = 499,
     OR = 500,
     ORDER = 501,
     OUT_P = 502,
     OUTER_P = 503,
     OVER = 504,
     OVERLAPS = 505,
     OVERLAY = 506,
     OWNED = 507,
     OWNER = 508,
     PARSER = 509,
     PARTIAL = 510,
     PARTITION = 511,
     PASSWORD = 512,
     PLACING = 513,
     PLANS = 514,
     POSITION = 515,
     PRECEDING = 516,
     PRECISION = 517,
     PRESERVE = 518,
     PREPARE = 519,
     PREPARED = 520,
     PRIMARY = 521,
     PRIOR = 522,
     PRIVILEGES = 523,
     PROCEDURAL = 524,
     PROCEDURE = 525,
     QUOTE = 526,
     RANGE = 527,
     READ = 528,
     REAL = 529,
     REASSIGN = 530,
     RECHECK = 531,
     RECURSIVE = 532,
     REFERENCES = 533,
     REINDEX = 534,
     RELATIVE_P = 535,
     RELEASE = 536,
     RENAME = 537,
     REPEATABLE = 538,
     REPLACE = 539,
     REPLICA = 540,
     RESET = 541,
     RESTART = 542,
     RESTRICT = 543,
     RETURNING = 544,
     RETURNS = 545,
     REVOKE = 546,
     RIGHT = 547,
     ROLE = 548,
     ROLLBACK = 549,
     ROW = 550,
     ROWS = 551,
     RULE = 552,
     SAVEPOINT = 553,
     SCHEMA = 554,
     SCROLL = 555,
     SEARCH = 556,
     SECOND_P = 557,
     SECURITY = 558,
     SELECT = 559,
     SEQUENCE = 560,
     SERIALIZABLE = 561,
     SERVER = 562,
     SESSION = 563,
     SESSION_USER = 564,
     SET = 565,
     SETOF = 566,
     SHARE = 567,
     SHOW = 568,
     SIMILAR = 569,
     SIMPLE = 570,
     SMALLINT = 571,
     SOME = 572,
     STABLE = 573,
     STANDALONE_P = 574,
     START = 575,
     STATEMENT = 576,
     STATISTICS = 577,
     STDIN = 578,
     STDOUT = 579,
     STORAGE = 580,
     STRICT_P = 581,
     STRIP_P = 582,
     SUBSTRING = 583,
     SUPERUSER_P = 584,
     SYMMETRIC = 585,
     SYSID = 586,
     SYSTEM_P = 587,
     TABLE = 588,
     TABLESPACE = 589,
     TEMP = 590,
     TEMPLATE = 591,
     TEMPORARY = 592,
     TEXT_P = 593,
     THEN = 594,
     TIME = 595,
     TIMESTAMP = 596,
     TO = 597,
     TRAILING = 598,
     TRANSACTION = 599,
     TREAT = 600,
     TRIGGER = 601,
     TRIM = 602,
     TRUE_P = 603,
     TRUNCATE = 604,
     TRUSTED = 605,
     TYPE_P = 606,
     UNBOUNDED = 607,
     UNCOMMITTED = 608,
     UNENCRYPTED = 609,
     UNION = 610,
     UNIQUE = 611,
     UNKNOWN = 612,
     UNLISTEN = 613,
     UNTIL = 614,
     UPDATE = 615,
     USER = 616,
     USING = 617,
     VACUUM = 618,
     VALID = 619,
     VALIDATOR = 620,
     VALUE_P = 621,
     VALUES = 622,
     VARCHAR = 623,
     VARIADIC = 624,
     VARYING = 625,
     VERBOSE = 626,
     VERSION_P = 627,
     VIEW = 628,
     VOLATILE = 629,
     WHEN = 630,
     WHERE = 631,
     WHITESPACE_P = 632,
     WINDOW = 633,
     WITH = 634,
     WITHOUT = 635,
     WORK = 636,
     WRAPPER = 637,
     WRITE = 638,
     XML_P = 639,
     XMLATTRIBUTES = 640,
     XMLCONCAT = 641,
     XMLELEMENT = 642,
     XMLFOREST = 643,
     XMLPARSE = 644,
     XMLPI = 645,
     XMLROOT = 646,
     XMLSERIALIZE = 647,
     YEAR_P = 648,
     YES_P = 649,
     ZONE = 650,
     NULLS_FIRST = 651,
     NULLS_LAST = 652,
     WITH_TIME = 653,
     IDENT = 654,
     FCONST = 655,
     SCONST = 656,
     BCONST = 657,
     XCONST = 658,
     Op = 659,
     ICONST = 660,
     PARAM = 661,
     POSTFIXOP = 662,
     UMINUS = 663,
     TYPECAST = 664
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 149 "gram.y"

	int					ival;
	char				chr;
	char				*str;
	const char			*keyword;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;

	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;

	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 708 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 733 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  663
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   56478

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  427
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  485
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2010
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3673

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   664

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   415,     2,     2,
     420,   421,   413,   411,   425,   412,   423,   414,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   426,   424,
     408,   407,   409,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   418,     2,   419,   416,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   410,   417,   422
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   214,   220,   222,
     223,   226,   227,   230,   233,   237,   241,   243,   245,   247,
     249,   251,   253,   255,   257,   259,   261,   263,   265,   269,
     273,   276,   279,   282,   285,   289,   293,   299,   305,   310,
     316,   321,   325,   331,   335,   341,   347,   354,   356,   358,
     362,   368,   376,   382,   384,   385,   388,   389,   391,   393,
     395,   397,   399,   401,   404,   408,   412,   416,   420,   424,
     428,   432,   436,   439,   445,   448,   451,   454,   457,   461,
     465,   469,   471,   475,   477,   481,   483,   485,   487,   490,
     493,   496,   498,   500,   502,   504,   506,   508,   510,   514,
     521,   523,   525,   527,   529,   531,   532,   534,   536,   539,
     543,   548,   552,   555,   558,   560,   563,   567,   572,   576,
     579,   584,   586,   588,   590,   592,   594,   597,   600,   603,
     606,   611,   616,   621,   626,   628,   632,   636,   641,   648,
     655,   662,   669,   674,   682,   685,   690,   694,   698,   702,
     706,   710,   715,   720,   724,   728,   732,   736,   740,   744,
     749,   754,   758,   761,   765,   769,   773,   776,   779,   783,
     786,   788,   790,   791,   794,   795,   799,   802,   803,   805,
     809,   813,   815,   821,   825,   828,   831,   842,   849,   851,
     853,   855,   857,   859,   862,   863,   865,   867,   871,   875,
     877,   879,   883,   887,   891,   896,   898,   899,   902,   903,
     907,   908,   910,   911,   924,   938,   940,   942,   945,   948,
     951,   954,   955,   957,   958,   960,   964,   966,   968,   970,
     974,   977,   978,   982,   984,   986,   989,   991,   995,  1000,
    1005,  1008,  1014,  1016,  1019,  1022,  1025,  1029,  1032,  1033,
    1036,  1039,  1042,  1045,  1048,  1051,  1055,  1057,  1062,  1069,
    1077,  1089,  1093,  1094,  1096,  1100,  1102,  1105,  1108,  1111,
    1112,  1114,  1116,  1119,  1122,  1123,  1127,  1131,  1134,  1136,
    1138,  1141,  1144,  1149,  1150,  1153,  1156,  1159,  1160,  1164,
    1169,  1174,  1175,  1178,  1179,  1184,  1185,  1193,  1199,  1203,
    1204,  1206,  1210,  1212,  1215,  1219,  1220,  1227,  1232,  1234,
    1235,  1237,  1240,  1243,  1245,  1248,  1252,  1255,  1258,  1261,
    1264,  1268,  1272,  1274,  1278,  1280,  1281,  1283,  1286,  1288,
    1294,  1304,  1306,  1307,  1309,  1312,  1315,  1318,  1320,  1321,
    1324,  1325,  1331,  1339,  1341,  1342,  1349,  1352,  1353,  1357,
    1363,  1371,  1378,  1387,  1395,  1402,  1409,  1414,  1415,  1417,
    1421,  1426,  1428,  1432,  1434,  1437,  1440,  1443,  1446,  1448,
    1450,  1461,  1464,  1465,  1468,  1471,  1473,  1474,  1479,  1486,
    1492,  1497,  1502,  1511,  1513,  1515,  1517,  1525,  1535,  1544,
    1559,  1579,  1581,  1583,  1585,  1589,  1591,  1593,  1595,  1597,
    1601,  1602,  1604,  1605,  1607,  1609,  1611,  1615,  1616,  1618,
    1620,  1622,  1624,  1626,  1628,  1631,  1632,  1634,  1637,  1639,
    1642,  1643,  1646,  1648,  1651,  1654,  1661,  1670,  1679,  1684,
    1690,  1695,  1700,  1705,  1709,  1717,  1726,  1733,  1740,  1747,
    1754,  1758,  1760,  1764,  1768,  1770,  1772,  1774,  1776,  1778,
    1780,  1784,  1788,  1792,  1794,  1798,  1802,  1804,  1808,  1822,
    1824,  1828,  1833,  1839,  1844,  1852,  1855,  1857,  1858,  1861,
    1862,  1864,  1865,  1872,  1881,  1890,  1892,  1896,  1902,  1908,
    1916,  1926,  1934,  1944,  1950,  1957,  1964,  1969,  1971,  1973,
    1975,  1977,  1979,  1981,  1983,  1985,  1989,  1993,  1997,  2001,
    2003,  2007,  2009,  2012,  2015,  2019,  2025,  2028,  2031,  2032,
    2039,  2047,  2055,  2063,  2072,  2081,  2088,  2097,  2107,  2117,
    2125,  2136,  2144,  2153,  2162,  2171,  2180,  2182,  2184,  2186,
    2188,  2190,  2192,  2194,  2196,  2198,  2200,  2202,  2204,  2206,
    2208,  2213,  2216,  2221,  2224,  2225,  2227,  2229,  2231,  2233,
    2236,  2239,  2241,  2243,  2245,  2248,  2251,  2253,  2256,  2259,
    2261,  2263,  2271,  2279,  2290,  2292,  2294,  2297,  2302,  2308,
    2310,  2314,  2317,  2320,  2323,  2326,  2328,  2331,  2334,  2339,
    2343,  2346,  2349,  2352,  2356,  2359,  2362,  2364,  2368,  2370,
    2373,  2377,  2378,  2380,  2384,  2387,  2394,  2401,  2411,  2415,
    2416,  2420,  2421,  2435,  2450,  2452,  2453,  2456,  2457,  2459,
    2463,  2468,  2473,  2480,  2482,  2485,  2486,  2488,  2490,  2491,
    2493,  2495,  2496,  2506,  2519,  2527,  2530,  2531,  2535,  2538,
    2540,  2544,  2548,  2551,  2553,  2557,  2561,  2565,  2568,  2571,
    2573,  2575,  2577,  2579,  2582,  2584,  2586,  2588,  2590,  2595,
    2601,  2603,  2607,  2611,  2613,  2616,  2621,  2627,  2629,  2631,
    2633,  2635,  2639,  2643,  2646,  2649,  2652,  2655,  2657,  2660,
    2663,  2665,  2667,  2669,  2671,  2675,  2678,  2679,  2682,  2684,
    2688,  2694,  2696,  2699,  2701,  2702,  2708,  2716,  2722,  2730,
    2736,  2744,  2748,  2754,  2760,  2766,  2768,  2772,  2784,  2795,
    2806,  2809,  2812,  2813,  2823,  2826,  2827,  2832,  2837,  2842,
    2844,  2846,  2848,  2849,  2857,  2864,  2871,  2878,  2885,  2893,
    2903,  2913,  2920,  2927,  2934,  2941,  2948,  2957,  2966,  2973,
    2980,  2987,  2996,  3005,  3014,  3023,  3030,  3032,  3033,  3036,
    3037,  3045,  3052,  3059,  3066,  3073,  3080,  3087,  3095,  3102,
    3109,  3116,  3123,  3131,  3139,  3147,  3157,  3167,  3174,  3181,
    3188,  3197,  3206,  3215,  3222,  3227,  3232,  3237,  3245,  3250,
    3255,  3261,  3267,  3268,  3270,  3274,  3276,  3280,  3282,  3283,
    3289,  3294,  3295,  3310,  3312,  3314,  3318,  3322,  3324,  3326,
    3328,  3330,  3332,  3334,  3336,  3337,  3339,  3341,  3343,  3345,
    3347,  3349,  3350,  3357,  3366,  3369,  3372,  3375,  3378,  3381,
    3385,  3389,  3392,  3395,  3398,  3401,  3405,  3408,  3414,  3419,
    3423,  3427,  3431,  3433,  3435,  3436,  3440,  3443,  3446,  3448,
    3452,  3455,  3457,  3458,  3467,  3478,  3482,  3487,  3492,  3493,
    3496,  3502,  3505,  3506,  3510,  3514,  3518,  3522,  3526,  3530,
    3534,  3538,  3542,  3546,  3550,  3554,  3558,  3563,  3567,  3571,
    3573,  3575,  3576,  3582,  3589,  3594,  3597,  3598,  3603,  3607,
    3613,  3620,  3625,  3632,  3639,  3645,  3653,  3655,  3656,  3663,
    3675,  3687,  3699,  3713,  3723,  3735,  3746,  3751,  3754,  3760,
    3763,  3764,  3769,  3775,  3781,  3784,  3789,  3791,  3793,  3795,
    3796,  3798,  3799,  3801,  3802,  3806,  3807,  3812,  3814,  3816,
    3818,  3820,  3822,  3824,  3826,  3828,  3829,  3835,  3839,  3840,
    3842,  3844,  3846,  3848,  3852,  3861,  3865,  3866,  3869,  3873,
    3876,  3880,  3886,  3888,  3893,  3896,  3898,  3902,  3905,  3908,
    3909,  3916,  3919,  3920,  3926,  3930,  3931,  3934,  3937,  3940,
    3944,  3946,  3950,  3952,  3955,  3957,  3958,  3966,  3968,  3972,
    3974,  3976,  3980,  3986,  3989,  3991,  3995,  4003,  4004,  4008,
    4011,  4014,  4017,  4018,  4021,  4024,  4026,  4028,  4032,  4036,
    4038,  4041,  4046,  4051,  4054,  4058,  4064,  4070,  4072,  4074,
    4084,  4086,  4089,  4094,  4099,  4104,  4107,  4111,  4113,  4117,
    4122,  4125,  4126,  4130,  4134,  4139,  4144,  4149,  4154,  4157,
    4159,  4161,  4162,  4164,  4166,  4167,  4169,  4175,  4177,  4178,
    4180,  4181,  4185,  4187,  4191,  4196,  4200,  4205,  4210,  4213,
    4216,  4221,  4225,  4231,  4240,  4242,  4243,  4245,  4247,  4249,
    4253,  4254,  4256,  4258,  4260,  4262,  4264,  4266,  4270,  4271,
    4274,  4275,  4277,  4281,  4283,  4284,  4286,  4289,  4294,  4299,
    4302,  4303,  4306,  4310,  4313,  4314,  4316,  4320,  4322,  4325,
    4327,  4330,  4336,  4343,  4349,  4351,  4354,  4356,  4361,  4365,
    4370,  4376,  4381,  4387,  4392,  4398,  4401,  4406,  4408,  4411,
    4414,  4417,  4419,  4421,  4422,  4427,  4430,  4432,  4435,  4438,
    4443,  4445,  4449,  4451,  4454,  4458,  4460,  4463,  4464,  4467,
    4472,  4477,  4478,  4480,  4484,  4487,  4490,  4494,  4500,  4507,
    4510,  4514,  4518,  4523,  4524,  4526,  4528,  4530,  4532,  4534,
    4537,  4543,  4545,  4547,  4549,  4551,  4554,  4558,  4562,  4563,
    4565,  4567,  4569,  4571,  4573,  4576,  4579,  4582,  4585,  4588,
    4590,  4594,  4595,  4597,  4599,  4601,  4603,  4609,  4612,  4614,
    4616,  4618,  4620,  4626,  4629,  4632,  4635,  4637,  4641,  4645,
    4648,  4650,  4651,  4655,  4656,  4662,  4665,  4671,  4674,  4676,
    4679,  4683,  4684,  4686,  4688,  4690,  4692,  4694,  4696,  4700,
    4704,  4708,  4712,  4716,  4720,  4724,  4725,  4727,  4732,  4734,
    4738,  4744,  4747,  4750,  4754,  4758,  4762,  4766,  4770,  4774,
    4778,  4782,  4786,  4790,  4793,  4796,  4800,  4804,  4807,  4811,
    4817,  4822,  4829,  4833,  4839,  4844,  4851,  4856,  4863,  4869,
    4877,  4881,  4884,  4889,  4892,  4896,  4900,  4905,  4909,  4914,
    4918,  4923,  4929,  4936,  4943,  4951,  4958,  4966,  4973,  4981,
    4985,  4990,  4995,  5002,  5005,  5009,  5014,  5016,  5020,  5023,
    5026,  5030,  5034,  5038,  5042,  5046,  5050,  5054,  5058,  5062,
    5066,  5069,  5072,  5078,  5085,  5092,  5100,  5104,  5109,  5111,
    5113,  5116,  5121,  5123,  5125,  5127,  5130,  5133,  5136,  5138,
    5143,  5149,  5156,  5165,  5172,  5179,  5185,  5187,  5189,  5194,
    5196,  5201,  5203,  5208,  5210,  5215,  5217,  5219,  5221,  5223,
    5225,  5227,  5234,  5239,  5244,  5249,  5254,  5261,  5267,  5273,
    5279,  5284,  5291,  5296,  5301,  5306,  5311,  5317,  5325,  5333,
    5343,  5348,  5355,  5361,  5369,  5377,  5385,  5388,  5392,  5396,
    5400,  5405,  5406,  5411,  5413,  5417,  5421,  5423,  5425,  5427,
    5430,  5433,  5434,  5437,  5438,  5440,  5444,  5448,  5451,  5454,
    5455,  5462,  5464,  5465,  5469,  5470,  5473,  5476,  5477,  5479,
    5484,  5487,  5490,  5493,  5498,  5502,  5508,  5510,  5512,  5514,
    5516,  5518,  5520,  5522,  5524,  5526,  5528,  5530,  5532,  5534,
    5536,  5538,  5543,  5545,  5550,  5552,  5557,  5559,  5562,  5564,
    5567,  5569,  5573,  5575,  5579,  5583,  5587,  5590,  5592,  5596,
    5600,  5601,  5603,  5605,  5607,  5609,  5611,  5613,  5615,  5617,
    5622,  5626,  5629,  5633,  5634,  5638,  5642,  5645,  5648,  5650,
    5651,  5654,  5657,  5661,  5664,  5666,  5668,  5672,  5678,  5680,
    5683,  5688,  5691,  5692,  5694,  5695,  5697,  5700,  5703,  5706,
    5710,  5716,  5718,  5721,  5722,  5725,  5727,  5728,  5730,  5732,
    5734,  5738,  5742,  5744,  5748,  5752,  5755,  5757,  5759,  5761,
    5763,  5765,  5769,  5771,  5774,  5776,  5780,  5782,  5784,  5786,
    5788,  5790,  5792,  5794,  5797,  5799,  5801,  5803,  5805,  5807,
    5810,  5816,  5819,  5823,  5830,  5832,  5834,  5836,  5838,  5840,
    5842,  5844,  5847,  5850,  5852,  5856,  5858,  5860,  5862,  5864,
    5866,  5868,  5870,  5872,  5874,  5876,  5878,  5880,  5882,  5884,
    5886,  5888,  5890,  5892,  5894,  5896,  5898,  5900,  5902,  5904,
    5906,  5908,  5910,  5912,  5914,  5916,  5918,  5920,  5922,  5924,
    5926,  5928,  5930,  5932,  5934,  5936,  5938,  5940,  5942,  5944,
    5946,  5948,  5950,  5952,  5954,  5956,  5958,  5960,  5962,  5964,
    5966,  5968,  5970,  5972,  5974,  5976,  5978,  5980,  5982,  5984,
    5986,  5988,  5990,  5992,  5994,  5996,  5998,  6000,  6002,  6004,
    6006,  6008,  6010,  6012,  6014,  6016,  6018,  6020,  6022,  6024,
    6026,  6028,  6030,  6032,  6034,  6036,  6038,  6040,  6042,  6044,
    6046,  6048,  6050,  6052,  6054,  6056,  6058,  6060,  6062,  6064,
    6066,  6068,  6070,  6072,  6074,  6076,  6078,  6080,  6082,  6084,
    6086,  6088,  6090,  6092,  6094,  6096,  6098,  6100,  6102,  6104,
    6106,  6108,  6110,  6112,  6114,  6116,  6118,  6120,  6122,  6124,
    6126,  6128,  6130,  6132,  6134,  6136,  6138,  6140,  6142,  6144,
    6146,  6148,  6150,  6152,  6154,  6156,  6158,  6160,  6162,  6164,
    6166,  6168,  6170,  6172,  6174,  6176,  6178,  6180,  6182,  6184,
    6186,  6188,  6190,  6192,  6194,  6196,  6198,  6200,  6202,  6204,
    6206,  6208,  6210,  6212,  6214,  6216,  6218,  6220,  6222,  6224,
    6226,  6228,  6230,  6232,  6234,  6236,  6238,  6240,  6242,  6244,
    6246,  6248,  6250,  6252,  6254,  6256,  6258,  6260,  6262,  6264,
    6266,  6268,  6270,  6272,  6274,  6276,  6278,  6280,  6282,  6284,
    6286,  6288,  6290,  6292,  6294,  6296,  6298,  6300,  6302,  6304,
    6306,  6308,  6310,  6312,  6314,  6316,  6318,  6320,  6322,  6324,
    6326,  6328,  6330,  6332,  6334,  6336,  6338,  6340,  6342,  6344,
    6346,  6348,  6350,  6352,  6354,  6356,  6358,  6360,  6362,  6364,
    6366,  6368,  6370,  6372,  6374,  6376,  6378,  6380,  6382,  6384,
    6386,  6388,  6390,  6392,  6394,  6396,  6398,  6400,  6402,  6404,
    6406,  6408,  6410,  6412,  6414,  6416,  6418,  6420,  6422,  6424,
    6426,  6428,  6430,  6432,  6434,  6436,  6438,  6440,  6442,  6444,
    6446,  6448,  6450,  6452,  6454,  6456,  6458,  6460,  6462,  6464,
    6466,  6468,  6470,  6472,  6474,  6476,  6478,  6480,  6482,  6484,
    6486,  6488,  6490,  6492,  6494,  6496,  6498,  6500,  6502,  6504,
    6506,  6508,  6510,  6512,  6514,  6516,  6518,  6520,  6522,  6524,
    6526,  6528,  6530,  6532,  6534,  6536,  6538,  6540,  6542,  6544,
    6546,  6548,  6550,  6552,  6554,  6556,  6558,  6560,  6562,  6564,
    6566,  6568,  6570,  6572,  6574,  6576,  6578,  6580,  6582,  6584,
    6586,  6588,  6590,  6592,  6594,  6596,  6598,  6600,  6602,  6604,
    6606,  6608,  6610,  6612,  6614,  6616,  6618,  6620,  6622,  6624,
    6626,  6628,  6630,  6632,  6634,  6636,  6638,  6640,  6642,  6644,
    6646,  6648,  6650,  6652,  6654,  6656,  6658,  6660,  6662,  6664,
    6666
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     428,     0,    -1,   429,    -1,   429,   424,   430,    -1,   430,
      -1,   707,    -1,   708,    -1,   713,    -1,   542,    -1,   556,
      -1,   656,    -1,   443,    -1,   674,    -1,   675,    -1,   676,
      -1,   523,    -1,   468,    -1,   437,    -1,   436,    -1,   716,
      -1,   715,    -1,   560,    -1,   439,    -1,   438,    -1,   721,
      -1,   466,    -1,   478,    -1,   718,    -1,   608,    -1,   463,
      -1,   479,    -1,   516,    -1,   575,    -1,   664,    -1,   717,
      -1,   712,    -1,   540,    -1,   551,    -1,   637,    -1,   442,
      -1,   587,    -1,   593,    -1,   594,    -1,   529,    -1,   446,
      -1,   522,    -1,   488,    -1,   537,    -1,   561,    -1,   431,
      -1,   435,    -1,   557,    -1,   703,    -1,   735,    -1,   754,
      -1,   577,    -1,   741,    -1,   467,    -1,   576,    -1,   666,
      -1,   541,    -1,   555,    -1,   445,    -1,   597,    -1,   598,
      -1,   599,    -1,   535,    -1,   691,    -1,   601,    -1,   539,
      -1,   574,    -1,   440,    -1,   441,    -1,   559,    -1,   711,
      -1,   733,    -1,   727,    -1,   611,    -1,   614,    -1,   625,
      -1,   629,    -1,   736,    -1,   693,    -1,   702,    -1,   743,
      -1,   692,    -1,   730,    -1,   600,    -1,   668,    -1,   660,
      -1,   659,    -1,   661,    -1,   671,    -1,   615,    -1,   626,
      -1,   683,    -1,   757,    -1,   695,    -1,   606,    -1,   694,
      -1,   747,    -1,   720,    -1,   460,    -1,   450,    -1,   462,
      -1,   700,    -1,    -1,    70,   293,   901,   432,   433,    -1,
     379,    -1,    -1,   433,   434,    -1,    -1,   257,   900,    -1,
     257,   230,    -1,   115,   257,   900,    -1,   354,   257,   900,
      -1,   329,    -1,   224,    -1,   162,    -1,   221,    -1,    71,
      -1,   218,    -1,    72,    -1,   219,    -1,    73,    -1,   220,
      -1,   201,    -1,   222,    -1,    61,   193,   902,    -1,   364,
     359,   900,    -1,   361,   890,    -1,   331,   899,    -1,     8,
     890,    -1,   293,   890,    -1,   157,   293,   890,    -1,   157,
     145,   890,    -1,    70,   361,   901,   432,   433,    -1,    13,
     293,   901,   432,   433,    -1,    13,   293,   901,   461,    -1,
      13,   361,   901,   432,   433,    -1,    13,   361,   901,   461,
      -1,   110,   293,   890,    -1,   110,   293,   152,   123,   890,
      -1,   110,   361,   890,    -1,   110,   361,   152,   123,   890,
      -1,    70,   145,   901,   432,   433,    -1,    13,   145,   901,
     444,   361,   890,    -1,     7,    -1,   110,    -1,   110,   145,
     890,    -1,   110,   145,   152,   123,   890,    -1,    70,   299,
     447,    26,   901,   680,   448,    -1,    70,   299,   904,   680,
     448,    -1,   904,    -1,    -1,   448,   449,    -1,    -1,   488,
      -1,   629,    -1,   522,    -1,   561,    -1,   614,    -1,   700,
      -1,   310,   451,    -1,   310,   196,   451,    -1,   310,   308,
     451,    -1,   452,   342,   453,    -1,   452,   407,   453,    -1,
     452,   342,    93,    -1,   452,   407,    93,    -1,   452,   138,
      76,    -1,   340,   395,   457,    -1,   344,   698,    -1,   308,
      47,    20,   344,   698,    -1,    43,   900,    -1,   299,   900,
      -1,   211,   458,    -1,   293,   459,    -1,   308,    26,   459,
      -1,   308,    26,    93,    -1,   384,   243,   839,    -1,   904,
      -1,   452,   423,   904,    -1,   454,    -1,   453,   425,   454,
      -1,   456,    -1,   459,    -1,   528,    -1,   273,   353,    -1,
     273,    58,    -1,   283,   273,    -1,   306,    -1,   348,    -1,
     127,    -1,   240,    -1,   236,    -1,   900,    -1,   399,    -1,
     826,   900,   828,    -1,   826,   420,   899,   421,   900,   828,
      -1,   528,    -1,    93,    -1,   196,    -1,   900,    -1,    93,
      -1,    -1,   904,    -1,   900,    -1,   286,   452,    -1,   286,
     340,   395,    -1,   286,   344,   179,   191,    -1,   286,   308,
      26,    -1,   286,    11,    -1,   310,   451,    -1,   460,    -1,
     313,   452,    -1,   313,   340,   395,    -1,   313,   344,   179,
     191,    -1,   313,   308,    26,    -1,   313,    11,    -1,   310,
      63,   464,   465,    -1,    11,    -1,   888,    -1,    96,    -1,
     154,    -1,    49,    -1,   104,    11,    -1,   104,   335,    -1,
     104,   337,    -1,   104,   259,    -1,    13,   333,   798,   469,
      -1,    13,   160,   889,   469,    -1,    13,   305,   889,   469,
      -1,    13,   373,   889,   469,    -1,   470,    -1,   469,   425,
     470,    -1,     7,   672,   493,    -1,    13,   672,   904,   471,
      -1,    13,   672,   904,   110,   225,   230,    -1,    13,   672,
     904,   310,   225,   230,    -1,    13,   672,   904,   310,   322,
     902,    -1,    13,   672,   904,   310,   325,   904,    -1,   110,
     672,   904,   472,    -1,    13,   672,   904,   673,   351,   806,
     473,    -1,     7,   501,    -1,   110,    62,   891,   472,    -1,
     310,   379,   238,    -1,   310,   380,   238,    -1,    52,   240,
     891,    -1,   310,   380,    52,    -1,   113,   346,   891,    -1,
     113,    14,   346,   891,    -1,   113,   285,   346,   891,    -1,
     113,   346,    11,    -1,   113,   346,   361,    -1,   103,   346,
     891,    -1,   103,   346,    11,    -1,   103,   346,   361,    -1,
     113,   297,   891,    -1,   113,    14,   297,   891,    -1,   113,
     285,   297,   891,    -1,   103,   297,   891,    -1,   162,   889,
      -1,   217,   162,   889,    -1,   253,   342,   901,    -1,   310,
     334,   891,    -1,   310,   474,    -1,   286,   474,    -1,   310,
      93,   830,    -1,   110,    93,    -1,    39,    -1,   288,    -1,
      -1,   362,   830,    -1,    -1,   420,   476,   421,    -1,   379,
     474,    -1,    -1,   477,    -1,   476,   425,   477,    -1,   906,
     407,   581,    -1,   906,    -1,   906,   423,   906,   407,   581,
      -1,   906,   423,   906,    -1,    51,   891,    -1,    51,    11,
      -1,    68,   484,   889,   503,   485,   480,   481,   486,   432,
     482,    -1,    68,   758,   342,   481,   432,   482,    -1,   138,
      -1,   342,    -1,   900,    -1,   323,    -1,   324,    -1,   482,
     483,    -1,    -1,    32,    -1,   238,    -1,    99,   714,   900,
      -1,   230,   714,   900,    -1,    75,    -1,   148,    -1,   271,
     714,   900,    -1,   118,   714,   900,    -1,   134,   271,   504,
      -1,   134,   225,   230,   504,    -1,    32,    -1,    -1,   379,
     238,    -1,    -1,   487,   100,   900,    -1,    -1,   362,    -1,
      -1,    70,   489,   333,   889,   420,   490,   421,   511,   512,
     513,   514,   677,    -1,    70,   489,   333,   889,   235,   889,
     420,   490,   421,   512,   513,   514,   677,    -1,   337,    -1,
     335,    -1,   196,   337,    -1,   196,   335,    -1,   141,   337,
      -1,   141,   335,    -1,    -1,   491,    -1,    -1,   492,    -1,
     491,   425,   492,    -1,   493,    -1,   498,    -1,   501,    -1,
     904,   806,   494,    -1,   494,   495,    -1,    -1,    62,   891,
     496,    -1,   496,    -1,   497,    -1,   225,   230,    -1,   230,
      -1,   356,   653,   515,    -1,   266,   181,   653,   515,    -1,
      48,   420,   830,   421,    -1,    93,   831,    -1,   278,   889,
     503,   506,   507,    -1,    95,    -1,   225,    95,    -1,   164,
      96,    -1,   164,   154,    -1,   192,   889,   499,    -1,   499,
     500,    -1,    -1,   158,    94,    -1,   120,    94,    -1,   158,
      63,    -1,   120,    63,    -1,   158,   161,    -1,   120,   161,
      -1,    62,   891,   502,    -1,   502,    -1,    48,   420,   830,
     421,    -1,   356,   420,   504,   421,   653,   515,    -1,   266,
     181,   420,   504,   421,   653,   515,    -1,   135,   181,   420,
     504,   421,   278,   889,   503,   506,   507,   571,    -1,   420,
     504,   421,    -1,    -1,   505,    -1,   504,   425,   505,    -1,
     904,    -1,   203,   139,    -1,   203,   255,    -1,   203,   315,
      -1,    -1,   508,    -1,   509,    -1,   508,   509,    -1,   509,
     508,    -1,    -1,   240,   360,   510,    -1,   240,    98,   510,
      -1,   217,     6,    -1,   288,    -1,    39,    -1,   310,   230,
      -1,   310,    93,    -1,   163,   420,   888,   421,    -1,    -1,
     379,   474,    -1,   379,   238,    -1,   380,   238,    -1,    -1,
     240,    57,   110,    -1,   240,    57,    98,   296,    -1,   240,
      57,   263,   296,    -1,    -1,   334,   891,    -1,    -1,   362,
     160,   334,   891,    -1,    -1,    70,   489,   333,   517,    20,
     757,   521,    -1,   889,   518,   512,   513,   514,    -1,   420,
     519,   421,    -1,    -1,   520,    -1,   519,   425,   520,    -1,
     904,    -1,   379,    86,    -1,   379,   217,    86,    -1,    -1,
      70,   489,   305,   889,   524,   680,    -1,    13,   305,   889,
     525,    -1,   525,    -1,    -1,   526,    -1,   525,   526,    -1,
      37,   528,    -1,    85,    -1,   217,    85,    -1,   159,   527,
     528,    -1,   204,   528,    -1,   206,   528,    -1,   217,   204,
      -1,   217,   206,    -1,   252,    36,   604,    -1,   320,   432,
     528,    -1,   287,    -1,   287,   432,   528,    -1,    36,    -1,
      -1,   400,    -1,   412,   400,    -1,   902,    -1,    70,   530,
     536,   183,   459,    -1,    70,   530,   536,   183,   459,   146,
     531,   533,   534,    -1,   350,    -1,    -1,   891,    -1,   891,
     605,    -1,   365,   531,    -1,   217,   365,    -1,   532,    -1,
      -1,   182,   900,    -1,    -1,   110,   536,   183,   459,   472,
      -1,   110,   536,   183,   152,   123,   459,   472,    -1,   269,
      -1,    -1,    70,   334,   891,   538,   199,   900,    -1,   253,
     891,    -1,    -1,   110,   334,   891,    -1,   110,   334,   152,
     123,   891,    -1,    70,   135,    86,   382,   891,   533,   543,
      -1,   110,   135,    86,   382,   891,   472,    -1,   110,   135,
      86,   382,   152,   123,   891,   472,    -1,    13,   135,    86,
     382,   891,   532,   545,    -1,    13,   135,    86,   382,   891,
     532,    -1,    13,   135,    86,   382,   891,   545,    -1,   244,
     420,   544,   421,    -1,    -1,   548,    -1,   544,   425,   548,
      -1,   244,   420,   546,   421,    -1,   547,    -1,   546,   425,
     547,    -1,   548,    -1,   310,   548,    -1,     7,   548,    -1,
     110,   549,    -1,   549,   550,    -1,   906,    -1,   900,    -1,
      70,   307,   891,   552,   554,   135,    86,   382,   891,   543,
      -1,   351,   900,    -1,    -1,   372,   900,    -1,   372,   230,
      -1,   553,    -1,    -1,   110,   307,   891,   472,    -1,   110,
     307,   152,   123,   891,   472,    -1,    13,   307,   891,   553,
     545,    -1,    13,   307,   891,   553,    -1,    13,   307,   891,
     545,    -1,    70,   361,   202,   133,   558,   307,   891,   543,
      -1,    83,    -1,   361,    -1,   901,    -1,   110,   361,   202,
     133,   558,   307,   891,    -1,   110,   361,   202,   152,   123,
     133,   558,   307,   891,    -1,    13,   361,   202,   133,   558,
     307,   891,   545,    -1,    70,   346,   891,   562,   563,   240,
     889,   565,   122,   270,   897,   420,   568,   421,    -1,    70,
      62,   346,   891,     9,   563,   240,   889,   570,   571,   133,
     111,   295,   122,   270,   897,   420,   568,   421,    -1,    28,
      -1,     9,    -1,   564,    -1,   563,   245,   564,    -1,   169,
      -1,    98,    -1,   360,    -1,   349,    -1,   133,   566,   567,
      -1,    -1,   111,    -1,    -1,   295,    -1,   321,    -1,   569,
      -1,   568,   425,   569,    -1,    -1,   899,    -1,   400,    -1,
     900,    -1,   402,    -1,   403,    -1,   904,    -1,   138,   889,
      -1,    -1,   572,    -1,   572,   573,    -1,   573,    -1,   573,
     572,    -1,    -1,   225,    95,    -1,    95,    -1,   164,   154,
      -1,   164,    96,    -1,   110,   346,   891,   240,   889,   472,
      -1,   110,   346,   152,   123,   891,   240,   889,   472,    -1,
      70,    22,   891,    48,   420,   830,   421,   571,    -1,   110,
      22,   891,   472,    -1,    70,    10,   897,   582,   578,    -1,
      70,    10,   897,   583,    -1,    70,   242,   663,   578,    -1,
      70,   351,   604,   578,    -1,    70,   351,   604,    -1,    70,
     351,   604,    20,   420,   804,   421,    -1,    70,   351,   604,
      20,   117,   420,   586,   421,    -1,    70,   338,   301,   254,
     604,   578,    -1,    70,   338,   301,   102,   604,   578,    -1,
      70,   338,   301,   336,   604,   578,    -1,    70,   338,   301,
      60,   604,   578,    -1,   420,   579,   421,    -1,   580,    -1,
     579,   425,   580,    -1,   906,   407,   581,    -1,   906,    -1,
     647,    -1,   910,    -1,   856,    -1,   528,    -1,   900,    -1,
     420,   859,   421,    -1,   420,   413,   421,    -1,   420,   584,
     421,    -1,   585,    -1,   584,   425,   585,    -1,   399,   407,
     581,    -1,   900,    -1,   586,   425,   900,    -1,    70,   242,
      50,   604,   590,   133,   351,   806,   362,   893,   591,    20,
     588,    -1,   589,    -1,   588,   425,   589,    -1,   242,   899,
     663,   592,    -1,   242,   899,   663,   662,   592,    -1,   140,
     899,   897,   639,    -1,   140,   899,   420,   859,   421,   897,
     639,    -1,   325,   806,    -1,    93,    -1,    -1,   128,   604,
      -1,    -1,   276,    -1,    -1,    70,   242,   128,   604,   362,
     893,    -1,    13,   242,   128,   604,   362,   893,     7,   588,
      -1,    13,   242,   128,   604,   362,   893,   110,   595,    -1,
     596,    -1,   595,   425,   596,    -1,   242,   899,   420,   859,
     421,    -1,   140,   899,   420,   859,   421,    -1,   110,   242,
      50,   604,   362,   893,   472,    -1,   110,   242,    50,   152,
     123,   604,   362,   893,   472,    -1,   110,   242,   128,   604,
     362,   893,   472,    -1,   110,   242,   128,   152,   123,   604,
     362,   893,   472,    -1,   110,   252,    36,   890,   472,    -1,
     275,   252,    36,   890,   342,   891,    -1,   110,   602,   152,
     123,   603,   472,    -1,   110,   602,   603,   472,    -1,   333,
      -1,   305,    -1,   373,    -1,   160,    -1,   351,    -1,   108,
      -1,    67,    -1,   299,    -1,   338,   301,   254,    -1,   338,
     301,   102,    -1,   338,   301,   336,    -1,   338,   301,    60,
      -1,   604,    -1,   603,   425,   604,    -1,   904,    -1,   904,
     605,    -1,   423,   894,    -1,   605,   423,   894,    -1,   349,
     767,   799,   607,   472,    -1,    66,   151,    -1,   287,   151,
      -1,    -1,    56,   240,   609,   604,   177,   610,    -1,    56,
     240,    10,   897,   582,   177,   610,    -1,    56,   240,   140,
     897,   639,   177,   610,    -1,    56,   240,   242,   663,   662,
     177,   610,    -1,    56,   240,    62,   891,   240,   604,   177,
     610,    -1,    56,   240,   297,   891,   240,   604,   177,   610,
      -1,    56,   240,   297,   891,   177,   610,    -1,    56,   240,
     346,   891,   240,   604,   177,   610,    -1,    56,   240,   242,
      50,   604,   362,   893,   177,   610,    -1,    56,   240,   242,
     128,   604,   362,   893,   177,   610,    -1,    56,   240,   184,
     234,   528,   177,   610,    -1,    56,   240,    42,   420,   806,
      20,   806,   421,   177,   610,    -1,    56,   240,   536,   183,
     604,   177,   610,    -1,    56,   240,   338,   301,   254,   604,
     177,   610,    -1,    56,   240,   338,   301,   102,   604,   177,
     610,    -1,    56,   240,   338,   301,   336,   604,   177,   610,
      -1,    56,   240,   338,   301,    60,   604,   177,   610,    -1,
      55,    -1,    87,    -1,   299,    -1,   160,    -1,   305,    -1,
     333,    -1,   108,    -1,   351,    -1,   373,    -1,    67,    -1,
     334,    -1,   293,    -1,   900,    -1,   230,    -1,   129,   612,
     613,   891,    -1,   129,   891,    -1,   209,   612,   613,   891,
      -1,   209,   891,    -1,    -1,   216,    -1,   267,    -1,   130,
      -1,   185,    -1,     4,   902,    -1,   280,   902,    -1,   902,
      -1,    11,    -1,   136,    -1,   136,   902,    -1,   136,    11,
      -1,    27,    -1,    27,   902,    -1,    27,    11,    -1,   138,
      -1,   157,    -1,   142,   616,   240,   619,   342,   620,   622,
      -1,   291,   616,   240,   619,   138,   620,   472,    -1,   291,
     142,   243,   133,   616,   240,   619,   138,   620,   472,    -1,
     617,    -1,    11,    -1,    11,   268,    -1,    11,   420,   504,
     421,    -1,    11,   268,   420,   504,   421,    -1,   618,    -1,
     617,   425,   618,    -1,   304,   503,    -1,   278,   503,    -1,
      70,   503,    -1,   904,   503,    -1,   888,    -1,   333,   888,
      -1,   305,   888,    -1,   135,    86,   382,   890,    -1,   135,
     307,   890,    -1,   140,   623,    -1,    87,   890,    -1,   183,
     890,    -1,   184,   234,   903,    -1,   299,   890,    -1,   334,
     890,    -1,   621,    -1,   620,   425,   621,    -1,   901,    -1,
     145,   901,    -1,   379,   142,   243,    -1,    -1,   624,    -1,
     623,   425,   624,    -1,   897,   639,    -1,   142,   617,   342,
     890,   627,   628,    -1,   291,   617,   138,   890,   628,   472,
      -1,   291,     8,   243,   133,   617,   138,   890,   628,   472,
      -1,   379,     8,   243,    -1,    -1,   143,    36,   901,    -1,
      -1,    70,   630,   160,   895,   240,   889,   631,   420,   632,
     421,   475,   514,   802,    -1,    70,   630,   160,    59,   895,
     240,   889,   631,   420,   632,   421,   475,   514,   802,    -1,
     356,    -1,    -1,   362,   893,    -1,    -1,   633,    -1,   632,
     425,   633,    -1,   904,   634,   635,   636,    -1,   833,   634,
     635,   636,    -1,   420,   830,   421,   634,   635,   636,    -1,
     604,    -1,   362,   604,    -1,    -1,    21,    -1,   101,    -1,
      -1,   396,    -1,   397,    -1,    -1,    70,   638,   140,   897,
     641,   290,   646,   649,   653,    -1,    70,   638,   140,   897,
     641,   290,   333,   420,   655,   421,   649,   653,    -1,    70,
     638,   140,   897,   641,   649,   653,    -1,   245,   284,    -1,
      -1,   420,   640,   421,    -1,   420,   421,    -1,   643,    -1,
     640,   425,   643,    -1,   420,   642,   421,    -1,   420,   421,
      -1,   648,    -1,   642,   425,   648,    -1,   644,   645,   647,
      -1,   645,   644,   647,    -1,   645,   647,    -1,   644,   647,
      -1,   647,    -1,   157,    -1,   247,    -1,   166,    -1,   157,
     247,    -1,   369,    -1,   905,    -1,   647,    -1,   806,    -1,
     905,   605,   415,   351,    -1,   311,   905,   605,   415,   351,
      -1,   643,    -1,   643,    93,   830,    -1,   643,   407,   830,
      -1,   651,    -1,   649,   651,    -1,    38,   240,   230,   167,
      -1,   290,   230,   240,   230,   167,    -1,   326,    -1,   155,
      -1,   318,    -1,   374,    -1,   125,   303,    97,    -1,   125,
     303,   176,    -1,   303,    97,    -1,   303,   176,    -1,    69,
     528,    -1,   296,   528,    -1,   461,    -1,    20,   652,    -1,
     183,   459,    -1,   378,    -1,   681,    -1,   650,    -1,   900,
      -1,   900,   425,   900,    -1,   379,   578,    -1,    -1,   645,
     647,    -1,   654,    -1,   655,   425,   654,    -1,    13,   140,
     624,   657,   658,    -1,   650,    -1,   657,   650,    -1,   288,
      -1,    -1,   110,   140,   897,   639,   472,    -1,   110,   140,
     152,   123,   897,   639,   472,    -1,   110,    10,   897,   582,
     472,    -1,   110,    10,   152,   123,   897,   582,   472,    -1,
     110,   242,   663,   662,   472,    -1,   110,   242,   152,   123,
     663,   662,   472,    -1,   420,   806,   421,    -1,   420,   806,
     425,   806,   421,    -1,   420,   223,   425,   806,   421,    -1,
     420,   806,   425,   223,   421,    -1,   853,    -1,   904,   423,
     663,    -1,    70,    42,   420,   806,    20,   806,   421,   379,
     140,   624,   665,    -1,    70,    42,   420,   806,    20,   806,
     421,   380,   140,   665,    -1,    70,    42,   420,   806,    20,
     806,   421,   379,   166,   665,    -1,    20,   156,    -1,    20,
      23,    -1,    -1,   110,    42,   667,   420,   806,    20,   806,
     421,   472,    -1,   152,   123,    -1,    -1,   279,   669,   889,
     670,    -1,   279,   332,   891,   670,    -1,   279,    87,   891,
     670,    -1,   160,    -1,   333,    -1,   134,    -1,    -1,    13,
      10,   897,   582,   282,   342,   891,    -1,    13,    67,   604,
     282,   342,   891,    -1,    13,    87,   892,   282,   342,   892,
      -1,    13,   140,   624,   282,   342,   891,    -1,    13,   145,
     901,   282,   342,   901,    -1,    13,   536,   183,   891,   282,
     342,   891,    -1,    13,   242,    50,   604,   362,   893,   282,
     342,   891,    -1,    13,   242,   128,   604,   362,   893,   282,
     342,   891,    -1,    13,   299,   891,   282,   342,   891,    -1,
      13,   333,   798,   282,   342,   891,    -1,    13,   305,   889,
     282,   342,   891,    -1,    13,   373,   889,   282,   342,   891,
      -1,    13,   160,   889,   282,   342,   891,    -1,    13,   333,
     798,   282,   672,   891,   342,   891,    -1,    13,   346,   891,
     240,   889,   282,   342,   891,    -1,    13,   293,   901,   282,
     342,   901,    -1,    13,   361,   901,   282,   342,   901,    -1,
      13,   334,   891,   282,   342,   891,    -1,    13,   338,   301,
     254,   604,   282,   342,   891,    -1,    13,   338,   301,   102,
     604,   282,   342,   891,    -1,    13,   338,   301,   336,   604,
     282,   342,   891,    -1,    13,   338,   301,    60,   604,   282,
     342,   891,    -1,    13,   351,   604,   282,   342,   891,    -1,
      55,    -1,    -1,   310,    86,    -1,    -1,    13,    10,   897,
     582,   310,   299,   891,    -1,    13,   108,   604,   310,   299,
     891,    -1,    13,   140,   624,   310,   299,   891,    -1,    13,
     333,   798,   310,   299,   891,    -1,    13,   305,   889,   310,
     299,   891,    -1,    13,   373,   889,   310,   299,   891,    -1,
      13,   351,   604,   310,   299,   891,    -1,    13,    10,   897,
     582,   253,   342,   901,    -1,    13,    67,   604,   253,   342,
     901,    -1,    13,    87,   892,   253,   342,   901,    -1,    13,
     108,   604,   253,   342,   901,    -1,    13,   140,   624,   253,
     342,   901,    -1,    13,   536,   183,   891,   253,   342,   901,
      -1,    13,   184,   234,   899,   253,   342,   901,    -1,    13,
     242,   663,   662,   253,   342,   901,    -1,    13,   242,    50,
     604,   362,   893,   253,   342,   901,    -1,    13,   242,   128,
     604,   362,   893,   253,   342,   901,    -1,    13,   299,   891,
     253,   342,   901,    -1,    13,   351,   604,   253,   342,   901,
      -1,    13,   334,   891,   253,   342,   901,    -1,    13,   338,
     301,   102,   604,   253,   342,   901,    -1,    13,   338,   301,
      60,   604,   253,   342,   901,    -1,    13,   135,    86,   382,
     891,   253,   342,   901,    -1,    13,   307,   891,   253,   342,
     901,    -1,    13,    87,   892,   682,    -1,    13,   299,   891,
     682,    -1,    13,   333,   798,   682,    -1,    13,   333,   798,
      13,   672,   904,   682,    -1,    13,   305,   798,   682,    -1,
      13,   140,   624,   682,    -1,    13,   184,   234,   899,   682,
      -1,   303,    65,   420,   678,   421,    -1,    -1,   679,    -1,
     678,   425,   679,    -1,   900,    -1,   904,   407,   900,    -1,
     681,    -1,    -1,   303,    65,   420,   900,   421,    -1,   303,
      65,   342,   900,    -1,    -1,    70,   638,   297,   891,    20,
     684,   240,   689,   342,   889,   802,   106,   690,   685,    -1,
     226,    -1,   687,    -1,   420,   686,   421,    -1,   686,   424,
     688,    -1,   688,    -1,   757,    -1,   736,    -1,   747,    -1,
     741,    -1,   692,    -1,   687,    -1,    -1,   304,    -1,   360,
      -1,    98,    -1,   169,    -1,   170,    -1,    12,    -1,    -1,
     110,   297,   891,   240,   889,   472,    -1,   110,   297,   152,
     123,   891,   240,   889,   472,    -1,   227,   904,    -1,   194,
     904,    -1,   358,   904,    -1,   358,   413,    -1,     3,   696,
      -1,    29,   696,   699,    -1,   320,   344,   699,    -1,    57,
     696,    -1,   116,   696,    -1,   294,   696,    -1,   298,   904,
      -1,   281,   298,   904,    -1,   281,   904,    -1,   294,   696,
     342,   298,   904,    -1,   294,   696,   342,   904,    -1,   264,
     344,   900,    -1,    57,   265,   900,    -1,   294,   265,   900,
      -1,   381,    -1,   344,    -1,    -1,   179,   191,   455,    -1,
     273,   241,    -1,   273,   383,    -1,   697,    -1,   698,   425,
     697,    -1,   698,   697,    -1,   698,    -1,    -1,    70,   489,
     373,   889,   503,    20,   757,   701,    -1,    70,   245,   284,
     489,   373,   889,   503,    20,   757,   701,    -1,   379,    48,
     243,    -1,   379,    40,    48,   243,    -1,   379,   196,    48,
     243,    -1,    -1,   195,   896,    -1,    70,    87,   892,   432,
     704,    -1,   704,   705,    -1,    -1,   334,   706,   891,    -1,
     334,   706,    93,    -1,   199,   706,   900,    -1,   199,   706,
      93,    -1,   336,   706,   891,    -1,   336,   706,    93,    -1,
     114,   706,   900,    -1,   114,   706,   899,    -1,   114,   706,
      93,    -1,   186,   706,   900,    -1,   186,   706,    93,    -1,
     187,   706,   900,    -1,   187,   706,    93,    -1,    61,   193,
     706,   902,    -1,   253,   706,   891,    -1,   253,   706,    93,
      -1,   681,    -1,   407,    -1,    -1,    13,    87,   892,   432,
     709,    -1,    13,    87,   892,   310,   334,   891,    -1,    13,
      87,   892,   461,    -1,   709,   710,    -1,    -1,    61,   193,
     706,   902,    -1,   110,    87,   892,    -1,   110,    87,   152,
     123,   892,    -1,    70,   108,   604,   714,   806,   494,    -1,
      13,   108,   604,   471,    -1,    13,   108,   604,   110,   225,
     230,    -1,    13,   108,   604,   310,   225,   230,    -1,    13,
     108,   604,     7,   501,    -1,    13,   108,   604,   110,    62,
     891,   472,    -1,    20,    -1,    -1,    13,   338,   301,   102,
     604,   578,    -1,    13,   338,   301,    60,   604,     7,   202,
     133,   890,   379,   603,    -1,    13,   338,   301,    60,   604,
      13,   202,   133,   890,   379,   603,    -1,    13,   338,   301,
      60,   604,    13,   202,   284,   604,   379,   604,    -1,    13,
     338,   301,    60,   604,    13,   202,   133,   890,   284,   604,
     379,   604,    -1,    13,   338,   301,    60,   604,   110,   202,
     133,   890,    -1,    13,   338,   301,    60,   604,   110,   202,
     152,   123,   133,   890,    -1,    70,   590,    67,   604,   133,
     900,   342,   900,   138,   604,    -1,    52,   723,   889,   719,
      -1,    52,   723,    -1,    52,   723,   895,   240,   889,    -1,
     362,   895,    -1,    -1,   363,   724,   725,   723,    -1,   363,
     724,   725,   723,   889,    -1,   363,   724,   725,   723,   721,
      -1,   722,   723,    -1,   722,   723,   889,   726,    -1,    16,
      -1,    15,    -1,   371,    -1,    -1,   139,    -1,    -1,   137,
      -1,    -1,   420,   890,   421,    -1,    -1,   124,   729,   723,
     728,    -1,   757,    -1,   736,    -1,   747,    -1,   741,    -1,
     754,    -1,   516,    -1,   733,    -1,   722,    -1,    -1,   264,
     891,   731,    20,   732,    -1,   420,   859,   421,    -1,    -1,
     757,    -1,   736,    -1,   747,    -1,   741,    -1,   122,   891,
     734,    -1,    70,   489,   333,   517,    20,   122,   891,   734,
      -1,   420,   858,   421,    -1,    -1,    89,   891,    -1,    89,
     264,   891,    -1,    89,    11,    -1,    89,   264,    11,    -1,
     169,   175,   889,   737,   740,    -1,   757,    -1,   420,   738,
     421,   757,    -1,    93,   367,    -1,   739,    -1,   738,   425,
     739,    -1,   904,   880,    -1,   289,   885,    -1,    -1,    98,
     138,   800,   742,   803,   740,    -1,   362,   791,    -1,    -1,
     200,   767,   799,   744,   746,    -1,   157,   745,   207,    -1,
      -1,     5,   312,    -1,   295,   312,    -1,   295,   121,    -1,
     312,   360,   121,    -1,   312,    -1,   312,   295,   121,    -1,
     121,    -1,     5,   121,    -1,   229,    -1,    -1,   360,   800,
     310,   748,   790,   803,   740,    -1,   749,    -1,   748,   425,
     749,    -1,   750,    -1,   751,    -1,   752,   407,   882,    -1,
     420,   753,   421,   407,   884,    -1,   904,   880,    -1,   752,
      -1,   753,   425,   752,    -1,    92,   891,   755,    84,   756,
     133,   757,    -1,    -1,   755,   217,   300,    -1,   755,   300,
      -1,   755,    32,    -1,   755,   168,    -1,    -1,   379,   149,
      -1,   380,   149,    -1,   759,    -1,   758,    -1,   420,   759,
     421,    -1,   420,   758,   421,    -1,   761,    -1,   760,   771,
      -1,   760,   770,   784,   775,    -1,   760,   770,   774,   785,
      -1,   762,   760,    -1,   762,   760,   771,    -1,   762,   760,
     770,   784,   775,    -1,   762,   760,   770,   774,   785,    -1,
     761,    -1,   758,    -1,   304,   769,   885,   765,   790,   802,
     782,   783,   841,    -1,   789,    -1,   333,   798,    -1,   760,
     355,   768,   760,    -1,   760,   173,   768,   760,    -1,   760,
     119,   768,   760,    -1,   379,   763,    -1,   379,   277,   763,
      -1,   764,    -1,   763,   425,   764,    -1,   891,   726,    20,
     758,    -1,   175,   766,    -1,    -1,   337,   767,   889,    -1,
     335,   767,   889,    -1,   196,   337,   767,   889,    -1,   196,
     335,   767,   889,    -1,   141,   337,   767,   889,    -1,   141,
     335,   767,   889,    -1,   333,   889,    -1,   889,    -1,   333,
      -1,    -1,    11,    -1,   105,    -1,    -1,   105,    -1,   105,
     240,   420,   858,   421,    -1,    11,    -1,    -1,   771,    -1,
      -1,   246,    36,   772,    -1,   773,    -1,   772,   425,   773,
      -1,   830,   362,   856,   636,    -1,   830,   635,   636,    -1,
     193,   776,   237,   778,    -1,   237,   778,   193,   776,    -1,
     193,   776,    -1,   237,   778,    -1,   193,   776,   425,   778,
      -1,   237,   779,   780,    -1,   129,   781,   777,   780,   241,
      -1,   237,   779,   780,   129,   781,   777,   780,   241,    -1,
     774,    -1,    -1,   830,    -1,    11,    -1,   902,    -1,   420,
     830,   421,    -1,    -1,   830,    -1,   832,    -1,   295,    -1,
     296,    -1,   130,    -1,   216,    -1,   145,    36,   858,    -1,
      -1,   147,   830,    -1,    -1,   786,    -1,   133,   273,   241,
      -1,   784,    -1,    -1,   787,    -1,   786,   787,    -1,   133,
     360,   788,   746,    -1,   133,   312,   788,   746,    -1,   235,
     888,    -1,    -1,   367,   884,    -1,   789,   425,   884,    -1,
     138,   791,    -1,    -1,   792,    -1,   791,   425,   792,    -1,
     798,    -1,   798,   794,    -1,   801,    -1,   801,   794,    -1,
     801,    20,   420,   804,   421,    -1,   801,    20,   904,   420,
     804,   421,    -1,   801,   904,   420,   804,   421,    -1,   758,
      -1,   758,   794,    -1,   793,    -1,   420,   793,   421,   794,
      -1,   420,   793,   421,    -1,   792,    74,   180,   792,    -1,
     792,   795,   180,   792,   797,    -1,   792,   180,   792,   797,
      -1,   792,   213,   795,   180,   792,    -1,   792,   213,   180,
     792,    -1,    20,   904,   420,   890,   421,    -1,    20,   904,
      -1,   904,   420,   890,   421,    -1,   904,    -1,   139,   796,
      -1,   190,   796,    -1,   292,   796,    -1,   165,    -1,   248,
      -1,    -1,   362,   420,   890,   421,    -1,   240,   830,    -1,
     889,    -1,   889,   413,    -1,   241,   889,    -1,   241,   420,
     889,   421,    -1,   798,    -1,   799,   425,   798,    -1,   798,
      -1,   798,   904,    -1,   798,    20,   904,    -1,   833,    -1,
     376,   830,    -1,    -1,   376,   830,    -1,   376,    76,   235,
     891,    -1,   376,    76,   235,   406,    -1,    -1,   805,    -1,
     804,   425,   805,    -1,   904,   806,    -1,   808,   807,    -1,
     311,   808,   807,    -1,   808,    19,   418,   899,   419,    -1,
     311,   808,    19,   418,   899,   419,    -1,   808,    19,    -1,
     311,   808,    19,    -1,   807,   418,   419,    -1,   807,   418,
     899,   419,    -1,    -1,   810,    -1,   812,    -1,   814,    -1,
     818,    -1,   825,    -1,   826,   828,    -1,   826,   420,   899,
     421,   828,    -1,   812,    -1,   815,    -1,   819,    -1,   825,
      -1,   905,   811,    -1,   905,   605,   811,    -1,   420,   858,
     421,    -1,    -1,   171,    -1,   172,    -1,   316,    -1,    31,
      -1,   274,    -1,   131,   813,    -1,   109,   262,    -1,    91,
     811,    -1,    90,   811,    -1,   233,   811,    -1,    34,    -1,
     420,   899,   421,    -1,    -1,   816,    -1,   817,    -1,   816,
      -1,   817,    -1,    33,   823,   420,   858,   421,    -1,    33,
     823,    -1,   820,    -1,   821,    -1,   820,    -1,   821,    -1,
     822,   420,   899,   421,   824,    -1,   822,   824,    -1,    46,
     823,    -1,    45,   823,    -1,   368,    -1,   212,    46,   823,
      -1,   212,    45,   823,    -1,   214,   823,    -1,   370,    -1,
      -1,    46,   310,   904,    -1,    -1,   341,   420,   899,   421,
     827,    -1,   341,   827,    -1,   340,   420,   899,   421,   827,
      -1,   340,   827,    -1,   174,    -1,   398,   395,    -1,   380,
     340,   395,    -1,    -1,   393,    -1,   208,    -1,    88,    -1,
     150,    -1,   205,    -1,   829,    -1,   393,   342,   208,    -1,
      88,   342,   150,    -1,    88,   342,   205,    -1,    88,   342,
     829,    -1,   150,   342,   205,    -1,   150,   342,   829,    -1,
     205,   342,   829,    -1,    -1,   302,    -1,   302,   420,   899,
     421,    -1,   832,    -1,   830,   422,   806,    -1,   830,    25,
     340,   395,   830,    -1,   411,   830,    -1,   412,   830,    -1,
     830,   411,   830,    -1,   830,   412,   830,    -1,   830,   413,
     830,    -1,   830,   414,   830,    -1,   830,   415,   830,    -1,
     830,   416,   830,    -1,   830,   408,   830,    -1,   830,   409,
     830,    -1,   830,   407,   830,    -1,   830,   855,   830,    -1,
     855,   830,    -1,   830,   855,    -1,   830,    17,   830,    -1,
     830,   245,   830,    -1,   225,   830,    -1,   830,   192,   830,
      -1,   830,   192,   830,   118,   830,    -1,   830,   225,   192,
     830,    -1,   830,   225,   192,   830,   118,   830,    -1,   830,
     153,   830,    -1,   830,   153,   830,   118,   830,    -1,   830,
     225,   153,   830,    -1,   830,   225,   153,   830,   118,   830,
      -1,   830,   314,   342,   830,    -1,   830,   314,   342,   830,
     118,   830,    -1,   830,   225,   314,   342,   830,    -1,   830,
     225,   314,   342,   830,   118,   830,    -1,   830,   177,   230,
      -1,   830,   178,    -1,   830,   177,   225,   230,    -1,   830,
     228,    -1,   851,   250,   851,    -1,   830,   177,   348,    -1,
     830,   177,   225,   348,    -1,   830,   177,   127,    -1,   830,
     177,   225,   127,    -1,   830,   177,   357,    -1,   830,   177,
     225,   357,    -1,   830,   177,   105,   138,   830,    -1,   830,
     177,   225,   105,   138,   830,    -1,   830,   177,   235,   420,
     859,   421,    -1,   830,   177,   225,   235,   420,   859,   421,
      -1,   830,    30,   881,   831,    17,   831,    -1,   830,   225,
      30,   881,   831,    17,   831,    -1,   830,    30,   330,   831,
      17,   831,    -1,   830,   225,    30,   330,   831,    17,   831,
      -1,   830,   157,   871,    -1,   830,   225,   157,   871,    -1,
     830,   857,   852,   758,    -1,   830,   857,   852,   420,   830,
     421,    -1,   356,   758,    -1,   830,   177,   107,    -1,   830,
     177,   225,   107,    -1,   832,    -1,   831,   422,   806,    -1,
     411,   831,    -1,   412,   831,    -1,   831,   411,   831,    -1,
     831,   412,   831,    -1,   831,   413,   831,    -1,   831,   414,
     831,    -1,   831,   415,   831,    -1,   831,   416,   831,    -1,
     831,   408,   831,    -1,   831,   409,   831,    -1,   831,   407,
     831,    -1,   831,   855,   831,    -1,   855,   831,    -1,   831,
     855,    -1,   831,   177,   105,   138,   831,    -1,   831,   177,
     225,   105,   138,   831,    -1,   831,   177,   235,   420,   859,
     421,    -1,   831,   177,   225,   235,   420,   859,   421,    -1,
     831,   177,   107,    -1,   831,   177,   225,   107,    -1,   877,
      -1,   898,    -1,   406,   880,    -1,   420,   830,   421,   880,
      -1,   872,    -1,   833,    -1,   758,    -1,   123,   758,    -1,
      19,   758,    -1,    19,   860,    -1,   851,    -1,   897,   420,
     421,   844,    -1,   897,   420,   858,   421,   844,    -1,   897,
     420,   369,   830,   421,   844,    -1,   897,   420,   858,   425,
     369,   830,   421,   844,    -1,   897,   420,    11,   858,   421,
     844,    -1,   897,   420,   105,   858,   421,   844,    -1,   897,
     420,   413,   421,   844,    -1,    78,    -1,    81,    -1,    81,
     420,   899,   421,    -1,    82,    -1,    82,   420,   899,   421,
      -1,   197,    -1,   197,   420,   899,   421,    -1,   198,    -1,
     198,   420,   899,   421,    -1,    79,    -1,    83,    -1,   309,
      -1,   361,    -1,    77,    -1,    80,    -1,    42,   420,   830,
      20,   806,   421,    -1,   126,   420,   862,   421,    -1,   251,
     420,   864,   421,    -1,   260,   420,   866,   421,    -1,   328,
     420,   867,   421,    -1,   345,   420,   830,    20,   806,   421,
      -1,   347,   420,    35,   870,   421,    -1,   347,   420,   188,
     870,   421,    -1,   347,   420,   343,   870,   421,    -1,   347,
     420,   870,   421,    -1,   231,   420,   830,   425,   830,   421,
      -1,    53,   420,   858,   421,    -1,   144,   420,   858,   421,
      -1,   189,   420,   858,   421,    -1,   386,   420,   858,   421,
      -1,   387,   420,   210,   906,   421,    -1,   387,   420,   210,
     906,   425,   836,   421,    -1,   387,   420,   210,   906,   425,
     858,   421,    -1,   387,   420,   210,   906,   425,   836,   425,
     858,   421,    -1,   388,   420,   837,   421,    -1,   389,   420,
     839,   830,   840,   421,    -1,   390,   420,   210,   906,   421,
      -1,   390,   420,   210,   906,   425,   830,   421,    -1,   391,
     420,   830,   425,   834,   835,   421,    -1,   392,   420,   839,
     830,    20,   808,   421,    -1,   372,   830,    -1,   372,   217,
     366,    -1,   425,   319,   394,    -1,   425,   319,   217,    -1,
     425,   319,   217,   366,    -1,    -1,   385,   420,   837,   421,
      -1,   838,    -1,   837,   425,   838,    -1,   830,    20,   906,
      -1,   830,    -1,   107,    -1,    64,    -1,   263,   377,    -1,
     327,   377,    -1,    -1,   378,   842,    -1,    -1,   843,    -1,
     842,   425,   843,    -1,   904,    20,   845,    -1,   249,   845,
      -1,   249,   904,    -1,    -1,   420,   846,   847,   770,   848,
     421,    -1,   904,    -1,    -1,   256,    36,   858,    -1,    -1,
     272,   849,    -1,   296,   849,    -1,    -1,   850,    -1,    30,
     850,    17,   850,    -1,   352,   261,    -1,   352,   132,    -1,
      76,   295,    -1,   295,   420,   858,   421,    -1,   295,   420,
     421,    -1,   420,   858,   425,   830,   421,    -1,    18,    -1,
     317,    -1,    11,    -1,   404,    -1,   854,    -1,   411,    -1,
     412,    -1,   413,    -1,   414,    -1,   415,    -1,   416,    -1,
     408,    -1,   409,    -1,   407,    -1,   404,    -1,   242,   420,
     663,   421,    -1,   853,    -1,   242,   420,   663,   421,    -1,
     853,    -1,   242,   420,   663,   421,    -1,   192,    -1,   225,
     192,    -1,   153,    -1,   225,   153,    -1,   830,    -1,   858,
     425,   830,    -1,   806,    -1,   859,   425,   806,    -1,   418,
     858,   419,    -1,   418,   861,   419,    -1,   418,   419,    -1,
     860,    -1,   861,   425,   860,    -1,   863,   138,   830,    -1,
      -1,   399,    -1,   393,    -1,   208,    -1,    88,    -1,   150,
      -1,   205,    -1,   302,    -1,   900,    -1,   830,   865,   868,
     869,    -1,   830,   865,   868,    -1,   258,   830,    -1,   831,
     157,   831,    -1,    -1,   830,   868,   869,    -1,   830,   869,
     868,    -1,   830,   868,    -1,   830,   869,    -1,   858,    -1,
      -1,   138,   830,    -1,   133,   830,    -1,   830,   138,   858,
      -1,   138,   858,    -1,   858,    -1,   758,    -1,   420,   858,
     421,    -1,    41,   876,   873,   875,   116,    -1,   874,    -1,
     873,   874,    -1,   375,   830,   339,   830,    -1,   112,   830,
      -1,    -1,   830,    -1,    -1,   887,    -1,   887,   879,    -1,
     423,   894,    -1,   423,   413,    -1,   418,   830,   419,    -1,
     418,   830,   426,   830,   419,    -1,   878,    -1,   879,   878,
      -1,    -1,   880,   878,    -1,    24,    -1,    -1,   830,    -1,
      93,    -1,   882,    -1,   883,   425,   882,    -1,   420,   883,
     421,    -1,   886,    -1,   885,   425,   886,    -1,   830,    20,
     906,    -1,   830,   399,    -1,   830,    -1,   413,    -1,   911,
      -1,   904,    -1,   889,    -1,   888,   425,   889,    -1,   887,
      -1,   887,   879,    -1,   891,    -1,   890,   425,   891,    -1,
     904,    -1,   904,    -1,   904,    -1,   906,    -1,   904,    -1,
     900,    -1,   905,    -1,   887,   879,    -1,   899,    -1,   400,
      -1,   900,    -1,   402,    -1,   403,    -1,   897,   900,    -1,
     897,   420,   858,   421,   900,    -1,   809,   900,    -1,   826,
     900,   828,    -1,   826,   420,   899,   421,   900,   828,    -1,
     348,    -1,   127,    -1,   230,    -1,   405,    -1,   401,    -1,
     904,    -1,   899,    -1,   411,   899,    -1,   412,   899,    -1,
     899,    -1,   903,   425,   899,    -1,   399,    -1,   907,    -1,
     908,    -1,   399,    -1,   907,    -1,   909,    -1,   399,    -1,
     907,    -1,   908,    -1,   909,    -1,   910,    -1,     3,    -1,
       4,    -1,     5,    -1,     6,    -1,     7,    -1,     8,    -1,
       9,    -1,    10,    -1,    12,    -1,    13,    -1,    14,    -1,
      22,    -1,    23,    -1,    25,    -1,    27,    -1,    28,    -1,
      29,    -1,    36,    -1,    37,    -1,    38,    -1,    39,    -1,
      40,    -1,    43,    -1,    44,    -1,    47,    -1,    49,    -1,
      50,    -1,    51,    -1,    52,    -1,    56,    -1,    57,    -1,
      58,    -1,    59,    -1,    60,    -1,    61,    -1,    63,    -1,
      64,    -1,    65,    -1,    66,    -1,    67,    -1,    68,    -1,
      69,    -1,    71,    -1,    72,    -1,    73,    -1,    75,    -1,
      76,    -1,    84,    -1,    85,    -1,    86,    -1,    87,    -1,
      88,    -1,    89,    -1,    92,    -1,    94,    -1,    96,    -1,
      97,    -1,    98,    -1,    99,    -1,   100,    -1,   102,    -1,
     103,    -1,   104,    -1,   107,    -1,   108,    -1,   109,    -1,
     110,    -1,   111,    -1,   113,    -1,   114,    -1,   115,    -1,
     117,    -1,   118,    -1,   120,    -1,   121,    -1,   122,    -1,
     124,    -1,   125,    -1,   128,    -1,   130,    -1,   132,    -1,
     134,    -1,   136,    -1,   140,    -1,   141,    -1,   143,    -1,
     146,    -1,   148,    -1,   149,    -1,   150,    -1,   151,    -1,
     152,    -1,   154,    -1,   155,    -1,   156,    -1,   158,    -1,
     159,    -1,   160,    -1,   161,    -1,   162,    -1,   163,    -1,
     167,    -1,   168,    -1,   169,    -1,   170,    -1,   176,    -1,
     179,    -1,   181,    -1,   182,    -1,   183,    -1,   184,    -1,
     185,    -1,   186,    -1,   187,    -1,   191,    -1,   194,    -1,
     195,    -1,   196,    -1,   199,    -1,   200,    -1,   201,    -1,
     202,    -1,   203,    -1,   204,    -1,   205,    -1,   206,    -1,
     207,    -1,   208,    -1,   209,    -1,   210,    -1,   211,    -1,
     216,    -1,   217,    -1,   218,    -1,   219,    -1,   220,    -1,
     221,    -1,   222,    -1,   224,    -1,   226,    -1,   227,    -1,
     229,    -1,   232,    -1,   234,    -1,   235,    -1,   238,    -1,
     242,    -1,   243,    -1,   244,    -1,   252,    -1,   253,    -1,
     254,    -1,   255,    -1,   256,    -1,   257,    -1,   259,    -1,
     261,    -1,   264,    -1,   265,    -1,   263,    -1,   267,    -1,
     268,    -1,   269,    -1,   270,    -1,   271,    -1,   272,    -1,
     273,    -1,   275,    -1,   276,    -1,   277,    -1,   279,    -1,
     280,    -1,   281,    -1,   282,    -1,   283,    -1,   284,    -1,
     285,    -1,   286,    -1,   287,    -1,   288,    -1,   290,    -1,
     291,    -1,   293,    -1,   294,    -1,   296,    -1,   297,    -1,
     298,    -1,   299,    -1,   300,    -1,   301,    -1,   302,    -1,
     303,    -1,   305,    -1,   306,    -1,   307,    -1,   308,    -1,
     310,    -1,   312,    -1,   313,    -1,   315,    -1,   318,    -1,
     319,    -1,   320,    -1,   321,    -1,   322,    -1,   323,    -1,
     324,    -1,   325,    -1,   326,    -1,   327,    -1,   329,    -1,
     331,    -1,   332,    -1,   334,    -1,   335,    -1,   336,    -1,
     337,    -1,   338,    -1,   344,    -1,   346,    -1,   349,    -1,
     350,    -1,   351,    -1,   352,    -1,   353,    -1,   354,    -1,
     357,    -1,   358,    -1,   359,    -1,   360,    -1,   363,    -1,
     364,    -1,   365,    -1,   366,    -1,   370,    -1,   372,    -1,
     373,    -1,   374,    -1,   377,    -1,   380,    -1,   381,    -1,
     382,    -1,   383,    -1,   384,    -1,   393,    -1,   394,    -1,
     395,    -1,    31,    -1,    33,    -1,    34,    -1,    45,    -1,
      46,    -1,    53,    -1,    90,    -1,    91,    -1,   123,    -1,
     126,    -1,   131,    -1,   144,    -1,   166,    -1,   171,    -1,
     172,    -1,   174,    -1,   189,    -1,   212,    -1,   214,    -1,
     223,    -1,   231,    -1,   233,    -1,   247,    -1,   251,    -1,
     260,    -1,   262,    -1,   274,    -1,   295,    -1,   311,    -1,
     316,    -1,   328,    -1,   340,    -1,   341,    -1,   345,    -1,
     347,    -1,   367,    -1,   368,    -1,   385,    -1,   386,    -1,
     387,    -1,   388,    -1,   389,    -1,   390,    -1,   391,    -1,
     392,    -1,    26,    -1,    30,    -1,    32,    -1,    74,    -1,
      80,    -1,   137,    -1,   139,    -1,   153,    -1,   165,    -1,
     177,    -1,   178,    -1,   180,    -1,   190,    -1,   192,    -1,
     213,    -1,   228,    -1,   248,    -1,   249,    -1,   250,    -1,
     292,    -1,   314,    -1,   371,    -1,    11,    -1,    15,    -1,
      16,    -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,
      21,    -1,    24,    -1,    35,    -1,    41,    -1,    42,    -1,
      48,    -1,    54,    -1,    55,    -1,    62,    -1,    70,    -1,
      77,    -1,    78,    -1,    79,    -1,    81,    -1,    82,    -1,
      83,    -1,    93,    -1,    95,    -1,   101,    -1,   105,    -1,
     106,    -1,   112,    -1,   116,    -1,   119,    -1,   127,    -1,
     129,    -1,   133,    -1,   135,    -1,   138,    -1,   142,    -1,
     145,    -1,   147,    -1,   157,    -1,   164,    -1,   173,    -1,
     175,    -1,   188,    -1,   193,    -1,   197,    -1,   198,    -1,
     215,    -1,   225,    -1,   230,    -1,   236,    -1,   237,    -1,
     239,    -1,   240,    -1,   241,    -1,   245,    -1,   246,    -1,
     258,    -1,   266,    -1,   278,    -1,   289,    -1,   304,    -1,
     309,    -1,   317,    -1,   330,    -1,   333,    -1,   339,    -1,
     342,    -1,   343,    -1,   348,    -1,   355,    -1,   356,    -1,
     361,    -1,   362,    -1,   369,    -1,   375,    -1,   376,    -1,
     378,    -1,   379,    -1,   239,    -1,   215,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   588,   588,   592,   598,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   709,   719,   730,   731,
     740,   741,   745,   750,   754,   759,   764,   768,   772,   776,
     780,   784,   788,   792,   796,   801,   805,   809,   813,   817,
     822,   827,   831,   835,   839,   843,   857,   875,   886,   903,
     915,   935,   942,   961,   968,   985,  1003,  1014,  1015,  1027,
    1034,  1051,  1064,  1077,  1078,  1082,  1083,  1091,  1092,  1093,
    1094,  1095,  1096,  1110,  1116,  1122,  1131,  1139,  1147,  1154,
    1161,  1169,  1180,  1188,  1196,  1204,  1212,  1223,  1231,  1239,
    1246,  1256,  1257,  1264,  1265,  1268,  1270,  1272,  1276,  1277,
    1278,  1279,  1283,  1284,  1285,  1286,  1298,  1302,  1306,  1321,
    1344,  1345,  1346,  1350,  1351,  1352,  1356,  1357,  1361,  1368,
    1375,  1382,  1389,  1399,  1400,  1405,  1411,  1417,  1423,  1429,
    1439,  1449,  1450,  1454,  1455,  1463,  1478,  1484,  1490,  1496,
    1514,  1522,  1530,  1538,  1549,  1550,  1555,  1563,  1572,  1580,
    1588,  1597,  1606,  1618,  1628,  1636,  1645,  1652,  1659,  1667,
    1675,  1683,  1691,  1699,  1706,  1713,  1721,  1728,  1735,  1743,
    1751,  1759,  1767,  1775,  1783,  1791,  1799,  1807,  1817,  1818,
    1822,  1823,  1824,  1828,  1829,  1833,  1836,  1837,  1841,  1842,
    1847,  1851,  1855,  1860,  1875,  1881,  1904,  1926,  1941,  1942,
    1951,  1952,  1953,  1959,  1960,  1965,  1969,  1973,  1977,  1981,
    1985,  1989,  1993,  1997,  2001,  2010,  2014,  2018,  2022,  2027,
    2031,  2035,  2036,  2047,  2062,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2099,  2100,  2104,  2108,  2115,  2116,  2117,  2120,
    2133,  2134,  2138,  2159,  2160,  2179,  2190,  2201,  2213,  2225,
    2236,  2247,  2276,  2282,  2288,  2294,  2312,  2322,  2323,  2327,
    2328,  2329,  2330,  2331,  2332,  2341,  2362,  2366,  2376,  2388,
    2400,  2418,  2419,  2423,  2424,  2427,  2433,  2437,  2445,  2450,
    2462,  2464,  2466,  2468,  2471,  2474,  2477,  2481,  2482,  2483,
    2484,  2485,  2488,  2489,  2494,  2495,  2496,  2497,  2500,  2501,
    2502,  2503,  2506,  2507,  2510,  2511,  2521,  2546,  2558,  2559,
    2563,  2564,  2568,  2584,  2585,  2586,  2599,  2611,  2620,  2621,
    2624,  2625,  2628,  2632,  2636,  2640,  2644,  2648,  2652,  2656,
    2660,  2664,  2668,  2672,  2678,  2679,  2683,  2684,  2689,  2701,
    2711,  2725,  2726,  2734,  2735,  2739,  2740,  2744,  2745,  2749,
    2750,  2754,  2762,  2773,  2774,  2784,  2794,  2795,  2808,  2815,
    2831,  2848,  2856,  2873,  2882,  2890,  2901,  2902,  2906,  2910,
    2918,  2922,  2926,  2933,  2937,  2942,  2947,  2954,  2961,  2966,
    2976,  2990,  2991,  2996,  2997,  3001,  3002,  3012,  3020,  3037,
    3046,  3054,  3070,  3082,  3083,  3084,  3094,  3102,  3119,  3138,
    3156,  3179,  3180,  3184,  3186,  3195,  3196,  3197,  3198,  3202,
    3207,  3217,  3218,  3222,  3223,  3227,  3228,  3229,  3233,  3239,
    3240,  3241,  3242,  3243,  3247,  3248,  3252,  3254,  3263,  3270,
    3280,  3284,  3285,  3289,  3290,  3295,  3305,  3327,  3346,  3369,
    3379,  3390,  3400,  3410,  3421,  3457,  3464,  3473,  3482,  3491,
    3502,  3505,  3506,  3509,  3513,  3520,  3521,  3522,  3523,  3524,
    3527,  3528,  3531,  3534,  3535,  3543,  3549,  3551,  3568,  3583,
    3584,  3588,  3597,  3606,  3615,  3625,  3634,  3635,  3638,  3639,
    3642,  3656,  3661,  3671,  3680,  3692,  3693,  3697,  3705,  3717,
    3726,  3738,  3747,  3768,  3778,  3796,  3805,  3817,  3818,  3819,
    3820,  3821,  3822,  3823,  3824,  3825,  3826,  3827,  3828,  3832,
    3833,  3836,  3837,  3840,  3842,  3855,  3866,  3867,  3868,  3893,
    3902,  3911,  3920,  3929,  3938,  3947,  3957,  3966,  3975,  3984,
    3993,  4002,  4011,  4019,  4027,  4035,  4046,  4047,  4048,  4049,
    4050,  4051,  4052,  4053,  4054,  4055,  4056,  4057,  4061,  4062,
    4072,  4079,  4088,  4095,  4108,  4114,  4121,  4128,  4135,  4142,
    4149,  4156,  4163,  4170,  4177,  4184,  4191,  4198,  4205,  4214,
    4215,  4225,  4240,  4253,  4278,  4280,  4282,  4284,  4291,  4300,
    4301,  4304,  4311,  4318,  4325,  4339,  4346,  4353,  4360,  4367,
    4374,  4381,  4388,  4395,  4402,  4409,  4420,  4421,  4424,  4434,
    4448,  4449,  4453,  4454,  4459,  4475,  4488,  4498,  4510,  4511,
    4514,  4515,  4530,  4546,  4565,  4566,  4570,  4571,  4574,  4575,
    4583,  4592,  4601,  4612,  4613,  4614,  4617,  4618,  4619,  4622,
    4623,  4624,  4640,  4652,  4665,  4680,  4681,  4684,  4685,  4689,
    4690,  4698,  4699,  4703,  4704,  4719,  4728,  4737,  4746,  4755,
    4767,  4768,  4769,  4770,  4771,  4777,  4781,  4796,  4797,  4803,
    4813,  4817,  4822,  4832,  4833,  4840,  4844,  4848,  4852,  4856,
    4860,  4864,  4868,  4872,  4876,  4880,  4884,  4888,  4896,  4900,
    4904,  4908,  4912,  4918,  4919,  4926,  4927,  4930,  4942,  4946,
    4961,  4972,  4973,  4978,  4979,  4994,  5004,  5017,  5027,  5040,
    5050,  5063,  5071,  5073,  5075,  5080,  5082,  5093,  5104,  5115,
    5128,  5129,  5130,  5134,  5145,  5146,  5160,  5168,  5178,  5191,
    5192,  5195,  5196,  5206,  5215,  5223,  5231,  5240,  5248,  5256,
    5265,  5274,  5282,  5291,  5300,  5309,  5318,  5327,  5336,  5344,
    5352,  5360,  5368,  5376,  5384,  5392,  5402,  5403,  5406,  5407,
    5417,  5426,  5434,  5443,  5451,  5459,  5467,  5483,  5492,  5500,
    5508,  5516,  5525,  5533,  5541,  5550,  5559,  5568,  5576,  5584,
    5592,  5600,  5608,  5616,  5632,  5640,  5648,  5656,  5665,  5673,
    5682,  5692,  5693,  5696,  5697,  5700,  5702,  5706,  5707,  5710,
    5716,  5729,  5728,  5747,  5748,  5749,  5754,  5760,  5769,  5770,
    5771,  5772,  5773,  5777,  5778,  5781,  5782,  5783,  5784,  5788,
    5789,  5790,  5795,  5805,  5826,  5834,  5843,  5849,  5868,  5875,
    5882,  5889,  5896,  5903,  5910,  5918,  5926,  5934,  5942,  5950,
    5957,  5964,  5973,  5974,  5975,  5979,  5982,  5985,  5992,  5994,
    5996,  6001,  6003,  6015,  6026,  6040,  6046,  6052,  6058,  6068,
    6084,  6094,  6095,  6099,  6103,  6107,  6111,  6115,  6119,  6123,
    6127,  6131,  6135,  6139,  6143,  6147,  6151,  6155,  6159,  6163,
    6173,  6174,  6185,  6192,  6203,  6214,  6215,  6219,  6233,  6240,
    6257,  6269,  6278,  6286,  6294,  6303,  6314,  6315,  6326,  6336,
    6346,  6356,  6366,  6376,  6384,  6405,  6428,  6436,  6445,  6456,
    6457,  6469,  6482,  6495,  6508,  6521,  6537,  6538,  6542,  6543,
    6546,  6547,  6550,  6551,  6555,  6556,  6567,  6578,  6579,  6580,
    6581,  6582,  6583,  6584,  6588,  6589,  6599,  6609,  6610,  6614,
    6615,  6616,  6617,  6627,  6635,  6652,  6653,  6663,  6669,  6675,
    6681,  6697,  6706,  6712,  6718,  6727,  6729,  6734,  6745,  6746,
    6757,  6770,  6771,  6782,  6793,  6794,  6797,  6798,  6799,  6800,
    6801,  6802,  6803,  6804,  6807,  6808,  6819,  6836,  6837,  6841,
    6842,  6846,  6854,  6882,  6893,  6894,  6904,  6915,  6916,  6917,
    6918,  6919,  6922,  6923,  6924,  6972,  6973,  6977,  6978,  6992,
    6993,  6999,  7006,  7013,  7020,  7027,  7034,  7044,  7045,  7072,
    7087,  7088,  7107,  7111,  7115,  7130,  7137,  7147,  7148,  7151,
    7163,  7173,  7181,  7186,  7191,  7196,  7201,  7206,  7211,  7216,
    7223,  7224,  7227,  7228,  7229,  7236,  7237,  7238,  7239,  7243,
    7244,  7248,  7252,  7253,  7256,  7265,  7278,  7280,  7282,  7284,
    7286,  7296,  7298,  7300,  7305,  7307,  7311,  7312,  7325,  7326,
    7327,  7331,  7339,  7344,  7345,  7350,  7351,  7355,  7356,  7360,
    7361,  7365,  7366,  7370,  7371,  7375,  7376,  7380,  7388,  7399,
    7400,  7405,  7411,  7429,  7430,  7434,  7435,  7445,  7449,  7454,
    7461,  7469,  7476,  7486,  7496,  7524,  7531,  7535,  7561,  7565,
    7577,  7590,  7604,  7615,  7630,  7636,  7641,  7647,  7654,  7655,
    7656,  7657,  7661,  7662,  7674,  7675,  7680,  7687,  7694,  7701,
    7712,  7713,  7726,  7730,  7737,  7747,  7752,  7753,  7758,  7759,
    7767,  7775,  7780,  7784,  7790,  7811,  7816,  7823,  7828,  7834,
    7839,  7848,  7850,  7853,  7857,  7858,  7859,  7860,  7861,  7862,
    7867,  7897,  7898,  7899,  7900,  7911,  7917,  7925,  7926,  7932,
    7937,  7942,  7947,  7952,  7957,  7962,  7967,  7973,  7979,  7985,
    7992,  8014,  8023,  8027,  8035,  8039,  8047,  8059,  8080,  8084,
    8090,  8094,  8107,  8126,  8149,  8151,  8153,  8155,  8157,  8159,
    8164,  8165,  8169,  8170,  8177,  8186,  8194,  8203,  8214,  8222,
    8223,  8224,  8228,  8230,  8232,  8234,  8236,  8238,  8240,  8245,
    8250,  8256,  8264,  8269,  8276,  8283,  8287,  8291,  8321,  8322,
    8324,  8345,  8347,  8349,  8351,  8353,  8355,  8357,  8359,  8361,
    8363,  8365,  8368,  8370,  8372,  8375,  8377,  8379,  8382,  8384,
    8396,  8398,  8410,  8412,  8424,  8426,  8439,  8451,  8463,  8475,
    8497,  8504,  8511,  8518,  8525,  8529,  8536,  8543,  8550,  8557,
    8564,  8571,  8575,  8583,  8587,  8596,  8603,  8610,  8623,  8636,
    8655,  8676,  8686,  8693,  8709,  8714,  8732,  8734,  8736,  8738,
    8740,  8742,  8744,  8746,  8748,  8750,  8752,  8754,  8756,  8758,
    8760,  8762,  8764,  8768,  8773,  8777,  8781,  8786,  8803,  8804,
    8805,  8820,  8832,  8834,  8836,  8846,  8856,  8866,  8874,  8892,
    8904,  8916,  8928,  8940,  8956,  8968,  8990,  9011,  9021,  9034,
    9050,  9063,  9073,  9086,  9096,  9109,  9121,  9133,  9145,  9157,
    9169,  9181,  9183,  9195,  9212,  9225,  9240,  9261,  9276,  9288,
    9300,  9312,  9316,  9323,  9331,  9339,  9343,  9347,  9351,  9355,
    9359,  9363,  9372,  9376,  9380,  9385,  9399,  9401,  9405,  9407,
    9409,  9412,  9415,  9418,  9419,  9422,  9430,  9440,  9441,  9444,
    9445,  9446,  9453,  9454,  9458,  9459,  9464,  9472,  9474,  9486,
    9489,  9513,  9514,  9517,  9518,  9527,  9531,  9536,  9539,  9554,
    9583,  9587,  9591,  9608,  9609,  9610,  9613,  9614,  9615,  9618,
    9619,  9622,  9623,  9624,  9625,  9626,  9627,  9628,  9629,  9630,
    9633,  9635,  9640,  9642,  9647,  9649,  9651,  9653,  9655,  9657,
    9669,  9673,  9679,  9680,  9683,  9687,  9691,  9697,  9698,  9703,
    9707,  9714,  9715,  9716,  9717,  9718,  9719,  9720,  9721,  9730,
    9734,  9741,  9748,  9749,  9765,  9769,  9774,  9778,  9793,  9798,
    9802,  9805,  9808,  9809,  9810,  9813,  9820,  9830,  9844,  9845,
    9849,  9860,  9861,  9864,  9865,  9873,  9877,  9884,  9888,  9892,
    9899,  9909,  9910,  9914,  9915,  9918,  9919,  9930,  9931,  9940,
    9941,  9949,  9960,  9961,  9964,  9980,  9988,  9996, 10018, 10019,
   10023, 10024, 10035, 10043, 10071, 10073, 10078, 10081, 10084, 10086,
   10088, 10090, 10100, 10102, 10110, 10114, 10118, 10122, 10126, 10135,
   10142, 10150, 10154, 10160, 10177, 10181, 10185, 10191, 10192, 10193,
   10195, 10196, 10197, 10200, 10201, 10217, 10218, 10219, 10224, 10225,
   10226, 10232, 10233, 10234, 10235, 10236, 10256, 10257, 10258, 10259,
   10260, 10261, 10262, 10263, 10264, 10265, 10266, 10267, 10268, 10269,
   10270, 10271, 10272, 10273, 10274, 10275, 10276, 10277, 10278, 10279,
   10280, 10281, 10282, 10283, 10284, 10285, 10286, 10287, 10288, 10289,
   10290, 10291, 10292, 10293, 10294, 10295, 10296, 10297, 10298, 10299,
   10300, 10301, 10302, 10303, 10304, 10305, 10306, 10307, 10308, 10309,
   10310, 10311, 10312, 10313, 10314, 10315, 10316, 10317, 10318, 10319,
   10320, 10321, 10322, 10323, 10324, 10325, 10326, 10327, 10328, 10329,
   10330, 10331, 10332, 10333, 10334, 10335, 10336, 10337, 10338, 10339,
   10340, 10341, 10342, 10343, 10344, 10345, 10346, 10347, 10348, 10349,
   10350, 10351, 10352, 10353, 10354, 10355, 10356, 10357, 10358, 10359,
   10360, 10361, 10362, 10363, 10364, 10365, 10366, 10367, 10368, 10369,
   10370, 10371, 10372, 10373, 10374, 10375, 10376, 10377, 10378, 10379,
   10380, 10381, 10382, 10383, 10384, 10385, 10386, 10387, 10388, 10389,
   10390, 10391, 10392, 10393, 10394, 10395, 10396, 10397, 10398, 10399,
   10400, 10401, 10402, 10403, 10404, 10405, 10406, 10407, 10408, 10409,
   10410, 10411, 10412, 10413, 10414, 10415, 10416, 10417, 10418, 10419,
   10420, 10421, 10422, 10423, 10424, 10425, 10426, 10427, 10428, 10429,
   10430, 10431, 10432, 10433, 10434, 10435, 10436, 10437, 10438, 10439,
   10440, 10441, 10442, 10443, 10444, 10445, 10446, 10447, 10448, 10449,
   10450, 10451, 10452, 10453, 10454, 10455, 10456, 10457, 10458, 10459,
   10460, 10461, 10462, 10463, 10464, 10465, 10466, 10467, 10468, 10469,
   10470, 10471, 10472, 10473, 10474, 10475, 10476, 10477, 10478, 10479,
   10480, 10481, 10482, 10483, 10484, 10485, 10486, 10487, 10488, 10489,
   10490, 10491, 10492, 10493, 10494, 10495, 10496, 10497, 10498, 10499,
   10500, 10501, 10502, 10516, 10517, 10518, 10519, 10520, 10521, 10522,
   10523, 10524, 10525, 10526, 10527, 10528, 10529, 10530, 10531, 10532,
   10533, 10534, 10535, 10536, 10537, 10538, 10539, 10540, 10541, 10542,
   10543, 10544, 10545, 10546, 10547, 10548, 10549, 10550, 10551, 10552,
   10553, 10554, 10555, 10556, 10557, 10558, 10559, 10560, 10574, 10575,
   10576, 10577, 10578, 10579, 10580, 10581, 10582, 10583, 10584, 10585,
   10586, 10587, 10588, 10589, 10590, 10591, 10592, 10593, 10594, 10595,
   10605, 10606, 10607, 10608, 10609, 10610, 10611, 10612, 10613, 10614,
   10615, 10616, 10617, 10618, 10619, 10620, 10621, 10622, 10623, 10624,
   10625, 10626, 10627, 10628, 10629, 10630, 10631, 10632, 10633, 10634,
   10635, 10636, 10637, 10638, 10639, 10640, 10641, 10642, 10643, 10644,
   10645, 10646, 10647, 10648, 10649, 10650, 10651, 10652, 10653, 10654,
   10655, 10656, 10657, 10658, 10659, 10660, 10661, 10662, 10663, 10664,
   10665, 10666, 10667, 10668, 10669, 10670, 10671, 10672, 10673, 10674,
   10675, 10676, 10677, 10678, 10679, 10680, 10681, 10682, 10683, 10688,
   10698
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "AT", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLUMN", "COMMENT", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTEXT_P", "CONTINUE_P", "CONVERSION_P",
  "COPY", "COST", "CREATE", "CREATEDB", "CREATEROLE", "CREATEUSER",
  "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FIRST_P",
  "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE",
  "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LANCOMPILER",
  "LANGUAGE", "LARGE_P", "LAST_P", "LC_COLLATE_P", "LC_CTYPE_P", "LEADING",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P",
  "MAPPING", "MATCH", "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE",
  "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR",
  "NEW", "NEXT", "NO", "NOCREATEDB", "NOCREATEROLE", "NOCREATEUSER",
  "NOINHERIT", "NOLOGIN_P", "NONE", "NOSUPERUSER", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY",
  "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSWORD", "PLACING", "PLANS", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE", "RANGE", "READ",
  "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REFERENCES", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE",
  "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE", "SAVEPOINT",
  "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SMALLINT", "SOME",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STRICT_P", "STRIP_P", "SUBSTRING", "SUPERUSER_P",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLESPACE", "TEMP",
  "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO",
  "TRAILING", "TRANSACTION", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNTIL",
  "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATOR", "VALUE_P",
  "VALUES", "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P",
  "VIEW", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES",
  "XMLCONCAT", "XMLELEMENT", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT",
  "XMLSERIALIZE", "YEAR_P", "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST",
  "WITH_TIME", "IDENT", "FCONST", "SCONST", "BCONST", "XCONST", "Op",
  "ICONST", "PARAM", "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'",
  "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('", "')'", "TYPECAST",
  "'.'", "';'", "','", "':'", "$accept", "stmtblock", "stmtmulti", "stmt",
  "CreateRoleStmt", "opt_with", "OptRoleList", "OptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean", "zone_value", "opt_encoding", "ColId_or_Sconst",
  "VariableResetStmt", "SetResetClause", "VariableShowStmt",
  "ConstraintsSetStmt", "constraints_set_list", "constraints_set_mode",
  "CheckPointStmt", "DiscardStmt", "AlterTableStmt", "alter_table_cmds",
  "alter_table_cmd", "alter_column_default", "opt_drop_behavior",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "ClosePortalStmt", "CopyStmt", "copy_from",
  "copy_file_name", "copy_opt_list", "copy_opt_item", "opt_binary",
  "opt_oids", "copy_delimiter", "opt_using", "CreateStmt", "OptTemp",
  "OptTableElementList", "TableElementList", "TableElement", "columnDef",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptWith", "OnCommitOption", "OptTableSpace",
  "OptConsTableSpace", "CreateAsStmt", "create_as_target", "OptCreateAs",
  "CreateAsList", "CreateAsElement", "opt_with_data", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "CreatePLangStmt", "opt_trusted", "handler_name",
  "validator_clause", "opt_validator", "opt_lancompiler", "DropPLangStmt",
  "opt_procedural", "CreateTableSpaceStmt", "OptTableSpaceOwner",
  "DropTableSpaceStmt", "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerFuncArgs",
  "TriggerFuncArg", "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintDeferrabilitySpec", "ConstraintTimeSpec", "DropTrigStmt",
  "CreateAssertStmt", "DropAssertStmt", "DefineStmt", "definition",
  "def_list", "def_elem", "def_arg", "aggr_args", "old_aggr_definition",
  "old_aggr_list", "old_aggr_elem", "enum_val_list", "CreateOpClassStmt",
  "opclass_item_list", "opclass_item", "opt_default", "opt_opfamily",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_direction", "from_in", "GrantStmt", "RevokeStmt",
  "privileges", "privilege_list", "privilege", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "IndexStmt", "index_opt_unique", "access_method_clause", "index_params",
  "index_elem", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "CreateCastStmt", "cast_context",
  "DropCastStmt", "opt_if_exists", "ReindexStmt", "reindex_type",
  "opt_force", "RenameStmt", "opt_column", "opt_set_data",
  "AlterObjectSchemaStmt", "AlterOwnerStmt", "AlterSecLabelStmt",
  "OptTableSecLabel", "TableSecLabelList", "TableSecLabelItem",
  "OptSecLabel", "SecLabelItem", "SecLabelToItem", "RuleStmt", "$@1",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "DropRuleStmt",
  "NotifyStmt", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "opt_analyze",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "into_clause", "OptTempTableName", "opt_table", "opt_all",
  "opt_distinct", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "select_limit_value",
  "opt_select_fetch_first_value", "select_offset_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "type_list",
  "array_expr", "array_expr_list", "extract_list", "extract_arg",
  "overlay_list", "overlay_placing", "position_list", "substr_list",
  "substr_from", "substr_for", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "indirection", "opt_indirection",
  "opt_asymmetric", "ctext_expr", "ctext_expr_list", "ctext_row",
  "target_list", "target_el", "relation_name", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "SignedIconst", "Iconst_list", "ColId",
  "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "SpecialRuleRelation", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,    61,    60,    62,
     662,    43,    45,    42,    47,    37,    94,   663,    91,    93,
      40,    41,   664,    46,    59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   427,   428,   429,   429,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   430,   430,   430,
     430,   430,   430,   430,   430,   430,   430,   431,   432,   432,
     433,   433,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   435,   436,   437,   438,
     439,   440,   440,   441,   441,   442,   443,   444,   444,   445,
     445,   446,   446,   447,   447,   448,   448,   449,   449,   449,
     449,   449,   449,   450,   450,   450,   451,   451,   451,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     451,   452,   452,   453,   453,   454,   454,   454,   455,   455,
     455,   455,   456,   456,   456,   456,   457,   457,   457,   457,
     457,   457,   457,   458,   458,   458,   459,   459,   460,   460,
     460,   460,   460,   461,   461,   462,   462,   462,   462,   462,
     463,   464,   464,   465,   465,   466,   467,   467,   467,   467,
     468,   468,   468,   468,   469,   469,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   471,   471,
     472,   472,   472,   473,   473,   474,   475,   475,   476,   476,
     477,   477,   477,   477,   478,   478,   479,   479,   480,   480,
     481,   481,   481,   482,   482,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   484,   484,   485,   485,   486,
     486,   487,   487,   488,   488,   489,   489,   489,   489,   489,
     489,   489,   490,   490,   491,   491,   492,   492,   492,   493,
     494,   494,   495,   495,   495,   496,   496,   496,   496,   496,
     496,   496,   497,   497,   497,   497,   498,   499,   499,   500,
     500,   500,   500,   500,   500,   501,   501,   502,   502,   502,
     502,   503,   503,   504,   504,   505,   506,   506,   506,   506,
     507,   507,   507,   507,   507,   508,   509,   510,   510,   510,
     510,   510,   511,   511,   512,   512,   512,   512,   513,   513,
     513,   513,   514,   514,   515,   515,   516,   517,   518,   518,
     519,   519,   520,   521,   521,   521,   522,   523,   524,   524,
     525,   525,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   527,   527,   528,   528,   528,   529,
     529,   530,   530,   531,   531,   532,   532,   533,   533,   534,
     534,   535,   535,   536,   536,   537,   538,   538,   539,   539,
     540,   541,   541,   542,   542,   542,   543,   543,   544,   544,
     545,   546,   546,   547,   547,   547,   547,   548,   549,   550,
     551,   552,   552,   553,   553,   554,   554,   555,   555,   556,
     556,   556,   557,   558,   558,   558,   559,   559,   560,   561,
     561,   562,   562,   563,   563,   564,   564,   564,   564,   565,
     565,   566,   566,   567,   567,   568,   568,   568,   569,   569,
     569,   569,   569,   569,   570,   570,   571,   571,   571,   571,
     571,   572,   572,   573,   573,   574,   574,   575,   576,   577,
     577,   577,   577,   577,   577,   577,   577,   577,   577,   577,
     578,   579,   579,   580,   580,   581,   581,   581,   581,   581,
     582,   582,   583,   584,   584,   585,   586,   586,   587,   588,
     588,   589,   589,   589,   589,   589,   590,   590,   591,   591,
     592,   592,   593,   594,   594,   595,   595,   596,   596,   597,
     597,   598,   598,   599,   600,   601,   601,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   603,
     603,   604,   604,   605,   605,   606,   607,   607,   607,   608,
     608,   608,   608,   608,   608,   608,   608,   608,   608,   608,
     608,   608,   608,   608,   608,   608,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   610,   610,
     611,   611,   611,   611,   612,   612,   612,   612,   612,   612,
     612,   612,   612,   612,   612,   612,   612,   612,   612,   613,
     613,   614,   615,   615,   616,   616,   616,   616,   616,   617,
     617,   618,   618,   618,   618,   619,   619,   619,   619,   619,
     619,   619,   619,   619,   619,   619,   620,   620,   621,   621,
     622,   622,   623,   623,   624,   625,   626,   626,   627,   627,
     628,   628,   629,   629,   630,   630,   631,   631,   632,   632,
     633,   633,   633,   634,   634,   634,   635,   635,   635,   636,
     636,   636,   637,   637,   637,   638,   638,   639,   639,   640,
     640,   641,   641,   642,   642,   643,   643,   643,   643,   643,
     644,   644,   644,   644,   644,   645,   646,   647,   647,   647,
     648,   648,   648,   649,   649,   650,   650,   650,   650,   650,
     650,   650,   650,   650,   650,   650,   650,   650,   651,   651,
     651,   651,   651,   652,   652,   653,   653,   654,   655,   655,
     656,   657,   657,   658,   658,   659,   659,   660,   660,   661,
     661,   662,   662,   662,   662,   663,   663,   664,   664,   664,
     665,   665,   665,   666,   667,   667,   668,   668,   668,   669,
     669,   670,   670,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   671,   671,   672,   672,   673,   673,
     674,   674,   674,   674,   674,   674,   674,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   676,   676,   676,   676,   676,   676,
     676,   677,   677,   678,   678,   679,   679,   680,   680,   681,
     682,   684,   683,   685,   685,   685,   686,   686,   687,   687,
     687,   687,   687,   688,   688,   689,   689,   689,   689,   690,
     690,   690,   691,   691,   692,   693,   694,   694,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   695,
     695,   695,   696,   696,   696,   697,   697,   697,   698,   698,
     698,   699,   699,   700,   700,   701,   701,   701,   701,   702,
     703,   704,   704,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     706,   706,   707,   707,   708,   709,   709,   710,   711,   711,
     712,   713,   713,   713,   713,   713,   714,   714,   715,   716,
     716,   716,   716,   716,   716,   717,   718,   718,   718,   719,
     719,   720,   720,   720,   721,   721,   722,   722,   723,   723,
     724,   724,   725,   725,   726,   726,   727,   728,   728,   728,
     728,   728,   728,   728,   729,   729,   730,   731,   731,   732,
     732,   732,   732,   733,   733,   734,   734,   735,   735,   735,
     735,   736,   737,   737,   737,   738,   738,   739,   740,   740,
     741,   742,   742,   743,   744,   744,   745,   745,   745,   745,
     745,   745,   745,   745,   746,   746,   747,   748,   748,   749,
     749,   750,   751,   752,   753,   753,   754,   755,   755,   755,
     755,   755,   756,   756,   756,   757,   757,   758,   758,   759,
     759,   759,   759,   759,   759,   759,   759,   760,   760,   761,
     761,   761,   761,   761,   761,   762,   762,   763,   763,   764,
     765,   765,   766,   766,   766,   766,   766,   766,   766,   766,
     767,   767,   768,   768,   768,   769,   769,   769,   769,   770,
     770,   771,   772,   772,   773,   773,   774,   774,   774,   774,
     774,   774,   774,   774,   775,   775,   776,   776,   777,   777,
     777,   778,   779,   780,   780,   781,   781,   782,   782,   783,
     783,   784,   784,   785,   785,   786,   786,   787,   787,   788,
     788,   789,   789,   790,   790,   791,   791,   792,   792,   792,
     792,   792,   792,   792,   792,   792,   792,   792,   793,   793,
     793,   793,   793,   793,   794,   794,   794,   794,   795,   795,
     795,   795,   796,   796,   797,   797,   798,   798,   798,   798,
     799,   799,   800,   800,   800,   801,   802,   802,   803,   803,
     803,   803,   804,   804,   805,   806,   806,   806,   806,   806,
     806,   807,   807,   807,   808,   808,   808,   808,   808,   808,
     808,   809,   809,   809,   809,   810,   810,   811,   811,   812,
     812,   812,   812,   812,   812,   812,   812,   812,   812,   812,
     813,   813,   814,   814,   815,   815,   816,   817,   818,   818,
     819,   819,   820,   821,   822,   822,   822,   822,   822,   822,
     823,   823,   824,   824,   825,   825,   825,   825,   826,   827,
     827,   827,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   829,   829,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   831,   831,   831,   831,   831,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   832,   832,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   834,   834,   835,   835,
     835,   835,   836,   837,   837,   838,   838,   839,   839,   840,
     840,   840,   841,   841,   842,   842,   843,   844,   844,   844,
     845,   846,   846,   847,   847,   848,   848,   848,   849,   849,
     850,   850,   850,   851,   851,   851,   852,   852,   852,   853,
     853,   854,   854,   854,   854,   854,   854,   854,   854,   854,
     855,   855,   856,   856,   857,   857,   857,   857,   857,   857,
     858,   858,   859,   859,   860,   860,   860,   861,   861,   862,
     862,   863,   863,   863,   863,   863,   863,   863,   863,   864,
     864,   865,   866,   866,   867,   867,   867,   867,   867,   867,
     868,   869,   870,   870,   870,   871,   871,   872,   873,   873,
     874,   875,   875,   876,   876,   877,   877,   878,   878,   878,
     878,   879,   879,   880,   880,   881,   881,   882,   882,   883,
     883,   884,   885,   885,   886,   886,   886,   886,   887,   887,
     888,   888,   889,   889,   890,   890,   891,   892,   893,   894,
     895,   896,   897,   897,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   899,   900,   901,
     902,   902,   902,   903,   903,   904,   904,   904,   905,   905,
     905,   906,   906,   906,   906,   906,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   907,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,   908,   908,   908,   908,   908,   909,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   909,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   911,
     911
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     1,     0,
       2,     0,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     5,     5,     4,     5,
       4,     3,     5,     3,     5,     5,     6,     1,     1,     3,
       5,     7,     5,     1,     0,     2,     0,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     5,     2,     2,     2,     2,     3,     3,
       3,     1,     3,     1,     3,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     6,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     3,
       4,     3,     2,     2,     1,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       4,     4,     4,     4,     1,     3,     3,     4,     6,     6,
       6,     6,     4,     7,     2,     4,     3,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     3,     3,     3,     4,
       4,     3,     2,     3,     3,     3,     2,     2,     3,     2,
       1,     1,     0,     2,     0,     3,     2,     0,     1,     3,
       3,     1,     5,     3,     2,     2,    10,     6,     1,     1,
       1,     1,     1,     2,     0,     1,     1,     3,     3,     1,
       1,     3,     3,     3,     4,     1,     0,     2,     0,     3,
       0,     1,     0,    12,    13,     1,     1,     2,     2,     2,
       2,     0,     1,     0,     1,     3,     1,     1,     1,     3,
       2,     0,     3,     1,     1,     2,     1,     3,     4,     4,
       2,     5,     1,     2,     2,     2,     3,     2,     0,     2,
       2,     2,     2,     2,     2,     3,     1,     4,     6,     7,
      11,     3,     0,     1,     3,     1,     2,     2,     2,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     7,     5,     3,     0,
       1,     3,     1,     2,     3,     0,     6,     4,     1,     0,
       1,     2,     2,     1,     2,     3,     2,     2,     2,     2,
       3,     3,     1,     3,     1,     0,     1,     2,     1,     5,
       9,     1,     0,     1,     2,     2,     2,     1,     0,     2,
       0,     5,     7,     1,     0,     6,     2,     0,     3,     5,
       7,     6,     8,     7,     6,     6,     4,     0,     1,     3,
       4,     1,     3,     1,     2,     2,     2,     2,     1,     1,
      10,     2,     0,     2,     2,     1,     0,     4,     6,     5,
       4,     4,     8,     1,     1,     1,     7,     9,     8,    14,
      19,     1,     1,     1,     3,     1,     1,     1,     1,     3,
       0,     1,     0,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     2,     0,     1,     2,     1,     2,
       0,     2,     1,     2,     2,     6,     8,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     3,    13,     1,
       3,     4,     5,     4,     7,     2,     1,     0,     2,     0,
       1,     0,     6,     8,     8,     1,     3,     5,     5,     7,
       9,     7,     9,     5,     6,     6,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     1,     2,     2,     3,     5,     2,     2,     0,     6,
       7,     7,     7,     8,     8,     6,     8,     9,     9,     7,
      10,     7,     8,     8,     8,     8,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     2,     4,     2,     0,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     2,     2,     1,
       1,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     3,     2,     2,     1,     3,     1,     2,
       3,     0,     1,     3,     2,     6,     6,     9,     3,     0,
       3,     0,    13,    14,     1,     0,     2,     0,     1,     3,
       4,     4,     6,     1,     2,     0,     1,     1,     0,     1,
       1,     0,     9,    12,     7,     2,     0,     3,     2,     1,
       3,     3,     2,     1,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     4,     5,
       1,     3,     3,     1,     2,     4,     5,     1,     1,     1,
       1,     3,     3,     2,     2,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     3,     2,     0,     2,     1,     3,
       5,     1,     2,     1,     0,     5,     7,     5,     7,     5,
       7,     3,     5,     5,     5,     1,     3,    11,    10,    10,
       2,     2,     0,     9,     2,     0,     4,     4,     4,     1,
       1,     1,     0,     7,     6,     6,     6,     6,     7,     9,
       9,     6,     6,     6,     6,     6,     8,     8,     6,     6,
       6,     8,     8,     8,     8,     6,     1,     0,     2,     0,
       7,     6,     6,     6,     6,     6,     6,     7,     6,     6,
       6,     6,     7,     7,     7,     9,     9,     6,     6,     6,
       8,     8,     8,     6,     4,     4,     4,     7,     4,     4,
       5,     5,     0,     1,     3,     1,     3,     1,     0,     5,
       4,     0,    14,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     6,     8,     2,     2,     2,     2,     2,     3,
       3,     2,     2,     2,     2,     3,     2,     5,     4,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     3,
       2,     1,     0,     8,    10,     3,     4,     4,     0,     2,
       5,     2,     0,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     1,
       1,     0,     5,     6,     4,     2,     0,     4,     3,     5,
       6,     4,     6,     6,     5,     7,     1,     0,     6,    11,
      11,    11,    13,     9,    11,    10,     4,     2,     5,     2,
       0,     4,     5,     5,     2,     4,     1,     1,     1,     0,
       1,     0,     1,     0,     3,     0,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     3,     0,     1,
       1,     1,     1,     3,     8,     3,     0,     2,     3,     2,
       3,     5,     1,     4,     2,     1,     3,     2,     2,     0,
       6,     2,     0,     5,     3,     0,     2,     2,     2,     3,
       1,     3,     1,     2,     1,     0,     7,     1,     3,     1,
       1,     3,     5,     2,     1,     3,     7,     0,     3,     2,
       2,     2,     0,     2,     2,     1,     1,     3,     3,     1,
       2,     4,     4,     2,     3,     5,     5,     1,     1,     9,
       1,     2,     4,     4,     4,     2,     3,     1,     3,     4,
       2,     0,     3,     3,     4,     4,     4,     4,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       0,     3,     1,     3,     4,     3,     4,     4,     2,     2,
       4,     3,     5,     8,     1,     0,     1,     1,     1,     3,
       0,     1,     1,     1,     1,     1,     1,     3,     0,     2,
       0,     1,     3,     1,     0,     1,     2,     4,     4,     2,
       0,     2,     3,     2,     0,     1,     3,     1,     2,     1,
       2,     5,     6,     5,     1,     2,     1,     4,     3,     4,
       5,     4,     5,     4,     5,     2,     4,     1,     2,     2,
       2,     1,     1,     0,     4,     2,     1,     2,     2,     4,
       1,     3,     1,     2,     3,     1,     2,     0,     2,     4,
       4,     0,     1,     3,     2,     2,     3,     5,     6,     2,
       3,     3,     4,     0,     1,     1,     1,     1,     1,     2,
       5,     1,     1,     1,     1,     2,     3,     3,     0,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     1,
       3,     0,     1,     1,     1,     1,     5,     2,     1,     1,
       1,     1,     5,     2,     2,     2,     1,     3,     3,     2,
       1,     0,     3,     0,     5,     2,     5,     2,     1,     2,
       3,     0,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     0,     1,     4,     1,     3,
       5,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     6,     7,     3,
       4,     4,     6,     2,     3,     4,     1,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     5,     6,     6,     7,     3,     4,     1,     1,
       2,     4,     1,     1,     1,     2,     2,     2,     1,     4,
       5,     6,     8,     6,     6,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       4,     6,     5,     7,     7,     7,     2,     3,     3,     3,
       4,     0,     4,     1,     3,     3,     1,     1,     1,     2,
       2,     0,     2,     0,     1,     3,     3,     2,     2,     0,
       6,     1,     0,     3,     0,     2,     2,     0,     1,     4,
       2,     2,     2,     4,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     4,     1,     4,     1,     2,     1,     2,
       1,     3,     1,     3,     3,     3,     2,     1,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       3,     2,     3,     0,     3,     3,     2,     2,     1,     0,
       2,     2,     3,     2,     1,     1,     3,     5,     1,     2,
       4,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       5,     1,     2,     0,     2,     1,     0,     1,     1,     1,
       3,     3,     1,     3,     3,     2,     1,     1,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       5,     2,     3,     6,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     106,   924,   444,   997,   996,   924,   225,     0,   999,     0,
     924,   306,   321,     0,     0,     0,     0,   444,   924,     0,
    1015,   644,     0,     0,     0,     0,  1111,   644,     0,     0,
       0,     0,     0,     0,     0,   924,     0,  1118,     0,     0,
       0,     0,  1111,     0,     0,  1001,     0,     0,     0,     0,
       2,     4,    49,    50,    18,    17,    23,    22,    71,    72,
      39,    11,    62,    44,   103,   102,   104,    29,    25,    57,
      16,    26,    30,    46,    31,    45,    15,    43,    66,    47,
      69,    36,    60,     8,    37,    61,     9,    51,    73,    21,
      48,    70,    32,    58,    55,    40,    41,    42,    63,    64,
      65,    87,    68,    98,    28,    77,    78,    93,    79,    94,
      80,    38,    10,    90,    89,    91,    33,    59,    88,    92,
      12,    13,    14,    95,    67,    85,    82,    99,    97,   105,
      83,    52,     5,     6,    74,    35,     7,    20,    19,    34,
      27,   101,    24,   999,    76,    86,    75,    53,    81,    56,
      84,   100,    54,    96,  1088,  1075,  1120,  1087,     0,  1090,
     923,   922,   908,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   443,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   932,  1616,  1617,  1618,
    1619,  1620,  1621,  1622,  1623,   285,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1863,  1864,  1865,  1633,  1634,
    1635,  1636,  1637,  1638,  1639,  1866,  1867,  1640,  1641,  1642,
    1643,  1644,  1868,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1869,  1870,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1871,  1692,  1693,  1872,  1694,  1695,  1873,  1696,
    1697,  1698,  1699,  1700,  1701,  1874,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1875,  1717,  1718,  1719,  1720,  1876,  1877,  1878,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1879,  1730,
    1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,
    1741,  1742,  1743,  1744,  1745,  1746,  1880,  1881,  1747,  1748,
    1749,  1750,  1751,  1752,  1753,  1882,  1754,  1755,  1756,  1757,
    1883,  1758,  1884,  1759,  1760,  1761,  1762,  1763,  1764,  1885,
    1886,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1887,  1772,
    1888,  1775,  1773,  1774,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1889,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,
    1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1890,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1891,  1813,  1814,  1815,  1892,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1893,  1826,
    1827,  1828,  1829,  1830,  1831,  1832,  1833,  1894,  1895,  1834,
    1896,  1835,  1897,  1836,  1837,  1838,  1839,  1840,  1841,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,  1849,  1898,  1899,  1850,
    1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1900,
    1901,  1902,  1903,  1904,  1905,  1906,  1907,  1860,  1861,  1862,
    1605,   284,  1576,  1606,  1607,   998,   987,   444,     0,   911,
     305,     0,     0,     0,     0,     0,     0,     0,   566,     0,
       0,     0,     0,     0,     0,     0,     0,   154,     0,     0,
     316,   315,     0,     0,   431,     0,   704,     0,     0,   444,
       0,     0,     0,  1029,  1773,  1027,  1067,     0,   226,   229,
     227,   228,     0,     0,   805,   593,     0,   592,     0,     0,
       0,   590,     0,     0,     0,     0,   594,   588,     0,   587,
       0,     0,     0,   591,     0,   589,     0,     0,   912,  1026,
    1014,   999,  1617,   652,   656,   647,   653,   648,   645,   646,
    1787,  1597,     0,     0,     0,   641,  1600,   651,   665,   362,
     362,   362,     0,   664,   669,   362,     0,   905,  1598,   939,
    1581,  1110,     0,     0,   643,   904,  1834,  1018,     0,     0,
     809,     0,   810,     0,  1802,   916,   212,  1811,  1894,  1834,
     208,   181,  1621,     0,     0,   664,     0,   913,   914,  1117,
    1115,     0,  1638,  1651,  1733,   205,  1798,  1803,  1811,  1894,
    1834,  1859,   163,     0,   219,  1811,  1894,  1834,   215,   932,
    2010,  2009,     0,  1091,  1572,  1196,  1569,  1568,     0,   907,
     906,  1202,     0,  1000,  1003,     0,  1161,  1785,  1095,  1097,
    1005,  1088,     0,     1,   106,   994,  1114,  1114,     0,  1114,
       0,  1080,  1088,  1083,  1087,     0,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1605,     0,
       0,  1582,  1606,  1610,     0,   601,   109,  1577,     0,     0,
       0,     0,     0,  1599,     0,     0,  1642,  1694,  1479,  1489,
    1487,  1488,  1481,  1482,  1483,  1484,  1485,  1486,     0,   795,
    1480,     0,   109,     0,     0,  1196,     0,     0,     0,     0,
       0,     0,  1737,   109,     0,     0,     0,     0,   928,   931,
     909,   990,     0,  1569,     0,     0,   626,     0,   635,   627,
     632,     0,   629,     0,     0,   637,     0,   628,   630,   631,
     636,     0,     0,   633,   634,     0,     0,   920,   362,     0,
       0,     0,     0,     0,   109,   977,     0,   320,   319,   109,
     318,   317,  1642,  1694,     0,   725,   109,     0,   878,   472,
     447,     0,     0,   533,  1737,   109,     0,     0,     0,     0,
       0,     0,     0,     0,  1030,  1028,     0,  1042,  1707,     0,
     272,     0,     0,  1707,   968,     0,  1707,     0,  1707,   149,
    1574,  1642,  1694,  1707,     0,     0,  1707,   141,  1707,     0,
    1707,   272,  1707,   448,     0,  1707,     0,  1707,  1737,   143,
       0,  1707,   272,   599,     0,  1023,     0,   649,   658,   657,
     655,   654,   650,  1601,  1602,   659,   660,     0,   666,     0,
       0,   673,   672,   671,     0,     0,     0,   674,     0,  1200,
    1045,     0,   919,     0,     0,     0,   812,   812,   812,   915,
     211,   209,     0,     0,     0,     0,     0,     0,   921,     0,
       0,     0,  1863,  1864,  1865,  1544,     0,  1866,  1867,  1868,
    1409,  1396,  1405,  1410,  1397,  1399,  1406,  1869,  1870,  1681,
    1871,  1872,  1595,  1873,  1874,  1876,  1877,  1878,  1879,  1401,
    1403,  1880,  1881,     0,  1596,  1883,  1884,  1762,  1886,  1887,
    1889,  1890,  1407,  1892,  1893,  1894,  1895,  1896,  1897,  1594,
       0,  1408,  1899,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1585,  1587,  1588,  1490,  1553,     0,     0,  1567,     0,  1384,
       0,  1231,  1232,  1254,  1255,  1233,  1260,  1261,  1273,  1234,
       0,  1566,  1298,  1383,  1388,     0,  1382,  1378,  1101,  1562,
    1545,     0,  1379,  1584,  1586,   174,   221,     0,   222,  1570,
    1811,   164,   204,   176,   203,   177,   207,   206,   175,     0,
    1640,   165,     0,   172,     0,     0,     0,     0,   218,   216,
       0,   910,     0,  1198,     0,     0,  1551,  1573,  1197,   608,
       0,  1203,     0,  1002,   999,  1558,  1557,  1559,     0,  1096,
       0,     0,     0,  1078,  1077,     3,  1005,  1112,  1113,     0,
       0,     0,     0,     0,     0,     0,     0,  1154,  1135,  1151,
    1155,     0,  1084,  1162,  1583,     0,     0,     0,     0,     0,
     602,     0,     0,     0,     0,   108,   966,   214,   964,   864,
       0,     0,     0,     0,   971,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,   759,   757,   760,   767,
     781,   784,   869,     0,   694,   147,   148,     0,     0,   837,
     837,     0,     0,   837,     0,     0,     0,     0,     0,     0,
       0,   231,   234,     0,     0,     0,     0,     0,     0,     0,
       0,   111,   138,     0,     0,   865,   868,     0,   413,   425,
       0,     0,     0,     0,     0,   422,     0,   109,   232,   407,
     410,     0,     0,     0,   481,   480,   837,   837,     0,   230,
     866,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   111,   140,     0,     0,   233,     0,     0,
     926,   927,     0,   930,     0,   986,     0,     0,     0,     0,
       0,     0,  1642,  1694,     0,     0,     0,     0,     0,     0,
     308,   291,   292,   109,   290,     0,     0,   530,     0,  1242,
    1271,  1249,  1271,  1271,  1238,  1238,  1251,  1239,  1240,  1278,
       0,  1271,  1238,  1243,     0,  1241,  1281,  1281,  1266,  1608,
       0,  1223,  1224,  1225,  1226,  1252,  1253,  1227,  1258,  1259,
    1228,  1295,  1238,  1609,     0,   942,   976,     0,     0,   111,
     567,     0,     0,   531,     0,   111,     0,     0,   156,   877,
       0,   476,     0,     0,     0,     0,     0,     0,   492,   491,
       0,     0,   532,     0,   111,   409,     0,   399,   362,     0,
       0,  1648,     0,  1580,     0,     0,  1070,  1072,  1071,     0,
    1069,     0,  1211,     0,   272,   270,   271,   528,   804,     0,
       0,     0,     0,   272,     0,     0,  1707,     0,  1707,     0,
       0,   272,   272,     0,     0,     0,     0,   477,     0,   598,
     596,   595,   597,     0,     0,     0,     0,     0,  1707,   272,
       0,     0,   586,  1500,     0,   321,  1012,  1006,  1013,  1008,
    1010,  1009,  1011,  1007,   640,     0,     0,   363,   365,     0,
    1666,     0,  1699,  1725,  1726,  1803,  1808,     0,  1829,     0,
     675,   699,   670,     0,     0,  1039,  1032,     0,     0,  1055,
     642,  1502,     0,     0,     0,   811,   808,   807,   806,   210,
     182,     0,     0,     0,   701,  1802,   918,     0,     0,  1386,
    1387,  1270,  1257,  1543,     0,     0,  1265,  1264,     0,     0,
       0,     0,  1247,  1246,  1245,  1385,  1510,     0,  1244,     0,
       0,     0,     0,  1271,  1271,  1269,  1317,     0,  1248,     0,
       0,  1523,     0,  1529,     0,     0,     0,  1277,     0,  1275,
       0,     0,  1353,     0,     0,     0,     0,     0,     0,     0,
    1380,  1301,  1302,  1898,  1384,  1500,     0,  1591,     0,     0,
    1263,     0,  1295,     0,     0,     0,  1556,  1498,     0,     0,
    1331,  1496,     0,  1333,     0,     0,     0,  1565,  1490,  1489,
    1487,  1488,  1481,  1482,  1483,  1484,  1485,  1486,     0,  1494,
    1314,     0,     0,  1313,     0,     0,  1164,  1546,     0,  1589,
     223,   224,   220,     0,     0,   179,   178,     0,   201,   202,
     197,   426,     0,   171,   200,     0,   196,   428,  1448,  1447,
     180,   170,   168,   193,   195,   194,   192,   166,   183,   185,
     186,   187,   169,   167,   217,     0,     0,  1930,  1931,  1932,
    1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,
    1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,
    1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,
    1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,
    1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,
    1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,
    1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,
    2003,  2004,  2005,  2006,  2007,  2008,  1611,  1548,  1547,  1579,
    1612,  1613,  1614,  1615,  1552,     0,     0,   272,  1204,     0,
    1164,  1057,  1059,  1060,     0,  1553,   991,  1561,     0,  1098,
       0,     0,   995,  1094,  1093,  1121,  1122,   718,  1092,  1145,
    1146,  1140,     0,  1160,  1160,  1137,  1128,  1136,  1129,     0,
    1141,  1298,  1153,  1082,  1134,  1081,     0,  1156,  1154,  1135,
       0,     0,     0,     0,     0,     0,     0,   603,     0,     0,
       0,     0,  1829,   213,   962,     0,     0,     0,     0,     0,
     974,   356,     0,   269,     0,     0,     0,     0,     0,     0,
       0,   765,     0,     0,     0,     0,   766,   763,   764,  1803,
     783,     0,   782,   780,   740,   742,   741,     0,   744,   728,
       0,   729,     0,     0,   739,   747,   745,     0,     0,   836,
     244,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   262,     0,     0,     0,     0,   267,     0,     0,
       0,   266,     0,     0,   870,     0,     0,     0,     0,     0,
     796,     0,   137,     0,     0,   412,   424,     0,   416,   417,
     414,   418,   419,     0,     0,     0,     0,     0,     0,   411,
       0,     0,   474,   473,   479,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   483,
     484,     0,   485,     0,   139,     0,     0,     0,     0,     0,
       0,   191,   925,   929,   989,   988,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,  1608,     0,   553,   529,
       0,  1223,     0,  1219,  1215,  1284,  1285,  1286,  1283,  1296,
    1282,     0,  1229,  1287,  1238,  1235,     0,   940,   331,   438,
     145,     0,     0,     0,   541,   544,     0,   107,   878,     0,
     152,   471,   475,     0,   446,     0,     0,     0,     0,     0,
     496,   495,   498,   497,     0,   493,     0,     0,     0,   136,
     878,   408,     0,     0,   323,   387,     0,   429,     0,     0,
       0,     0,     0,   881,     0,     0,     0,  1068,     0,  1174,
    1041,  1165,  1176,  1167,  1169,  1205,  1572,     0,     0,  1039,
       0,   787,     0,   969,  1707,   272,     0,   785,   150,  1575,
       0,     0,     0,     0,     0,   789,   583,   142,     0,   272,
     272,   449,     0,   272,   144,     0,     0,     0,   441,   272,
     600,  1025,     0,     0,     0,   667,     0,   361,   681,     0,
       0,   680,   692,   682,     0,   684,   677,   676,   685,     0,
       0,   701,  1034,     0,  1035,  1553,     0,  1031,     0,  1052,
       0,  1050,     0,  1201,  1054,  1043,  1017,     0,  1016,  1020,
    1022,  1021,  1019,     0,     0,     0,   664,     0,     0,   272,
     917,     0,  1506,     0,  1507,     0,     0,     0,  1542,  1538,
       0,     0,     0,     0,     0,  1514,  1515,  1516,  1513,  1517,
    1512,  1511,     0,     0,  1518,     0,     0,     0,     0,     0,
    1268,  1267,     0,     0,     0,     0,     0,     0,     0,  1356,
    1388,     0,     0,  1474,     0,  1500,  1528,     0,     0,  1279,
       0,     0,     0,     0,     0,     0,     0,  1500,  1534,     0,
       0,     0,  1446,     0,  1443,     0,     0,     0,     0,  1554,
    1553,     0,     0,     0,     0,  1592,  1315,  1564,     0,  1555,
       0,     0,  1322,     0,  1535,  1349,     0,  1354,  1337,     0,
    1330,     0,  1335,  1339,  1318,  1556,  1499,     0,  1497,     0,
       0,  1316,     0,  1311,  1309,  1310,  1303,  1304,  1305,  1306,
    1307,  1308,  1299,  1312,  1478,  1476,  1477,     0,     0,     0,
    1334,  1700,  1733,     0,  1111,  1111,  1100,  1109,  1563,     0,
    1207,     0,     0,     0,     0,  1459,     0,  1571,     0,   427,
       0,  1295,     0,  1199,  1549,     0,   606,   607,   605,  1064,
       0,     0,  1211,     0,  1063,   993,   992,  1560,  1004,  1099,
       0,   716,   717,     0,   721,     0,     0,  1138,  1152,     0,
    1055,  1055,     0,     0,     0,  1143,  1144,  1131,  1086,  1085,
     551,   550,     0,     0,     0,   848,   814,   604,   849,   815,
       0,   963,     0,   965,     0,     0,     0,     0,     0,   272,
     972,   850,   268,   973,   841,     0,     0,     0,   454,   455,
       0,   761,   762,   851,   816,     0,   842,   743,  1238,   727,
       0,     0,   738,     0,   737,  1238,  1238,   817,   146,   236,
       0,   839,   248,   261,   256,   257,   255,   272,   272,     0,
       0,     0,     0,   258,   253,   254,   250,   263,   264,   825,
       0,   278,   281,   265,   246,   249,   247,   235,     0,     0,
    1578,     0,     0,   791,     0,     0,   828,     0,     0,   120,
     122,   124,     0,     0,   118,   126,   121,   123,   125,   119,
     127,   117,     0,     0,   116,     0,     0,     0,     0,   110,
     857,   821,   415,   420,   823,   423,   844,   421,  1620,  1682,
    1812,     0,   461,   463,     0,   468,   863,   839,   822,     0,
     843,   859,   830,     0,     0,     0,     0,     0,     0,     0,
     978,     0,     0,     0,   858,   835,   846,     0,   829,   824,
     845,     0,     0,   189,   188,   190,     0,     0,     0,     0,
       0,     0,     0,     0,   639,   615,   638,     0,     0,     0,
       0,     0,     0,     0,   609,   307,   288,   289,     0,   287,
       0,   552,     0,     0,  1220,  1216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1236,     0,     0,   961,   961,
     961,   961,   961,   961,   961,   959,   941,   970,   437,   457,
       0,   572,   540,     0,     0,   362,   156,     0,   321,     0,
     155,   157,   159,   160,   161,   158,   162,     0,   445,   539,
     537,   536,   538,     0,     0,     0,     0,  1212,     0,     0,
     406,     0,   405,     0,     0,     0,   322,   324,   326,   327,
     328,     0,   400,   402,     0,     0,   391,     0,     0,     0,
       0,   707,   732,     0,   750,   733,     0,     0,     0,     0,
     770,   776,   772,   753,   771,     0,  1073,  1074,     0,  1088,
       0,  1176,     0,  1175,  1187,     0,     0,  1193,  1191,     0,
    1193,     0,  1193,     0,  1168,     0,  1170,  1187,  1573,     0,
    1662,  1208,  1040,   272,     0,     0,   451,   272,     0,   272,
       0,   272,   272,     0,   902,   478,     0,   525,     0,     0,
     272,   585,  1501,     0,   668,   364,     0,   679,     0,  1603,
     683,     0,   691,   686,   688,     0,   695,     0,     0,  1037,
    1038,  1053,  1046,  1048,  1047,     0,     0,  1044,  1503,   584,
       0,     0,   272,     0,   696,  1116,  1504,  1505,     0,     0,
       0,     0,  1539,     0,     0,  1422,  1398,  1400,  1237,  1412,
       0,  1250,  1423,  1424,  1402,  1404,     0,  1491,     0,     0,
    1413,  1358,  1359,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1371,  1370,  1414,  1473,
       0,     0,  1526,  1527,  1415,  1280,  1281,  1281,     0,     0,
    1533,     0,     0,     0,  1420,  1425,     0,     0,  1430,     0,
    1451,     0,     0,     0,  1381,  1501,  1272,  1273,     0,     0,
       0,     0,     0,     0,     0,     0,  1355,  1338,  1332,     0,
    1336,  1340,     0,     0,     0,     0,  1324,  1350,  1320,     0,
       0,  1326,     0,  1351,  1111,  1111,  1111,  1111,  1108,     0,
       0,  1163,     0,  1148,     0,     0,     0,  1459,     0,  1389,
    1459,     0,   173,     0,   198,   184,     0,     0,     0,  1058,
    1039,  1061,  1123,     0,  1492,   721,   719,   720,  1125,     0,
       0,  1159,  1158,  1157,  1126,  1130,  1127,     0,   847,   813,
     840,   880,   961,     0,   355,     0,     0,     0,   975,   436,
       0,   435,   433,   453,   755,     0,  1238,   730,   735,   736,
       0,   331,     0,     0,   237,     0,   245,   242,   259,   251,
     260,   252,   275,     0,     0,     0,   853,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   854,   132,     0,     0,
       0,     0,   113,   112,   133,   131,     0,   130,     0,   465,
     466,   464,   460,     0,   467,   469,   867,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   852,
     818,   610,     0,     0,   611,   619,     0,     0,   612,     0,
       0,     0,     0,     0,     0,   621,   310,   295,   299,   977,
     977,     0,   300,   977,   296,   977,   293,  1762,  1481,  1482,
     548,   555,   545,   547,   549,   546,     0,   554,   520,     0,
       0,     0,  1221,     0,  1289,  1290,  1291,  1292,  1293,  1294,
       0,  1288,  1295,     0,   961,   960,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   342,     0,     0,   336,
       0,     0,   776,   330,   333,   334,     0,   450,     0,   542,
     543,     0,   151,     0,     0,     0,     0,   500,   494,     0,
     556,   534,     0,  1214,   457,  1026,     0,   396,   323,   348,
     383,     0,   398,     0,   385,   384,   386,     0,   393,   938,
     438,     0,   707,     0,     0,   731,     0,     0,     0,   768,
     773,   769,     0,     0,   746,     0,   754,   724,     0,  1066,
    1178,  1185,     0,  1166,     0,  1192,  1188,     0,  1189,     0,
       0,  1190,     0,     0,  1185,     0,     0,     0,   788,     0,
     272,   786,     0,   579,     0,   581,   790,   272,   272,   486,
       0,   442,   399,   678,   693,     0,   689,     0,     0,   661,
     698,  1033,  1036,  1051,  1049,   701,     0,   662,   700,  1508,
    1256,     0,  1541,  1537,     0,  1509,     0,  1521,  1520,  1522,
       0,  1376,     0,     0,  1368,  1366,  1367,  1360,  1361,  1362,
    1363,  1364,  1365,  1357,  1369,  1531,  1530,  1524,  1525,  1276,
    1274,     0,  1417,  1418,  1419,  1532,  1426,     0,  1445,  1444,
       0,     0,     0,  1432,     0,     0,  1441,     0,  1475,  1262,
    1295,  1300,     0,     0,  1323,  1536,  1341,     0,     0,     0,
    1319,     0,     0,     0,     0,  1328,  1491,     0,     0,     0,
       0,     0,     0,  1103,  1102,  1206,     0,  1150,  1459,  1459,
    1459,  1395,  1462,  1457,  1458,  1390,  1590,     0,     0,  1550,
       0,  1065,  1056,     0,  1124,  1139,  1132,  1140,     0,   357,
       0,     0,   776,   862,   434,   756,     0,   748,   329,     0,
     838,     0,     0,     0,     0,   279,   280,   283,     0,     0,
       0,     0,     0,   573,   559,     0,     0,   574,   575,     0,
       0,   793,   794,   792,   128,   114,   135,   134,   115,   129,
     462,   826,     0,     0,     0,     0,     0,   861,   834,   860,
     832,   831,   833,   827,   488,     0,   613,     0,     0,   614,
     625,   623,   622,   624,   616,   311,   109,     0,     0,     0,
       0,     0,     0,     0,   522,     0,     0,   527,   516,   518,
       0,     0,     0,  1217,  1222,  1297,  1230,   515,     0,   951,
     950,   949,   953,   952,   955,   954,   946,   945,   958,   957,
     944,   943,   948,   947,     0,     0,   340,   344,   345,   343,
     335,   776,   362,   395,     0,     0,     0,   879,   321,     0,
       0,   502,     0,   535,     0,  1213,   482,  1024,   403,     0,
       0,   346,     0,   387,   325,   401,   402,     0,     0,   397,
       0,   933,   440,     0,     0,   706,     0,   734,   751,   752,
       0,     0,   776,   775,   897,   898,   895,   896,     0,  1177,
       0,     0,  1179,     0,     0,  1181,  1183,     0,     0,     0,
       0,     0,  1576,  1459,  1210,  1209,   272,   452,   272,   272,
     903,   526,     0,     0,  1604,     0,   687,   272,     0,  1540,
    1411,  1421,  1519,     0,     0,  1377,     0,     0,  1416,  1900,
       0,     0,  1449,  1450,  1431,     0,  1748,  1436,     0,     0,
       0,  1593,  1347,  1345,  1342,     0,  1343,     0,     0,  1325,
    1321,     0,  1327,  1352,  1107,  1106,  1105,  1104,     0,     0,
    1453,  1393,  1394,  1391,  1464,  1461,     0,  1295,  1062,     0,
       0,   967,     0,   776,   395,   749,   238,   239,   240,   241,
     274,     0,   855,   819,     0,     0,   565,     0,     0,     0,
       0,   856,   820,     0,     0,     0,   983,     0,     0,   617,
     618,   294,     0,   297,   302,     0,   303,   298,   301,   524,
     523,   521,   517,   519,  1218,     0,   802,   802,     0,   520,
     956,     0,     0,   332,   395,   369,     0,   337,     0,   458,
       0,   938,     0,   457,   501,     0,     0,   557,   404,   387,
       0,     0,   347,     0,   391,     0,   388,     0,   392,     0,
       0,     0,     0,   430,     0,     0,     0,     0,   708,   715,
     715,   774,     0,   778,     0,   745,   722,     0,     0,  1186,
    1195,     0,  1182,  1180,  1171,     0,  1173,   803,   580,   582,
     487,   690,   697,   272,  1372,     0,     0,     0,     0,  1427,
       0,  1428,  1433,  1437,     0,  1434,  1435,  1344,  1348,  1346,
    1329,  1147,  1149,     0,  1089,     0,  1120,  1459,   199,  1493,
       0,     0,   395,   358,     0,   243,   282,     0,     0,   571,
     560,     0,     0,   576,     0,     0,     0,     0,     0,   620,
     286,   309,   304,   802,     0,   799,   798,   514,     0,   339,
     338,     0,   374,     0,   456,     0,   569,   934,   323,   470,
     503,   504,   499,     0,   391,   352,   350,   354,   351,   349,
     353,     0,   393,   389,   390,     0,   935,     0,   439,   985,
       0,     0,   277,     0,     0,   713,   718,   718,   777,     0,
       0,  1207,  1184,     0,  1172,   663,  1373,     0,  1374,     0,
       0,  1439,  1438,  1452,  1454,     0,     0,  1467,  1119,  1392,
    1133,   362,   359,   273,     0,   563,   570,   561,   571,     0,
       0,   979,     0,   980,   981,   984,   797,   801,   800,     0,
     366,   367,   368,     0,   341,   370,   371,     0,   459,     0,
       0,     0,   393,   382,   872,   936,   937,   277,   715,     0,
     393,   709,   714,   721,   721,   776,   779,     0,  1194,  1375,
    1442,  1429,  1440,     0,     0,  1463,     0,     0,     0,   369,
       0,   562,   578,   577,     0,     0,     0,     0,     0,   372,
       0,   373,   394,   568,     0,   507,   872,     0,   313,   393,
     718,   276,  1207,   711,   710,   723,   901,  1455,  1456,     0,
       0,     0,  1465,  1468,  1466,  1460,   374,     0,   982,     0,
     379,     0,   378,     0,   376,   375,   558,   509,   511,   512,
       0,   505,   508,   510,   513,   314,     0,  1207,   721,   702,
     900,   899,     0,     0,  1472,  1471,  1470,   520,   564,     0,
     377,   381,   380,   489,     0,     0,   703,   712,   883,   894,
     882,   884,   892,   889,   891,   890,   888,     0,   360,     0,
     506,     0,   873,   875,     0,     0,   893,   887,  1088,  1075,
    1469,     0,   871,     0,     0,   885,   894,   507,   874,   876,
     886,     0,   490
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1076,  1752,  2279,    53,    54,
      55,    56,    57,    58,    59,    60,    61,  1108,    62,    63,
     797,  1860,  2390,    64,  1673,   633,  1517,  1518,  1802,  1519,
    1503,  1003,  1520,  1077,  1099,    66,    67,   997,  1492,    68,
      69,    70,  1121,  1122,  2694,  1297,  3415,  1741,  3540,  2240,
    2241,    71,    72,  2348,  1203,  2349,  2776,   491,  1824,  3096,
    3097,    73,  1254,  2415,  2416,  2417,  2418,  2377,  2823,  2824,
    2825,  2419,  3161,  3342,  2420,  1681,   871,  1346,  1347,  3442,
    3524,  3525,  3526,  3604,  3163,  2426,  2858,  3169,  3327,    74,
    1276,  1885,  2421,  2422,  2847,    75,    76,  1880,  1149,  1150,
    1757,  2780,    77,   519,  2681,  2378,  2379,  3353,    78,   185,
      79,  1263,    80,    81,    82,    83,  2827,  3328,  1154,  2291,
    2292,  2293,  2294,  2734,    84,  1261,  1155,  1863,    85,    86,
      87,  1791,    88,    89,    90,  1270,  1874,  1875,  3152,  3335,
    3452,  3610,  3611,  3319,  3107,  3108,  3109,    91,    92,    93,
      94,  1253,  1853,  1854,  2781,  1066,  1207,  1827,  1828,  2839,
      95,  3053,  3054,   520,  3530,  3507,    96,    97,  3057,  3058,
      98,    99,   100,   101,   102,   557,   852,   853,  2216,   103,
    1617,   104,   776,  2335,   105,   574,   867,   106,   107,   582,
    1986,   584,  1359,  2502,  2503,  2919,  1951,   710,   108,   109,
    1961,  1989,   110,   521,  2864,  3357,  3358,  3476,  2154,  2658,
     111,   522,  1104,  1710,  1892,  2433,  2434,  1712,  1713,  2873,
    1714,  2435,  2441,  2442,  2443,  2869,  2877,  3363,  3364,   112,
    1101,  1703,   113,   114,   115,  1127,   728,   116,  3435,   117,
     822,   118,   603,  1376,   119,  1721,  2695,   120,   121,   122,
    3578,  3651,  3652,  1258,  2444,  1079,   123,  2445,  3640,  3655,
    3656,  3657,  3188,  3622,   124,  3642,   126,   127,   128,   162,
     748,   749,   750,   129,  3171,   130,   131,  1847,  2376,  2806,
     132,   133,  1674,  2183,   134,   135,   136,  1247,   137,   138,
     139,   140,  1185,   141,   142,   143,   486,   654,  1034,  1042,
     144,  1337,   561,   145,   884,  1978,   146,   855,   147,  3643,
    1365,  1963,  1964,  1967,  3644,  1292,   150,  1369,  1972,  1975,
    3645,  1620,  1621,  1622,  1623,  1624,  2140,   152,   816,  1896,
    3646,   969,   155,   156,   157,   158,   658,   659,  1486,  2116,
     592,  1049,   621,   670,   671,  1635,  1636,  1654,  1655,  1646,
    2156,  1648,  1649,  2167,  1641,  3007,  3260,  1652,  1653,  1059,
    1060,  2160,   159,  2120,  1900,  1901,  1902,  2453,  2463,  2886,
    3195,  1903,   880,   652,  1904,  2633,  1909,  2406,  2407,  1715,
    1834,  1231,   970,  1232,  1845,   971,  1408,  1234,   972,   973,
     974,  1237,   975,   976,   977,   978,  1392,  1450,   979,   980,
    1427,  1842,  1843,  1333,  2028,   982,   983,  2976,  3239,  3230,
    2053,  2054,  1510,  2972,  3404,  3493,  3494,  3015,  3013,  3264,
    3406,  3558,  3592,  3593,   984,  2107,  1479,   730,   985,  2783,
    1481,  2048,  1661,  1390,  1995,  2012,  2013,  2025,  2549,  2032,
    2037,  2572,  2573,  2049,  2075,   986,  1998,  1999,  2533,  1394,
     987,  1026,  1027,  1440,  2071,  1037,  1038,   656,   988,   989,
     990,  1360,   645,  3191,   830,   706,  2249,  1608,   752,   589,
     991,   992,   993,   994,  1792,  1507,  2500,   646,   701,  2295,
     483,   484,   703,  1613,   647
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3202
static const int yypact[] =
{
    8715,   297,  4142, -3202, -3202,   297, -3202, 37817,   -50,   404,
       2,   140,  9898, 38214, 43375,   517,   153,  6399,   297, 43375,
    1781, 28257, 33450,   541, 43375,   397,   510, 28257, 43375, 43772,
     654,   604, 44169, 38611, 33053,   777, 43375,   788, 44566, 39008,
     618, 34641,   510, 25836, 34641,   775,   567, 44963,   950,   970,
     637, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202,   -50, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202,   155, -3202,   718,   198,   901,   691,
   -3202, -3202, -3202, 31465, 43375, 43375, 43375,   985, 31465, 43375,
   36229,   929, 23369, -3202, 43375, 43375, 34641, 43375, 34641, 43375,
     874, 43375, 43375, 45360, 36229,  1005,   659, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, 36229,  3216,   397, -3202,
   -3202, 36229,   864, 31465, 43375,   853,   883, 43375, -3202, 43375,
    1202,   966, 43375,  1089, 23783,  1060, 43375, 43375, 43375, 43375,
   -3202, -3202,  1068, 43375, -3202, 43375, -3202, 45757,   865,  1166,
    1336,  1300,   120, -3202, 39405, -3202, -3202, 34641, -3202, -3202,
   -3202, -3202, 31862, 43375,  1320, -3202, 46154, -3202,  1391, 32259,
   46551, -3202, 24197,  1453, 46948, 47345, -3202, -3202, 47742, -3202,
   48139,  1196, 48536, -3202, 48933, -3202,  1322, 49330, -3202,  1090,
   -3202,   -50,  1039, -3202,   222,   151,   278,   154,   159,   160,
    1039, -3202,  1123,  1123,   200, -3202, -3202, -3202,    14,  1146,
    1146,  1146,  1335,   547, -3202,  1146, 36229, -3202, -3202, -3202,
   -3202, -3202, 34641,   200, -3202, -3202,   397,  1176,  1603, 43375,
   -3202, 43375, -3202, 36229, 43375, -3202, -3202,  1623,  1271,  1496,
    1260, -3202,  1493,  1507,  1516,    33,   397,  1423, -3202, -3202,
    1542, 14329,   397, 35038, 49727,   355, 29873,   397, 39802,  1409,
     659,  1580, -3202,   238, -3202,  1760,  1416,  1661,  1260,   659,
   -3202, -3202, 21340, -3202,   217,  1435, -3202, -3202, 34641, -3202,
   -3202, 50124,  1541, -3202,  1746, 14747, -3202, 43375,  1455, -3202,
    1477,  1467,  1482, -3202,  8715, 36229,   855,   855,  1883,   855,
     694,   945, -3202,  1584, -3202,   567, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,   575,   217,
    1523, -3202,   634, -3202,    79,  1504,  1022, -3202,   171,  1547,
    3527,  1538,   178, -3202,  2426,  1123, 43375, 43375, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,  1545, -3202,
   -3202,  1544,   870,    62,  1670,  4345,   467,  2862,   747,   135,
    1762,  1045,  1842,   917,  3545, 43375,  1818,    38, -3202,    17,
   -3202,  1664,  1788,  1804, 31465,  1626, -3202, 43375, -3202, -3202,
   -3202, 31465, -3202,  1820, 24611, -3202, 43375, -3202, -3202, -3202,
   -3202,  1751, 43375, -3202, -3202,  1896, 43375, -3202,  1146,   808,
    1668,  2043, 54491, 43375,  1724,  2096,  1741, -3202, -3202,  1724,
   -3202, -3202, 43375, 43375,  1752,   628,  1724,  2099,   212,  1784,
    1889,   603,  1262,   125,  2022,  1724, 36229, 36229, 36229,  1987,
   43375, 50521, 31465, 43375, -3202, -3202,   218,  1809,  2050,  1523,
     308,  2051,  1755,  2053, -3202,  1795,  2055,  1538,  2057,  1757,
   -3202, 50918, 51315,  2061,  1545, 43375,  2064,  1757,  2068,  1952,
    2071,   308,  2072, -3202,   620,  2078,  1962,  2082,  1233,  1757,
   30272,  2083,   163, -3202, 16419, -3202,  1865, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, 43375,  1789, 43375,
   43375, -3202, -3202, -3202, 33847, 43375, 35435, -3202,   426, -3202,
      87, 43375, -3202, 54491,  2184, 43375,  2076,  2076,  2076, -3202,
   -3202, -3202,  2021, 43375,  2084,  2091, 33847, 43375, -3202, 51712,
    1796,  1168,  1825,   537,  1826, 16419,  1810,   102,   102,  1813,
   -3202, -3202, -3202,   976,  1816,  1822, -3202,  1056,  1056,  1967,
    1827,  1828, -3202,  1134,  1829,  1837,  1839,  1154,  1831,  1832,
    1833,  1666,   102, 16419, -3202,  1834,  1056,  1835,  1836,  1840,
    1844,  1843, -3202,  1856,  1845,  1120,  1192,  1846,  1848, -3202,
    1827, -3202,   103,  1849,  1850,  1853,  1854,  1855,  1857,  1862,
   -3202, -3202, -3202, -3202, -3202, 16419, 16419, -3202, 13493, -3202,
     397, -3202, -3202, -3202, -3202, -3202, -3202, -3202,   100, -3202,
    1159,  3543, -3202, -3202,  2012, 16419, -3202, -3202,   183, -3202,
     217,  1205, -3202, -3202, -3202, -3202, -3202,   223,  1851, -3202,
    1311, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, 29474,
    2266, -3202,  1152,    17,   897,  2211, 27027, 27437, -3202, -3202,
    2100, -3202, 36229, -3202, 16419, 25439, -3202,   217, -3202,   116,
   43375, -3202, 21739, -3202,   -50, -3202,  9664, -3202,  1137,  1455,
   43375, 43375,  2270, -3202, -3202, -3202,  1477, -3202, -3202,   901,
     901, 16419,   901,   686,   685, 15165, 16419,  2160,   806,  2161,
   -3202,   694,   945, -3202,   217, 26233,  1104,  1953,  1956, 30671,
    1877,  1959,  1960,  2240, 52109, -3202, -3202, -3202, -3202, -3202,
     365,   193,  1966,   106, -3202, 43375,  2077,   971,  2013, -3202,
    1979,  1982,  2097,   971,   942, 52506, -3202, -3202, -3202, -3202,
   -3202,  1841, -3202, 12281, -3202, -3202, -3202,  1996,  1978,   191,
    2286,  2102,   672,  1306,   148, 36229,  2182,  2004,  2007,  1931,
     927,  1929, -3202,    47,  1993,  1994, 53697,  2104, 25025,  2016,
   49727, -3202, -3202,  2017,  2020, -3202, -3202,   971, -3202,  2329,
     971,   971,   809,  2331,  2026,  1282,  1099,  1724,  1929,   858,
   -3202,  1949,  2030,    -3, -3202,  2129,  2286,   124,  1361,  1929,
   -3202,  2033,  2035, 43375, 43375, 43375, 43375, 36229,  2041,  2044,
    2086, 36626,  2045, -3202, -3202,  2048,  1427,  1929,   869,  1050,
   -3202, -3202,   659, -3202, 43375, -3202, 36229,  1523, 54491,  2151,
    1538,   971, 43375, 43375,  1545,   131,   701,  2152, 43375,  2217,
    2023, -3202, -3202,  1724, -3202, 26630,  1752, -3202,  1975, -3202,
    2031, -3202,  2031,  2031,  1976,  1976,  1980, -3202, -3202, -3202,
    1666,  2031,  1976, -3202, 55682, -3202,  1008,  1083, -3202, -3202,
    2385,  2388, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202,    93,   678, -3202,  2399, -3202, -3202, 54491, 43375, -3202,
    2316,  2049, 30671, -3202,  2037, -3202, 43375,  2348, -3202, -3202,
     397,  2046, 43375,  2230, 43375, 43375, 43375, 43375, -3202, -3202,
     519,    56, -3202, 36626, -3202,   858,  2415,    10,  1146, 29873,
    2304, 43375,  2200, -3202,  2024,  2422, -3202,  1437, -3202,  2149,
   -3202, 19744,  2080, 31465,   308, -3202, -3202, -3202, -3202, 54491,
   43375, 52903, 31465,   308, 43375, 43375,  2334,  2090,  2338,  2092,
   25025,   308,   167, 43375, 43375, 36229, 43375, -3202, 43375, -3202,
   -3202, -3202, -3202, 43375, 36229, 43375, 36626,  2340,  2341,   308,
   43375, 43375, -3202,  9664,  1217,    69, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, 43375,  1263, -3202, -3202,  1326,
   43375,   133, 31465, 43375,  2233, 43375, 36229, 36229, 43375,  2126,
    1851,   -65, -3202,  2103, 20941,  2180, -3202,   215, 34641,  2242,
   -3202, -3202,  1343,  1318,   566, -3202, -3202, -3202, -3202, -3202,
   -3202, 35435, 33450,  2335,    40, 43375, -3202, 16419, 13911, -3202,
   -3202, -3202,  2052,  9664,  2101, 16419, -3202, -3202, 16419,  1123,
    1123, 16419, -3202, -3202, -3202, -3202,    98,  1123, -3202, 16419,
   16419,  1123,  1123,  2031,  2031, -3202,   117, 16419, -3202, 25025,
   16419, 18091, 11465, 16419,  2134,  2088,  1123, -3202,  1123, -3202,
   16419, 13075, -3202, 16419,  2269, 16419,   897,  2271, 16419,   897,
     217,  2062,  2062,   567,  1035,  5408,  2066, -3202,  2177,  1123,
   -3202,  1123,   574, 16419, 30671,  2159,   181, 16419,  2085,  1442,
   -3202, 16419,   627, -3202,  2089, 16419,  2158, -3202,   269, 16419,
   16419, 16419, 16419, 16419, 16419, 16419, 16419, 16419, 54491, -3202,
   18509,   293,   531,   359, 35832, 14329,  2365,  1212, 11046, -3202,
   -3202, -3202, -3202, 36229,  2266, -3202, -3202,  2166, -3202, -3202,
   -3202, -3202,  1010, -3202, -3202,  1208, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202,  2079, -3202, -3202,
   -3202, -3202, -3202,  2079, -3202,  2094,  1921, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202,  2360,  2366,   308, -3202, 43375,
      53, -3202, -3202, -3202,  2111, -3202, 34244, -3202, 14747, -3202,
    1367,  1827, -3202,  2346, -3202,  2098, -3202,  4415,  2346, -3202,
   -3202,  1269,  2280,  2287,  2287, -3202,   -26,  9664,  2342,  1565,
    9664,  1687, -3202, -3202, -3202, -3202,     4, -3202,  2160,   806,
    2107,  1368,  2191,  2198,  2243, 43375, 43375, -3202, 30671, 43375,
   43375,  2201, 43375, -3202,  2483,  2127, 43375,  2371,  2372,  2138,
   -3202, -3202, 43375, -3202,  2330, 43375, 16419,  2332, 43375,   490,
    2336, -3202,   960, 43375, 43375,  2306, -3202, -3202, -3202, 29873,
   -3202,  1040, -3202, -3202,  2312, -3202, -3202, 55682, -3202, -3202,
    1384, -3202, 54888, 40199, -3202, -3202,   330, 43375, 43375, -3202,
   -3202, 43375, 43375, 43375, 43375, 37023, 43375, 43375,   754,   856,
   43375, 37420, -3202, 36229, 43375, 43375, 30671, -3202, 43375,  2326,
     190, -3202,  3616,  2225, -3202, 43375, 43375,  2143,  1389,  2228,
   -3202, 43375,  4956, 43375, 43375, -3202, -3202,   971, -3202, -3202,
   -3202, -3202, -3202, 43375, 43375,   971, 43375,   971,   174, -3202,
   31068, 43375, -3202, -3202, -3202, 43375, 43375, 43375, 43375, 43375,
   43375,   778,   394,  2289,  2291,  2293, 43375, 43375, 43375, -3202,
   -3202,  2272, -3202, 43375,  4956, 43375, 43375,  2236,  2238,   249,
    2308, -3202, -3202, -3202, -3202, -3202,  2405,  2565, 43375,  2409,
    2412,  2234,  2235,  2413,   105, 43375, 43375, 43375, 43375, 43375,
   43375,  2424,   105,  2361,    55, -3202,  2202,  1397, -3202, -3202,
   16419,  2586, 54491,  2189,  2190,  2268,  2273,  2274, -3202,  2192,
    2275,  1123, -3202, -3202,  1097, -3202,   519,   916, -3202,   398,
    4956,  2478, 43375,  1413, -3202,  2207, 36229,  4956,  2315,  2204,
     240, -3202, -3202,  2485, -3202,   397,  1752,  1752,  1752,  1752,
   -3202, -3202, -3202, -3202,  1222, -3202,  2205, 43375,  2314,  4956,
    2315,   858,   503, 36229, 32656,  1526,  2606,  2481,   397,  2389,
   36229, 12678,  2890, -3202,  2479,  2482,  2497, -3202, 19345, 40596,
    2210,   683, -3202, 40596, 40993, -3202,   217,  2212, 16837,  2180,
    1523, -3202,  2616, -3202,  2514,   308,  1538, -3202,  1757, -3202,
   43375, 43375, 43375, 43375,  1545, -3202, -3202,  1757,  2398,   308,
     308, -3202,  2400,   308,  1757,  2337,  2508, 29873, -3202,   163,
   -3202, -3202, 16419,  2309,  1433, -3202, 43375, -3202,  1757,  2263,
   43375,  2221, -3202,  1757,  1123,  1757,  1851,  1851,  1757, 41390,
    2639,  2507, -3202,  1438, -3202, -3202, 14329, -3202,    76, -3202,
      95,   557,  2444, -3202, -3202, -3202, -3202, 54491, -3202, -3202,
   -3202, -3202, -3202, 43375,   180,  2414,  2227, 41390,  2619,   308,
   -3202,  1468, -3202,  1170, -3202,  1201, 16419, 16419,    77, -3202,
    5439,  1469,  2241,  2244,  1470, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202,  2246,  2518, -3202,  2248,  1483,  1490,  2249,  2250,
   -3202, -3202,  3473,  2251,  5925,  2252, 18091, 18091,  3651, -3202,
   -3202, 18091,  2254, -3202,  1503,  4848,  2232,  2255,  2264, -3202,
    2256,  2257,  5887, 15583, 16419, 15583, 15583,  6762,  2232,  2259,
    1509, 30671,  7263,  1511, -3202, 16419, 30671,  3994, 16419, -3202,
   -3202, 16419, 43375,  2260,  2261, -3202,   117, -3202,  2290, -3202,
   18091, 18091,  2288, 13493, -3202, -3202,  2523, -3202, -3202,  1514,
   -3202,  2276, -3202, -3202,  2690,   184, 16419,  2085, 16419,  2322,
   25025,  2933, 16419,  2349,  3853,  3853,   271,   271,   128,   128,
     128,   127, -3202,   359, -3202, -3202, -3202,  2278,  1843, 16419,
   -3202,  1281,  1355, 36229,  1106,  1147, -3202, -3202, -3202, 19744,
    2307, 16419, 16419, 16419,  2265,  2435,  1520, -3202,   659, -3202,
    1123,   574, 27847, -3202, -3202, 16419, -3202, -3202, -3202, -3202,
    1529, 21739,  2080, 14747,   217, -3202, -3202, -3202, -3202, -3202,
   16419, -3202, -3202,  2081,  1595, 16419,  1565, -3202, -3202, 36229,
    2242,  2242, 16419, 16419, 15165, -3202, -3202,  2559, -3202, -3202,
   -3202, -3202, 43375, 43375, 43375, -3202, -3202, -3202, -3202, -3202,
     397, -3202,  2498, -3202, 16419,   136,  2285,  2294, 43375,   308,
   -3202, -3202,  9664, -3202, -3202,  2325,  2351, 43375,  2129, -3202,
    2528, -3202, -3202, -3202, -3202,  2477, -3202, -3202,   678, -3202,
   40199, 54888, -3202, 54888, -3202,   678,   977, -3202,  1757, -3202,
   54491,    99, -3202, -3202, -3202, -3202, -3202,   308,   308, 43375,
   43375, 43375, 43375, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
    1534, -3202,   851, -3202, -3202, -3202, -3202, -3202, 43375,   940,
   -3202,   644, 54491, -3202, 54094, 43375, -3202, 43375,  2516, -3202,
   -3202, -3202,  2454,   507, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202,   382, 43375, -3202,  1123,  2459, 43375,  2359, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, 30671, 30671,
   30671,  1535, -3202, -3202,   397, -3202, -3202,   508, -3202,  2377,
   -3202, -3202, -3202,  2519,  2520,  2521,  2384,  2391,  2393,  2401,
   -3202,  2403,  2404,  2410, -3202, -3202, -3202, 43375, -3202, -3202,
   -3202, 43375, 43375, -3202, -3202, -3202,   105, 54491,  2550,   105,
     105, 43375, 43375,   105, -3202, -3202, -3202,  2554,  2563,  2564,
    2571,  2574,  2577,   105, -3202, -3202, -3202, -3202,   808,  1990,
   22955, -3202,  2356,  7308,  2350,  2190,  2345,  1123,   -53,   112,
      67,  2457,  1123,  2566,  2354, -3202,  1261,  2579,  2369,  2369,
    2369,  2369,  2369,  2369,  2369, -3202, -3202,  2283, -3202,  2534,
    2416, -3202, -3202, 30671, 22955,  1146, -3202,   397,  2047, 33450,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202,  2693, -3202, -3202,
   -3202, -3202, -3202, 36229,   519,   397,  1543, -3202, 54491, 43375,
   -3202, 43375,  2402,  2362, 36229,  2363,  2355, -3202, -3202, -3202,
   -3202,  1560, -3202, 54491,    -4,  2545,  2548,   950, 43375,  2443,
   36229,  2427, -3202,  1563,    73, -3202,   397, 29873, 53300,  1070,
   -3202,  1893, -3202, -3202, -3202,  2557, -3202, -3202,   950, 11884,
     683,  2378, 43375, -3202,  2380, 19744,  2618,  2553, -3202, 19744,
    2553,   975,  2553,  2622, -3202, 22138, -3202,  2383,  1310, 11046,
    2569,  9664, -3202,   308, 54491, 43375, -3202,   308,  2445,   308,
    2447,   308,   308, 36229, -3202, -3202, 36229, -3202, 43375, 36626,
     308, -3202,  9664, 36229, -3202, -3202, 43375,  1757, 31465, -3202,
    2381, 43375,   -57, -3202, -3202,  2562, -3202,   950, 43375,   217,
    2386, -3202, -3202, -3202, -3202,  2692,  2695, -3202, -3202, -3202,
   43375, 33847,   173, 43375, -3202, -3202, -3202, -3202,  2396,  1568,
    7601, 16419, -3202,  2707, 54491, -3202, -3202, -3202, -3202, -3202,
   16419, -3202, -3202, -3202, -3202, -3202, 16419, -3202, 16419,  2687,
   -3202,  2408,  2408, 18091,   156,  1835, 18091, 18091, 18091, 18091,
   18091, 18091, 18091, 18091, 18091, 54491, 18927,  1007, -3202, -3202,
   16419, 16419,  2694,  2687, -3202, -3202,   453,   453, 54491,  2417,
    2232,  2418,  2420, 16419, -3202, -3202,  1569, 30671, -3202, 16419,
    5138,  1576,  2461,  7627,   217,  8028, -3202,  2780,   397, 16419,
     612,  1100, 16419,  1579, 16419,  2696, -3202, -3202, -3202,  2425,
   -3202, -3202, 54491, 16419, 18091, 18091,  3205, -3202,  4434, 16419,
    2423,  4643, 13493, -3202,   510,   510,   510,   510, -3202, 36229,
   36229,  2210, 16419,  2701,  1586,  1589,  8054,  2435, 22537, -3202,
     416, 16001,    17,  2428, -3202, -3202,  8268,  2441, 43375, -3202,
    2180, -3202, -3202,  2430, -3202,  1595, -3202, -3202, -3202,  8384,
    2594,  1851, -3202, -3202, -3202, -3202, -3202,   686, -3202, -3202,
   -3202, -3202,  2369,  8873, -3202, 43375, 43375,  1596, -3202, -3202,
   43375, -3202,  1504, -3202, -3202,  2684,  1309, -3202, -3202, -3202,
    2501, -3202,   533,   962, -3202,  2503, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, 30671, 22955, 30671, -3202,  2513,  2515,   101,
     737,  2522,  2529,  2449,  2451,  2453, -3202,  1757,  1039,   397,
   43375, 43375, -3202, -3202,  1757, -3202,   397,  1757,   397, -3202,
   -3202, -3202, -3202, 31068, -3202, -3202, -3202, 43375,  2723,   166,
    1313, 43375, 43375, 43375, 43375, 43375, 43375, 43375,  2129, -3202,
   -3202, -3202,  2456,   105, -3202, -3202,  2685,  2688, -3202,   105,
     105,   105,   105,   105,   105, -3202,   107, -3202, -3202,  2096,
    2096,   114, -3202,  2096, -3202,  2096, -3202,  2430,  1123,  1010,
   -3202, -3202, -3202, -3202, -3202, -3202,  2202, -3202,   646,  1123,
    1636,  2460, -3202,  2462, -3202, -3202, -3202, -3202, -3202, -3202,
    2464, -3202,   574, 36229,  2369, -3202,    84,    81,    82,    83,
   41787, 42184, 42581,  2458, 43375, 18091, -3202,   902,   571, -3202,
    2699, 36229,  2504, -3202, -3202, -3202,  2466, -3202, 54491, -3202,
   -3202,  2867,   240,  2467,  2609,   891,  2517,  2757, -3202,  1608,
   -3202, -3202, 43375, -3202,  2534,  1090,   205, -3202, 32656, -3202,
    2732, 32656, -3202, 43375, -3202, -3202, -3202,  2839,  2567,  2524,
     398,   397,  2427, 43375,  2486, -3202, 40199, 16419, 16419, -3202,
    2473, -3202,  2488,  5623, -3202,  1752, -3202, -3202,   662, -3202,
   40596,  2491, 43375,   683, 19744, -3202, -3202,  1046, -3202, 19744,
    2733, -3202, 19744, 43375,  2495, 43375,  1610, 28667, -3202,  2496,
     308, -3202, 43375, -3202, 43375, -3202, -3202,   308,   308, -3202,
    2612, -3202,  2500,  1757, -3202,  1123, -3202,  2774, 41390, -3202,
   -3202, -3202, -3202, -3202, -3202,    40,  2783, -3202, -3202, -3202,
   -3202, 16419,  9664, -3202,  2502,  9664,  8889,  9664,  2694,  3963,
    2784, -3202,   842,  2505,  3963,  3625,  3625,  1462,  1462,   919,
     919,   919,  2408, -3202,  1007,  9664,  9664, -3202, -3202, -3202,
   -3202,  2506, -3202, -3202, -3202,  2232, -3202, 17255, -3202, -3202,
    2549,  2556,  2509, -3202, 16419, 17673,  2510, 55682, -3202, -3202,
     574,  2062, 18091, 18091,  2406, -3202,   570, 16419, 54491,  1617,
    2406,  1169,  2008, 16419, 16419,  5477,   294, 16419,  8915, 36229,
   36229, 36229, 36229, -3202, -3202,  9664,  2898,  2789,  2435,  2435,
    2435, -3202, 55285, -3202, -3202, -3202, -3202, 16419,   397, -3202,
     567, -3202, -3202, 25025, -3202, -3202, -3202,  1269,  1039, -3202,
    1620,  1622,  2504, -3202,  1877, -3202,  2589, -3202,  2283,  2711,
   -3202,  2713,  1039, 43375, 54491, -3202, -3202,  2530, 43375, 43375,
    1123,  1123, 54491,  2527, -3202,  1123,  1123,  2531, -3202, 43375,
   43375, -3202, -3202, -3202, -3202, -3202,  1757,  1757, -3202, -3202,
   -3202, -3202, 43375, 43375, 43375, 43375,  2822, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202,  2770, -3202,   105,   105, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202,  1724,  2854,   397,   397,
    2727, 43375,   397,   397, -3202,   989,  2865, -3202,  2797,   640,
    2543,   185,  2824, -3202, -3202, -3202, -3202,  2828,  1039, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, 16419,   142,  3963, -3202, -3202, -3202,
   -3202,  2504,  1146,  2607, 30671,  2611,   950, -3202,    69, 36229,
   43375,  2860,  2855, -3202,   397, -3202, -3202, -3202, -3202,  2892,
    2558,   204,  2560,  1526, -3202, -3202, -3202,   539, 43375, -3202,
     748, -3202,  2800,  2846,  2568, -3202, 20143, -3202,  9664,  9664,
     397, 56079,  1893, -3202, -3202, -3202, -3202, -3202,  2643, -3202,
   43375,  1628, -3202, 16419,  2570, -3202, -3202, 19744,  1046,  1630,
   43375,  1641, 54491,  2435, -3202, -3202,   308, -3202,   308,   308,
   -3202, -3202, 43375, 43375, -3202,  2743, -3202,   308, 41390,  9664,
   -3202, -3202, -3202, 18091,  2851, -3202,  2572, 54491, -3202,  2573,
    1642,  1647, -3202, -3202, -3202,  9201,  2625,  9664,  2677,  2578,
    2581, -3202,  1232,  1232,   570,  1650, -3202, 18091, 18091,  2406,
    2406, 16419,  2406, -3202, -3202, -3202, -3202, -3202, 16419, 16419,
    2620, -3202, -3202, -3202,  2747, -3202,  9339,   574, -3202,  2584,
    1565, -3202,  2729,  2504,  2607, -3202, -3202, -3202, -3202, -3202,
    2647, 22955, -3202, -3202, 20542, 25025, -3202,   101,  2590,  2591,
     737, -3202, -3202,   815,   352,  2634,  1757,  2885,   105, -3202,
   -3202, -3202,   397, -3202, -3202, 43375,  2595, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, 31465,  2999,  2999, 36229,   646,
   -3202,  9450,  2791, -3202,  2607,  2820,  2868, -3202,  1656, -3202,
   43375,  2524,    48,  2534, -3202,   333,  2755, -3202, -3202,  1526,
     229,   835, -3202, 36229,  2548,  2734, -3202,  2736, -3202,  2985,
    2792,  2989,   397, -3202, 43375, 20143, 16419,  1659, -3202, 42978,
   10644, -3202, 54888, -3202,  1665, -3202, -3202, 36229,  1681, -3202,
    9664, 43375, -3202, -3202, -3202,  1689, -3202, -3202, -3202, -3202,
   -3202, -3202, -3202,   173,  1294, 18091, 54491,  1696, 16419, -3202,
   16419, -3202, -3202, -3202,   396, -3202, -3202, -3202,  1232,  1232,
    2406,  2232,  9664, 43375, -3202,  3004,  2796,  2435, -3202, -3202,
    2802, 36229,  2607, -3202, 16419, -3202, -3202, 54491,  1538,   348,
   -3202, 54491, 54491, -3202, 43375, 43375, 43375, 43375, 43375, -3202,
    1990, -3202,  2595,  2999,   719, -3202, -3202, -3202,  2911, -3202,
   -3202,    78,  2806,  2714, -3202, 30671,  2922, -3202, 32656, -3202,
   -3202, -3202, -3202, 31465,  2548, -3202, -3202, -3202, -3202, -3202,
   -3202,  1705,  2567, -3202, -3202,  2808, -3202,  2810, -3202, -3202,
    1707,  9472,  2675, 20143, 43375, -3202,   272,   272, -3202,  5623,
   56079,  2307, -3202,  1715, -3202, -3202,  1294,  1720, -3202,  1722,
    1727,  2689, -3202,  2631, -3202,  3037, 16419,   877, -3202, -3202,
   -3202,  1146, -3202,  9664,  1729, -3202, -3202, -3202,  2782,  1732,
    1735,  2635,  2680,  2635, -3202,  1757, -3202, -3202, -3202,  2951,
   -3202, -3202, -3202,   230, -3202,  2823,  2825, 43375, -3202, 43375,
    3044,  2648,  2567, -3202,  2766, -3202, -3202,  2675, 42978,  1931,
    2567, -3202, -3202,  1595,  1595,  1893, -3202,  2964, -3202, -3202,
   -3202, -3202, -3202, 43375,  2651,  2232,   164,   164,  2653,  2820,
   31465, -3202, -3202, -3202, 43375,  2785,   617,   617,  2977, -3202,
    2717, -3202, -3202, -3202,   101, 29071,  2766,  3013, -3202,  2567,
     272, -3202,  2307, -3202, -3202, -3202,   245, -3202, -3202,   111,
    2786,   608, -3202, -3202, -3202, -3202,  2806,  1538, -3202,  2961,
   -3202,  3078, -3202,   619, -3202, -3202,  2527, -3202, -3202, -3202,
    1737, -3202, -3202, -3202, -3202, -3202,  2665,  2307,  1595, -3202,
   -3202, -3202,  1319,  3070, -3202, -3202, -3202,   646, -3202,  2818,
   -3202, -3202, -3202, -3202, 29071, 29873, -3202, -3202, -3202,   525,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202,   111, -3202, 31465,
   -3202,  1740, -3202, -3202,  2682,  1252, -3202, -3202,  1299,  1482,
   -3202,  2671, -3202, 29873,   397, -3202,   525, 29071, -3202, -3202,
   -3202,  1743, -3202
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3202, -3202, -3202,  2431, -3202,  -698,   282, -3202, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202,   710, -3202, -3202,    91,  1624,  2109,   967, -3202, -3202,
   -3202, -3202,  -598,   122,   550, -3202, -3202, -3202, -3202, -3202,
   -3202, -3202,   729,  1358,  2411,  -170, -3202, -1105,  -430, -3202,
     411, -3202, -3202, -3202,   768,  -183, -3202, -3202, -3202, -3202,
   -3202, -1756,     1,   279, -3202,   283,  1399,   437, -3202,    -6,
   -3202, -3202, -3202, -3202,  -746,   951,  -577,  -843,  1184,  -422,
    -456,  -385,  -383,  -424, -3202, -2886, -3080, -2270, -2479,  2296,
   -3202, -3202, -3202,   296, -3202, -1752, -3202, -3202,  1872, -1034,
   -3202,  -937, -3202, -3202,   725,  1465,   299, -3202, -3202,   113,
   -3202, -3202, -3202, -3202, -3202, -3202, -2713, -3202, -1115, -3202,
     423, -2235,   868, -3202, -3202, -3202,  1899, -3202, -3202, -3202,
   -3202, -1224, -3202, -3202, -1746, -3202,  1317,   763, -3202, -3202,
   -3202,  -494,  -465, -3202, -3154,    65,    71, -3202, -3202, -3202,
   -3202,  -774, -3202,   798, -2275,  -720, -3202, -3202,   830, -3202,
   -3202,  -391,  -103,  1935, -3202,  -321, -3202, -3202, -3202,  -102,
   -3202, -3202, -3202, -3202, -3202, -3202, -1306,   277,  -670, -3202,
   -3202, -3202, -3202, -1634, -3202,  3162,  2597, -1744, -3202,     9,
      24,  2318,  -859, -1940,   273, -3202, -3202, -1336, -3202, -3202,
   -3202, -1866, -1741, -3202,   334,  -160,  -275, -3113, -3201, -2555,
   -3202, -3202,  -820, -3202, -3202, -3202, -1038,  1488, -1682, -3202,
   -1671,   337, -2747,  -549, -2374, -3202, -2705,  -276, -3202, -3202,
   -3202, -3202, -3202, -3202, -3202,  -819,  -498, -3202, -2520, -3202,
   -3202, -3202, -3202,  1182, -3202,   339, -3202, -3202, -3202, -3202,
    -371, -3202,  -454,  -556,  -697,  -644, -3202, -3202, -3202, -3202,
    -411,  -452, -3202, -3202, -3202,   123, -3202, -3202, -3202,  1717,
    -728,  -592,  2580, -1735,  -119, -3202, -3202, -3202, -3202, -2233,
   -3202, -3202, -3202, -3202, -3202, -3202, -3202,  -920, -3202, -3202,
   -3202, -3202, -3202, -3202,  1592,  3200,   -23, -3202, -3202,  2175,
   -3202, -3202, -3202, -3202, -3202, -3202,  2367,   377, -3202,    54,
   -3202, -3202,   716, -1797,    59, -3202, -3202, -3202, -3202,   -56,
      72, -3202,  1086, -3202, -3202, -1535, -3202,  2373, -3202, -3202,
       5,     0,   -46,   -47,   -40, -3202,  2575,  2193, -3202, -3202,
     -32,  1033, -3202,  -672,  -664, -3202,  1081,  -507,  1575,  1072,
     210,   -29, -3202, -2104,   573, -3202, -3202,  -502,  1583, -3202,
    2183,  1599, -3202,  1625,  1127, -1785,  1352, -1798,   793,  -619,
      57,    80,  2617,  2730, -3202, -2773,  1117, -2726,   418,  -215,
    1439, -1199, -3202, -3202,  -885,  2112, -3202, -3202, -3202,  5171,
    5724, -3202, -3202,  5750,  6161, -3202,  -775,   669,  6175,  4401,
    -907, -1421,  -443,  5360,  1354,  -959, -1255, -3202, -3202, -3202,
    -116,   680,   319, -3202, -3202, -3202,  -280, -2056,  -278, -3202,
   -3202, -3202,  -283, -2450,   878, -3202,  -150, -3202,  7173,  1124,
   -3202,  -684,  -866, -1327, -3202, -3202, -3202, -3202, -3202, -3202,
   -3202, -1239, -2429, -1690,  1194, -3202, -3202,  1284, -3202, -3202,
   -3202,  -970,  -649, -1490,  1199, -1501, -3202,  -656,  1321,  1794,
    2490,  -611,  3721,   346,  2987,  -433, -1672,  -941,  -677, -3202,
    -145, -3202,   474,  1434,   227,    -1, -3202,    49,  1750,  -833,
    3934,  -796,  -756, -2240, -3202
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1913
static const yytype_int16 yytable[] =
{
     154,  1061,   662,   872,   873,   153,   794,  1303,   877,  1062,
     648,   492,   998,   518,  1737,  1311,  1952,  1372,   700,  1063,
     577,  1183,   729,   711,  1939,  1831,   577,  1349,  1005,  1272,
    2211,  2065,  1402,  1403,  1131,  1070,  1905,  1383,  1013,  1429,
    1774,  2212,  2214,   614,   834,  1173,   583,  2522,   661,  1878,
    1064,  1418,  2660,  2729,   148,  2731,   482,  1614,   615,   149,
    1206,  1994,   482,   482,   784,  1711,  1102,  2876,   482,  2639,
     482,   585,   151,   587,  2251,  1504,   482,   595,   482,  1521,
    1521,   605,   611,   585,  2139,   618,  1245,   611,   611,  1135,
    1136,  1249,   650,  1160,  1614,  2506,   482,  1651,  1255,  1294,
    3024,  1259,  1935,   824,  2391,  2464,  2466,  1274,  2392,  2830,
    2785,   673,  2472,  2450,  2393,  1769,  2394,  3143,   674,  2395,
     665,   643,    65,   125,   651,  2396,  3182,  2147,  1667,   632,
     556,  3156,  1396,  1397,  1282,  2144,  2807,  2808,  2809,  2810,
    2811,  2812,  1455,  2957,  2785,  1271,  1448,  1456, -1271, -1266,
    1691, -1695,  1455,  1455, -1727, -1076,  1696,  1415,   672, -1747,
   -1776,  1100,  1728,  1057,   528,  3438,  2867,  3199,  1058,  3201,
    1334,   897,   490,  1876,  3122,  3124,  3126,  3119,  1080,  1719,
    2381,  1835,  1615,  1988,  1675,  1105,  2005,  3590,  2344,  2531,
    2813,  2119,  1609,  2346,  3589,  1163,   746,  2511, -1079,  1686,
    1755,  1200,  1295,  1758,  1759,  2069,  1295,  -312,  2069,  2692,
     501,  2162,  1295,   705,   707,   705,  2513,  3520,   713,  1949,
    1968,   731, -1630,   713,   482, -1076,   482,  1772,   482,  1611,
     482,   705,   713,   858,  2854,  2815,  1609,  1164,  -153,  1675,
    3590,  3050,  2245,  1836,  1367,  1883,  1719,  3477,  2006,  2479,
    1286,  2481,  1329,  1676,  1810,  1682,   734,  3620,   737,  1760,
     812,  2940,  2794,  2941,  3462,   503,  1194,   488, -1079,  1612,
    1457,  1677,  2797,  1611,  1458,  3543,  3544,  3344, -1698,  1180,
   -1479,  1081,   868,  1883,  1446,  1183,  1683, -1479,  1106,   860,
     747,  3158,  3455,  2151,  1459,  1460,  1455, -1076,  1837,  3073,
    1743,  1838,  1287,  2007,  2104, -1495,  2008,  2323,  1814,  1461,
    2388,  2105, -1495,  1612,  1960,  1133,  1643,  2795,  2520,  1490,
    1429,   485,  2917,  3456,  3340,  3315,  1677,  3274,  3566,  1402,
    1403,  1687,  1067,  3521,  1680,  2334,  1969,  1418,   865,  3100,
   -1079,  1487,  1462,  3051,  1134,  1463,   160,  1295,   780, -1238,
    1073,  3316,   571,  2579,   729,  2581,  2582,   866,  1484,  1464,
    1305,  1068,  3341,  1720,  1644,  1073,  2792,  3322,  2918,  1839,
    1809,  1815,  2819,  2152,  3532,  1813,  1015,  1491,  1761,  3618,
    1762,  2942,  2389,   161,  1455,  3101,  1288,   819,  2512,  1165,
    3457,  2943,   729,  3522,   827,  1839,   712,  2347,   588,  2163,
    2009,   732,  1678,  1616,   510,  1688,   511,  2514,  2820,  2693,
     743,  1496,   529,  1675,  1839,  3621,  1736,   813,  1684,  1855,
    2821,  1181,  3159, -1238,  1082,  3580,  3052,  1676,  2246,  3046,
    1884,  1466,  1829,  1729,   869,  1289,  3324,  1396,  1397,  3028,
    1950,   704,  1182,   708, -1076,  1730,  1415,  1765,  1002,  1767,
    3074,  1296,  1997,  3454,  1803,  1296,  1611,  1678,   876,   741,
    1107,  1296,  2029,  3591,  2785,  1305,  1776,  1806,  3448,  3095,
    2059,  1166,  1391,  3648,  3375,  2509,  1877,  3366,  2141,  1744,
    2868,  1083,   588,   588,   588,   588,  1840, -1079,   530,   571,
     531,  2010,  1679, -1746,  1731,   576,  1612,  2011,  2822,   588,
    1677,   576,  1944, -1271, -1266,  1825,   588,  1804,  1831,  3222,
    1970,  2070,  1368,  1841,  2614,  1257,  3591,  1614,  1290,  1363,
    1449,  1468, -1271, -1266,  1469,  1470,  1471,  1971,  1472,  1473,
    1474,  1475,  1476,  1477, -1076,   753,  1459,  1460,   856,  1478,
    2688,  1368,  2689,   482,  1477,  1252,   707,  1679,   705,  1478,
    1478,   713,  1702,   731,  1658,   713,   798,   482,   482,  1659,
      48,   857,   482,   859,   705,   861,   713,  1230,  3412,   862,
    2594,  3118,  1844,   482,  2199, -1695, -1076, -1079, -1727, -1076,
    1016,  3011,   482, -1747, -1776,   707, -1479,  1463,  1331,   482,
    3567,   731,  1305,   482,   482,  1455,  1296,   482,  2918,   482,
     775,   482,  2324,   482,  1889,   876,   705,   651,  1485,  1187,
    2106, -1495,  2722,  3491,   729,  2195,  1190,  1870,  2692, -1079,
    3449,  2067, -1079,    15,  3506,  2411,  1683,   571,  3450,  2982,
    1750,  1678,   809,   572,   573,  1024,  3425,  3345,  2020,  2021,
    1025,   160,  2651,  1905,   487,  1017, -1630,  2308,   482,  3346,
     482,  2709,  2720,   889,  3451,   527,  3600,  2085,  1611,  2756,
    2757,   893,  1835,  1264,   154,  2638,  3139,  1284,  1371,   153,
    2883,  1317,   879,   611,  2887,  1007,  2309,   611,   161,  2782,
    1319,  1887,  1332,   571,  1474,  1475,  1476,  1477,  1871,   572,
     573,   599,  2751,  1478,    23,  2754,  2755, -1746,  1612,  2758,
    1031,  1886, -1698,  1991,  1993,  1265,   482,  2195,  3547,  2765,
    2644,  1151,  3631,  2782,  2001,  1001,   586,  2004,   148,  1011,
    1152,  1679,  1320,   149,  1836,  2016,  2017,  2177,   879,   789,
      37,  3426,  3545,   796,  1151,  3104,   151, -1238,  2034,  2036,
    3625,  3104,  3517,  2196,   805,  1956,  1957, -1913, -1238,  2050,
    1401, -1238,    28,  1069,  2710, -1238,   588,  2456,  3039,    41,
    3184,  1816, -1746,  2197,   600,   705,   705,  2874,  1126,   501,
    1472,  1473,  1474,  1475,  1476,  1477,   785,  1305, -1746,  1837,
    2086,  1478,  1838,   588,  2087,  2303,    65,   125,  3349,  2554,
    3492,  2304,   803,    46,   482,  3413,  3350,  3436,   588,   619,
    2721,  3140,  3347,  1817,  2126,    47,   482,    37,  2876,  3619,
    3105,  1073,  1924,   731,  1252,   482,  1639,   588,  2693,  2088,
    2282,   482,  2457,  1053,   503,   705,  2108,  1054,  2285,    37,
    2287,  3185,   482,  1424,  3601,  1609,    41,   666,   746,  1153,
    3585,   705,   705,   591,  3636,  3440,  1364,  1769,  2458,  3632,
    1371,  1425,  2515,  3022,  2555,  2197,   154,  1266,    41,   705,
    1283,  1343,   482,  2459,  1905,  3106,  1047,  1913,  1872,  3626,
      46,  3106,  1611,  2460,  1321,  3518,  1839,  3055,   154,  1873,
     705,   705,    47,  1366,   482,    44,   829,  1055,  2305,   875,
     837,   667,    46,   620,  1760,  1137,  2461,  2711,  3458,  1007,
     849,  1389,  1640,  2242,    47,  3602,   598,  1391,  1983,  3329,
    1339,  1748,  1612,  3516,   653,  1340,   482,  2516,  1348,  1348,
    1405,  2023,   662,    48,   482,   585,  2712,  3603,  1341,  3459,
     482,  1056,   747,  3502,   482,  1053,   601,   602, -1271,  1267,
    1611,  2089,  1380,  1138,  3351,    48,   482,  3224,  1386,  3225,
    1432,  2109,  3261,  3262,  3263,  1818,  1322, -1271,  1642,  2365,
    1048,  1508,   639,   510,   668,   511,  3186,  1840,  1444,  1724,
     663,  1733,   876,  1807,  1611,  2462, -1608,  2367,   729,  3056,
    1612,  1472,  1473,  1474,  1475,  1476,  1477,   655,  3583,  3584,
    1371,  1305,  1478,  1124,  1125, -1608,  3460,  1643,  3137,  1055,
    1161,  -321,  1633,  1634,  1509,  1638,  3416,  1671,  2310,   674,
     674,  1626,   674,  1761,  1612,  1762,   963,  1139,  1725,  2556,
    2557,  2558,  3187,  2559,  2560,  2561,  2562,  2563,  2564,  1162,
    2368,  2306,  1848,  2782,  2565, -1609,   576,  1819,   576,  1697,
     576,  2785,   616,  1056,   576,  1644,   863,   864,  3040,   672,
     672,  2229,   672,  1199, -1609,  1686,  3138,  2201,  1007,  3217,
    2307,   664,  1140,  3637,  1141,  1007,  1007,  2029,  2029,  1250,
    1251,   709,  2029,   669, -1119,  1768,  2391,  3226, -1119,  1618,
    2392,  1625,  3189,  2683,  1912,  3309,  2393,  1280,  2394,   482,
     482,  2395,  2399,  2400,  2401,  2402,  2477,  2396,  1401,  3192,
    2230,  1069,  2369,  2370,  3196,  2482, -1830,  3198,  1307,  1309,
    1143,  2029,  2029,  3021,  2457,  2371,   675,  2983,  1698,  3086,
    2456,   160,  1797,   611,  1911,  3089,  3090,  3091,  3092,  3093,
    3094,  1201,  1202,  1917,   482,  1859,  2202,  1697, -1119,  3623,
    2458,  1925,  1926,  3310,   611,  1145,  1907, -1832,  1910,  3556,
    2375,  1798,  1129,  2231, -1088,  2889,    33,  1916,   161,  1938,
     729,  1259,  2914,   715, -1088,  2460,  3410,  1697, -1088,  2372,
     806,  2876,  2687,  3557,  2059,   739, -1830,   731,  1147,   611,
    1130,  1312, -1119,  1259,  2554,  2457,  3247,  3041,   745,  1123,
    2473,  3175,  3534,  2707,  3424,  1521,   806,  3660,   807,  1172,
    1905,  2929,  2232,    33,  1905,    37,   779,   711, -1088,   588,
    3528,  2458,   705,   705,   705,   705,  1698, -1832,  2586,  1257,
     713,  1361,  2708,  2591,  3149, -1830,  2459,  1130, -1088,   783,
    3208,  1374,  3209,  1283,    41, -1830,  2460,  2179,   808, -1830,
    1305,   705,   705,  1384, -1830,  1498,  1698,   705, -1830,  1075,
    2373, -1830,  2374, -1830,    37,  1611,  1078,  2468,  2704,  2461,
    1611,  1738,  3576,  2102,   808,  2910, -1832,  2462,    46,   729,
    3582,  1268, -1088,   782,  2705,  1071, -1832,  2554,  3383, -1830,
   -1832, -1088,  1132,    41,  3042, -1832,  3193,  3043,   786, -1832,
    1269,  1899, -1832,  1174, -1832,  1612,  1075,   482,  1168, -1830,
    1612,   787,  2386,   788,  1072,   713,  1739,  1740,    33,  3617,
    2938,   482,  2529,   705,   705,   705,   705,    46,   662,  2855,
   -1832,    48,   713,  1799,  2410,  1073,  1219,  1169,  1007,    47,
    1283,  2365,  1074,  1800,  2958,  2564,  1943,  1009,  2462,  2490,
   -1832,  2565,  2555, -1830,   795,  2677,  2554,  1736,  1499,   707,
     482,  3499, -1830,   482,   482,  1170,  1801,  1662,  1494,   731,
    2580,  1719,   482,   482,   661,   482,  1326,   482,  1726,   801,
      48,  1501,   482,   154,   482,   713,   571, -1912,  1982,   705,
     705,  3116,   572,  1502, -1832,  1327,  1663,  1630,  1424,  2603,
   -1088,  1985,  2690, -1832,  1348, -1830, -1912,  1401,  1766,   482,
    1668,  1075,   482,   810,   482,  1984,  1425,   482,  3194,  2554,
    2129,  2555,  3372,  1965,  1664,   571,    15,    15,  2559,  2560,
    2561,  2562,  2563,  2564,   790,  1446,   791,  1979,  1426,  2565,
     585,   585,  1980,  1738,  1990,   173, -1832,  2634,  2635,   591,
    1781,  1782,  1783,  1784,   571,  1981,  3075,  2138,  1973,  1722,
     572,   573,  1727,  3299,  3300,  1794,  1043, -1238,  2074,   590,
     811, -1830,  2403,  1424,  1148,  3076,  1159,  2404,   731,  1811,
    1812, -1913,   821,  1177,  2555,  1821,  1401,   825,  1739,  1740,
     591,  1425, -1830,  1858, -1830, -1830,   576,    23,    23,   835,
     576,   576,  1611,  1611,  1611,  1775,  1777,   844,  1614,  3362,
    1424,  2803, -1832,  1428,   963,   850,  2404,  2556,  2557,  2558,
     854,  2559,  2560,  2561,  2562,  2563,  2564,  1401,  1425,  1736,
    1668, -1281,  2565, -1832, -1830, -1832, -1832, -1830,   571, -1830,
   -1830,  1850,  1612,  1612,  1612, -1251,  2642,  1857,  2686,  2059,
    1426,  1866,  1867,  1868,  1869,  3638,    28,  2076,  2661,  2077,
    1855,  1500,  1501,   588,  1407, -1278,  1879,   571,  1627,  3241,
     588,   576,  1628,   572,  1502, -1832,   870,   576, -1832,  2078,
   -1832, -1832,  1424,   963, -1278,   874,  2556,  2557,  2558,  1451,
    2559,  2560,  2561,  2562,  2563,  2564,  1388,  1611,    48,  2526,
    1425,  2565,  2620, -1281,  2029,  1942,   883,  2029,  2029,  2029,
    2029,  2029,  2029,  2029,  2029,  2029,   588,  2029,  1940,   588,
    2782,   576,  1428, -1583,   576,   576,  2624,  2356,  2625,  2605,
    2527,  2606,    37,    37,  2059,  1488,  2528,  1612,  2130,  1905,
    1024,  2149, -1583,  3084,  1905,  1025,   963,  1905,  1941,   885,
    2157,  2607,  1942,  2559,  2560,  2561,  2562,  2563,  2564,   890,
    1918,    41,    41,  2736,  2565,  2029,  2029,   610,  3446,  1927,
    1778,  1075,  2926,   638,  3429,   576,   891,  2079,  1625,  2959,
    2960,  1934,  2080,  3665,   571,   892,  3666,  2081,    44,    44,
     572,   573,  -109,   893,  1945,    46,    46,  -109,  1946,  2155,
    2626,  3478,  2627,  -109,  -109,  1738,  1948,    47,    47,  1953,
    1050,  1955,  1052,   666,  1958,  2559,  2560,  2561,  2562,  2563,
    2564,  1413,  1414, -1120,   713,   482,  2565, -1120,   713,   707,
    1043,   482,   186, -1076,  3036,   482,  1796,   489,  1024,  1401,
   -1583,   482,  1668,  1025,   713,   558,   894,   482,    48,  3639,
    1739,  1740,   713,   482,  2608,  2476,  2989,  1947,   482,  2609,
     895,  1946,   617,  1907,  2968,  2055,   896,   667,  2058,  2484,
    2485,  1738,  2518,  2487,  1976,   899,   713,   482,  1977,  2491,
    2220,  2221,   482,   482,   482,   482,  2228, -1120,  3240,   482,
     482,  1736,   900,   713,   482,  2896,  1018,   482,  2148,  2171,
    2082,  1611,  1305,  1977,  2250,  2250,     3,     4,  3362,  2083,
     713,  2365,   713,   482,  1012,  2209,  1739,  1740,  2831,  2210,
    2253,  1019,   705,   482,  2254,   482,  1894,  1895,  2351,  2524,
     713, -1120,  2352,  1014,  2297,   482,   482,   482,   713,   482,
     668,  1612,  3030,  3031,  2382,   713,   482,   482,  2383,  2871,
    1020,  2888,   713,  2891,   482,   482,  3408,  1736,  1028,  3098,
    3099,  1032,   662,  3102,  2494,  3103,  2029,   705,  1946,  2507,
    2165,  2166,  2610,  2508,   705,   705,   705,   705,   705,   705,
    2242,  2611,  3047,  2002,  2003,  2561,  2562,  2563,  2564,  1086,
    1040,  2015,   154,  1033,  2565,  2018,  2019,  2412,  1043,  2525,
    2535,  2538,  2175,  1942,  1942,  1942,  2178,  1041,  2449,  2965,
    2040,  2250,  2041,  1044,  2542,  2424,  2425,  1611,  1942,  1611,
    1087,  2543,  2191,  2436,  1183,  1942,  2796,  2798,  2799,  1051,
    2203,  3359,   777,  2063,  2569,  2064,  2408,  1069,  1942,  1085,
    2585,  1086,  2588,  2423,  1942,  1335,  2589,  1611,  1453,   669,
     729,  2640,  1905,  1065,  2217,  2641,  1455,  1612,  2454,  1612,
    2647,  1456,  2454,  2467,  2648,  2702,  2732,    14,  1103,  2703,
    2733,  2238,  1087,    15,  2841,  1126,  1088,  1128,  2842,   705,
    2250,   705,  2250,  1073,  1907,  1171,   864,  1612,  2256,  3433,
    2280,  2852, -1142, -1142,  2865,  2853,  1007,    19,  2866,  2930,
    2966,  2656,  2657,  1942,  2967,  1348,  1089,  2973,  2296,   482,
    2985,  2974,  1167,  2654,  1942,  2691,  2301,  3008,   713,  1179,
    3009,  1942,  3034,  2314,  1942,  3111,  3112,  3032,  1088,  2678,
    2318,  1946,  2767,  2029,  2029,  3248,  1184,   662,  1186,  3153,
     882,  3203,   482,  3154,    23,  2641,   713,  2713,  3246,  2715,
    2283,  3272,  1977,  3273, -1580,  1946,  1188,  1946,  1089,  3369,
     898,  3374,  1196,  1305,  1191,  2842,   995,  2696,  2697,  1004,
    1006,  1008,  3376,  3389,  2218,  2768,  2842,  3390,  3391,  1377,
    1378,  3397,  1942,  1444,  1457,  1977,  2437,  3444,  1458,  1198,
    3472,  3445,  2629,  2630,  3473,  2328,  3479,  2074,  1205,  2769,
    3480,  1208,  2337,  2338,  2339,  2340,  2341,  2342,  1459,  1460,
    3359,  3183,  3482,  1075,  2662,  2663,  1305,  2623,  2770,   496,
    3484,  2596,  2752,  1461,  2842,   576,  1246,  3488,  3511,  1899,
    3513,  1977,  3245,  1248,  2771,  1256,  3533,    33,  3537,  1700,
    1493,  1092,  3473,  2664,  2665,  1260,  3548,  1093,  2772,   731,
    1305,  3549,  1262,  3550,  1701,  1977,  1462,  2589,  3551,  1463,
    3560,  1130,  1942,  3562,  1977,  1273,  3563,  1977,  3633,  1096,
    1977,  3662,  3634,  1464,  3672,  3663,  1465,  1097,  3634,    37,
    1279,  1291,  1252,  1293,  1298,  1299,  1300,  1301,  1302,    33,
    1304,  1007,  1305,  1092,  1310,  2554,  2504,  1313,   501,  1093,
    1625,  1314,  1315,  2843,  1316,  1318,  2439,  2478,    41,  2480,
    2654,  1323,  1324,  1130,  1373,  1325,  1330,  -705,  2691,  1345,
    1375,  1096,  1379,  1204,  2504,  1098,  1387,  1381,  3359,  1097,
    2773,   713,   482,   482,  1382,    44, -1242, -1249,  2774,  1404,
    1395,   576,    46,  1398,  2654,  1466,  1399,  1348, -1239,   576,
   -1240,   576,  1400,   503,    47, -1243,   482,    48,  1406,  1409,
    2555,  1410,  1411,  1412,  1417,  1419,  1420, -1241,  3306,  2899,
    1421,  2775,  1482,  1422,  2029,  1423,  1430,  1098,  1431,  1433,
    1434,  2440,  2875,  1435,  1436,  1437,  1493,  1438,   482,   482,
     482,   482,  1439,  3231,  1006,    48,  1497,  1511,  2029,  2029,
    1631,  1524,  2834,  1054,  1656,  1665,  2497,   713,  1666,  2030,
    1668,  1669,  1670,  2898,   713,  1671,   482,  2901,  1685,  2903,
    1907,  2905,  2906,  1455,  1907,  2364,  1692,  1690,  1456,  2934,
    2911,  1693,   482,  2653,  1694,  1468,   482,  1695,  1469,  1470,
    1471,  2813,  1472,  1473,  1474,  1475,  1476,  1477,  1717,  1718,
    2134,  1719,  1723,  1478,  1733,  2814,  1734,  2135,  1611,  1735,
    2953,  1736,  2927,   711,  1742,  1745,  1746,  1749,  1751,  1753,
    2110,  3387,  1754,  2961,  3268,  1756,   482,  1763,  1764,  1770,
     713,   482,  1771,  1151,  1455,  1779,  2815,  1780,  2816,  1456,
    2250,  2250,   510,  1786,   511,  1788,  1787,  1793,  1612,  2835,
    1795,  1808,  1820,   513,  1822,  1830,  1401,  1371,  3301,  2668,
    1407,  1391,  1823,   516,  1447,  1832,  2602,  1833,  1846,   498,
    1856,  1852,   963,  1859,  1452,  2556,  2557,  2558,  1153,  2559,
    2560,  2561,  2562,  2563,  2564,  1489,  2029,   154,  2499,  1865,
    2565,  1455,  2859,  1109,  3581,  1882,  1456,  1888,   585,  1110,
    1890, -1913,  1893,  1006,  1891,  1458,  1506,  2817,   154,  1897,
    1006,  1006,  1921,  2879,  1923,  1899,  1908,  1920,   482,  1899,
     482,  1922,  3432,  1936,  1937,  1459,  1460,  1954,  1959,  1966,
    1962,  1974,  1996,  1987,  2038,  2706,  1997,   482,  1111,  2051,
   -1913,  2056,  2716,  2039,  1478,   718,  1007,  2062,   719,   720,
     721,  2061,   722,   723,   724,   725,   726,   727,  2454,  2068,
    2092,  2881,  1457,  2119,  2132,  2073,  1458,   154,  2818,  2090,
    2128,  2136,  2921,  2819,  2894,  2133,  1463,  2137,  2143,   667,
    3487,  2158,  2159,  2150,   482,  3269,  1459,  1460,  2170,  1112,
    1464,   644,  1242,  2172,   644,  2164,  1113,   482,   713,  1114,
    2173,  1461,  2174,  2180,  2182,   482,  2205,  2184,  2749,  2820,
     713,  3504,  2186,  2187,  2654,  3509,  3510,  1965,  2188,  2207,
    2190,  2821,  2193,  1458,  2244,  3325,  2200,  2248,  2252,   482,
    2255,  2311,   713,  2312,  3401,  2313,   662,  1463,  2321,  2317,
    2322,  2325,  2326,  1459,  1460,  2327,  2329,  1773,  1115,  2330,
    2333,  1464,  2999,  3000,  3001,  3002,  2331,  2332,  3505,  2345,
    3508,  2343, -1913,  2717,  2643,  2354,   576,  2357,  2358,  2350,
    2359,  2380,  2362,  3145,  2384,  2360,  2361,  2363,  1257,  2724,
    2397,  2409,  1444,  2727,  2387,  2405,  2427,  2428,  2446,  2430,
    2448,  2447,  2469,  1242,  1463,  2455,  2474,  2475,  2483,  2822,
    2486,  2489,  2493,  1116,  2488,  2496,  2498,  2505,  1464,  1611,
    1988,  2517,   876,   699,  2521,  2523,  2540,  1942,   699,  2575,
     644,  2604,  2536,  1466,  2619,  2537,   644,  2539,   644,  2541,
    2544,  2545,  2547,  2550,   644,  2568,  2574,  2576,  2577,  1117,
    2584,  2597,  2598,  2632,  2638,  2599,  2637,  3014,  2667,  1612,
    2679,  2672,  1468,  2680,  1861,  2684,  2612,  1625,  2622,  1472,
    1473,  1474,  1475,  1476,  1477,  2675,  3490,  2685,  1118,  2718,
    1478,  2719,  1119,  1006,  2676,  1455,  2726,  3064,  2728,  2737,
    1456,  2738,  2739,  2740,  1348,  1348,  2741,  2753,  2916,   713,
    3207,  2759,  3461,  2742,  3497,  2743,  1120,  3210,  3211,  1907,
    2760,  2761,  3498,  2744,  1907,  2745,  2746,  1907,  2762,  2725,
    2928,  2763,  2747,  1468,  2764,  2786,  1469,  1470,  1471,  1839,
    1472,  1473,  1474,  1475,  1476,  1477,  2790,  2828,  2789,   482,
     482,  1478,  2804,  1371,  2801,  2802,  2805,  3628,  2826,  2836,
    2851,  2846,  2848,  2856,  2850,  2861,   482,  3419,  2857,  2863,
     713,   482,   713,   482,   482,   482,   482,  2878,  2884,  2880,
    2882,  2885,  2892,  2895,  2897,  2920,  2915,  2902,  2613,  2904,
    1468,  1485,  3555,  2923,  1388,  1242,  2924,  1472,  1473,  1474,
    1475,  1476,  1477,  2933,   576,  2571,  1448,  2570,  1478,  3280,
    2565,  2791,  2793,  2975,  2987,  3026,  2800,  3286,  2962,  2963,
    2014,  2964,  2913, -1913,  2996,  2988,  3006,  1458,  3020,  3018,
    3023,  3035,  3037,  1716,  3044,  3048,  3072,  3049,   576,   482,
     482,   482,  3087,   482,  3059,  3088,  2925,  1459,  1460,  1109,
    3061,  3060,  3062,   729,  3063,  1156,  1242,  3085,  3134,  3113,
    3141,  3114, -1913,  2875,  1899,  3115,  3144,  3146,  3147,  1899,
    3151,  2408,  1899,  3148,  1233,  3162,  3167,  2220,  3180,  3150,
    2220,  3168,  3166,  3170,  2030,  2030,  3176,  3033,  3181,  2030,
    2436,  3190,  2250,  3197,  1111,  3200,  3215,  3206,  1463,  3212,
    3213,  3218,  3223,  3220,  3559,  3227,  3232,  3228,  1086,  2454,
    3234,   482,  1464,  3233,  3258,  3238,  3259,  3281,  1242,  2131,
    3275,  3276,  2408,  3277,  3202,  3297,   482,  3298,  2030,  2030,
    1453,  2250,  3287,  2250,  3302,  1242,  3290,  3305,  1455,  1087,
    3311,  3105,  3314,  1456,  3317,  1112,  3318,   713,  3077,  3326,
    3079,  3334,  1113,  3330,  1242,  1114,   644,  3336,  3338,  3339,
    3343,   644,  3352,   699,  3354,  3367,  3381,  2843,  3355,  3385,
    3371,  3393,  3386,  3388,   481,  1233,  3394,  1242,  3403,  3395,
     525,   526,  3396,  3405, -1913,  3409,   559,  3411,   575,  3414,
    3421,  3422,  1371,  3427,   594,  1088,   597,   644,  3428,  3434,
    1946,  3140,   699,  3441,  1115,  3453,  2157,  3271,  3443,   699,
    3463,  1907,  3464,  3465,   660,  3466,  3377,  3467,  3378,  3379,
    3496,  3278,   668,  3500,  3519,  1089,  3523,  3382,  3527,  1242,
    3529,  3535,  1907,  3536,  3539,  3552,  3553,  3554,  3506,  3564,
    1331,  3265,  3565,  3568,  3574,  3570,  3066,  3067,  3575,  3577,
    3586,  3012,   731,  2437,  3595,  3566,   644,  3567,  3616,  1116,
    3599,  3624,   644,  3629,  3630,  3635,  1457,  3647,  3649,  3664,
    1458,  3667,  3279,   644,  1468,  1045,  2832,   713,   482,  2645,
    2247,  1472,  1473,  1474,  1475,  1476,  1477,  3579,   713,   482,
    1459,  1460,  1478,   644,  3045,  1117,  2766,  3320,  3430,  1084,
    2219,   482,   482,   705,   482,  1461,  1523,  3160,  3038,  3323,
    2495,  2654,   644,  1008,  3164,   729,  2674,  3596,   644,  3418,
    3627,  3571,  3569,  3605,  1157,  2504,   154,  1881,  1119,  3165,
    1348,  3331,  1336,  2860,  2198,   644,  3070,  2730,  1462,  3172,
    1862,  1463,   733,  2366,   736,  1073,   738,  2838,   740,  3650,
     711,  1371,  1158,  3671,  3313,  1464,    33,  1233,   576,  3312,
    2438,  2829,  2787,  3606,  3420,  1851,  1093,  3561,  3423,   593,
     881,  3216,   576,  2439,  1362,  3470,  3174,  1899,  3541,   482,
    1130,  2213,  1371,  3177,  3546,  3615,  1371,  1371,  1096,  3668,
    1907,  3641,  3447,  3485,  3670,  1233,  1097,   482,  2145,  1021,
     560,  1632,  3157,  1338,  2922,  3360,   754,  2649,  1242,  1342,
    1455,  2652,  1039,  1629,  2169,  1456,  2666,  3270,  1233,   482,
    3027,  2168,  1657,  2161,   699,  2142,  2631,  1466,  2336,  3202,
    2451,   699,   863,   864,  2890,  3373,  2336,   817,   755,  2650,
    3155,   482,  3166,  3110,  1098,  1029,  2979,   713,  2440,  2969,
    2355,   756,  3489,  3587,  3594,  3282,  3588,  2655,   757,  2118,
    3120,  2617,  2532,   758,  2615,     0,  3291,  2510,     0,     0,
       0,     0,     0,     0,     0,     0,   644,   644,   644,  2398,
    1233,     0,   699,   759,     0,     0,     0,     0,  3531,     0,
       0,     0,     0,     0,     0,     0,     0,  1233,     0,     0,
       0,     0,  2429,  2993,   760,     0,     0,     0,  1907,     0,
       0,     0,     0,     0,   731,     0,  1233,  1468,     0,     0,
    1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,
       0,  3295,     0,     0,  1348,  1478,   761,     0, -1913,  1233,
       0,     0,  1458,     0,   644,     0,     0,     0,     0,     0,
       0,  1006,     0,     0,     0,     0,   762,     0,     0,  2250,
    2551,  2552,  1459,  1460,     0,  2567,   644,     0,     0,  3214,
       0,     0,     0,     0,     0,     0,     0, -1913,     0,     0,
     763,     0,     0,   705,  3360,     0,     0,     0,   705,   705,
       0,  1233,     0,     0,     0,  3597,     0,     0,  3293,  3294,
     482,  3296,     0,     0,  2600,  2601,     0,     0,     0,     0,
       0,  2030,     0,  1463,  2030,  2030,  2030,  2030,  2030,  2030,
    2030,  2030,  2030,     0,  2030,  2504,     0,  1464,     0,     0,
       0,     0,  3495,     0,     0,     0,     0,  2208,   764,     0,
       0,     0,  1716,  2215,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   705,   705,   705,   705,   482,     0,     0,
       0,   781,     0,     0,     0,   173,     0,     0,     0,     0,
    1453,     0,  2030,  2030,     0,   799,   800,  2220,  1455,     0,
     802,   576,   576,  1456,  3661,     0,     0,     0,     0,   765,
       0,   815,   644,   766,     0,   767,   576,     0,     0, -1913,
     820,   768,  3360,   705,  3284,  3285,     0,     0,     0,  3288,
    3289,     0,   839,     0,     0,   841,  3368,   843,     0,   846,
       0,     0,     0,     0,     0,     0,  3368,     0,     0,   769,
     770,     0,  1109,     0,   771,     0,     0,     0,  1110,     0,
    1453,     0,   772,  1454,     0,  1086,  1006,   773,  1455,     0,
       0,     0,     0,  1456,     0,     0,   482,     0,   705,     0,
       0,     0,  1242,     0,     0,     0,   886,   705,   887,   774,
    1233,     0,   576,  3659,     0,     0,  1087,  1111,     0,     0,
       0,     0,  3495,     0,     0,   644,     0,     0,     0,  1468,
       0,     0,     0,   705,  2671,     0,  1472,  1473,  1474,  1475,
    1476,  1477,   154,  1109,  3614,     0,  1457,  1478,     0,  1110,
    1458,  3469,     0,     0,     0,     0,  3475,  3475,     0,  3658,
       0,  1716,     0,     0,   660,     0,     0,     0,  1112,     0,
    1459,  1460,  1088,     0,     0,  1113,     0,   644,  1114,     0,
       0,     0,     0,     0,     0,  1461,   154,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,   644,     0,     0,     0,
       0,     0,  1089,  3614,  3654,     0,     0,     0,     0,     0,
       0,     0,     0,  2030,     0,     0,  1457,     0,  1462,     0,
    1458,  1463,  3512,     0,  3514,     0,  2723,  1115,     0,     0,
       0,     0,  3654,     0,     0,  1464,  3614,  3483,  1465,  1112,
    1459,  1460,     0,     0,     0,     0,  1113,  1242,  2735,  1114,
       0,     0,  1178,     0,     0,  1461,     0,     0,     0,     0,
       0,     0,     0,     0,  1189,     0,     0,     0,     0,     0,
       0,  3542,     0,  1195,     0,   576,     0,     0,     0,  1197,
    2336,     0,  1116,  2336,  2336,     0,     0,  2336,  1462,     0,
    1244,  1463,     0,     0,  3515,     0,     0,  2336,  1115,     0,
    1090,  1906,  1204,   699,  2784,  1464,     0,  1466,  1465,     0,
       0,     0,   699,     0,     0,     0,     0,     0,  1117,     0,
    1285,     0,  2554,     0,     0,   644,  3573,     0,  2553,  1091,
       0,     0,     0,    33,   644,  3475,     0,  1092,  2784,  1233,
       0,  2833,     0,  1093,  1233,  1233,     0,  1175,  2554,     0,
    1094,  1119,     0,  1116,     0,     0,     0,  1095,     0,  2840,
       0,  3598,   699,     0,     0,  1096,   644,   644,     0,     0,
       0,     0,     0,  1097,  1344,  1176,     0,  1466,   644,     0,
    2030,  2030,     0,     0,     0,     0,     0,  2555,  1370,  1117,
    2870,  1006,     0,     0,     0,     0,     0,  1468,  1455,     0,
    1469,  1470,  1471,  1456,  1472,  1473,  1474,  1475,  1476,  1477,
       0,   714,     0,  2555,     0,  1478,     0,   735,  2546,     0,
       0,  1098,  1119,     0,     0,   744,     0,  2939,     0,     0,
    2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,  2952,     0,
    2954,     0,     0,     0,     0,     0,  1120,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1467,     0,  1233,     0,     0,  1468,     0,     0,
    1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,
    1716,  2215,     0,  2215,     0,  1478,     0,     0,  2991,  2992,
    1242,     0,     0,     0,   644,     0,     0,     0,     0,     0,
       0,     0,     0,   644,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1242,  1233,  1242,     0,  1457,     0,     0,     0,
    1458,  1453,     0,     0,     0,     0,     0,     0,     0,  1455,
       0,     0,     0,     0,  1456,     0,     0,   660,     0,   963,
    1459,  1460,  2980, -1913, -1913,     0,  2559,  2560,  2561,  2562,
    2563,  2564,     0,     0,     0,  1461,     0,  2565,     0,  3612,
       0,     0,     0,     0,     0,   963,     0,     0,  2556,  2557,
    2558,     0,  2559,  2560,  2561,  2562,  2563,  2564,     0,     0,
       0,     0,  1689,  2565,  3016,     0,     0,  1242,     0,     0,
       0,  1463,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,  1464,     0,   702,     0,     0,
    2215,  2030,   702,     0,     0,     0,     0,     0,  3612,     0,
       0,     0,     0,     0,     0,     0,   644,     0,     0,     0,
       0,     0,     0,     0,     0,  2030,  2030,     0,     0,     0,
       0,     0,     0,     0,  2215,     0,     0,     0,  2784,     0,
    2554,  3612,     0,     0,     0,     0,     0,  1457,     0,     0,
       0,  1458,   163,  3065,     0,     0,     0,     0,  1242,     0,
    3068,     0,  3069,     0,     0,     0,     0,  1466,     0,  3136,
       0,  1459,  1460,  1242,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1461,  2336,  2215,     0,
       0,     0,     0,  2336,  2336,  2336,  2336,  2336,  2336,     0,
       0,     0,     0,     0,     0,  2555,     0,   751,     0,   164,
       0,     0,   778,     0,     0,     0,     0,     0,     0,  1462,
       0,     0,  1463,   644,  1242,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,  1849,  1464,     0,     0,  1465,
    3121,  3123,  3125,  3127,     0,     0,     0,     0,     0,  1864,
     166,     0,     0,     0,     0,     0,     0,  1468,     0,     0,
       0, -1913, -1913,  2030,  1472,  1473,  1474,  1475,  1476,  1477,
       0,     0,     0,     0,     0,  1478,     0,   167,     0,     0,
       0,     0,   168,     0,  1242,     0,     0,   169,  1915,     0,
       0,     0,  1919,     0,     0,  3173,     0,     0,     0,     0,
       0,  1928,   170,  1930,     0,  1931,     0,   878,  1466,     0,
    1932,     0,     0,     0,     0,  1242,     0,     0,     0,     0,
       0,     0,  1233,  1233,   888,  1233,   171,     0,  1242,     0,
       0,     0,  1233,     0,     0,     0,  3242,  3243,     0,     0,
       0,     0,     0,     0,   999,     0,   644,     0,     0,     0,
       0,     0,  1109,     0,     0,     0,     0,     0,  1110,     0,
       0,     0,  1242,  1023,  1233,     0,  1233,   963,     0,     0,
    2556,  2557,  2558,   644,  2559,  2560,  2561,  2562,  2563,  2564,
     644,     0,  1137,     0,   172,  2565,  1046,     0,  1906,     0,
       0,     0,     0,     0,     0,     0,     0,  1111,  1468,     0,
       0,  1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,
    1477,   173,     0,     0,     0,     0,  1478,     0,     0,  2592,
       0,     0,     0,     0,     0,     0,     0,   702,     0,     0,
    1138,     0,  1453,     0,     0,   174,  2151,     0,     0,  1233,
    1455,   175,     0,     0,     0,  1456,     0,   176,  1112,   177,
       0,     0,  3267,     0,  2215,  1113,     0,     0,  1114,  1455,
       0,     0,  1233,     0,  1456,     0,   702,     0,     0,     0,
       0,     0,     0,   702,     0,   178,   179,     0,     0,     0,
     180,     0,     0,     0,     0,     0,     0,     0,   181,     0,
       0,     0,     0,   182,     0,     0,  1233,     0,     0,     0,
       0,     0,     0,   183,  1139,     0,     0,  1115,     0,     0,
       0,     0,     0,     0,     0,   184,  2152,     0,     0,     0,
    1233,  2336,  2336,     0,     0,     0,     0,  1275,  1277,  1278,
       0,     0,  3303,  3304,     0,  1233,  3307,  3308,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
    1233,  1141,  2994,     0,     0,   702,     0,     0,     0,     0,
       0,     0,  1142,     0,     0,     0,     0,     0,  1457,     0,
       0,     0,  1458,     0,     0,     0,     0,  3384,  1242,     0,
       0,     0,     0,     0,     0,     0,  1233, -1913,  3337,   702,
       0,  1458,  1459,  1460,     0,   999,     0,  1143,  1117,     0,
       0,  3398,  3399,   644,     0,     0,     0,  1461,     0,  1906,
       0,  1459,  1460,     0,  3361,     0,  1716,   999,     0,     0,
       0,     0,     0,     0,     0,     0, -1913,  1144,     0,     0,
       0,  1119,  1145,     0,     0,     0,     0,     0,     0,     0,
    1462,     0,     0,  1463,     0,     0,  1233,     0,     0,   644,
       0,     0,     0,  2176,     0,  1146,     0,  1464,     0,  2181,
    1465,     0,  1463,  2185,     0,  1147,     0,     0,  1455,  2189,
       0,     0,     0,  1456,     0,  2194,  1464,  1233,     0,     0,
       0,  2204,     0,     0,     0,     0,  2206,     0,   702,     0,
    1233,     0,     0,     0,     0,   702,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2222,  2223,  2226,  2227,     0,  2784,  1243,  2233,  2236,     0,
       0,     0,  2239,     0,  1233,  2243,     0,  1242,     0,  1466,
       0,     0,  2336,     0,     0,     0,  3431,     0,  1242,  3486,
       0,  2281,     0,  1525,     0,     0,   702,     0, -1913,     0,
       0,  2284,     0,  2286,     0,     0,     0,     0,  1028,     0,
       0,  2997,     0,  2298,  2299,  2300,     0,  2302,     0,     0,
       0,     0,     0,     0,  2315,  2316,     0,  2153,     0,     0,
       0,     0,  2319,  2320,     0,     0,  3468,     0,   702,     0,
       0,     0,     0,     0,  1242,     0, -1913,     0,     0,     0,
    1458,     0,  1242,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1233,  1243,     0,  1468,
    1459,  1460,  1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,
    1476,  1477,     0,     0,     0, -1913,  1732,  1478,  1468,   702,
       0,     0,     0,     0,     0,  1472,  1473,  1474,  1475,  1476,
    1477,     0,     0,     0,     0,     0,  1478,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,     0,   702,     0,     0,
       0,  1463,     0,  1455,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,  1464,     0,     0,  1785,     0,
       0,     0,     0,   644,     0,     0,     0,     0,     0,   702,
     702,     0,   702,     0,   644,     0,     0,  1805,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   702,
     644,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3365,     0,     0,     0,     0,     0,     0,     0,     0,
    1233,     0,     0,     0,     0,  1906,     0,     0,     0,  1906,
       0,     0,  1242,     0,     0,     0,     0, -1913,   702,  1610,
       0,     0,     0,     0,  2257,     0,     0,     0,     0,     0,
    2519,     0,     0,   644,     0,     0,   644,  1242,  1233,     0,
       0,  2570,     0,   644,     0,   702,  2571,     0,   699,   702,
     702,     0,     0,     0,     0,     0,     0,     0,     0,  1243,
       0,  1457,     0,  1610,     0,  1458,     0,     0,     0,  3613,
       0,   644,     0,     0,     0,     0,     0,  2258,     0,     0,
       0,     0,     0,     0,     0,  1459,  1460,  2259,  2260,  2261,
       0,  2215,     0,     0,     0,     0,  1929,  1243,     0,     0,
    1461,     0,     0,     0,     0,  1933,     0,  1468,     0,     0,
       0,     0,     0,     0,  1472,  1473,  1474,  1475,  1476,  1477,
    1243,     0,     0,     0,     0,  1478,     0,     0,  3613,  3653,
       0,  2262,     0,  1462,     0,     0,  1463,   999,   999,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
    1464,     0,     0,  1465,     0,     0,     0,  3653,  3669,     0,
    1233,  3613,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2215,  2263,     0,     0,     0,     0,  2264,   644,
     644,     0,  1243,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1242,     0,     0,  1243,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1453,  1233,  2265,  1243,     0,
    2669,  2670,  1466,  1455,  1233,     0,     0,  1242,  1456,     0,
       0,  1242,  1242,     0,  2266,  2267,  2268,  2269,  2270,     0,
    2271,  1243,     0,  1241,  2682,     0,  1610,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2117,     0,     0,     0,     0,
       0,     0,     0,  2272,  2127,     0,  2698,  2699,  2700,  2701,
       0,     0,     0,     0,     0,   702,     0,   702,     0,     0,
    3365,     0,     0,  1243,     0,     0,   702,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2273,
       0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,  1472,
    1473,  1474,  1475,  1476,  1477,     0,     0,     0,     0,     0,
    1478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1241,  2274,   702,  2275,     0,     0,
       0,  1457,     0,   644,     0,  1458,     0,     0,     0,     0,
       0,     0,     0,     0,  2748,     0,     0,     0,     0,  2750,
    2276,   644,     0,     0,  1233,  1459,  1460,  2277,     0,     0,
    2278,   702,   702,     0,     0,     0,     0,     0,     0,   702,
    1461,     0,   702,     0,     0,   702,     0,     0,     0,  1233,
       0,     0,     0,   702,   702,     0,     0,  2146,     0,     0,
       0,   702,     0,     0,   702,   702,   702,   702,     0,     0,
       0,     0,     0,  1462,   702,   702,  1463,   702,     0,   702,
       0,     0,   702,     0,  1906,     0,     0,     0,     0,  1906,
    1464,     0,  1906,  1465,     0,     0,     0,   702,  1610,     0,
       0,   702,     0,  1233,     0,   702,  2844,     0,  2845,   702,
       0,  2970,     0,   702,   702,   702,   702,   702,   702,   702,
     702,   702,  1243,  1505,   702,  2682,     0,     0,     0,   702,
       0,     0,   702,     0,     0,  1453,     0,     0,     0,     0,
       0,     0,     0,  1455,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1466,     0,  2237,     0,  1453,     0,     0,  2534,
       0,     0,  2900,     0,  1455,  2971,  1241,     0,     0,  1456,
       0,     0,     0,     0,  1233,  2909,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   644,
     644,   644,   644,     0,     0,     0,     0,     0,  1233,     0,
       0,     0,  1455,     0,  1241,     0,     0,  1456,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1241,     0,  1233,
       0,     0,     0,  1233,  1233,     0,     0,     0,     0,     0,
       0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,  1472,
    1473,  1474,  1475,  1476,  1477,     0,     0,     0,     0,     0,
    1478,  1457,   702,     0,     0,  1458,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2385,     0,     0,
       0,     0,     0,     0,     0,  1459,  1460,     0,     0,  1241,
       0,     0,  1457,     0,     0,  3251,  1458,     0,     0,     0,
    1461,     0,  1610,     0,  2413,     0,  1241,     0,     0,     0,
       0,  2431,     0,     0,     0,     0,  1459,  1460,     0,     0,
     702,     0,     0,     0,     0,  1241,     0,     0,     0,     0,
   -1913,  1461,     0,  1462,  1458,     0,  1463,     0,     0,   644,
       0,  1243,     0,  2436,     0,     0,  1243,  1243,  1241,     0,
    1464,     0,     0,  1465,  1459,  1460,     0,     0,     0,     0,
       0,  1086,     0,     0,  1462,     0,   699,  1463,     0, -1913,
    1610,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1464,     0,     0,  1465,     0,     0,  1906,     0,     0,
       0,     0,  1087,     0,     0,     0,     0,     0,     0,     0,
    1241,     0,     0,     0,  1610,  1463,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1464,
       0,     0,  1466,     0,  3071,     0,     0,     0,     0,  3078,
       0,  3080,  3081,  3082,  3083,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1088,     0,
       0,     0,     0,  1466,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   702,     0,  1243,     0,     0,     0,
       0,     0,     0,     0,   699,     0,     0,     0,  1089,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -1913,     0,     0,     0,     0,     0,  3129,  3131,  3133,
       0,  3135,     0,     0,     0,   699,  2437,     0,   644,     0,
       0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,  1472,
    1473,  1474,  1475,  1476,  1477,  1243,     0,     0,     0,  2060,
    1478,     0,   702,   644,  2628,     0,     0,     0,     0,     0,
       0,     0,   702,  1468,     0,   699,  1469,  1470,  1471,     0,
    1472,  1473,  1474,  1475,  1476,  1477,     0,   644,     0,     0,
       0,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   702,     0,     0,  1241,
     999,  1468,     0,     0,  3205,     0,     0,     0,  1472,  1473,
    1474,  1475,  1476,  1477,     0,     0,     0,     0,     0,  1478,
     702,   644,     0,     0,  1453,     0,     0,  2578,     0,    33,
       0,  1243,  1455,  1092,     0,     0,     0,  1456,     0,  1093,
       0,     0,     0,     0,     0,     0,  2439,     0,     0,     0,
     702,   702,     0,  1130,     0,     0,     0,     0,     0,     0,
       0,  1096,  1453,   699,     0,     0,     0,     0,     0,  1097,
    1455,     0,     0,  1235,     0,  1456,     0,     0,     0,     0,
     702,   702,     0,   699,     0,   702,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   702,   702,   702,
     702,   981,     0,     0,     0,  1610,     0,     0,     0,   702,
    1610,     0,   702,     0,     0,   702,     0,  1098,     0,     0,
       0,  2440,     0,     0,   702,   702,     0,   702,     0,     0,
       0,     0,     0,     0,     0,  1036,     0,     0,     0,     0,
     702,     0,   702,     0,     0,     0,   702,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3283,     0,     0,     0,
    1457,     0,     0,   702,  1458,     0,     0,  3292,     0,     0,
     699,     0,     0,   702,  1235,   702,   702,   702,     0,     0,
       0,     0,     0,     0,  1459,  1460,     0,     0,     0,   702,
       0,     0,     0,     0,     0,     0,     0,   702,  1457,  1461,
       0,     0,  1458,     0,   702,     0,     0,     0,     0,   702,
       0,     0,     0,     0,     0,     0,   702,   702,   702,     0,
       0,     0,  1459,  1460,     0,     0,     0,     0,  1241,     0,
       0,     0,  1462,  1241,  1241,  1463,     0,  1461,   702,     0,
       0,     0,     0,     0,  2837,     0,     0,     0,     0,  1464,
       0,     0,  1465,     0,     0,  2849,     0,  3333,     0,   699,
       0,     0,     0,     0,  1243,  1243,     0,  1243,     0,     0,
    1462,  2862,     0,  1463,  1243,  3348,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1464,     0,     0,
    1465,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2548,     0,     0,  1243,     0,  1243,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3380,
       0,  1466,     0,     0,  2907,     0,     0,  2908,     0,     0,
       0,     0,     0,     0,  2912,     0,     0,     0,     0,     0,
       0,     0,  1610,  1610,  1610,     0,     0,     0,     0,     0,
       0,     0,     0,  1241,     0,     0,  1235,     0,     0,  1466,
       0,     0,   999,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1243,     0,     0,     0,  1393,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1243,     0,     0,     0,     0,     0,
       0,  1468,  1241,  1416,  1469,  1470,  1471,  1235,  1472,  1473,
    1474,  1475,  1476,  1477,     0,     0,     0,     0,     0,  1478,
       0,     0,     0,     0,     0,     0,     0,  1610,  1243,     0,
       0,     0,     0,     0,     0,  1441,  1442,     0,  1445,  1468,
       0,     0,  1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,
    1476,  1477,  1243,     0,     0,  1483,     0,  1478,     0,     0,
    3003,  3004,     0,     0,     0,     0,     0,  1243,     0,  1235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1243,     0,     0,     0,  1235,     0,  1241,     0,
       0,     0,     0,     0,  1526,     0,     0,     0,     0,   702,
       0,     0,     0,   702,     0,  1235,     0,     0,     0,     0,
       0,     0,     0,   702,     0,     0,     0,     0,  1243,   532,
       0,  1637,     0,     0,     0,  1647,  1650,     0,  1235,     0,
       0,   533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   702,     0,     0,     0,     0,     0,     0,     0,
       0,   534,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   702,   535,     0,  1243,     0,
    1235,     0,     0,     0,   702,     0,     0,     0,     0,     0,
     702,     0,   702,     0,     0,     0,   536,   702,     0,     0,
     702,   702,   702,   702,   702,   702,   702,   702,   702,  1243,
     702,     0,     0,     0,   702,   702,  1236,   537,     0,     0,
       0,     0,  1243,     0,  3572,     0,     0,   702,     0,     0,
       0,  1610,     0,   702,  3117,     0,     0,     0,     0,     0,
       0,     0,  1238,   702,   538,     0,   702,     0,   702,   539,
       0,     0,  3142,     0,   540,     0,  1243,   702,   702,   702,
       0,     0,     0,   702,     0,     0,   702,     0,     0,   541,
       0,     0,     0,     0,     0,     0,   702,     0,     0,     0,
       0,     0,     0,     0,     0,   702,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,     0,     0,
       0,  1241,  1241,     0,  1241,     0,     0,     0,     0,     0,
       0,  1241,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1238,     0,     0,     0,  1610,  1243,  1610,
       0,   542,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,   543,     0,  1241,     0,  1241,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1610,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   544,     0,     0,     0,   545,     0,   546,     0,
       0,     0,     0,     0,   547,     0,   548,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3254,  3255,  3256,  3257,     0,     0,     0,     0,  1241,     0,
       0,     0,   549,   550,     0,     0,     0,   551,     0,     0,
       0,     0,     0,     0,     0,   552,     0,     0,     0,   702,
     553,  1241,     0,     0,     0,  2000,     0,     0,     0,     0,
     554,     0,  1243,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   555,     0,     0,     0,     0,  2022,     0,  1453,
    2024,     0,     0,  2035,     0,  1241,     0,  1455,     0,  1236,
    2042,  2047,  1456,     0,     0,  2052,     0,     0,  2057,     0,
    1243,   702,   702,     0,     0,     0,     0,     0,     0,  1241,
       0,     0,     0,  2066,     0,  1238,     0,  2072,   702,     0,
       0,  2084,     0,   702,  1241,  2091,   702,  1236,     0,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,     0,  1241,
    2103,     0,     0,     0,     0,   981,     0,     0,     0,     0,
    1236,     0,     0,  1238,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   702,     0,     0,     0,     0,
    3332,     0,     0,     0,     0,  1241,  1238,     0,  1235,     0,
       0,     0,     0,  1235,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2583,   702,     0,     0,     0,     0,     0,     0,   702,   702,
       0,  1243,  1236,     0,     0,  1457,   702,   702,     0,  1458,
       0,   702,  1243,     0,     0,     0,     0,   702,   702,  1236,
       0,   702,     0,     0,     0,  1241,     0,     0,  1238,  1459,
    1460,     0,     0,  1239,     0,     0,     0,     0,  1236,     0,
       0,   702,     0,     0,  1461,  1238,     0,  1240,     0,     0,
       0,     0,     0,     0,     0,     0,  1241,     0,     0,     0,
       0,  1236,     0,     0,  1238,     0,     0,     0,  1243,  1241,
       0,     0,     0,     0,     0,     0,  1243,  1462,  1036,     0,
    1463,     0,     0,     0,     0,     0,     0,  1238,     0,     0,
       0,     0,     0,  1235,  1464,     0,     0,  1465,     0,     0,
       0,     0,     0,  1241,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1236,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3437,
       0,     0,     0,     0,  1239,     0,  2192,     0,     0,  1238,
       0,     0,     0,     0,     0,     0,     0,     0,  1240,     0,
       0,     0,  1235,     0,   999,     0,     0,     0,   702,     0,
       0,     0,     0,     0,     0,     0,  1466,     0,  1610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3481,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1241,     0,     0,     0,     0,
     702,     0,     0,     0,     0,  1243,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   702,     0,     0,
       0,   702,  3501,     0,     0,     0,  1243,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1235,     0,
       0,     0,     0,     0,     0,     0,     0,   702,     0,     0,
       0,  1243,     0,     0,     0,     0,  1468,     0,     0,  1469,
    1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,     0,
       0,   702,   702,     0,  1478,   702,     0,     0,     0,     0,
    2353,     0,   702,   702,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1243,     0,     0,   702,     0,
       0,     0,     0,     0,     0,     0,  1239,     0,  1238,  1241,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1240,     0,     0,     0,     0,     0,     0,     0,     0,   702,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1239,     0,     0,  1241,  2471,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1240,     0,
    1453,     0,     0,  2587,     0,     0,     0,  1239,  1455,   702,
     702,     0,     0,  1456,     0,     0,  1243,     0,     0,     0,
       0,  1240,  2492,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   702,
    1243,     0,   702,     0,   702,  1453,   981,     0,     0,     0,
       0,     0,     0,  1455,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   702,  1239,
       0,  1243,     0,     0,     0,  1243,  1243,  2530,     0,     0,
       0,     0,     0,  1240,     0,     0,  1239,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1241,  1610,
    1240,  1235,  1235,     0,  1235,  1239,     0,   702,     0,  1241,
       0,  1235,     0,     0,     0,     0,     0,     0,     0,  1240,
       0,     0,     0,  2047,     0,  2047,  2047,   702,  1239,     0,
       0,     0,     0,     0,  1243,  2590,  1457,     0,  2593,     0,
    1458,  2595,  1240,  1235,     0,  1235,     0,     0,     0,     0,
     702,  1236,     0,     0,     0,     0,  1236,  1236,     0,     0,
    1459,  1460,     0,     0,     0,  1241,  2616,     0,  2618,     0,
       0,     0,  2621,  1241,     0,  1461,     0,  1238,     0,     0,
    1239,  1457,  1238,  1238,     0,  1458,     0,     0,     0,     0,
       0,     0,     0,     0,  1240,     0,     0,     0,     0,     0,
       0,     0,     0,  2636,     0,  1459,  1460,     0,  1462,     0,
       0,  1463,     0,     0,   702,  2646,     0,     0,  1235,     0,
    1461,     0,     0,  1036,     0,  1464,     0,     0,  1465,     0,
    1637,     0,     0,     0,     0,  2659,     0,     0,     0,     0,
       0,  1235,  1650,  1650,  1647,     0,     0,     0,     0,     0,
       0,     0,     0,  1462,     0,     0,  1463,     0,     0,     0,
       0,     0,     0,     0,  2673,     0,     0,     0,     0,     0,
    1464,     0,     0,  1465,     0,  1235,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1466,     0,  1235,
       0,     0,  1238,   702,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,     0,
       0,     0,     0,  1241,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,     0,  1236,     0,     0,  1453,     0,
       0,     0,  1466,     0,     0,     0,  1455,     0,  1241,     0,
       0,  1456,     0,     0,     0,     0,     0,     0,     0,  1239,
       0,  1238,     0,     0,  1453,  1235,     0,  2977,     0,     0,
       0,     0,  1455,  1240,     0,     0,     0,  1456,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1468,     0,     0,
    1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,
       0,     0,  1241,     0,     0,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1236,     0,     0,     0,  1235,     0,     0,     0,     0,
       0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,  1472,
    1473,  1474,  1475,  1476,  1477,     0,     0,  1238,     0,  2788,
    1478,     0,     0,     0,     0,     0,  1235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,     0,     0,     0,  1457,     0,     0,     0,  1458,     0,
       0,     0,     0,  1241,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1459,  1460,
    1457,     0,     0,  1235,  1458,     0,     0,  1241,     0,     0,
       0,     0,     0,  1461,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1459,  1460,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1241,  1461,
       0,     0,  1241,  1241,     0,     0,  1462,     0,     0,  1463,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1464,     0,     0,  1465,     0,     0,     0,
       0,     0,  1462,     0,     0,  1463,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1239,  1464,
       0,     0,  1465,  1239,  1239,  1235,     0,     0,     0,     0,
       0,     0,  1240,     0,     0,     0,     0,  1240,  1240,     0,
       0,  2932,     0,     0,     0,     0,     0,     0,     0,     0,
    2935,     0,     0,     0,     0,     0,  2936,     0,  2937,     0,
       0,     0,     0,     0,     0,  1466,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2955,  2956,     0,     0,  1236,  1236,     0,  1236,     0,     0,
    2931,  1466,     0,     0,  1236,     0,     0,     0,     0,  2052,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2981,
    1238,  1238,  2984,  1238,  2986,     0,     0,     0,     0,     0,
    1238,     0,     0,  2990,     0,     0,  1236,     0,  1236,  2995,
       0,     0,  2998,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3005,  1239,     0,     0,     0,     0,     0,  1235,
       0,  2492,  1238,     0,  1238,  1468,     0,  1240,  1469,  1470,
    1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,     0,     0,
       0,     0,     0,  1478,     0,     0,     0,     0,     0,     0,
       0,  1468,     0,     0,  1469,  1470,  1471,  1235,  1472,  1473,
    1474,  1475,  1476,  1477,     0,  1453,     0,     0,     0,  1478,
       0,  1236,  1239,  1455,     0,     0,     0,     0,  1456,     0,
       0,     0,     0,     0,     0,     0,  1240,     0,     0,     0,
       0,  1453,     0,     0,  1236,     0,     0,  1238,     0,  1455,
       0,     0,     0,     0,  1456,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1238,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1236,     0,  1238,     0,     0,     0,  1239,     0,
       0,     0,     0,     0,     0,     0,     0,  1236,  1235,     0,
       0,     0,  1240,     0,  1480,     0,     0,     0,  1238,  1235,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1238,     0,     0,     0,     0,     0,     0,
       0,  1457,     0,     0,     0,  1458,     0,     0,  1238,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1236,     0,
       0,     0,     0,     0,     0,  1459,  1460,  1457,     0,  1480,
       0,  1458,     0,     0,     0,  1235,     0,     0,     0,     0,
    1461,     0,     0,  1235,  1238,     0,     0,  3178,  3179,     0,
       0,  1459,  1460,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1461,     0,     0,     0,
       0,     0,     0,  1462,     0,     0,  1463,     0,  1236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1464,     0,     0,  1465,     0,     0,     0,     0,     0,  1462,
       0,     0,  1463,     0,  1238,  1453,     0,     0,     0,  1236,
       0,  3219,     0,  1455,     0,     0,  1464,     0,  1456,  1465,
       0,     0,  1236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1238,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1238,     0,
       0,     0,     0,     0,  3235,  3237,  1236,     0,     0,     0,
       0,     0,  1466,     0,     0,     0,     0,  3244,     0,     0,
       0,     0,     0,  3249,  3250,     0,     0,  3252,     0,     0,
       0,     0,  1238,     0,     0,     0,     0,     0,  1466,     0,
       0,  1239,  1239,  1235,  1239,     0,     0,  3266,     0,     0,
       0,  1239,     0,     0,     0,  1240,  1240,     0,  1240,     0,
       0,     0,     0,     0,     0,  1240,     0,     0,  1235,     0,
       0,  1453,     0,     0,     0,     0,     0,     0,     0,  1455,
       0,     0,     0,  1239,  1456,  1239,     0,     0,     0,     0,
       0,  1457,     0,     0,     0,  1458,     0,  1240,  1236,  1240,
       0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,  1472,
    1473,  1474,  1475,  1476,  1477,  1459,  1460,     0,     0,  2978,
    1478,     0,  1235,     0,  1238,     0,     0,     0,  1468,     0,
    1461,  1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,
    1477,     0,     0,     0,     0,  3010,  1478,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1239,     0,
       0,     0,     0,  1462,  3321,     0,  1463,     0,     0,     0,
       0,     0,  1240,     0,     0,     0,  1480,     0,     0,     0,
    1464,  1239,     0,  1465,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1240,     0,     0,     0,     0,
       0,     0,     0,  1235,     0,     0,     0,  1457,     0,     0,
       0,  1458,     0,     0,     0,  1239,     0,     0,     0,     0,
       0,     0,  1236,  3370,     0,     0,     0,  1235,     0,  1240,
       0,  1459,  1460,     0,     0,     0,  1480,     0,     0,  1239,
       0,     0,     0,     0,     0,     0,  1461,     0,  1238,     0,
       0,     0,  1466,  1240,  1239,     0,     0,     0,  1235,  1480,
    1236,     0,  1235,  1235,  2031,     0,     0,     0,  1240,  1239,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1462,
       0,  3400,  1463,  1240,  1480,  1480,  1238,     0,  1480,  3402,
       0,     0,     0,     0,     0,     0,  1464,     0,     0,  1465,
       0,     0,     0,     0,     0,  1239,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1240,
       0,     0,     0,     0,     0,     0,  1480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,  1472,
    1473,  1474,  1475,  1476,  1477,     0,     0,  3019,     0,     0,
    1478,     0,     0,     0,     0,  1239,     0,     0,  1466,  1480,
       0,  1236,     0,     0,     0,     0,     0,     0,     0,  1240,
       0,     0,  1236,     0,     0,     0,  3471,     0,     1,     0,
       0,     0,     0,     0,     0,     0,  1239,  1238,     2,     0,
       3,     4,     0,     0,     0,     0,     0,     0,  1238,  1239,
    1240,     0,     0,     0,     5,     0,     0,     0,  2052,     0,
       0,     0,     0,  1240,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     7,     8,  1236,     0,
       0,     9,    10,  1239,  3503,     0,  1236,     0,     0,     0,
       0,     0,     0,    11,     0,    12,     0,  1240,  1468,     0,
       0,  1469,  1470,  1471,  1238,  1472,  1473,  1474,  1475,  1476,
    1477,     0,  1238,     0,    13,  3025,  1478,    14,     0,     0,
    1480,     0,     0,    15,     0,     0,     0,     0,     0,    16,
    1480,     0,     0,  1480,     0,    17,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,     0,    19,     0,    20,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     0,     0,     0,  1239,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1240,
       0,     0,     0,     0,    23,     0,     0,     0,     0,     0,
    1453,     0,     0,     0,     0,     0,     0,     0,  1455,     0,
       0,     0,     0,  1456,     0,     0,  1453,     0,     0,    24,
      25,     0,     0,     0,  1455,    26,     0,     0,     0,  1456,
       0,     0,     0,     0,    27,     0,  1236,     0,     0,     0,
       0,     0,  1453,     0,     0,     0,     0,     0,     0,     0,
    1455,     0,    28,     0,     0,  1456,     0,     0,     0,     0,
       0,  1236,  1238,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1238,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1239,
      30,     0,     0,     0,    31,     0,    32,     0,     0,     0,
       0,    33,     0,  1240,     0,  1236,    34,     0,     0,    35,
       0,     0,     0,    36,     0,     0,     0,     0,     0,    37,
       0,     0,     0,     0,     0,    38,  1457,  1239,    39,     0,
    1458,  1238,     0,     0,     0,    40,     0,     0,     0,     0,
       0,  1240,  1457,     0,     0,     0,  1458,     0,    41,     0,
    1459,  1460,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,  1461,  1459,  1460,  1457,     0,
       0,     0,  1458,    43,     0,    44,     0,     0,    45,     0,
       0,  1461,    46,     0,     0,     0,  1236,     0,     0,     0,
       0,     0,  1459,  1460,    47,     0,     0,     0,  1462,     0,
       0,  1463,     0,     0,     0,     0,     0,  1461,     0,     0,
    1236,     0,  1238,     0,  1462,  1464,     0,  1463,  1465,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1464,     0,     0,  1465,    48,  1238,     0,  1239,     0,
    1462,  1236,     0,  1463,     0,  1236,  1236,     0,     0,  1239,
       0,     0,  1240,     0,     0,     0,     0,  1464,     0,     0,
    1465,     0,     0,  1240,     0,     0,     0,  1238,     0,     0,
       0,  1238,  1238,  1480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1466,     0,     0,
       0,     0,     0,     0,     0,  1480,     0,  1480,     0,  2031,
    2031,  2566,     0,  1466,  2031,  1239,     0,     0,  1480,     0,
       0,     0,     0,  1239,     0,  1480,     0,     0,  1453,  1240,
    1480,     0,     0,     0,     0,  1480,  1455,  1240,     0,  1466,
    1480,  1456,     0,     0,     0,     0,     0,     0,     0,  1480,
       0,     0,     0,  2031,  2031,  1480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1480,     0,     0,
       0,     0,     0,     0,  1480,     0,  1480,  1480,  1480,  1480,
    1480,  1480,  1480,  1480,  1480,     0,  1480,  1468,     0,     0,
    1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,
       0,     0,     0,  1468,  3029,  1478,  1469,  1470,  1471,     0,
    1472,  1473,  1474,  1475,  1476,  1477,     0,     0,     0,     0,
    3221,  1478,     0,     0,     0,     0,     0,     0,     0,  1468,
       0,     0,  1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,
    1476,  1477,     0,     0,     0,     0,  3253,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1457,     0,  1453,     0,  1458,     0,
       0,     0,     0,  1239,  1455,  1480,     0,     0,     0,  1456,
       0,     0,     0,     0,     0,     0,     0,  1240,  1459,  1460,
       0,     0,     0,     0,     0,     0,     0,     0,  1239,     0,
       0,     0,     0,  1461,     0,     0,     0,     0,     0,     0,
       0,     0,  1240,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1462,     0,     0,  1463,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1239,  1464,     0,     0,  1465,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1240,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,     0,     0,
       0,     0,     0,     0,     0,  1455,     0,     0,     0,     0,
    1456,     0,     0,     0,     0,     0,     0,     0,     0,  1453,
       0,     0,  1457,     0,     0,     0,  1458,  1455,     0,     0,
       0,     0,  1456,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1466,  1459,  1460,     0,     0,
       0,     0,     0,  1239,     0,     0,  1480,     0,     0,     0,
       0,  1461,     0,     0,     0,     0,     0,  1240,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1239,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1240,     0,     0,  1462,     0,     0,  1463,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1239,     0,
       0,  1464,  1239,  1239,  1465,     0,     0,     0,     0,     0,
       0,     0,  1240,     0,     0,     0,  1240,  1240,     0,     0,
       0,     0,     0,  1457,     0,  1468,     0,  1458,  1469,  1470,
    1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,     0,     0,
       0,     0,  3392,  1478,     0,  1457,     0,  1459,  1460,  1458,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1461,     0,  1480,     0,     0,     0,     0,  1459,
    1460,     0,     0,  1466,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1461,  1480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1462,     0,     0,  1463,     0,
       0,  1453,     0,     0,     0,     0,     0,     0,     0,  1455,
       0,     0,  1464,     0,  1456,  1465,     0,  1462,     0,     0,
    1463,     0,     0,  1480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1464,     0,     0,  1465,     0,     0,
       0,     0,     0,     0,  2566,  2566,  2031,     0,     0,  2031,
    2031,  2031,  2031,  2031,  2031,  2031,  2031,  2031,     0,  2031,
    2566,     0,     0,  1468,     0,     0,  1469,  1470,  1471,     0,
    1472,  1473,  1474,  1475,  1476,  1477,     0,     0,     0,     0,
    3407,  1478,     0,  1480,  1466,     0,  1480,     0,  1480,     0,
       0,     0,     0,  2566,  2566,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1466,  2031,  2031,  1480,
       0,  1480,     0,     0,  1480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1480,
       0,     0,     0,     0,     0,     0,     0,  1457,     0,  1480,
       0,  1458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1480,     0,     0,     0,     0,     0,     0,     0,
       0,  1459,  1460,     0,     0,     0,  1480,     0,     0,     0,
       0,     0,     0,     0,  1468,     0,  1461,  1469,  1470,  1471,
       0,  1472,  1473,  1474,  1475,  1476,  1477,     0,     0,     0,
       0,  3439,  1478,     0,     0,     0,  1468,     0,     0,  1469,
    1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,  1477,  1462,
       0,     0,  1463,  3538,  1478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1464,     0,   493,  1465,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     494,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     496,     0,     0,     0,     0,  -567,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1466,     0,
       0,     0,     0,     0,     0,   497,     0,     0,  2031,     0,
       0,   498,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   500,     0,     0,     0,     0,  -726,   501,
       0,     0,     0,   502,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -705,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1468,     0,
       0,  1469,  1470,  1471,     0,  1472,  1473,  1474,  1475,  1476,
    1477,  -432,     0,     0,     0,     0,  1478,     0,     0,     0,
       0,     0,     0,     0,   503,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1480,     0,     0,  1480,  1480,
    1480,     0,  2566,     0,     0,     0,     0,  2566,  2566,  2566,
    2566,  2566,  2566,  2566,  2566,  2566,     0,  2566,  1480,  1480,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     504,     0,     0,   505,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1480,  2031,  2031,  1480,     0,  1480,
       0,     0,     0,  1480,  2566,  2566,     0,  -432,  1480,     0,
       0,  1480,     0,     0,     0,     0,     0,     0,  1480,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   506,     0,     0,     0,  -726,     0,   507,     0,     0,
       0,     0,     0,     0,     0,   508,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   509,   510,     0,   511,   512,     0,     0,     0,
       0,     0,     0,     0,   513,     0,     0,     0,   514,   515,
       0,     0,     0,     0,   516,     0,     0,     0,     0,   517,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2566,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1480,  1480,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1480,     0,     0,     0,  2031,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1480,     0,
    1480,     0,     0,     0,     0,  2566,  2566,  1480,     0,     0,
    2031,  2031,  1480,  1480,     0,  1480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1480,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2566,  2031,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2566,  2566,  1480,     0,  1480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1480,     0,     0,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,  2566,
       0,     0,     0,     0,     0,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,  1480,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,  3474,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,     0,     0,     0,     0,     0,   187,
     188,   189,   190,   191,   192,   193,   194,  2121,   196,   197,
     198,     0, -1569,     0,     0,   901,     0, -1569,   199,   200,
       0,   201,   676,   202,   203,   204,   677,   902,   678,   903,
     904,     0,   208,   209,   210,   211,   212,   905,   906,   213,
     214,   907,   908,   217,     0,   218,   219,   220,   221,   909,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
     679,   239,   240,   910,   911,   912,   913,   914,   915,   916,
     241,   242,   243,   244,   245,   246,   917,   918,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,  2122,     0,   259,   260,   919,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   920,
     273,   274,   921,   922,   276,     0,   277,   923,   279,     0,
     280,     0,   281,   681,     0,   682,   282,   283,     0,   284,
     924,     0,   286,     0,   287,   288,   289,   290,   291,   683,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,   684,   301,   302,   303,   304,   305,   925,   926,     0,
     927,     0,   309,   685,   686,   310,   687,   311,   312,   313,
     314,   315,   316,   317,     0,   928,   688,   319,   689,     0,
     320,   321,   322,   929,   930,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   931,   690,
     932,   640,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   933,   347,   348,   691,   349,   934,   935,   351,   936,
     353,   354,     0,     0,   355,   641,     0,     0,   937,   357,
     358,     0,     0,   359,   692,   693,   694,   938,   361,   362,
     363,   364,   365,   366,     0,   367,   939,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     940,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   695,   397,
     398,   941,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   942,   412,   413,   414,   415,
     696,   416,   943,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   944,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   945,   946,     0,     0,
     439,   947,   441,   948,   949,   443,   444,   445,   446,   447,
     448,     0,   950,   449,   450,   451,   452,   951,     0,   453,
     454,   455,   456,   457,   952,  2123,   459,   697,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   953,   954,   955,   956,   957,   958,   959,   477,
     478,   479,     0,     0,     0,   698,   960,   588,   961,   962,
     963,   571,   964,     0,     0,     0,     0,   965,   966,  2124,
       0,     0,     0,     0,     0,     0,   968,  2125,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,   901,     0,     0,   199,   200,     0,
     201,   676,   202,   203,   204,   677,   902,   678,   903,   904,
       0,   208,   209,   210,   211,   212,   905,   906,   213,   214,
     907,   908,   217,     0,   218,   219,   220,   221,   909,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,   679,
     239,   240,   910,   911,   912,   913,   914,   915,   916,   241,
     242,   243,   244,   245,   246,   917,   918,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   919,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   920,   273,
     274,   921,   922,   276,     0,   277,   923,   279,     0,   280,
       0,   281,   681,     0,   682,   282,   283,     0,   284,   924,
       0,   286,     0,   287,   288,   289,   290,   291,   683,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
     684,   301,   302,   303,   304,   305,   925,   926,     0,   927,
       0,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,     0,   928,   688,   319,   689,     0,   320,
     321,   322,   929,   930,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   931,   690,   932,
     640,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     933,   347,   348,   691,   349,   934,   935,   351,   936,   353,
     354,     0,     0,   355,   641,     0,     0,   937,   357,   358,
       0,     0,   359,   692,   693,   694,   938,   361,   362,   363,
     364,   365,   366,     0,   367,   939,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   940,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   695,   397,   398,
     941,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   942,   412,   413,   414,   415,   696,
     416,   943,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   944,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   945,   946,     0,     0,   439,
     947,   441,   948,   949,   443,   444,   445,   446,   447,   448,
       0,   950,   449,   450,   451,   452,   951,     0,   453,   454,
     455,   456,   457,   952,     0,   459,   697,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   953,   954,   955,   956,   957,   958,   959,   477,   478,
     479,     0,     0,     0,   698,   960,   588,   961,   962,   963,
     571,   964,     0,     0,     0,     0,   965,   966,     0,     0,
       0,     0,     0,     0,     0,   968,  2033,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,  2452,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238, -1174,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0, -1174,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0, -1174,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310, -1174,   311,   312,   313,   314,   315,
     316,   317,     0,   318, -1174,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336, -1174,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396, -1174,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,  1043,   201,   676,   202,   203,
     204,   677,  1209,   678,  1210,  1211,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,  1212,  1213,   217,     0,
     218,   219,   220,   221,     0,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,   679,   239,   240,     0,     0,
       0,   680,     0,     0,     0,   241,   242,   243,   244,   245,
     246,  1214,  1215,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     919,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,     0,   273,   274,     0,     0,   276,
       0,   277,  1216,   279,     0,   280,     0,   281,   681,     0,
     682,   282,   283,     0,   284,     0,     0,   286,     0,   287,
     288,   289,   290,   291,   683,   292,   293,   294,  1704,   295,
     296,   297,   298,   299,   300,     0,   684,  1705,   302,   303,
     304,   305,  1217,  1218,     0,  1219,     0,   309,   685,   686,
     310,   687,   311,   312,   313,   314,   315,   316,   317,     0,
       0,   688,   319,   689,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,  1220,   690,  1221,     0,   338,   339,   340,
     341,   342,   343,   344,     0,   346,     0,   347,   348,   691,
     349,     0,     0,   351,  1222,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,  1706,   692,
     693,   694,     0,   361,   362,   363,   364,   365,   366,     0,
     367,     0,   369,     0,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,  1223,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   695,   397,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,  1707,   414,   415,   696,   416,  1225,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,  1226,  1227,     0,     0,   439,     0,   441,     0,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,     0,  1228,
    1708,   459,   697,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,     0,     0,
       0,     0,     0,     0,   477,   478,   479,     0,     0,     0,
    1229,   187,   188,   189,   190,   191,   192,   193,   194,     0,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,  1709,   201,   676,   202,   203,   204,   677,  1209,
     678,  1210,  1211,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,  1212,  1213,   217,     0,   218,   219,   220,
     221,     0,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,   679,   239,   240,     0,     0,     0,   680,     0,
       0,     0,   241,   242,   243,   244,   245,   246,  1214,  1215,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   919,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,     0,   273,   274,     0,     0,   276,     0,   277,  1216,
     279,     0,   280,     0,   281,   681,     0,   682,   282,   283,
       0,   284,     0,     0,   286,     0,   287,   288,   289,   290,
     291,   683,   292,   293,   294,  1704,   295,   296,   297,   298,
     299,   300,     0,   684,  1705,   302,   303,   304,   305,  1217,
    1218,     0,  1219,     0,   309,   685,   686,   310,   687,   311,
     312,   313,   314,   315,   316,   317,     0,     0,   688,   319,
     689,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
    1220,   690,  1221,     0,   338,   339,   340,   341,   342,   343,
     344,     0,   346,     0,   347,   348,   691,   349,     0,     0,
     351,  1222,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,  1706,   692,   693,   694,     0,
     361,   362,   363,   364,   365,   366,     0,   367,     0,   369,
       0,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,  1223,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     695,   397,   398,     0,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,  1707,
     414,   415,   696,   416,  1225,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,  1226,  1227,
       0,     0,   439,     0,   441,     0,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,     0,  1228,  1708,   459,   697,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,     0,     0,     0,  1229,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,   901,     0,     0,   199,   200,  2432,
     201,   676,   202,   203,   204,   677,   902,   678,   903,   904,
    2043,   208,   209,   210,   211,   212,   905,   906,   213,   214,
     907,   908,   217,     0,   218,   219,   220,   221,   909,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,   679,
     239,   240,   910,   911,   912,   913,   914,   915,   916,   241,
     242,   243,   244,   245,   246,   917,   918,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   919,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   920,   273,
     274,   921,   922,   276,     0,   277,   923,   279,     0,   280,
       0,   281,   681,  2044,   682,   282,   283,     0,   284,   924,
       0,   286,     0,   287,   288,   289,   290,   291,   683,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
     684,   301,   302,   303,   304,   305,   925,   926,     0,   927,
       0,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,  2045,   928,   688,   319,   689,     0,   320,
     321,   322,   929,   930,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   931,   690,   932,
     640,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     933,   347,   348,   691,   349,   934,   935,   351,   936,   353,
     354,     0,     0,   355,   641,     0,     0,   937,   357,   358,
       0,     0,   359,   692,   693,   694,   938,   361,   362,   363,
     364,   365,   366,     0,   367,   939,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   940,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   695,   397,   398,
     941,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   942,   412,   413,   414,   415,   696,
     416,   943,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   944,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   945,   946,     0,  2046,   439,
     947,   441,   948,   949,   443,   444,   445,   446,   447,   448,
       0,   950,   449,   450,   451,   452,   951,     0,   453,   454,
     455,   456,   457,   952,     0,   459,   697,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   953,   954,   955,   956,   957,   958,   959,   477,   478,
     479,     0,     0,     0,   698,   960,   588,   961,   962,   963,
     571,   964,     0,     0,     0,     0,   965,   966,     0,     0,
       0,     0,     0,     0,     0,   968,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,   901,     0,     0,   199,   200,     0,   201,   676,
     202,   203,   204,   677,   902,   678,   903,   904,     0,   208,
     209,   210,   211,   212,   905,   906,   213,   214,   907,   908,
     217,     0,   218,   219,   220,   221,   909,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,   679,   239,   240,
     910,   911,   912,   913,   914,   915,   916,   241,   242,   243,
     244,   245,   246,   917,   918,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   919,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   920,   273,   274,   921,
     922,   276,     0,   277,   923,   279,     0,   280,     0,   281,
     681,     0,   682,   282,   283,     0,   284,   924,     0,   286,
       0,   287,   288,   289,   290,   291,   683,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,   684,   301,
     302,   303,   304,   305,   925,   926,     0,   927,     0,   309,
     685,   686,   310,   687,   311,   312,   313,   314,   315,   316,
     317,     0,   928,   688,   319,   689,     0,   320,   321,   322,
     929,   930,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   931,   690,   932,   640,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   933,   347,
     348,   691,   349,   934,   935,   351,   936,   353,   354,     0,
       0,   355,   641,     0,     0,   937,   357,   358,     0,     0,
     359,   692,   693,   694,   938,   361,   362,   363,   364,   365,
     366,     0,   367,   939,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   940,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   695,   397,   398,   941,   400,
     401,   402,   403,   404,   405,   406,   407,    37,   408,   409,
     410,   411,   942,   412,   413,   414,   415,   696,   416,   943,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   944,   429,     0,   430,   431,    41,   432,   433,   434,
     435,   436,     0,   945,   946,     0,     0,   439,   947,   441,
     948,   949,   443,   444,   445,   446,   447,   448,     0,   950,
     449,   450,   451,   452,   951,     0,   453,   454,   455,   456,
    1443,   952,     0,   459,   697,   460,   461,   462,     0,     0,
     463,     0,    47,   464,   465,   466,   467,   468,   469,   953,
     954,   955,   956,   957,   958,   959,   477,   478,   479,     0,
       0,     0,   698,   960,   588,   961,   962,   963,   571,   964,
       0,     0,     0,     0,   965,   966,     0,     0,     0,     0,
       0,     0,     0,   968,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
     901,     0,     0,   199,   200,     0,   201,   676,   202,   203,
     204,   677,   902,   678,   903,   904,     0,   208,   209,   210,
     211,   212,   905,   906,   213,   214,   907,   908,   217,     0,
     218,   219,   220,   221,   909,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,   679,   239,   240,   910,   911,
     912,   913,   914,   915,   916,   241,   242,   243,   244,   245,
     246,   917,   918,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     919,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   920,   273,   274,   921,   922,   276,
       0,   277,   923,   279,     0,   280,     0,   281,   681,     0,
     682,   282,   283,     0,   284,   924,     0,   286,     0,   287,
     288,   289,   290,   291,   683,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,   684,   301,   302,   303,
     304,   305,   925,   926,     0,   927,     0,   309,   685,   686,
     310,   687,   311,   312,   313,   314,   315,   316,   317,     0,
     928,   688,   319,   689,     0,   320,   321,   322,   929,   930,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   931,   690,   932,   640,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   933,   347,   348,   691,
     349,   934,   935,   351,   936,   353,   354,     0,     0,   355,
     641,     0,     0,   937,   357,   358,     0,     0,   359,   692,
     693,   694,   938,   361,   362,   363,   364,   365,   366,     0,
     367,   939,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   940,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   695,   397,   398,   941,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     942,   412,   413,   414,   415,   696,   416,   943,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   944,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   945,   946,     0,     0,   439,   947,   441,   948,   949,
     443,   444,   445,   446,   447,   448,     0,   950,   449,   450,
     451,   452,   951,     0,   453,   454,   455,   456,   457,   952,
       0,   459,   697,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   953,   954,   955,
     956,   957,   958,   959,   477,   478,   479,     0,     0,     0,
     698,   960,   588,   961,   962,   963,   571,   964,     0,     0,
       0,     0,   965,   966,     0,     0,     0,     0,     0,  1388,
    1992,   968,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,   901,     0,
       0,   199,   200,     0,   201,   676,   202,   203,   204,   677,
     902,   678,   903,   904,     0,   208,   209,   210,   211,   212,
     905,   906,   213,   214,   907,   908,   217,     0,   218,   219,
     220,   221,   909,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,   679,   239,   240,   910,   911,   912,   913,
     914,   915,   916,   241,   242,   243,   244,   245,   246,   917,
     918,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   919,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   920,   273,   274,   921,   922,   276,     0,   277,
     923,   279,     0,   280,     0,   281,   681,     0,   682,   282,
     283,     0,   284,   924,     0,   286,     0,   287,   288,   289,
     290,   291,   683,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,   684,   301,   302,   303,   304,   305,
     925,   926,     0,   927,     0,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,     0,   928,   688,
     319,   689,     0,   320,   321,   322,   929,   930,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   931,   690,   932,   640,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   933,   347,   348,   691,   349,   934,
     935,   351,   936,   353,   354,     0,     0,   355,   641,     0,
       0,   937,   357,   358,     0,     0,   359,   692,   693,   694,
     938,   361,   362,   363,   364,   365,   366,     0,   367,   939,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   940,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   695,   397,   398,   941,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   942,   412,
     413,   414,   415,   696,   416,   943,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   944,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   945,
     946,     0,     0,   439,   947,   441,   948,   949,   443,   444,
     445,   446,   447,   448,     0,   950,   449,   450,   451,   452,
     951,     0,   453,   454,   455,   456,   457,   952,     0,   459,
     697,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   953,   954,   955,   956,   957,
     958,   959,   477,   478,   479,     0,     0,     0,   698,   960,
     588,   961,   962,   963,   571,   964,     0,     0,     0,     0,
     965,   966,   967,     0,     0,     0,     0,     0,     0,   968,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,   901,     0,     0,   199,
     200,     0,   201,   676,   202,   203,   204,   677,   902,   678,
     903,   904,     0,   208,   209,   210,   211,   212,   905,   906,
     213,   214,   907,   908,   217,     0,   218,   219,   220,   221,
     909,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,   679,   239,   240,   910,   911,   912,   913,   914,   915,
     916,   241,   242,   243,   244,   245,   246,   917,   918,   249,
    1035,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   919,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     920,   273,   274,   921,   922,   276,     0,   277,   923,   279,
       0,   280,     0,   281,   681,     0,   682,   282,   283,     0,
     284,   924,     0,   286,     0,   287,   288,   289,   290,   291,
     683,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,   684,   301,   302,   303,   304,   305,   925,   926,
       0,   927,     0,   309,   685,   686,   310,   687,   311,   312,
     313,   314,   315,   316,   317,     0,   928,   688,   319,   689,
       0,   320,   321,   322,   929,   930,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   931,
     690,   932,   640,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   933,   347,   348,   691,   349,   934,   935,   351,
     936,   353,   354,     0,     0,   355,   641,     0,     0,   937,
     357,   358,     0,     0,   359,   692,   693,   694,   938,   361,
     362,   363,   364,   365,   366,     0,   367,   939,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   940,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   695,
     397,   398,   941,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   942,   412,   413,   414,
     415,   696,   416,   943,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   944,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   945,   946,     0,
       0,   439,   947,   441,   948,   949,   443,   444,   445,   446,
     447,   448,     0,   950,   449,   450,   451,   452,   951,     0,
     453,   454,   455,   456,   457,   952,     0,   459,   697,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   953,   954,   955,   956,   957,   958,   959,
     477,   478,   479,     0,     0,     0,   698,   960,   588,   961,
     962,   963,   571,   964,     0,     0,     0,     0,   965,   966,
       0,     0,     0,     0,     0,     0,     0,   968,   187,   188,
     189,   190,   191,   192,   193,   194,  1645,   196,   197,   198,
       0,     0,     0,     0,   901,     0,     0,   199,   200,     0,
     201,   676,   202,   203,   204,   677,   902,   678,   903,   904,
       0,   208,   209,   210,   211,   212,   905,   906,   213,   214,
     907,   908,   217,     0,   218,   219,   220,   221,   909,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,   679,
     239,   240,   910,   911,   912,   913,   914,   915,   916,   241,
     242,   243,   244,   245,   246,   917,   918,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   919,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   920,   273,
     274,   921,   922,   276,     0,   277,   923,   279,     0,   280,
       0,   281,   681,     0,   682,   282,   283,     0,   284,   924,
       0,   286,     0,   287,   288,   289,   290,   291,   683,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
     684,   301,   302,   303,   304,   305,   925,   926,     0,   927,
       0,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,     0,   928,   688,   319,   689,     0,   320,
     321,   322,   929,   930,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   931,   690,   932,
     640,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     933,   347,   348,   691,   349,   934,   935,   351,   936,   353,
     354,     0,     0,   355,   641,     0,     0,   937,   357,   358,
       0,     0,   359,   692,   693,   694,   938,   361,   362,   363,
     364,   365,   366,     0,   367,   939,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   940,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   695,   397,   398,
     941,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   942,   412,   413,   414,   415,   696,
     416,   943,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   944,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   945,   946,     0,     0,   439,
     947,   441,   948,   949,   443,   444,   445,   446,   447,   448,
       0,   950,   449,   450,   451,   452,   951,     0,   453,   454,
     455,   456,   457,   952,     0,   459,   697,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   953,   954,   955,   956,   957,   958,   959,   477,   478,
     479,     0,     0,     0,   698,   960,   588,   961,   962,   963,
     571,   964,     0,     0,     0,     0,   965,   966,     0,     0,
       0,     0,     0,     0,     0,   968,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,   901,     0,     0,   199,   200,     0,   201,   676,
     202,   203,   204,   677,   902,   678,   903,   904,     0,   208,
     209,   210,   211,   212,   905,   906,   213,   214,   907,   908,
     217,     0,   218,   219,   220,   221,   909,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,   679,   239,   240,
     910,   911,   912,   913,   914,   915,   916,   241,   242,   243,
     244,   245,   246,   917,   918,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   919,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   920,   273,   274,   921,
     922,   276,     0,   277,   923,   279,     0,   280,     0,   281,
     681,  2044,   682,   282,   283,     0,   284,   924,     0,   286,
       0,   287,   288,   289,   290,   291,   683,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,   684,   301,
     302,   303,   304,   305,   925,   926,     0,   927,     0,   309,
     685,   686,   310,   687,   311,   312,   313,   314,   315,   316,
     317,     0,   928,   688,   319,   689,     0,   320,   321,   322,
     929,   930,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   931,   690,   932,   640,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   933,   347,
     348,   691,   349,   934,   935,   351,   936,   353,   354,     0,
       0,   355,   641,     0,     0,   937,   357,   358,     0,     0,
     359,   692,   693,   694,   938,   361,   362,   363,   364,   365,
     366,     0,   367,   939,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   940,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   695,   397,   398,   941,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   942,   412,   413,   414,   415,   696,   416,   943,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   944,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   945,   946,     0,     0,   439,   947,   441,
     948,   949,   443,   444,   445,   446,   447,   448,     0,   950,
     449,   450,   451,   452,   951,     0,   453,   454,   455,   456,
     457,   952,     0,   459,   697,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   953,
     954,   955,   956,   957,   958,   959,   477,   478,   479,     0,
       0,     0,   698,   960,   588,   961,   962,   963,   571,   964,
       0,     0,     0,     0,   965,   966,     0,     0,     0,     0,
       0,     0,     0,   968,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
     901,     0,     0,   199,   200,     0,   201,   676,   202,   203,
     204,   677,   902,   678,   903,   904,     0,   208,   209,   210,
     211,   212,   905,   906,   213,   214,   907,   908,   217,     0,
     218,   219,   220,   221,   909,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,   679,   239,   240,   910,   911,
     912,   913,   914,   915,   916,   241,   242,   243,   244,   245,
     246,   917,   918,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     919,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   920,   273,   274,   921,   922,   276,
       0,   277,   923,   279,     0,   280,     0,   281,   681,     0,
     682,   282,   283,     0,   284,   924,     0,   286,     0,   287,
     288,   289,   290,   291,   683,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,   684,   301,   302,   303,
     304,   305,   925,   926,     0,   927,     0,   309,   685,   686,
     310,   687,   311,   312,   313,   314,   315,   316,   317,     0,
     928,   688,   319,   689,     0,   320,   321,   322,   929,   930,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   931,   690,   932,   640,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   933,   347,   348,   691,
     349,   934,   935,   351,   936,   353,   354,     0,     0,   355,
     641,     0,     0,   937,   357,   358,     0,     0,   359,   692,
     693,   694,   938,   361,   362,   363,   364,   365,   366,     0,
     367,   939,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   940,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   695,   397,   398,   941,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     942,   412,   413,   414,   415,   696,   416,   943,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   944,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   945,   946,     0,     0,   439,   947,   441,   948,   949,
     443,   444,   445,   446,   447,   448,     0,   950,   449,   450,
     451,   452,   951,     0,   453,   454,   455,   456,   457,   952,
    3017,   459,   697,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   953,   954,   955,
     956,   957,   958,   959,   477,   478,   479,     0,     0,     0,
     698,   960,   588,   961,   962,   963,   571,   964,     0,     0,
       0,     0,   965,   966,     0,     0,     0,     0,     0,     0,
       0,   968,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,   901,     0,
       0,   199,   200,     0,   201,   676,   202,   203,   204,   677,
     902,   678,   903,   904,     0,   208,   209,   210,   211,   212,
     905,   906,   213,   214,   907,   908,   217,     0,   218,   219,
     220,   221,   909,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,   679,   239,   240,   910,   911,   912,   913,
     914,   915,   916,   241,   242,   243,   244,   245,   246,   917,
     918,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   919,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   920,   273,   274,   921,   922,   276,     0,   277,
     923,   279,     0,   280,     0,   281,   681,     0,   682,   282,
     283,     0,   284,   924,     0,   286,     0,   287,   288,   289,
     290,   291,   683,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,   684,   301,   302,   303,   304,   305,
     925,   926,     0,   927,     0,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,     0,   928,   688,
     319,   689,     0,   320,   321,   322,   929,   930,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   931,   690,   932,   640,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   933,   347,   348,   691,   349,   934,
     935,   351,   936,   353,   354,     0,     0,   355,   641,     0,
       0,   937,   357,   358,     0,     0,   359,   692,   693,   694,
     938,   361,   362,   363,   364,   365,   366,     0,   367,   939,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   940,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   695,   397,   398,   941,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   942,   412,
     413,   414,   415,   696,   416,   943,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   944,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   945,
     946,     0,     0,   439,   947,   441,   948,   949,   443,   444,
     445,   446,   447,   448,     0,   950,   449,   450,   451,   452,
     951,     0,   453,   454,   455,   456,   457,   952,     0,   459,
     697,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   953,   954,   955,   956,   957,
     958,   959,   477,   478,   479,     0,     0,     0,   698,   960,
     588,   961,   962,   963,   571,   964,     0,     0,     0,     0,
     965,   966,     0,     0,     0,     0,     0,     0,     0,   968,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,   901,     0,     0,   199,
     200,     0,   201,   676,   202,   203,   204,   677,   902,   678,
     903,   904,     0,   208,   209,   210,   211,   212,   905,   906,
     213,   214,   907,   908,   217,     0,   218,   219,   220,   221,
     909,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,   679,   239,  2470,   910,   911,   912,   913,   914,   915,
     916,   241,   242,   243,   244,   245,   246,   917,   918,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   919,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     920,   273,   274,   921,   922,   276,     0,   277,   923,   279,
       0,   280,     0,   281,   681,     0,   682,   282,   283,     0,
     284,   924,     0,   286,     0,   287,   288,   289,   290,   291,
     683,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,   684,   301,   302,   303,   304,   305,   925,   926,
       0,   927,     0,   309,   685,   686,   310,   687,   311,   312,
     313,   314,   315,   316,   317,     0,   928,   688,   319,   689,
       0,   320,   321,   322,   929,   930,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   931,
     690,   932,   640,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   933,   347,   348,   691,   349,   934,   935,   351,
     936,   353,   354,     0,     0,   355,   641,     0,     0,   937,
     357,   358,     0,     0,   359,   692,   693,   694,   938,   361,
     362,   363,   364,   365,   366,     0,   367,   939,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   940,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   695,
     397,   398,   941,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   942,   412,   413,   414,
     415,   696,   416,   943,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   944,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   945,   946,     0,
       0,   439,   947,   441,   948,   949,   443,   444,   445,   446,
     447,   448,     0,   950,   449,   450,   451,   452,   951,     0,
     453,   454,   455,   456,   457,   952,     0,   459,   697,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   953,   954,   955,   956,   957,   958,   959,
     477,   478,   479,     0,     0,     0,   698,   960,   588,   961,
     962,   963,   571,   964,     0,     0,     0,     0,   965,   966,
       0,     0,     0,     0,     0,     0,     0,   968,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,   901,     0,     0,   199,   200,     0,
     201,   676,   202,   203,   204,   677,   902,   678,   903,   904,
       0,   208,   209,   210,   211,   212,   905,   906,   213,   214,
     907,   908,   217,     0,   218,   219,   220,   221,   909,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,   679,
     239,   240,   910,   911,   912,   913,   914,   915,   916,   241,
     242,   243,   244,   245,   246,   917,   918,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   919,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   920,   273,
     274,   921,   922,   276,     0,   277,   923,   279,     0,   280,
       0,   281,   681,     0,   682,   282,   283,     0,   284,   924,
       0,   286,     0,   287,   288,   289,   290,   291,   683,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
     684,   301,   302,   303,   304,   305,   925,   926,     0,   927,
       0,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,     0,   928,   688,   319,   689,     0,   320,
     321,   322,   929,   930,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   931,   690,   932,
     640,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     933,   347,   348,   691,   349,   934,   935,   351,   936,   353,
     354,     0,     0,   355,   641,     0,     0,   937,   357,   358,
       0,     0,   359,   692,   693,   694,   938,   361,   362,   363,
     364,   365,   366,     0,   367,   939,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   940,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   695,   397,   398,
     941,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   942,   412,   413,   414,   415,   696,
     416,   943,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   944,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   945,   946,     0,     0,   439,
     947,   441,   948,   949,   443,   444,   445,   446,   447,   448,
       0,   950,   449,   450,   451,   452,   951,     0,   453,   454,
     455,   456,   457,   952,     0,   459,   697,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
    3229,   953,   954,   955,   956,   957,   958,   959,   477,   478,
     479,     0,     0,     0,   698,   960,   588,   961,   962,   963,
     571,   964,     0,     0,     0,     0,   965,   966,     0,     0,
       0,     0,     0,     0,     0,   968,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,   901,     0,     0,   199,   200,     0,   201,   676,
     202,   203,   204,   677,   902,   678,   903,   904,     0,   208,
     209,   210,   211,   212,   905,   906,   213,   214,   907,   908,
     217,     0,   218,   219,   220,   221,   909,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,   679,   239,   240,
     910,   911,   912,   913,   914,   915,   916,   241,   242,   243,
     244,   245,   246,   917,   918,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   919,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   920,   273,   274,   921,
     922,   276,     0,   277,   923,   279,     0,   280,     0,   281,
     681,     0,   682,   282,   283,     0,   284,   924,     0,   286,
       0,   287,   288,   289,   290,   291,   683,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,   684,   301,
     302,   303,   304,   305,   925,   926,     0,   927,     0,   309,
     685,   686,   310,   687,   311,   312,   313,   314,   315,   316,
     317,     0,   928,   688,   319,   689,     0,   320,   321,   322,
     929,   930,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   931,   690,   932,   640,   338,
    3236,   340,   341,   342,   343,   344,   345,   346,   933,   347,
     348,   691,   349,   934,   935,   351,   936,   353,   354,     0,
       0,   355,   641,     0,     0,   937,   357,   358,     0,     0,
     359,   692,   693,   694,   938,   361,   362,   363,   364,   365,
     366,     0,   367,   939,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   940,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   695,   397,   398,   941,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   942,   412,   413,   414,   415,   696,   416,   943,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   944,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   945,   946,     0,     0,   439,   947,   441,
     948,   949,   443,   444,   445,   446,   447,   448,     0,   950,
     449,   450,   451,   452,   951,     0,   453,   454,   455,   456,
     457,   952,     0,   459,   697,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   953,
     954,   955,   956,   957,   958,   959,   477,   478,   479,     0,
       0,     0,   698,   960,   588,   961,   962,   963,   571,   964,
       0,     0,     0,     0,   965,   966,     0,     0,     0,     0,
       0,     0,     0,   968,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
     901,     0,     0,   199,   200,     0,   201,   676,   202,   203,
     204,   677,   902,   678,   903,   904,     0,   208,   209,   210,
     211,   212,   905,   906,   213,   214,   907,   908,   217,     0,
     218,   219,   220,   221,   909,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,   679,   239,   240,   910,   911,
     912,   913,   914,   915,   916,   241,   242,   243,   244,   245,
     246,   917,   918,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     919,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   920,   273,   274,   921,   922,   276,
       0,   277,   923,   279,     0,   280,     0,   281,   681,     0,
     682,   282,   283,     0,   284,   924,     0,   286,     0,   287,
     288,   289,   290,   291,   683,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,   684,   301,   302,   303,
     304,   305,   925,   926,     0,   927,     0,   309,   685,   686,
     310,   687,   311,   312,   313,   314,   315,   316,   317,     0,
     928,   688,   319,   689,     0,   320,   321,   322,   929,   930,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   931,   690,   932,   640,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,   691,
     349,   934,   935,   351,   936,   353,   354,     0,     0,   355,
     641,     0,     0,   937,   357,   358,     0,     0,   359,   692,
     693,   694,   938,   361,   362,   363,   364,   365,   366,     0,
     367,   939,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   940,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   695,   397,   398,   941,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     942,   412,   413,   414,   415,   696,   416,   943,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   944,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   945,   946,     0,     0,   439,   947,   441,   948,   949,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,   951,     0,   453,   454,   455,   456,   457,   952,
       0,   459,   697,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   953,   954,   955,
     956,   957,   958,   959,   477,   478,   479,     0,     0,     0,
     698,   960,   588,   961,   962,   963,   571,   964,     0,     0,
       0,     0,  2026,  2027,     0,     0,     0,     0,     0,     0,
       0,   968,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,   901,     0,
       0,   199,   200,     0,   201,   676,   202,   203,   204,     0,
     902,   678,   903,   904,     0,   208,   209,   210,   211,   212,
     905,   906,   213,   214,   907,   908,   217,     0,   218,   219,
     220,   221,   909,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,   679,   239,   240,   910,   911,   912,   913,
     914,   915,   916,   241,   242,   243,   244,   245,   246,   917,
     918,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   919,   262,
     263,     0,   264,   265,   266,     0,   267,     0,     0,   269,
     270,   271,   920,   273,   274,   921,   922,   276,     0,   277,
     923,   279,     0,   280,     0,   281,   681,     0,   682,   282,
     283,     0,   284,   924,     0,   286,     0,   287,   288,   289,
     290,   291,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,   684,   301,   302,   303,   304,   305,
     925,   926,     0,   927,     0,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,     0,   928,   688,
     319,     0,     0,   320,   321,   322,   929,   930,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   931,   690,   932,   640,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,   691,   349,   934,
     935,   351,   936,   353,   354,     0,     0,   355,   641,     0,
       0,   937,   357,   358,     0,     0,   359,   692,   693,   694,
     938,   361,   362,   363,   364,   365,   366,     0,   367,   939,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   940,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   695,   397,   398,   941,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   942,   412,
     413,   414,   415,     0,   416,   943,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   944,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   945,
     946,     0,     0,   439,   947,   441,   948,   949,   443,   444,
     445,   446,   447,   448,     0,   950,   449,   450,   451,   452,
     951,     0,   453,   454,   455,   456,   457,   952,     0,   459,
     697,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   953,   954,   955,   956,   957,
     958,   959,   477,   478,   479,     0,     0,     0,   698,   960,
     588,   961,   962,   963,   571,   964,     0,     0,     0,     0,
     965,   966,     0,     0,     0,     0,     0,     0,     0,   968,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,   901,     0,     0,   199,
     200,     0,   201,   676,   202,   203,   204,     0,   902,   678,
     903,   904,     0,   208,   209,   210,   211,   212,   905,   906,
     213,   214,   907,   908,   217,     0,   218,   219,   220,   221,
     909,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,   679,   239,   240,   910,   911,   912,   913,   914,   915,
     916,   241,   242,   243,   244,   245,   246,   917,   918,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   919,   262,   263,     0,
     264,   265,   266,     0,   267,     0,     0,   269,   270,   271,
     920,   273,   274,   921,   922,   276,     0,   277,   923,   279,
       0,   280,     0,   281,   681,     0,   682,   282,   283,     0,
     284,   924,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,   684,   301,   302,   303,   304,   305,   925,   926,
       0,   927,     0,   309,   685,   686,   310,   687,   311,   312,
     313,   314,   315,   316,   317,     0,   928,   688,   319,     0,
       0,   320,   321,   322,   929,   930,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   931,
     690,   932,   640,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,   691,   349,   934,   935,   351,
     936,   353,   354,     0,     0,   355,   641,     0,     0,   937,
     357,   358,     0,     0,   359,   692,   693,   694,   938,   361,
     362,   363,   364,   365,   366,     0,   367,   939,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   940,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   695,
     397,   398,   941,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   942,   412,   413,   414,
     415,     0,   416,   943,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   944,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   945,   946,     0,
       0,   439,   947,   441,   948,   949,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,   951,     0,
     453,   454,   455,   456,   457,   952,     0,   459,   697,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   953,   954,   955,   956,   957,   958,   959,
     477,   478,   479,     0,     0,     0,   698,   960,   588,   961,
     962,   963,   571,   964,     0,     0,     0,     0,  2026,  2027,
       0,     0,     0,     0,     0,     0,     0,   968,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,   676,   202,   203,   204,   677,   205,   678,   206,   207,
       0,   208,   209,   210,   211,   212,     0,   906,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   909,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,   679,
     239,   240,   910,   911,   912,   913,   914,   915,   916,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   921,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,   681,     0,   682,   282,   283,     0,   284,   924,
       0,   286,     0,   287,   288,   289,   290,   291,   683,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
     684,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,     0,   928,   688,   319,   689,     0,   320,
     321,   322,   929,   930,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   690,   337,
     640,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,   691,   349,     0,   935,   351,   352,   353,
     354,     0,     0,   355,   641,     0,   642,   356,   357,   358,
       0,     0,   359,   692,   693,   694,   938,   361,   362,   363,
     364,   365,   366,     0,   367,   939,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   695,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,    37,
     408,   409,   410,   411,   942,   412,   413,   414,   415,   696,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   944,   429,     0,   430,   431,    41,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     947,   441,   948,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,   951,     0,   453,   454,
     455,   456,  1443,   458,     0,   459,   697,   460,   461,   462,
       0,     0,   463,     0,    47,   464,   465,   466,   467,   468,
     469,   953,   954,   955,   956,   957,   958,   959,   477,   478,
     479,     0,     0,     0,   698,     0,     0,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,     0,  1898,   199,   200,     0,   201,
     676,   202,   203,   204,   677,   205,   678,   206,   207,     0,
     208,   209,   210,   211,   212,     0,   906,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   909,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,   679,   239,
     240,   910,   911,   912,   913,   914,   915,   916,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     921,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,   681,     0,   682,   282,   283,     0,   284,   924,     0,
     286,     0,   287,   288,   289,   290,   291,   683,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,   684,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   685,   686,   310,   687,   311,   312,   313,   314,   315,
     316,   317,     0,   928,   688,   319,   689,     0,   320,   321,
     322,   929,   930,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   690,   337,   640,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,   691,   349,     0,   935,   351,   352,   353,   354,
       0,     0,   355,   641,     0,   642,   356,   357,   358,     0,
       0,   359,   692,   693,   694,   938,   361,   362,   363,   364,
     365,   366,     0,   367,   939,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   695,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   942,   412,   413,   414,   415,   696,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   944,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   947,
     441,   948,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,   951,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   697,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     953,   954,   955,   956,   957,   958,   959,   477,   478,   479,
       0,     0,     0,   698,     0,     0,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,     0,  1898,   199,   200,     0,   201,   676,
     202,   203,   204,   677,   205,   678,   206,   207,     0,   208,
     209,   210,   211,   212,     0,   906,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   909,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,   679,   239,   240,
     910,   911,   912,   913,   914,   915,   916,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   921,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
     681,     0,   682,   282,   283,     0,   284,   924,     0,   286,
       0,   287,   288,   289,   290,   291,   683,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,   684,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     685,   686,   310,   687,   311,   312,   313,   314,   315,   316,
     317,     0,   928,   688,   319,   689,     0,   320,   321,   322,
     929,   930,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   690,   337,   640,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,   691,   349,     0,   935,   351,   352,   353,   354,     0,
       0,   355,   641,     0,     0,   356,   357,   358,     0,     0,
     359,   692,   693,   694,   938,   361,   362,   363,   364,   365,
     366,     0,   367,   939,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   695,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   942,   412,   413,   414,   415,   696,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   944,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   947,   441,
     948,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,   951,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   697,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   953,
     954,   955,   956,   957,   958,   959,   477,   478,   479,     0,
       0,     0,   698,     0,     0,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,  3356,   199,   200,     0,   201,   676,   202,
     203,   204,   677,   205,   678,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,   679,   239,   240,     0,
       0,     0,   680,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,   681,
       0,   682,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,   683,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,   684,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   685,
     686,   310,   687,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   688,   319,   689,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   690,   337,   640,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
     691,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,   641,     0,     0,   356,   357,   358,     0,     0,   359,
     692,   693,   694,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   695,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   696,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,     0,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   697,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   698,     0,     0,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,  3417,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,    37,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,    41,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,  1443,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
      47,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,     0,     0,   187,   188,   189,   190,   191,   192,   193,
     194,     0,   196,   197,   198,     0,     0,     0,     0,     0,
       0,    48,   199,   200,     0,   201,     0,   202,   203,   204,
       0,   205,     0,   206,   207,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,   243,   244,   245,   246,
     247,   248,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   261,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,   272,   273,   274,   275,     0,   276,     0,
     277,   278,   279,     0,   280,     0,   281,     0,     0,     0,
     282,   283,     0,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,     0,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,     0,   301,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,     0,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
       0,   319,     0,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,     0,   337,   640,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,   348,     0,   349,
       0,   350,   351,   352,   353,   354,     0,     0,   355,   641,
       0,     0,   356,   357,   358,     0,     0,   359,     0,     0,
       0,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,     0,   416,   417,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,     0,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,   457,   458,     0,
     459,     0,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,     0,   480,
       0,     0,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
    1022,   199,   200,     0,   201,     0,   202,   203,   204,     0,
     205,     0,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   276,     0,   277,
     278,   279,     0,   280,     0,   281,     0,     0,     0,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,     0,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,     0,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,     0,
     319,     0,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,     0,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,   359,     0,     0,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,     0,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,     0,     0,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
       0,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   480,     0,
       0,   187,   188,   189,   190,   191,   192,   193,   194,     0,
     196,   197,   198,     0,     0,     0,     0,     0,     0,  1619,
     199,   200,     0,   201,     0,   202,   203,   204,     0,   205,
       0,   206,   207,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,   243,   244,   245,   246,   247,   248,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   261,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,   272,   273,   274,   275,     0,   276,     0,   277,   278,
     279,     0,   280,     0,   281,     0,     0,     0,   282,   283,
       0,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,     0,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,     0,   301,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,     0,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,     0,   319,
       0,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,   348,     0,   349,     0,   350,
     351,   352,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,   359,     0,     0,     0,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,   413,
     414,   415,     0,   416,   417,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
       0,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,   457,   458,     0,   459,     0,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,   480,     0,     0,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,  2893,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3012,   187,   188,
     189,   190,   191,   192,   193,   194,  1527,   196,   197,   198,
    1528,  1529,  1530,  1531,  1532,  1533,  1534,   199,   200,  1535,
     201,   676,   202,   203,   204,   677,  1209,   678,  1210,  1211,
    1536,   208,   209,   210,   211,   212,  1537,  1538,   213,   214,
    1212,  1213,   217,  1539,   218,   219,   220,   221,     0,  1540,
    1541,   223,   224,   225,   226,   227,   228,  1542,   229,   230,
     231,   232,   233,   234,   235,  1543,   236,   237,   238,   679,
     239,   240,  1544,  1545,  1546,   680,  1547,  1548,  1549,   241,
     242,   243,   244,   245,   246,  1214,  1215,   249,  1550,   250,
    1551,   251,   252,   253,   254,   255,  1552,   256,   257,   258,
    1553,  1554,   259,   260,   919,   262,   263,  1555,   264,   265,
     266,  1556,   267,   268,  1557,   269,   270,   271,     0,   273,
     274,     0,  1558,   276,  1559,   277,  1216,   279,  1560,   280,
    1561,   281,   681,  1562,   682,   282,   283,  1563,   284,     0,
    1564,   286,  1565,   287,   288,   289,   290,   291,   683,   292,
     293,   294,  1566,   295,   296,   297,   298,   299,   300,  1567,
     684,     0,   302,   303,   304,   305,  1217,  1218,  1568,  1219,
    1569,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,  1570,     0,   688,   319,   689,  1571,   320,
     321,   322,  1572,  1573,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,  1220,   690,  1221,
    1574,   338,   339,   340,   341,   342,   343,   344,     0,   346,
    1575,   347,   348,   691,   349,  1576,     0,   351,  1222,   353,
     354,  1577,  1578,   355,  1579,  1580,  1581,  2777,   357,   358,
    1582,  1583,     0,   692,   693,   694,     0,   361,   362,   363,
     364,   365,   366,  1584,   367,     0,   369,     0,   371,   372,
     373,  1585,   374,   375,   376,   377,   378,   379,   380,  1223,
     382,   383,   384,  1586,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,  1587,   395,   396,   695,   397,   398,
       0,   400,   401,   402,   403,   404,   405,   406,   407,  1588,
     408,   409,   410,   411,  1589,   412,  1707,   414,   415,   696,
     416,  1225,  1590,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,     0,   429,  1591,   430,   431,  1592,   432,
     433,   434,   435,   436,  1593,  1226,  1227,  1594,  1595,   439,
       0,   441,     0,  1596,   443,   444,   445,   446,   447,   448,
    1597,  1598,   449,   450,   451,   452,  1599,  1600,   453,   454,
     455,   456,     0,  1228,  1601,   459,   697,   460,   461,   462,
    1602,  1603,   463,  1604,  1605,   464,   465,   466,   467,   468,
       0,     0,     0,     0,     0,     0,     0,     0,   477,   478,
     479,     0,     0,     0,  1229,  1501,   588,     0,     0,   718,
     571,     0,   719,   720,   721,     0,  2778,  2779,   724,   725,
     726,   727,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,     0,   202,   203,   204,     0,
     205,     0,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   716,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   717,     0,   277,
     278,   279,     0,   280,     0,   281,     0,     0,     0,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,     0,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,     0,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,     0,
     319,     0,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,     0,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,   359,     0,     0,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,     0,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,     0,     0,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
       0,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   480,     0,
       0,     0,     0,   718,     0,     0,   719,   720,   721,     0,
     722,   723,   724,   725,   726,   727,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   792,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   793,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,     0,     0,     0,     0,   718,     0,     0,
     719,   720,   721,     0,   722,   723,   724,   725,   726,   727,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   831,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   832,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   833,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,     0,     0,     0,
       0,   718,     0,     0,   719,   720,   721,     0,   722,   723,
     724,   725,   726,   727,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,  1192,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,  1193,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,     0,     0,     0,     0,   718,     0,     0,   719,   720,
     721,     0,   722,   723,   724,   725,   726,   727,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,     0,     0,     0,     0,   718,
       0,     0,   719,   720,   721,     0,   722,   723,   724,   725,
     726,   727,   187,   188,   189,   190,   191,   192,   193,   194,
    1527,   196,   197,   198,  1528,  1529,  1530,  1531,  1532,  1533,
    1534,   199,   200,  1535,   201,   676,   202,   203,   204,   677,
     205,   678,   206,   207,  1536,   208,   209,   210,   211,   212,
    1537,  1538,   213,   214,   215,   216,   217,  1539,   218,   219,
     220,   221,   222,  1540,  1541,   223,   224,   225,   226,   227,
     228,  1542,   229,   230,   231,   232,   233,   234,   235,  1543,
     236,   237,   238,   679,   239,   240,  1544,  1545,  1546,   680,
    1547,  1548,  1549,   241,   242,   243,   244,   245,   246,   247,
     248,   249,  1550,   250,  1551,   251,   252,   253,   254,   255,
    1552,   256,   257,   258,  1553,  1554,   259,   260,   261,   262,
     263,  1555,   264,   265,   266,  1556,   267,   268,  1557,   269,
     270,   271,   272,   273,   274,   275,  1558,   276,  1559,   277,
     278,   279,  1560,   280,  1561,   281,   681,  1562,   682,   282,
     283,  1563,   284,   285,  1564,   286,  1565,   287,   288,   289,
     290,   291,   683,   292,   293,   294,  1566,   295,   296,   297,
     298,   299,   300,  1567,   684,   301,   302,   303,   304,   305,
     306,   307,  1568,   308,  1569,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,  1570,   318,   688,
     319,   689,  1571,   320,   321,   322,  1572,  1573,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   690,   337,  1574,   338,   339,   340,   341,   342,
     343,   344,   345,   346,  1575,   347,   348,   691,   349,  1576,
     350,   351,   352,   353,   354,  1577,  1578,   355,  1579,  1580,
    1581,   356,   357,   358,  1582,  1583,   359,   692,   693,   694,
     360,   361,   362,   363,   364,   365,   366,  1584,   367,   368,
     369,   370,   371,   372,   373,  1585,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,  1586,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,  1587,   395,
     396,   695,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,  1588,   408,   409,   410,   411,  1589,   412,
     413,   414,   415,   696,   416,   417,  1590,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,  1591,
     430,   431,  1592,   432,   433,   434,   435,   436,  1593,   437,
     438,  1594,  1595,   439,   440,   441,   442,  1596,   443,   444,
     445,   446,   447,   448,  1597,  1598,   449,   450,   451,   452,
    1599,  1600,   453,   454,   455,   456,   457,   458,  1601,   459,
     697,   460,   461,   462,  1602,  1603,   463,  1604,  1605,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,  1606,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,  1607,     0,     0,     0,     0,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   213,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,     0,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,     0,     0,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,     0,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,     0,   449,   450,   451,   452,     0,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,   649,
       0,     0,     0,     0,     0,   199,   200,     0,   201,   676,
     202,   203,   204,   677,  1209,   678,  1210,  1211,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,  1212,  1213,
     217,     0,   218,   219,   220,   221,     0,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,   679,   239,   240,
       0,     0,     0,   680,     0,     0,     0,   241,   242,   243,
     244,   245,   246,  1214,  1215,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   919,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,     0,   273,   274,     0,
       0,   276,     0,   277,  1216,   279,     0,   280,     0,   281,
     681,     0,   682,   282,   283,     0,   284,     0,     0,   286,
       0,   287,   288,   289,   290,   291,   683,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,   684,     0,
     302,   303,   304,   305,  1217,  1218,     0,  1219,     0,   309,
     685,   686,   310,   687,   311,   312,   313,   314,   315,   316,
     317,     0,     0,   688,   319,   689,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,  1220,   690,  1221,     0,   338,
     339,   340,   341,   342,   343,   344,     0,   346,     0,   347,
     348,   691,   349,     0,     0,   351,  1222,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
       0,   692,   693,   694,     0,   361,   362,   363,   364,   365,
     366,     0,   367,     0,   369,     0,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,  1223,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   695,   397,   398,     0,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,  1224,   414,   415,   696,   416,  1225,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,     0,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,  1226,  1227,     0,     0,   439,     0,   441,
       0,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
       0,  1228,     0,   459,   697,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,     0,     0,
       0,     0,     0,     0,     0,     0,   477,   478,   479,     0,
       0,     0,  1229,   187,   188,   189,   190,   191,   192,   193,
     194,     0,   196,   197,   198,     0,  1660,     0,     0,     0,
       0,     0,   199,   200,     0,   201,   676,   202,   203,   204,
     677,  1209,   678,  1210,  1211,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,  1212,  1213,   217,     0,   218,
     219,   220,   221,     0,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,   679,   239,   240,     0,     0,     0,
     680,     0,     0,     0,   241,   242,   243,   244,   245,   246,
    1214,  1215,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   919,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,     0,   273,   274,     0,     0,   276,     0,
     277,  1216,   279,     0,   280,     0,   281,   681,     0,   682,
     282,   283,     0,   284,     0,     0,   286,     0,   287,   288,
     289,   290,   291,   683,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,   684,     0,   302,   303,   304,
     305,  1217,  1218,     0,  1219,     0,   309,   685,   686,   310,
     687,   311,   312,   313,   314,   315,   316,   317,     0,     0,
     688,   319,   689,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,  1220,   690,  1221,     0,   338,   339,   340,   341,
     342,   343,   344,     0,   346,     0,   347,   348,   691,   349,
       0,     0,   351,  1222,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,     0,   692,   693,
     694,     0,   361,   362,   363,   364,   365,   366,     0,   367,
       0,   369,     0,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,  1223,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   695,   397,   398,     0,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,  1224,   414,   415,   696,   416,  1225,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
    1226,  1227,     0,     0,   439,     0,   441,     0,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,     0,  1228,     0,
     459,   697,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,     0,     0,     0,  1826,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,  1660,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
    1512,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,  1513,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,  1514,     0,   355,     0,  1515,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,  1516,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,  1501,   588,     0,
       0,     0,   571,     0,     0,     0,     0,     0,   572,  1502,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
    1522,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,  1513,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,  1514,     0,   355,     0,  1515,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,  1516,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,  1501,   588,     0,
       0,     0,   571,     0,     0,     0,     0,     0,   572,  1502,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,  1513,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,  1514,     0,   355,     0,  1515,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,  1516,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,  1501,   588,     0,
       0,     0,   571,     0,     0,     0,     0,     0,   572,  1502,
     187,   562,   189,   190,   191,   192,   193,   194,   563,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   564,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   565,   278,   279,
       0,   280,     0,   566,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   567,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   568,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   569,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   570,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,     0,     0,     0,
       0,     0,   571,     0,     0,     0,     0,     0,   572,   573,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,     0,     0,     0,
       0,     0,     0,  3204,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,  3607,   588,  3608,  3609,     0,   571,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,     0,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,  1495,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,     0,   588,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,     0,   588,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,     0,   202,
     203,   204,     0,   205,     0,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,     0,
       0,     0,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,  1328,     0,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,     0,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,     0,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,     0,   319,     0,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
       0,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,     0,     0,     0,   356,   357,   358,     0,     0,   359,
       0,     0,     0,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,     0,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,     0,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,     0,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   480,     0,   588,   187,   188,   189,   190,   191,   192,
     193,   194,  1527,   196,   197,   198,  1528,  1529,  1530,  1531,
    1532,  1533,  1534,   199,   200,  1535,   201,   676,   202,   203,
     204,   677,   205,   678,   206,   207,  1536,   208,   209,   210,
     211,   212,  1537,  1538,   213,   214,   215,   216,   217,  1539,
     218,   219,   220,   221,   222,  1540,  1541,   223,   224,   225,
     226,   227,   228,  1542,   229,   230,   231,   232,   233,   234,
     235,  1543,   236,   237,   238,   679,   239,   240,  1544,  1545,
    1546,   680,  1547,  1548,  1549,   241,   242,   243,   244,   245,
     246,   247,   248,   249,  1550,   250,  1551,   251,   252,   253,
     254,   255,  1552,   256,   257,   258,  1553,  1554,   259,   260,
     261,   262,   263,  1555,   264,   265,   266,  1556,   267,   268,
    1557,   269,   270,   271,   272,   273,   274,   275,  1558,   276,
    1559,   277,   278,   279,  1560,   280,  1561,   281,   681,  1562,
     682,   282,   283,  1563,   284,   285,  1564,   286,  1565,   287,
     288,   289,   290,   291,   683,   292,   293,   294,  1566,   295,
     296,   297,   298,   299,   300,  1567,   684,   301,   302,   303,
     304,   305,   306,   307,  1568,   308,  1569,   309,   685,   686,
     310,   687,   311,   312,   313,   314,   315,   316,   317,  1570,
     318,   688,   319,   689,  1571,   320,   321,   322,  1572,  1573,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   690,   337,  1574,   338,   339,   340,
     341,   342,   343,   344,   345,   346,  1575,   347,   348,   691,
     349,  1576,   350,   351,   352,   353,   354,  1577,  1578,   355,
    1579,  1580,  1581,   356,   357,   358,  1582,  1583,   359,   692,
     693,   694,   360,   361,   362,   363,   364,   365,   366,  1584,
     367,   368,   369,   370,   371,   372,   373,  1585,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,  1586,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
    1587,   395,   396,   695,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,  1588,   408,   409,   410,   411,
    1589,   412,   413,   414,   415,   696,   416,   417,  1590,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,  1591,   430,   431,  1592,   432,   433,   434,   435,   436,
    1593,   437,   438,  1594,  1595,   439,   440,   441,   442,  1596,
     443,   444,   445,   446,   447,   448,  1597,  1598,   449,   450,
     451,   452,  1599,  1600,   453,   454,   455,   456,   457,   458,
    1601,   459,   697,   460,   461,   462,  1602,  1603,   463,  1604,
    1605,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
    1606,   187,   188,   189,   190,  2288,   192,   193,   194,  1527,
     196,   197,   198,  1528,  1529,  1530,  1531,  1532,  1533,  1534,
     199,   200,  1535,   201,   676,   202,   203,   204,   677,   205,
     678,   206,   207,  1536,   208,   209,   210,   211,   212,  1537,
    1538,   213,   214,   215,   216,   217,  1539,   218,   219,   220,
     221,   222,  1540,  1541,   223,   224,   225,   226,   227,   228,
    1542,   229,   230,   231,   232,   233,   234,   235,  1543,   236,
     237,   238,   679,   239,   240,  1544,  1545,  1546,   680,  1547,
    1548,  1549,   241,   242,   243,   244,   245,   246,   247,   248,
     249,  1550,   250,  1551,   251,   252,   253,   254,   255,  1552,
     256,   257,   258,  1553,  1554,   259,   260,   261,  2289,   263,
    1555,   264,   265,   266,  1556,   267,   268,  1557,   269,   270,
     271,   272,   273,   274,   275,  1558,   276,  1559,   277,   278,
     279,  1560,   280,  1561,   281,   681,  1562,   682,   282,   283,
    1563,   284,   285,  1564,   286,  1565,   287,   288,   289,   290,
     291,   683,   292,   293,   294,  1566,   295,   296,   297,   298,
     299,   300,  1567,   684,   301,   302,   303,   304,   305,   306,
     307,  1568,   308,  1569,   309,   685,   686,   310,   687,   311,
     312,   313,   314,   315,   316,   317,  1570,   318,   688,   319,
     689,  1571,   320,   321,   322,  1572,  1573,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   690,   337,  1574,   338,   339,   340,   341,   342,   343,
     344,   345,   346,  1575,   347,   348,   691,   349,  1576,   350,
     351,   352,   353,   354,  1577,  1578,   355,  1579,  1580,  1581,
     356,   357,   358,  1582,  1583,   359,   692,   693,   694,   360,
     361,   362,   363,   364,   365,   366,  1584,   367,   368,   369,
     370,   371,   372,   373,  1585,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,  1586,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,  1587,   395,   396,
     695,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,  1588,   408,   409,   410,   411,  1589,  2290,   413,
     414,   415,   696,   416,   417,  1590,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,  1591,   430,
     431,  1592,   432,   433,   434,   435,   436,  1593,   437,   438,
    1594,  1595,   439,   440,   441,   442,  1596,   443,   444,   445,
     446,   447,   448,  1597,  1598,   449,   450,   451,   452,  1599,
    1600,   453,   454,   455,   456,   457,   458,  1601,   459,   697,
     460,   461,   462,  1602,  1603,   463,  1604,  1605,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,  1606,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,   676,   202,   203,   204,   677,   205,   678,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,   679,
     239,   240,     0,     0,     0,   680,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,   681,     0,   682,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,   683,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
     684,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   685,   686,   310,   687,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   688,   319,   689,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   690,   337,
     640,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,   691,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,   641,     0,     0,   356,   357,   358,
       0,     0,   359,   692,   693,   694,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   695,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   696,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   697,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   698,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,   676,   202,
     203,   204,   677,   205,   678,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,   679,   239,   240,     0,
       0,     0,   680,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,   681,
       0,   682,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   818,   683,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,   684,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   685,
     686,   310,   687,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   688,   319,   689,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   690,   337,   640,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
     691,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,   641,     0,     0,   356,   357,   358,     0,     0,   359,
     692,   693,   694,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   695,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   696,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,     0,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   697,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   698,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,   676,   202,   203,   204,   677,
     205,   678,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,   679,   239,   240,     0,     0,     0,   680,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   276,     0,   277,
     278,   279,     0,   280,     0,   281,   681,     0,   682,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   826,   683,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,   684,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   688,
     319,   689,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   690,   337,   640,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,   691,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,   641,     0,
       0,   356,   357,   358,     0,     0,   359,   692,   693,   694,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   695,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   696,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,     0,     0,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     697,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   698,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,     0,     0,     0,     0,     0,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   213,
     214,   215,   216,   217,  1675,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,  1676,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,  1677,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,  2414,     0,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,  1678,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,     0,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,  1679,   449,   450,   451,   452,     0,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   612,   193,   194,   578,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,   579,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,   613,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   580,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   581,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,   187,   188,   189,   190,   191,   192,   193,
     194,   578,   196,   197,   198,     0,     0,     0,     0,     0,
       0,     0,   199,   200,     0,   201,     0,   202,   203,   204,
       0,   205,     0,   206,   207,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
     579,   236,   237,   238,     0,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,   243,   244,   245,   246,
     247,   248,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   261,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,   272,   273,   274,   275,     0,   276,     0,
     277,   278,   279,     0,   280,     0,   281,     0,     0,     0,
     282,   283,     0,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,     0,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,     0,   301,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,     0,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
       0,   319,     0,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,   348,     0,   349,
       0,   350,   351,   352,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,   359,     0,     0,
       0,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   580,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   581,   408,   409,   410,   411,     0,
     412,   413,   414,   415,     0,   416,   417,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,     0,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,   457,   458,     0,
     459,     0,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,     0,   480,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,  1350,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,  1351,   281,     0,     0,     0,  1352,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
    1353,  1354,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,   640,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,   641,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,  1355,   404,   405,   406,
     407,     0,  1356,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
    1357,  1358,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     3,
       4,     0,     0,     0,     0,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,   640,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,   641,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,   640,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
     641,     0,   642,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,   187,   188,   189,   190,   191,   192,   193,   194,   996,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,   201,     0,   202,   203,   204,     0,   205,
       0,   206,   207,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,   243,   244,   245,   246,   247,   248,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   261,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,   272,   273,   274,   275,     0,   276,     0,   277,   278,
     279,     0,   280,     0,   281,     0,     0,     0,   282,   283,
       0,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,     0,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,     0,   301,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,     0,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,     0,   319,
       0,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,     0,   337,   640,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,   348,     0,   349,     0,   350,
     351,   352,   353,   354,     0,     0,   355,   641,     0,     0,
     356,   357,   358,     0,     0,   359,     0,     0,     0,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,   413,
     414,   415,     0,   416,   417,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
       0,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,   457,   458,     0,   459,     0,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,   480,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,   579,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   580,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   581,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,     0,   202,
     203,   204,     0,   205,     0,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,     0,
       0,     0,   282,  2111,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,     0,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,     0,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,     0,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,     0,   319,     0,     0,   320,   321,  2112,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,     0,   337,   640,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
       0,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,   641,     0,     0,   356,   357,   358,     0,     0,   359,
       0,     0,     0,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,     0,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,  2113,   432,  2114,   434,  2115,
     436,     0,   437,   438,     0,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,     0,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   480,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,     0,   202,   203,   204,     0,
     205,     0,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   276,     0,   277,
     278,   279,     0,   280,     0,   281,     0,     0,     0,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,     0,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,     0,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,     0,
     319,     0,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,   640,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,     0,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,   641,     0,
       0,   356,   357,   358,     0,     0,   359,     0,     0,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,     0,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,     0,     0,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
       0,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   480,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,     0,     0,     0,     0,     0,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   213,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,  1789,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,     0,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,     0,     0,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,     0,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,     0,   449,   450,   451,   452,  1790,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   192,   193,   194,  2224,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,  2225,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,   187,   188,   189,   190,   191,   192,   193,
     194,  2234,   196,   197,   198,     0,     0,     0,     0,     0,
       0,     0,   199,   200,     0,   201,     0,   202,   203,   204,
       0,   205,     0,   206,   207,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,   243,   244,   245,   246,
     247,   248,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   261,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,   272,   273,   274,   275,     0,   276,     0,
     277,   278,   279,     0,   280,     0,   281,     0,     0,     0,
     282,   283,     0,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,     0,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,     0,   301,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,     0,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
       0,   319,     0,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,   348,     0,   349,
       0,   350,   351,   352,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,   359,     0,     0,
       0,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,     0,   416,   417,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,     0,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,  2235,     0,   453,   454,   455,   456,   457,   458,     0,
     459,     0,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,     0,   480,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,   187,   188,   189,
     190,   191,   192,   193,   194,   523,   196,   197,   198,     0,
       0,     0,     0,     0,     0,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   524,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,   187,   188,   189,   190,   191,   192,
     193,   194,   606,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   607,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   608,   438,     0,     0,   609,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,   187,   188,   189,   190,   191,   192,   193,   194,   634,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,   201,     0,   202,   203,   204,     0,   205,
       0,   206,   207,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,   243,   244,   245,   246,   247,   248,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   261,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,   272,   273,   274,   275,     0,   276,     0,   277,   278,
     279,     0,   280,     0,   281,     0,     0,     0,   282,   283,
       0,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,     0,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,     0,   301,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,     0,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,     0,   319,
       0,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,   348,     0,   349,     0,   350,
     351,   352,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,   359,     0,     0,     0,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   635,     0,   412,   413,
     414,   415,     0,   416,   417,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   636,   438,
       0,     0,   637,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,   457,   458,     0,   459,     0,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,   480,   187,   188,
     189,   190,   191,   192,   193,   194,   814,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,  1009,   202,
     203,   204,     0,   205,     0,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   622,   214,   215,   216,  1010,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,     0,
       0,     0,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,     0,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,     0,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,     0,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,     0,   319,     0,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   625,   336,     0,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
       0,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,     0,     0,     0,   356,   357,   358,     0,     0,   359,
       0,     0,     0,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,     0,   626,   398,   399,   400,   401,
     402,   627,   404,   405,   406,   407,     0,   408,   409,   410,
    1000,     0,   412,   413,   414,   415,     0,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   629,   438,     0,     0,   630,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,     0,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   631,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   480,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,   676,   202,   203,   204,   677,
    1209,   678,  1210,  1211,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,  1212,  1213,   217,     0,   218,   219,
     220,   221,     0,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,   679,   239,   240,     0,     0,     0,   680,
       0,     0,     0,   241,   242,   243,   244,   245,   246,  1214,
    1215,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   919,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,     0,   273,   274,     0,     0,   276,     0,   277,
    1216,   279,     0,   280,     0,   281,   681,     0,   682,   282,
     283,     0,   284,     0,     0,   286,     0,   287,   288,   289,
     290,   291,   683,   292,   293,   294,  1704,   295,   296,   297,
     298,   299,   300,     0,   684,  1705,   302,   303,   304,   305,
    1217,  1218,     0,  1219,     0,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,     0,     0,   688,
     319,   689,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,  1220,   690,  1221,     0,   338,   339,   340,   341,   342,
     343,   344,     0,   346,     0,   347,   348,   691,   349,     0,
       0,   351,  1222,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,  1706,   692,   693,   694,
       0,   361,   362,   363,   364,   365,   366,     0,   367,     0,
     369,     0,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,  1223,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   695,   397,   398,     0,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
    1707,   414,   415,   696,   416,  1225,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,  1226,
    1227,     0,     0,   439,     0,   441,     0,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,     0,  1228,  1708,   459,
     697,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,     0,     0,     0,     0,
       0,     0,   477,   478,   479,     0,     0,     0,  1229,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,     0,     0,     0,     0,  2452,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   213,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,     0,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,     0,     0,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,     0,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,     0,   449,   450,   451,   452,     0,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,  2465,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,   187,   188,   189,   190,   191,   192,   193,
     194,     0,   196,   197,   198,     0,     0,     0,     0,     0,
       0,     0,   199,   200,     0,   201,     0,   202,   203,   204,
       0,   205,     0,   206,   207,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,   243,   244,   245,   246,
     247,   248,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   261,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,   272,   273,   274,   275,     0,   276,     0,
     277,   278,   279,     0,   280,     0,   281,     0,     0,     0,
     282,   283,     0,   284,   285,  2501,   286,     0,   287,   288,
     289,   290,   291,     0,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,     0,   301,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,     0,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
       0,   319,     0,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,   348,     0,   349,
       0,   350,   351,   352,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,   359,     0,     0,
       0,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,     0,   416,   417,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,     0,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,   457,   458,     0,
     459,     0,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,     0,   480,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
    3128,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,     0,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,  3130,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,  3132,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,   187,   188,   189,   190,   191,   192,   193,   194,     0,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,   201,     0,   202,   203,   204,     0,   205,
       0,   206,   207,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,   243,   244,   245,   246,   247,   248,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   261,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,   272,   273,   274,   275,     0,   276,     0,   277,   278,
     279,     0,   280,     0,   281,     0,     0,     0,   282,   283,
       0,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     291,     0,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,     0,   301,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,     0,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,     0,   319,
       0,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,   348,     0,   349,     0,   350,
     351,   352,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,   359,     0,     0,     0,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,   413,
     414,   415,     0,   416,   417,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
       0,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
    3474,   453,   454,   455,   456,   457,   458,     0,   459,     0,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,   480,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,     0,   202,
     203,   204,     0,   205,     0,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,     0,
       0,     0,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,     0,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,     0,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,     0,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,     0,   319,     0,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
       0,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,     0,     0,     0,   356,   357,   358,     0,     0,   359,
       0,     0,     0,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,     0,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,     0,     0,   596,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,     0,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   480,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,     0,   202,   203,   204,     0,
     205,     0,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   276,     0,   277,
     278,   279,     0,   280,     0,   281,     0,     0,     0,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,     0,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,     0,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,     0,
     319,     0,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,     0,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,   359,     0,     0,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,     0,   397,   398,   399,   400,   401,   604,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,     0,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,     0,     0,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
       0,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   480,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,     0,     0,     0,     0,     0,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   622,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   623,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,     0,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,     0,     0,
     320,   321,   624,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   625,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   626,
     398,   399,   400,   401,   402,   627,   404,   405,   406,   407,
       0,   408,   409,   410,   628,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   629,   438,     0,     0,
     630,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,     0,   449,   450,   451,   452,     0,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     631,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   291,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     657,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,   187,   188,   189,   190,   191,   192,   193,
     194,     0,   196,   197,   198,     0,     0,     0,     0,     0,
       0,     0,   199,   200,     0,   201,     0,   202,   203,   204,
       0,   205,     0,   206,   207,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,   243,   244,   245,   246,
     247,   248,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   261,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,   272,   273,   274,   275,     0,   276,     0,
     277,   278,   279,     0,   280,     0,   281,     0,     0,     0,
     282,   283,     0,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   291,     0,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,     0,   301,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,     0,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
       0,   319,     0,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   742,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,   348,     0,   349,
       0,   350,   351,   352,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,   359,     0,     0,
       0,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,     0,   416,   417,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,     0,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,   457,   458,     0,
     459,     0,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,     0,   480,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   804,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,     0,
       0,   439,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,     0,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   823,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   828,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,   187,   188,   189,   190,   191,   192,   193,   194,     0,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,   201,     0,   202,   203,   204,     0,   205,
       0,   206,   207,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,   243,   244,   245,   246,   247,   248,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   261,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,   272,   273,   274,   275,     0,   276,     0,   277,   278,
     279,     0,   280,     0,   281,     0,     0,     0,   282,   283,
       0,   284,   285,     0,   286,     0,   287,   288,   289,   290,
     836,     0,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,     0,   301,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,     0,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,     0,   319,
       0,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,   348,     0,   349,     0,   350,
     351,   352,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,   359,     0,     0,     0,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,   413,
     414,   415,     0,   416,   417,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
       0,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,   457,   458,     0,   459,     0,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,   480,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   838,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,     0,   202,
     203,   204,     0,   205,     0,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,     0,
       0,     0,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   840,     0,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,     0,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,     0,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,     0,   319,     0,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
       0,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,     0,     0,     0,   356,   357,   358,     0,     0,   359,
       0,     0,     0,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,     0,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,     0,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,     0,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   480,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,     0,   202,   203,   204,     0,
     205,     0,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   276,     0,   277,
     278,   279,     0,   280,     0,   281,     0,     0,     0,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   842,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,     0,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,     0,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,     0,
     319,     0,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,     0,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,   359,     0,     0,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,     0,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,     0,     0,   439,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
       0,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   480,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,     0,     0,     0,     0,     0,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   213,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,     0,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   845,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,     0,     0,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,     0,     0,
     439,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,     0,   449,   450,   451,   452,     0,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,   847,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   848,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,   187,   188,   189,   190,   191,   192,   193,
     194,     0,   196,   197,   198,     0,     0,     0,     0,     0,
       0,     0,   199,   200,     0,   201,     0,   202,   203,   204,
       0,   205,     0,   206,   207,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,   215,   216,   217,     0,   218,
     219,   220,   221,   222,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,     0,   239,   240,     0,     0,     0,
       0,     0,     0,     0,   241,   242,   243,   244,   245,   246,
     247,   248,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   261,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,   272,   273,   274,   275,     0,   276,     0,
     277,   278,   279,     0,   280,     0,   281,     0,     0,     0,
     282,   283,     0,   284,   285,     0,   286,     0,   287,   288,
     289,   290,   851,     0,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,     0,   301,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,     0,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
       0,   319,     0,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,     0,   347,   348,     0,   349,
       0,   350,   351,   352,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,   359,     0,     0,
       0,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,     0,   416,   417,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
       0,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,     0,     0,   439,   440,   441,   442,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,   457,   458,     0,
     459,     0,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,     0,   480,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,     0,   202,   203,   204,     0,   205,     0,
     206,   207,     0,   208,   209,   210,   211,   212,     0,     0,
     622,   214,   215,   216,   217,     0,   218,   219,   220,   221,
     222,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,     0,   239,   240,     0,     0,     0,     0,     0,     0,
       0,   241,   242,   243,   244,   245,   246,   247,   248,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   261,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
     272,   273,   274,   275,     0,   276,     0,   277,   278,   279,
       0,   280,     0,   281,     0,     0,     0,   282,   283,     0,
     284,   285,     0,   286,     0,   287,   288,   289,   290,   291,
       0,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,     0,   301,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,     0,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,     0,   319,     0,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   625,   336,
       0,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,     0,   347,   348,     0,   349,     0,   350,   351,
     352,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,   359,     0,     0,     0,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,     0,
     626,   398,   399,   400,   401,   402,   627,   404,   405,   406,
     407,     0,   408,   409,   410,  1000,     0,   412,   413,   414,
     415,     0,   416,   417,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   629,   438,     0,
       0,   630,   440,   441,   442,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,   457,   458,     0,   459,     0,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   631,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,     0,   480,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,  1030,     0,   199,   200,     0,   201,
       0,   202,   203,   204,     0,   205,     0,   206,   207,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,   215,
     216,   217,     0,   218,   219,   220,   221,   222,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,     0,   239,
     240,     0,     0,     0,     0,     0,     0,     0,   241,   242,
     243,   244,   245,   246,   247,   248,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   261,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,   272,   273,   274,
     275,     0,   276,     0,   277,   278,   279,     0,   280,     0,
     281,     0,     0,     0,   282,   283,     0,   284,   285,     0,
     286,     0,   287,   288,   289,   290,   291,     0,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,     0,
     301,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,     0,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,     0,   319,     0,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,     0,
     347,   348,     0,   349,     0,   350,   351,   352,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,   359,     0,     0,     0,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,     0,   413,   414,   415,     0,   416,
     417,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,     0,     0,   439,   440,
     441,   442,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,   457,   458,     0,   459,     0,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,     0,   480,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,     0,   202,   203,
     204,     0,   205,     0,   206,   207,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,   215,   216,   217,     0,
     218,   219,   220,   221,   222,     0,     0,   223,   224,   225,
    1281,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,     0,   239,   240,     0,     0,
       0,     0,     0,     0,     0,   241,   242,   243,   244,   245,
     246,   247,   248,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     261,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,   272,   273,   274,   275,     0,   276,
       0,   277,   278,   279,     0,   280,     0,   281,     0,     0,
       0,   282,   283,     0,   284,   285,     0,   286,     0,   287,
     288,   289,   290,   291,     0,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,     0,   301,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,     0,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,     0,   319,     0,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,     0,   347,   348,     0,
     349,     0,   350,   351,   352,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,   359,     0,
       0,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,     0,   416,   417,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,     0,     0,   439,   440,   441,   442,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,   457,   458,
       0,   459,     0,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,     0,
     480,   187,   188,   189,   190,   191,   192,   193,   194,     0,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,   201,     0,   202,   203,   204,     0,   205,
       0,   206,   207,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,   215,   216,   217,     0,   218,   219,   220,
     221,   222,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,     0,   239,   240,     0,     0,     0,     0,     0,
       0,     0,   241,   242,   243,   244,   245,   246,   247,   248,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   261,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,   272,   273,   274,   275,     0,   276,     0,   277,   278,
     279,     0,   280,     0,   281,     0,     0,     0,   282,   283,
       0,   284,   285,     0,   286,     0,   287,   288,   289,   290,
    1306,     0,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,     0,   301,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,     0,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,     0,   319,
       0,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,     0,   347,   348,     0,   349,     0,   350,
     351,   352,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,   359,     0,     0,     0,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,   413,
     414,   415,     0,   416,   417,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
       0,     0,   439,   440,   441,   442,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,   457,   458,     0,   459,     0,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,     0,   480,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,  1308,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,     0,   202,
     203,   204,     0,   205,     0,   206,   207,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,   215,   216,   217,
       0,   218,   219,   220,   221,   222,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,     0,   239,   240,     0,
       0,     0,     0,     0,     0,     0,   241,   242,   243,   244,
     245,   246,   247,   248,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   261,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,   272,   273,   274,   275,     0,
     276,     0,   277,   278,   279,     0,   280,     0,   281,     0,
       0,     0,   282,   283,     0,   284,   285,     0,   286,     0,
     287,   288,   289,   290,   291,     0,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,     0,   301,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,     0,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,     0,   319,     0,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,     0,   347,   348,
       0,   349,     0,   350,   351,   352,   353,   354,     0,     0,
     355,     0,     0,     0,   356,   357,   358,     0,     0,   359,
       0,     0,     0,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,     0,   397,   398,   399,   400,   401,
    1385,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,     0,   416,   417,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,     0,     0,   439,   440,   441,   442,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,     0,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
       0,   480,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,     0,   202,   203,   204,     0,
     205,     0,   206,   207,     0,   208,   209,   210,   211,   212,
       0,     0,   622,   214,   215,   216,   217,     0,   218,   219,
     220,   221,   222,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,     0,   239,   240,     0,     0,     0,     0,
       0,     0,     0,   241,   242,   243,   244,   245,   246,   247,
     248,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,   272,   273,   274,   275,     0,   276,     0,   277,
     278,   279,     0,   280,     0,   281,     0,     0,     0,   282,
     283,     0,   284,   285,     0,   286,     0,   287,   288,   289,
     290,   291,     0,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,     0,   301,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,     0,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,     0,
     319,     0,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     625,   336,     0,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,     0,   347,   348,     0,   349,     0,
     350,   351,   352,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,   359,     0,     0,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,     0,   626,   398,   399,   400,   401,   402,   627,   404,
     405,   406,   407,     0,   408,   409,   410,  1000,     0,   412,
     413,   414,   415,     0,   416,   417,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,     0,
     430,   431,     0,  1672,   433,   434,   435,   436,     0,   629,
     438,     0,     0,   630,   440,   441,   442,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,   457,   458,     0,   459,
       0,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   631,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,     0,   480,   187,
     188,   189,   190,   191,   192,   193,   194,     0,   196,   197,
     198,     0,     0,     0,     0,     0,     0,     0,   199,   200,
       0,   201,     0,   202,   203,   204,     0,   205,     0,   206,
     207,     0,   208,   209,   210,   211,   212,     0,     0,   622,
     214,   215,   216,   217,     0,   218,   219,   220,   221,   222,
       0,     0,   223,   224,   225,   226,   227,   228,     0,   229,
     230,   231,   232,   233,   234,   235,     0,   236,   237,   238,
       0,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,     0,
     250,     0,   251,   252,   253,   254,   255,     0,   256,   257,
     258,     0,     0,   259,   260,   261,   262,   263,     0,   264,
     265,   266,     0,   267,   268,     0,   269,   270,   271,   272,
     273,   274,   275,     0,   276,     0,   277,   278,   279,     0,
     280,     0,   281,     0,     0,     0,   282,   283,     0,   284,
     285,     0,   286,     0,   287,   288,   289,   290,   291,     0,
     292,   293,   294,     0,   295,   296,   297,   298,   299,   300,
       0,     0,   301,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,     0,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,     0,   319,     0,     0,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   625,   336,     0,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,     0,   347,   348,     0,   349,     0,   350,   351,   352,
     353,   354,     0,     0,   355,     0,     0,     0,   356,   357,
     358,     0,     0,   359,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,     0,   626,
     398,   399,   400,   401,   402,  1699,   404,   405,   406,   407,
       0,   408,   409,   410,  1000,     0,   412,   413,   414,   415,
       0,   416,   417,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,     0,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   629,   438,     0,     0,
     630,   440,   441,   442,     0,   443,   444,   445,   446,   447,
     448,     0,     0,   449,   450,   451,   452,     0,     0,   453,
     454,   455,   456,   457,   458,     0,   459,     0,   460,   461,
     462,     0,     0,   463,     0,     0,   464,   465,   466,   467,
     631,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,     0,   480,   187,   188,   189,   190,
     191,   192,   193,   194,     0,   196,   197,   198,     0,     0,
       0,     0,     0,     0,     0,   199,   200,     0,   201,     0,
     202,   203,   204,     0,   205,     0,   206,   207,     0,   208,
     209,   210,   211,   212,     0,     0,   213,   214,   215,   216,
     217,     0,   218,   219,   220,   221,   222,     0,     0,   223,
     224,   225,   226,   227,   228,     0,   229,   230,   231,   232,
     233,   234,   235,     0,   236,   237,   238,     0,   239,   240,
       0,     0,     0,     0,     0,     0,     0,   241,   242,   243,
     244,   245,   246,   247,   248,   249,     0,   250,     0,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
     259,   260,   261,   262,   263,     0,   264,   265,   266,     0,
     267,   268,     0,   269,   270,   271,   272,   273,   274,   275,
       0,   276,     0,   277,   278,   279,     0,   280,     0,   281,
       0,     0,     0,   282,   283,     0,   284,   285,     0,   286,
       0,   287,   288,   289,   290,  1914,     0,   292,   293,   294,
       0,   295,   296,   297,   298,   299,   300,     0,     0,   301,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
       0,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,     0,   319,     0,     0,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,     0,   347,
     348,     0,   349,     0,   350,   351,   352,   353,   354,     0,
       0,   355,     0,     0,     0,   356,   357,   358,     0,     0,
     359,     0,     0,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,     0,   416,   417,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,     0,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,     0,     0,   439,   440,   441,
     442,     0,   443,   444,   445,   446,   447,   448,     0,     0,
     449,   450,   451,   452,     0,     0,   453,   454,   455,   456,
     457,   458,     0,   459,     0,   460,   461,   462,     0,     0,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,     0,   480,   187,   188,   189,   190,   191,   192,   193,
     194,     0,   196,   197,   198,     0,     0,     0,     0,     0,
       0,     0,   199,   200,     0,   201,   676,   202,   203,   204,
     677,  1209,   678,  1210,  1211,     0,   208,   209,   210,   211,
     212,     0,     0,   213,   214,  1212,  1213,   217,     0,   218,
     219,   220,   221,     0,     0,     0,   223,   224,   225,   226,
     227,   228,     0,   229,   230,   231,   232,   233,   234,   235,
       0,   236,   237,   238,   679,   239,   240,     0,     0,     0,
     680,     0,     0,     0,   241,   242,   243,   244,   245,   246,
    1214,  1215,   249,     0,   250,     0,   251,   252,   253,   254,
     255,     0,   256,   257,   258,     0,     0,   259,   260,   919,
     262,   263,     0,   264,   265,   266,     0,   267,   268,     0,
     269,   270,   271,     0,   273,   274,     0,     0,   276,     0,
     277,  1216,   279,     0,   280,     0,   281,   681,     0,   682,
     282,   283,     0,   284,     0,     0,   286,     0,   287,   288,
     289,   290,   291,   683,   292,   293,   294,     0,   295,   296,
     297,   298,   299,   300,     0,   684,     0,   302,   303,   304,
     305,  1217,  1218,     0,  1219,     0,   309,   685,   686,   310,
     687,   311,   312,   313,   314,   315,   316,   317,     0,     0,
     688,   319,   689,     0,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,  1220,   690,  1221,     0,   338,   339,   340,   341,
     342,   343,   344,     0,   346,     0,   347,   348,   691,   349,
    1695,     0,   351,  1222,   353,   354,     0,     0,   355,     0,
       0,     0,   356,   357,   358,     0,     0,     0,   692,   693,
     694,     0,   361,   362,   363,   364,   365,   366,     0,   367,
       0,   369,     0,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,  1223,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   695,   397,   398,     0,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,     0,
     412,  1707,   414,   415,   696,   416,  1225,     0,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,     0,   429,
       0,   430,   431,  2872,   432,   433,   434,   435,   436,     0,
    1226,  1227,     0,     0,   439,     0,   441,     0,     0,   443,
     444,   445,   446,   447,   448,     0,     0,   449,   450,   451,
     452,     0,     0,   453,   454,   455,   456,     0,  1228,     0,
     459,   697,   460,   461,   462,     0,     0,   463,     0,     0,
     464,   465,   466,   467,   468,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,     0,     0,     0,  1229,
     187,   188,   189,   190,   191,   192,   193,   194,     0,   196,
     197,   198,     0,     0,     0,     0,     0,     0,     0,   199,
     200,     0,   201,   676,   202,   203,   204,   677,  1209,   678,
    1210,  1211,     0,   208,   209,   210,   211,   212,     0,     0,
     213,   214,  1212,  1213,   217,     0,   218,   219,   220,   221,
       0,     0,     0,   223,   224,   225,   226,   227,   228,     0,
     229,   230,   231,   232,   233,   234,   235,     0,   236,   237,
     238,   679,   239,   240,     0,     0,     0,   680,     0,     0,
       0,   241,   242,   243,   244,   245,   246,  1214,  1215,   249,
       0,   250,     0,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,   259,   260,   919,   262,   263,     0,
     264,   265,   266,     0,   267,   268,     0,   269,   270,   271,
       0,   273,   274,     0,     0,   276,     0,   277,  1216,   279,
       0,   280,     0,   281,   681,     0,   682,   282,   283,     0,
     284,     0,     0,   286,     0,   287,   288,   289,   290,   291,
     683,   292,   293,   294,     0,   295,   296,   297,   298,   299,
     300,     0,   684,     0,   302,   303,   304,   305,  1217,  1218,
       0,  1219,     0,   309,   685,   686,   310,   687,   311,   312,
     313,   314,   315,   316,   317,     0,     0,   688,   319,   689,
       0,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,  1220,
     690,  1221,     0,   338,   339,   340,   341,   342,   343,   344,
    1747,   346,     0,   347,   348,   691,   349,     0,     0,   351,
    1222,   353,   354,     0,     0,   355,     0,     0,     0,   356,
     357,   358,     0,     0,     0,   692,   693,   694,     0,   361,
     362,   363,   364,   365,   366,     0,   367,     0,   369,     0,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,  1223,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   695,
     397,   398,     0,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,     0,   412,  1224,   414,
     415,   696,   416,  1225,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,     0,   429,     0,   430,   431,
       0,   432,   433,   434,   435,   436,     0,  1226,  1227,     0,
       0,   439,     0,   441,     0,     0,   443,   444,   445,   446,
     447,   448,     0,     0,   449,   450,   451,   452,     0,     0,
     453,   454,   455,   456,     0,  1228,     0,   459,   697,   460,
     461,   462,     0,     0,   463,     0,     0,   464,   465,   466,
     467,   468,     0,     0,     0,     0,     0,     0,     0,     0,
     477,   478,   479,     0,     0,     0,  1229,   187,   188,   189,
     190,   191,   192,   193,   194,     0,   196,   197,   198,     0,
       0,     0,     0,     0,     0,     0,   199,   200,     0,   201,
     676,   202,   203,   204,   677,  1209,   678,  1210,  1211,     0,
     208,   209,   210,   211,   212,     0,     0,   213,   214,  1212,
    1213,   217,     0,   218,   219,   220,   221,     0,     0,     0,
     223,   224,   225,   226,   227,   228,     0,   229,   230,   231,
     232,   233,   234,   235,     0,   236,   237,   238,   679,   239,
     240,     0,     0,     0,   680,     0,     0,     0,   241,   242,
     243,   244,   245,   246,  1214,  1215,   249,     0,   250,     0,
     251,   252,   253,   254,   255,     0,   256,   257,   258,     0,
       0,   259,   260,   919,   262,   263,     0,   264,   265,   266,
       0,   267,   268,     0,   269,   270,   271,     0,   273,   274,
       0,     0,   276,     0,   277,  1216,   279,     0,   280,     0,
     281,   681,     0,   682,   282,   283,     0,   284,     0,     0,
     286,     0,   287,   288,   289,   290,   291,   683,   292,   293,
     294,     0,   295,   296,   297,   298,   299,   300,     0,   684,
       0,   302,   303,   304,   305,  1217,  1218,     0,  1219,     0,
     309,   685,   686,   310,   687,   311,   312,   313,   314,   315,
     316,   317,     0,     0,   688,   319,   689,     0,   320,   321,
     322,     0,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,  1220,   690,  1221,     0,
     338,   339,   340,   341,   342,   343,   344,  2714,   346,     0,
     347,   348,   691,   349,     0,     0,   351,  1222,   353,   354,
       0,     0,   355,     0,     0,     0,   356,   357,   358,     0,
       0,     0,   692,   693,   694,     0,   361,   362,   363,   364,
     365,   366,     0,   367,     0,   369,     0,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,  1223,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   695,   397,   398,     0,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,     0,   412,  1224,   414,   415,   696,   416,
    1225,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,     0,   429,     0,   430,   431,     0,   432,   433,
     434,   435,   436,     0,  1226,  1227,     0,     0,   439,     0,
     441,     0,     0,   443,   444,   445,   446,   447,   448,     0,
       0,   449,   450,   451,   452,     0,     0,   453,   454,   455,
     456,     0,  1228,     0,   459,   697,   460,   461,   462,     0,
       0,   463,     0,     0,   464,   465,   466,   467,   468,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
       0,     0,     0,  1229,   187,   188,   189,   190,   191,   192,
     193,   194,     0,   196,   197,   198,     0,     0,     0,     0,
       0,     0,     0,   199,   200,     0,   201,   676,   202,   203,
     204,   677,  1209,   678,  1210,  1211,     0,   208,   209,   210,
     211,   212,     0,     0,   213,   214,  1212,  1213,   217,     0,
     218,   219,   220,   221,     0,     0,     0,   223,   224,   225,
     226,   227,   228,     0,   229,   230,   231,   232,   233,   234,
     235,     0,   236,   237,   238,   679,   239,   240,     0,     0,
       0,   680,     0,     0,     0,   241,   242,   243,   244,   245,
     246,  1214,  1215,   249,     0,   250,     0,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,   259,   260,
     919,   262,   263,     0,   264,   265,   266,     0,   267,   268,
       0,   269,   270,   271,     0,   273,   274,     0,     0,   276,
       0,   277,  1216,   279,     0,   280,     0,   281,   681,     0,
     682,   282,   283,     0,   284,     0,     0,   286,     0,   287,
     288,   289,   290,   291,   683,   292,   293,   294,     0,   295,
     296,   297,   298,   299,   300,     0,   684,     0,   302,   303,
     304,   305,  1217,  1218,     0,  1219,     0,   309,   685,   686,
     310,   687,   311,   312,   313,   314,   315,   316,   317,     0,
       0,   688,   319,   689,     0,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,  1220,   690,  1221,     0,   338,   339,   340,
     341,   342,   343,   344,     0,   346,     0,   347,   348,   691,
     349,     0,     0,   351,  1222,   353,   354,     0,     0,   355,
       0,     0,     0,   356,   357,   358,     0,     0,     0,   692,
     693,   694,     0,   361,   362,   363,   364,   365,   366,     0,
     367,     0,   369,     0,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,  1223,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   695,   397,   398,     0,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
       0,   412,  1224,   414,   415,   696,   416,  1225,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,     0,
     429,     0,   430,   431,     0,   432,   433,   434,   435,   436,
       0,  1226,  1227,     0,     0,   439,     0,   441,     0,     0,
     443,   444,   445,   446,   447,   448,     0,     0,   449,   450,
     451,   452,     0,     0,   453,   454,   455,   456,     0,  1228,
       0,   459,   697,   460,   461,   462,     0,     0,   463,     0,
       0,   464,   465,   466,   467,   468,     0,     0,     0,     0,
       0,     0,     0,     0,   477,   478,   479,     0,     0,     0,
    1229,   187,   188,   189,   190,   191,   192,   193,   194,     0,
     196,   197,   198,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,   201,   676,   202,   203,   204,   677,  1209,
     678,  1210,  1211,     0,   208,   209,   210,   211,   212,     0,
       0,   213,   214,  1212,  1213,   217,     0,   218,   219,   220,
     221,     0,     0,     0,   223,   224,   225,   226,   227,   228,
       0,   229,   230,   231,   232,   233,   234,   235,     0,   236,
     237,   238,   679,   239,   240,     0,     0,     0,   680,     0,
       0,     0,   241,   242,   243,   244,   245,   246,  1214,  1215,
     249,     0,   250,     0,   251,   252,   253,   254,   255,     0,
     256,   257,   258,     0,     0,   259,   260,   919,   262,   263,
       0,   264,   265,   266,     0,   267,   268,     0,   269,   270,
     271,     0,   273,   274,     0,     0,   276,     0,   277,  1216,
     279,     0,   280,     0,   281,   681,     0,   682,   282,   283,
       0,   284,     0,     0,   286,     0,   287,   288,   289,   290,
     291,   683,   292,   293,   294,     0,   295,   296,   297,   298,
     299,   300,     0,   684,     0,   302,   303,   304,   305,  1217,
    1218,     0,  1219,     0,   309,   685,   686,   310,   687,   311,
     312,   313,   314,   315,   316,   317,     0,     0,   688,   319,
     689,     0,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
    1220,   690,  1221,     0,   338,   339,   340,   341,   342,   343,
     344,     0,   346,     0,   347,   348,   691,   349,     0,     0,
     351,  1222,   353,   354,     0,     0,   355,     0,     0,     0,
     356,   357,   358,     0,     0,     0,   692,   693,   694,     0,
     361,   362,   363,   364,   365,   366,     0,   367,     0,   369,
       0,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,  1223,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     695,   397,   398,     0,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,     0,   412,  1707,
     414,   415,   696,   416,  1225,     0,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,     0,   429,     0,   430,
     431,     0,   432,   433,   434,   435,   436,     0,  1226,  1227,
       0,     0,   439,     0,   441,     0,     0,   443,   444,   445,
     446,   447,   448,     0,     0,   449,   450,   451,   452,     0,
       0,   453,   454,   455,   456,     0,  1228,     0,   459,   697,
     460,   461,   462,     0,     0,   463,     0,     0,   464,   465,
     466,   467,   468,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,     0,     0,     0,  1229,   187,   188,
     189,   190,   191,   192,   193,   194,     0,   196,   197,   198,
       0,     0,     0,     0,     0,     0,     0,   199,   200,     0,
     201,     0,   202,   203,   204,     0,   205,     0,   206,   207,
       0,   208,   209,   210,   211,   212,     0,     0,   213,   214,
     215,   216,   217,     0,   218,   219,   220,   221,   222,     0,
       0,   223,   224,   225,   226,   227,   228,     0,   229,   230,
     231,   232,   233,   234,   235,     0,   236,   237,   238,     0,
     239,   240,     0,     0,     0,     0,     0,     0,     0,   241,
     242,   243,   244,   245,   246,   247,   248,   249,     0,   250,
       0,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,     0,   259,   260,   261,   262,   263,     0,   264,   265,
     266,     0,   267,   268,     0,   269,   270,   271,   272,   273,
     274,   275,     0,   276,     0,   277,   278,   279,     0,   280,
       0,   281,     0,     0,     0,   282,   283,     0,   284,   285,
       0,   286,     0,   287,   288,   289,   290,   291,     0,   292,
     293,   294,     0,   295,   296,   297,   298,   299,   300,     0,
       0,   301,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,     0,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,     0,   319,     0,     0,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
       0,   347,   348,     0,   349,     0,   350,   351,   352,   353,
     354,     0,     0,   355,     0,     0,     0,   356,   357,   358,
       0,     0,   359,     0,     0,     0,   360,   361,   362,   363,
     364,     0,   366,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,     0,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,     0,   397,   398,
     399,     0,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,     0,
     416,   417,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,     0,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,     0,     0,   439,
     440,   441,   442,     0,   443,   444,   445,   446,   447,   448,
       0,     0,   449,   450,   451,   452,     0,     0,   453,   454,
     455,   456,   457,   458,     0,   459,     0,   460,   461,   462,
       0,     0,   463,     0,     0,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,     0,   480,   187,   188,   189,   190,   191,
     192,   193,   194,     0,   196,   197,   198,     0,     0,     0,
       0,     0,     0,     0,   199,   200,     0,   201,   676,   202,
     203,   204,   677,  1209,   678,  1210,  1211,     0,   208,   209,
     210,   211,   212,     0,     0,   213,   214,  1212,  1213,   217,
       0,   218,   219,   220,   221,     0,     0,     0,   223,   224,
     225,   226,   227,   228,     0,   229,   230,   231,   232,   233,
     234,   235,     0,   236,   237,   238,   679,   239,   240,     0,
       0,     0,   680,     0,     0,     0,   241,   242,   243,   244,
     245,   246,  1214,  1215,   249,     0,   250,     0,   251,   252,
     253,   254,   255,     0,   256,   257,   258,     0,     0,   259,
     260,   919,   262,   263,     0,   264,   265,   266,     0,   267,
     268,     0,   269,   270,   271,     0,   273,   274,     0,     0,
     276,     0,   277,  1216,   279,     0,   280,     0,   281,   681,
       0,   682,   282,   283,     0,   284,     0,     0,   286,     0,
     287,   288,   289,   290,   291,   683,   292,   293,   294,     0,
     295,   296,   297,   298,   299,   300,     0,   684,     0,   302,
     303,   304,   305,  1217,  1218,     0,  1219,     0,   309,   685,
     686,   310,   687,   311,   312,   313,   314,   315,   316,   317,
       0,     0,   688,   319,   689,     0,   320,   321,   322,     0,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,  1220,   690,  1221,     0,   338,   339,
     340,   341,   342,   343,   344,     0,   346,     0,   347,   348,
     691,   349,     0,     0,   351,  1222,   353,   354,     0,     0,
     355,     0,     0,     0,   356,   357,   358,     0,     0,     0,
     692,   693,   694,     0,   361,   362,   363,   364,   365,   366,
       0,   367,     0,   369,     0,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,  1223,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   695,   397,   398,     0,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,     0,   412,     0,   414,   415,   696,   416,  1225,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
       0,   429,     0,   430,   431,     0,   432,   433,   434,   435,
     436,     0,  1226,  1227,     0,     0,   439,     0,   441,     0,
       0,   443,   444,   445,   446,   447,   448,     0,     0,   449,
     450,   451,   452,     0,     0,   453,   454,   455,   456,     0,
    1228,     0,   459,   697,   460,   461,   462,     0,     0,   463,
       0,     0,   464,   465,   466,   467,   468,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,     0,     0,
       0,  1229,   187,   188,   189,   190,   191,   192,   193,   194,
       0,   196,   197,   198,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,   201,   676,   202,   203,   204,   677,
       0,   678,     0,     0,     0,   208,   209,   210,   211,   212,
       0,     0,   213,   214,     0,     0,   217,     0,   218,   219,
     220,   221,     0,     0,     0,   223,   224,   225,   226,   227,
     228,     0,   229,   230,   231,   232,   233,   234,   235,     0,
     236,   237,   238,   679,   239,   240,     0,     0,     0,   680,
       0,     0,     0,   241,   242,   243,   244,   245,   246,     0,
       0,   249,     0,   250,     0,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,   259,   260,   261,   262,
     263,     0,   264,   265,   266,     0,   267,   268,     0,   269,
     270,   271,     0,   273,   274,     0,     0,   276,     0,   277,
       0,   279,     0,   280,     0,   281,   681,     0,   682,   282,
     283,     0,   284,     0,     0,   286,     0,   287,   288,   289,
     290,   291,   683,   292,   293,   294,     0,   295,   296,   297,
     298,   299,   300,     0,   684,     0,   302,   303,   304,   305,
       0,     0,     0,     0,     0,   309,   685,   686,   310,   687,
     311,   312,   313,   314,   315,   316,   317,     0,     0,   688,
     319,   689,     0,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,     0,   690,     0,     0,   338,   339,   340,   341,   342,
     343,   344,     0,   346,     0,   347,   348,   691,   349,     0,
       0,   351,     0,   353,   354,     0,     0,   355,     0,     0,
       0,   356,   357,   358,     0,     0,     0,   692,   693,   694,
       0,   361,   362,   363,   364,   365,   366,     0,   367,     0,
     369,     0,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   695,   397,   398,     0,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,     0,   412,
       0,   414,   415,   696,   416,     0,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,     0,   429,     0,
     430,   431,     0,   432,   433,   434,   435,   436,     0,     0,
       0,     0,     0,   439,     0,   441,     0,     0,   443,   444,
     445,   446,   447,   448,     0,     0,   449,   450,   451,   452,
       0,     0,   453,   454,   455,   456,     0,     0,     0,   459,
     697,   460,   461,   462,     0,     0,   463,     0,     0,   464,
     465,   466,   467,   468,     0,     0,     0,     0,     0,     0,
       0,     0,   477,   478,   479,     0,     0,     0,  1229
};

static const yytype_int16 yycheck[] =
{
       0,   673,    48,   580,   581,     0,   504,   827,   585,   673,
      42,    11,   623,    12,  1119,   834,  1352,   883,   163,   675,
      21,   749,   172,   168,  1330,  1224,    27,   870,   626,   803,
    1712,  1452,   917,   918,   732,   705,  1291,   896,   630,   946,
    1155,  1712,  1713,    34,   542,   743,    22,  1987,    48,  1273,
     699,   936,  2156,  2288,     0,  2290,     7,  1027,    34,     0,
     780,  1388,    13,    14,   497,  1103,   710,  2441,    19,  2125,
      21,    22,     0,    24,  1746,  1012,    27,    28,    29,  1016,
    1017,    32,    33,    34,  1619,    36,   784,    38,    39,   733,
     734,   789,    43,   737,  1064,  1961,    47,  1056,   796,   819,
    2655,   798,  1326,   536,  1860,  1903,  1904,   805,  1860,  2384,
    2350,   158,  1909,  1898,  1860,  1149,  1860,  2822,   158,  1860,
     143,    41,     0,     0,    44,  1860,  2873,  1628,  1069,    38,
      17,  2844,   907,   908,   811,  1625,  2369,  2370,  2371,  2372,
    2373,  2374,    25,  2572,  2384,    20,    46,    30,    46,    46,
    1087,     0,    25,    25,     0,     0,  1093,   932,   158,     0,
       0,   710,    14,   670,    11,  3319,    93,  2893,   670,  2895,
     854,   138,    32,   117,    93,    93,    93,    93,     7,    55,
    1852,    88,    66,   143,    48,     7,    88,    76,  1822,   112,
      48,   138,  1025,   138,    30,    60,   179,   121,     0,    93,
    1137,   778,    39,  1140,  1141,    24,    39,   100,    24,   110,
     141,   237,    39,   164,   165,   166,   121,   139,   169,    86,
       5,   172,     0,   174,   175,    70,   177,   230,   179,  1025,
     181,   182,   183,    11,   238,    93,  1069,   102,    26,    48,
      76,   140,    52,   150,   157,   235,    55,  3360,   150,  1921,
      32,  1923,   850,    62,  1191,    62,   176,    12,   178,    85,
     140,   105,   150,   107,  3344,   196,   764,   265,    70,  1025,
     153,   135,   205,  1069,   157,  3476,  3477,  3163,     0,   241,
      11,   110,   268,   235,   968,  1013,    93,    18,   110,    11,
     273,    86,    63,    21,   177,   178,    25,   142,   205,   133,
     253,   208,    84,   205,    11,    11,   208,    58,   177,   192,
      70,    18,    18,  1069,   379,   253,   312,   205,   138,    96,
    1227,   371,   379,    94,   120,   140,   135,  3032,    98,  1214,
    1215,   225,   253,   255,  1080,   230,   121,  1222,   138,   225,
     142,   990,   225,   242,   282,   228,   344,    39,   493,    19,
     303,   166,   405,  2043,   504,  2045,  2046,   157,   175,   242,
     425,   282,   158,  1109,   360,   303,   419,   225,   425,   302,
    1190,   240,   230,   101,  3454,  1194,   138,   154,   204,  3580,
     206,   225,   142,   381,    25,   271,   168,   532,   312,   254,
     161,   235,   542,   315,   539,   302,   169,   342,   401,   425,
     302,   174,   266,   287,   335,   299,   337,   312,   266,   310,
     183,  1009,   259,    48,   302,   170,   420,   297,   225,  1252,
     278,   383,   217,    93,   253,  3538,   325,    62,   238,  2704,
     420,   314,  1206,   285,   420,   217,  3141,  1212,  1213,  2672,
     307,   164,   425,   166,   289,   297,  1221,  1145,    93,  1147,
     284,   288,   375,  3339,  1182,   288,  1252,   266,   425,   182,
     282,   288,  1421,   352,  2704,   425,   342,  1187,   420,   362,
    1440,   336,   370,  3627,  3200,  1965,   420,  3182,   425,  1123,
     407,   310,   401,   401,   401,   401,   393,   289,   335,   405,
     337,   393,   356,   138,   346,    21,  1252,   399,   356,   401,
     135,    27,  1345,   401,   401,  1203,   401,  1184,  1707,  2938,
     295,   330,   425,   420,   330,   303,   352,  1487,   300,    93,
     420,   404,   420,   420,   407,   408,   409,   312,   411,   412,
     413,   414,   415,   416,   379,   486,   177,   178,   561,   422,
    2211,   425,  2213,   494,   416,   420,   497,   356,   499,   422,
     422,   502,  1101,   504,  1061,   506,   507,   508,   509,  1061,
     420,   562,   513,   564,   515,   566,   517,   782,  3273,   570,
    2060,  2804,  1242,   524,  1689,   424,   421,   379,   424,   424,
     342,  2637,   533,   424,   424,   536,   317,   228,   425,   540,
     360,   542,   425,   544,   545,    25,   288,   548,   425,   550,
     487,   552,   353,   554,  1281,   425,   557,   527,   425,   754,
     317,   317,   230,   217,   764,   217,   761,    98,   110,   421,
    3333,  1454,   424,    98,   276,   122,    93,   405,   295,    17,
    1128,   266,   519,   411,   412,   418,   284,    98,  1413,  1414,
     423,   344,  2143,  1898,   240,   407,   424,   253,   599,   110,
     601,     7,   145,   604,   321,   138,    39,    30,  1454,  2331,
    2332,   423,    88,    60,   664,   249,    95,   812,   883,   664,
    2455,   841,   592,   624,  2459,   626,   282,   628,   381,  2350,
      60,  1279,   852,   405,   413,   414,   415,   416,   169,   411,
     412,    87,  2326,   422,   169,  2329,  2330,   342,  1454,  2333,
     651,  1278,   424,  1387,  1388,   102,   657,   217,  3481,  2343,
    2131,   244,    93,  2384,  1398,   624,   175,  1401,   664,   628,
     253,   356,   102,   664,   150,  1409,  1410,  1668,   648,   502,
     304,   379,  3479,   506,   244,    95,   664,   407,  1422,  1423,
     132,    95,    23,   253,   517,  1356,  1357,   177,   418,  1433,
     420,   421,   227,   423,   110,   425,   401,    74,   225,   333,
      98,    60,   407,   365,   160,   716,   717,  2438,   420,   141,
     411,   412,   413,   414,   415,   416,   499,   425,   423,   205,
     153,   422,   208,   401,   157,     7,   664,   664,    40,   177,
     394,    13,   515,   367,   745,  3274,    48,  3317,   401,    11,
     293,   230,   263,   102,  1488,   379,   757,   304,  3182,  3582,
     164,   303,  1310,   764,   420,   766,   130,   401,   310,   192,
    1757,   772,   139,   129,   196,   776,   295,   133,  1765,   304,
    1767,   169,   783,   380,   217,  1668,   333,   119,   179,   372,
    3545,   792,   793,   333,  3617,  3324,   420,  1881,   165,   230,
    1065,   398,   295,  2650,   242,   365,   856,   254,   333,   810,
     811,   856,   813,   180,  2119,   225,    11,  1300,   349,   261,
     367,   225,  1668,   190,   254,   156,   302,   140,   878,   360,
     831,   832,   379,   878,   835,   360,   540,   193,   110,   342,
     544,   173,   367,   105,    85,    37,   213,   253,    63,   850,
     554,   901,   216,  1736,   379,   288,   252,   370,   342,  3144,
     856,  1126,  1668,  3433,   139,   856,   867,   360,   869,   870,
     920,  1419,   968,   420,   875,   876,   282,   310,   856,    94,
     881,   237,   273,  3412,   885,   129,   332,   333,   401,   336,
    1736,   314,   893,    85,   196,   420,   897,   105,   899,   107,
     950,   420,  3008,  3009,  3010,   254,   336,   420,   273,  1844,
     105,    64,   344,   335,   246,   337,   304,   393,   968,   297,
       0,   162,   425,  1188,  1770,   292,   401,    61,  1128,   242,
    1736,   411,   412,   413,   414,   415,   416,   420,  3543,  3544,
    1205,   425,   422,   716,   717,   420,   161,   312,    96,   193,
     253,   373,  1049,  1050,   107,  1052,  3281,    65,  1782,  1049,
    1050,  1034,  1052,   204,  1770,   206,   404,   159,   346,   407,
     408,   409,   360,   411,   412,   413,   414,   415,   416,   282,
     114,   253,  1247,  2704,   422,   401,   562,   336,   564,    97,
     566,  3281,   265,   237,   570,   360,   572,   573,    86,  1049,
    1050,   297,  1052,   776,   420,    93,   154,    97,  1009,  2925,
     282,   424,   204,  3618,   206,  1016,  1017,  2026,  2027,   792,
     793,    86,  2031,   355,   129,   217,  2832,   235,   133,  1030,
    2832,  1032,  2880,  2198,  1299,    96,  2832,   810,  2832,  1040,
    1041,  2832,  1866,  1867,  1868,  1869,  1916,  2832,   420,  2884,
     346,   423,   186,   187,  2889,  1924,     0,  2892,   831,   832,
     252,  2070,  2071,  2648,   139,   199,   425,    17,   176,  2753,
      74,   344,   253,  1074,  1294,  2759,  2760,  2761,  2762,  2763,
    2764,   323,   324,  1303,  1085,    65,   176,    97,   193,  3589,
     165,  1311,  1312,   154,  1095,   287,  1291,     0,  1293,   272,
    1847,   282,   282,   297,   119,   180,   286,  1302,   381,  1329,
    1310,  1858,  2498,   234,   129,   190,  3270,    97,   133,   253,
     305,  3545,  2210,   296,  2144,   301,    70,  1128,   320,  1130,
     310,   835,   237,  1880,   177,   139,    17,   225,   183,   715,
    1910,  2863,  3462,   253,   379,  2132,   305,  3647,   333,   282,
    2455,  2528,   346,   286,  2459,   304,   342,  1352,   173,   401,
    3445,   165,  1163,  1164,  1165,  1166,   176,    70,  2051,   303,
    1171,   875,   282,  2056,   333,   119,   180,   310,   193,   346,
    2902,   885,  2904,  1184,   333,   129,   190,  1670,   373,   133,
     425,  1192,  1193,   897,   138,    93,   176,  1198,   142,   379,
     334,   145,   336,   147,   304,  2051,   706,  1906,   407,   213,
    2056,   334,  3532,  1478,   373,  2489,   119,   292,   367,  1419,
    3540,     9,   237,   420,   423,   253,   129,   177,  3218,   173,
     133,   246,   732,   333,   322,   138,   240,   325,    86,   142,
      28,  1291,   145,   743,   147,  2051,   379,  1248,   253,   193,
    2056,   335,  1858,   337,   282,  1256,   379,   380,   286,  3579,
    2549,  1262,  1996,  1264,  1265,  1266,  1267,   367,  1364,  2424,
     173,   420,  1273,   273,  1880,   303,   174,   282,  1279,   379,
    1281,  2216,   310,   283,  2573,   416,  1335,    26,   292,  1937,
     193,   422,   242,   237,   284,  2188,   177,   420,   196,  1300,
    1301,  3407,   246,  1304,  1305,   310,   306,   253,    47,  1310,
    2044,    55,  1313,  1314,  1364,  1316,   133,  1318,    62,   301,
     420,   400,  1323,  1373,  1325,  1326,   405,   401,  1373,  1330,
    1331,  2802,   411,   412,   237,   152,   282,  1041,   380,  2073,
     355,  1382,   415,   246,  1345,   289,   420,   420,   299,  1350,
     423,   379,  1353,    67,  1355,  1381,   398,  1358,   362,   177,
     400,   242,  3197,  1364,   310,   405,    98,    98,   411,   412,
     413,   414,   415,   416,   335,  2109,   337,  1373,   420,   422,
    1381,  1382,  1373,   334,  1385,   269,   289,  2121,  2122,   333,
    1163,  1164,  1165,  1166,   405,  1373,   133,  1617,  1368,  1110,
     411,   412,  1113,  3087,  3088,  1173,   421,   401,  1458,    25,
     160,   355,   240,   380,   735,   152,   737,   245,  1419,  1192,
    1193,   177,   152,   744,   242,  1198,   420,    86,   379,   380,
     333,   398,   376,  1256,   378,   379,  1012,   169,   169,    36,
    1016,  1017,  2288,  2289,  2290,  1156,  1157,   301,  2468,  3181,
     380,   240,   355,   420,   404,   183,   245,   407,   408,   409,
     420,   411,   412,   413,   414,   415,   416,   420,   398,   420,
     423,   401,   422,   376,   418,   378,   379,   421,   405,   423,
     424,  1249,  2288,  2289,  2290,   401,  2128,  1255,  2208,  2509,
     420,  1264,  1265,  1266,  1267,   226,   227,   105,  2159,   107,
    2383,   399,   400,   401,   420,   401,  1274,   405,   421,  2980,
     401,  1087,   425,   411,   412,   418,   420,  1093,   421,   127,
     423,   424,   380,   404,   420,   240,   407,   408,   409,   420,
     411,   412,   413,   414,   415,   416,   418,  2383,   420,   419,
     398,   422,  2090,   401,  2553,   425,   420,  2556,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,   401,  2566,  1331,   401,
    3281,  1137,   420,   401,  1140,  1141,   335,  1832,   337,   105,
     419,   107,   304,   304,  2594,   420,   425,  2383,   420,  2884,
     418,  1631,   420,  2748,  2889,   423,   404,  2892,   421,    36,
    1641,   127,   425,   411,   412,   413,   414,   415,   416,    26,
    1304,   333,   333,  2297,   422,  2614,  2615,    33,  3330,  1313,
     299,   379,  2521,    39,  3298,  1191,   395,   225,  1619,  2576,
    2577,  1325,   230,   421,   405,   179,   424,   235,   360,   360,
     411,   412,   400,   423,   421,   367,   367,   405,   425,   420,
     335,  3362,   337,   411,   412,   334,  1350,   379,   379,  1353,
     667,  1355,   669,   119,  1358,   411,   412,   413,   414,   415,
     416,    45,    46,   129,  1665,  1666,   422,   133,  1669,  1670,
     421,  1672,     5,   424,   415,  1676,   299,    10,   418,   420,
     420,  1682,   423,   423,  1685,    18,   243,  1688,   420,   420,
     379,   380,  1693,  1694,   230,  1915,  2612,   421,  1699,   235,
     243,   425,    35,  1898,  2587,  1436,   240,   173,  1439,  1929,
    1930,   334,  1977,  1933,   421,   342,  1717,  1718,   425,  1939,
    1721,  1722,  1723,  1724,  1725,  1726,  1727,   193,  2977,  1730,
    1731,   420,   240,  1734,  1735,  2469,    26,  1738,   421,   421,
     348,  2587,   425,   425,  1745,  1746,    15,    16,  3480,   357,
    1751,  2686,  1753,  1754,   395,   421,   379,   380,  2385,   425,
     421,   395,  1763,  1764,   425,  1766,   379,   380,   421,  1989,
    1771,   237,   425,   243,  1775,  1776,  1777,  1778,  1779,  1780,
     246,  2587,  2675,  2676,   421,  1786,  1787,  1788,   425,  2437,
     179,  2460,  1793,  2462,  1795,  1796,  3267,   420,   413,  2769,
    2770,   310,  1898,  2773,   421,  2775,  2815,  1808,   425,   421,
     295,   296,   348,   425,  1815,  1816,  1817,  1818,  1819,  1820,
    2703,   357,  2705,  1399,  1400,   413,   414,   415,   416,    38,
     425,  1407,  1882,   137,   422,  1411,  1412,  1882,   421,   421,
     421,   421,  1665,   425,   425,   425,  1669,   420,  1898,  2583,
    1426,  1852,  1428,   421,   421,   379,   380,  2703,   425,  2705,
      69,   421,  1685,    20,  2642,   425,  2359,  2360,  2361,    36,
    1693,  3176,   488,  1449,   421,  1451,  1877,   423,   425,   382,
     421,    38,   421,  1884,   425,    70,   425,  2733,    17,   355,
    2090,   421,  3197,   420,  1717,   425,    25,  2703,  1899,  2705,
     421,    30,  1903,  1904,   425,   421,   421,    92,   420,   425,
     425,  1734,    69,    98,   421,   420,   125,   423,   425,  1920,
    1921,  1922,  1923,   303,  2119,   133,  1502,  2733,  1751,  3315,
    1753,   421,   295,   296,   421,   425,  1937,   122,   425,   421,
     421,   396,   397,   425,   425,  1946,   155,   421,  1771,  1950,
     421,   425,   240,  2153,   425,  2220,  1779,   421,  1959,   191,
     421,   425,  2682,  1786,   425,   379,   380,   421,   125,  2189,
    1793,   425,    32,  2982,  2983,    17,   362,  2073,   240,   421,
     596,   421,  1983,   425,   169,   425,  1987,  2252,   421,  2254,
    1763,   421,   425,   421,   240,   425,   420,   425,   155,   421,
     616,   421,   301,   425,   234,   425,   622,  2227,  2228,   625,
     626,   627,   421,   421,  1718,    75,   425,   425,   421,   887,
     888,   421,   425,  2073,   153,   425,   183,   421,   157,   183,
     421,   425,  2114,  2115,   425,  1808,   421,  2087,   420,    99,
     425,    48,  1815,  1816,  1817,  1818,  1819,  1820,   177,   178,
    3355,  2875,   421,   379,  2160,  2161,   425,  2107,   118,    62,
     421,  2062,  2327,   192,   425,  1641,    20,   421,  3424,  2119,
    3426,   425,  2988,   382,   134,    26,   421,   286,   421,   288,
     425,   290,   425,  2162,  2163,   351,   421,   296,   148,  2090,
     425,   421,   253,   421,   303,   425,   225,   425,   421,   228,
     421,   310,   425,   421,   425,   133,   421,   425,   421,   318,
     425,   421,   425,   242,   421,   425,   245,   326,   425,   304,
     183,   362,   420,   123,   123,   420,   123,   382,   123,   286,
     123,  2132,   425,   290,   123,   177,  1959,   123,   141,   296,
    2141,   123,   240,  2408,   123,   123,   303,  1920,   333,  1922,
    2350,   123,   240,   310,    20,   123,   123,   160,  2423,   420,
     134,   318,   191,   779,  1987,   374,   420,   133,  3473,   326,
     230,  2172,  2173,  2174,   133,   360,   401,   401,   238,   262,
     420,  1757,   367,   420,  2384,   314,   420,  2188,   401,  1765,
     401,  1767,   420,   196,   379,   401,  2197,   420,   420,   420,
     242,   420,   420,   420,   420,   420,   420,   401,  3101,  2474,
     420,   271,   250,   420,  3223,   420,   420,   374,   420,   420,
     420,   378,   379,   420,   420,   420,   425,   420,  2229,  2230,
    2231,  2232,   420,  2967,   850,   420,    20,    76,  3247,  3248,
      20,   191,   245,   133,   133,   342,  1950,  2248,   342,  1421,
     423,   342,   342,  2473,  2255,    65,  2257,  2477,   342,  2479,
    2455,  2481,  2482,    25,  2459,  1841,   303,   240,    30,  2534,
    2490,   342,  2273,   242,   342,   404,  2277,   230,   407,   408,
     409,    48,   411,   412,   413,   414,   415,   416,   342,   361,
     419,    55,   240,   422,   162,    62,   342,   426,  3144,   342,
    2565,   420,  2522,  2498,   425,   362,   362,   253,   342,   342,
    1482,  3227,   342,  2578,  3020,    36,  2317,    36,   342,   420,
    2321,  2322,   342,   244,    25,   342,    93,   342,    95,    30,
    2331,  2332,   335,   342,   337,   299,   342,   342,  3144,  2388,
     342,   240,   240,   346,   177,   420,   420,  2612,  3096,  2172,
     420,   370,   379,   356,   970,    20,   118,    19,     9,    93,
     373,   362,   404,    65,   980,   407,   408,   409,   372,   411,
     412,   413,   414,   415,   416,   991,  3385,  2427,  1954,   199,
     422,    25,  2427,     7,  3539,    20,    30,   133,  2389,    13,
     240,   153,    20,  1009,   420,   157,  1012,   164,  2448,   300,
    1016,  1017,   362,  2448,   362,  2455,   376,   123,  2409,  2459,
    2411,   123,  3305,   123,   123,   177,   178,   234,   342,   289,
     367,   229,   420,   138,   340,  2248,   375,  2428,    52,   210,
     192,   210,  2255,   395,   422,   404,  2437,   310,   407,   408,
     409,   425,   411,   412,   413,   414,   415,   416,  2449,   340,
     342,  2452,   153,   138,   425,   420,   157,  2507,   225,   420,
     344,   151,  2507,   230,  2465,   421,   228,   151,   407,   173,
    3386,   241,   235,   425,  2475,  3023,   177,   178,   421,   103,
     242,    41,   782,   342,    44,   193,   110,  2488,  2489,   113,
     342,   192,   299,   342,    61,  2496,   240,   420,  2321,   266,
    2501,  3417,   181,   181,  2704,  3421,  3422,  2508,   420,   247,
     230,   278,   230,   157,   238,  3142,   230,   342,   425,  2520,
     342,   282,  2523,   282,  3258,   282,  2622,   228,   342,   307,
     342,   273,   177,   177,   178,    20,   177,  1153,   162,   177,
     177,   242,  2624,  2625,  2626,  2627,   362,   362,  3418,   238,
    3419,   177,   314,  2257,  2130,    19,  2132,   418,   418,   407,
     342,   133,   420,  2828,   407,   342,   342,   342,   303,  2273,
     135,   307,  2622,  2277,   420,   420,    20,   146,   149,   240,
     133,   149,   420,   883,   228,   425,    20,   123,   240,   356,
     240,   133,   333,   217,   307,   382,   425,     8,   242,  3445,
     143,   207,   425,   163,   240,    36,   138,   425,   168,   395,
     170,   138,   421,   314,   342,   421,   176,   421,   178,   421,
     421,   421,   421,   421,   184,   421,   421,   421,   421,   253,
     421,   421,   421,   376,   249,   395,   421,  2638,   129,  3445,
     365,   193,   404,   342,  1260,   167,   420,  2648,   420,   411,
     412,   413,   414,   415,   416,   420,  3390,   230,   282,   193,
     422,   257,   286,  1279,   420,    25,   257,  2718,   359,   342,
      30,   202,   202,   202,  2675,  2676,   342,   177,  2501,  2680,
    2900,   177,  3343,   342,  3406,   342,   310,  2907,  2908,  2884,
     177,   177,  3406,   342,  2889,   342,   342,  2892,   177,  2275,
    2523,   177,   342,   404,   177,   399,   407,   408,   409,   302,
     411,   412,   413,   414,   415,   416,   421,   351,   418,  2720,
    2721,   422,   193,  2988,   208,   421,   407,  3597,   244,    86,
     425,   379,   420,   238,   421,   342,  2737,  3285,   240,   362,
    2741,  2742,  2743,  2744,  2745,  2746,  2747,   240,   180,   421,
     420,   248,   180,   420,   235,   243,   425,   362,   118,   362,
     404,   425,  3496,   121,   418,  1065,   121,   411,   412,   413,
     414,   415,   416,   116,  2350,   138,    46,   133,   422,  3044,
     422,  2357,  2358,   372,   138,   241,  2362,  3052,   421,   421,
    1406,   421,  2496,   153,   421,   420,   145,   157,   407,   421,
     420,   167,   351,  1103,   351,   342,   133,   342,  2384,  2810,
    2811,  2812,   177,  2814,   342,   177,  2520,   177,   178,     7,
     421,   342,   421,  3023,   421,    13,  1126,   421,   420,   419,
     181,   419,   192,   379,  2884,   421,   420,    20,   421,  2889,
     133,  2842,  2892,   284,   782,   163,    57,  2848,   425,   382,
    2851,   334,  2853,   379,  2026,  2027,   420,  2680,   420,  2031,
      20,   420,  2863,   180,    52,   420,   142,   421,   228,   307,
     420,   138,   138,   421,  3501,   420,   377,   421,    38,  2880,
     421,  2882,   242,   377,    36,   425,   147,   407,  1188,  1505,
     351,   230,  2893,   230,  2895,   123,  2897,   177,  2070,  2071,
      17,  2902,   425,  2904,   100,  1205,   425,   230,    25,    69,
      95,   164,   419,    30,   140,   103,   138,  2918,  2741,   362,
    2743,   111,   110,   362,  1224,   113,   486,   122,    86,   421,
     420,   491,   182,   493,   138,   342,   243,  3202,   420,   138,
     420,   366,   420,   420,     7,   883,   319,  1247,   378,   421,
      13,    14,   421,   256,   314,   421,    19,   278,    21,   362,
     420,   420,  3227,   379,    27,   125,    29,   527,   133,    20,
     425,   230,   532,   203,   162,   270,  3027,  3028,   160,   539,
     296,  3176,   296,    48,    47,   243,  3206,    48,  3208,  3209,
      36,  3042,   246,   241,   133,   155,   240,  3217,   334,  1299,
     128,   243,  3197,   243,   379,   366,   425,    20,   276,   379,
     425,  3012,   111,   240,    20,   240,  2720,  2721,   420,   303,
     106,   420,  3023,   183,   421,    98,   586,   360,    65,   217,
     295,   295,   592,   122,     6,   420,   153,    17,   270,   407,
     157,   420,  3043,   603,   404,   664,  2386,  3048,  3049,  2132,
    1742,   411,   412,   413,   414,   415,   416,  3537,  3059,  3060,
     177,   178,   422,   623,  2703,   253,  2348,  3118,  3301,   708,
    1721,  3072,  3073,  3074,  3075,   192,  1017,  2848,  2691,  3135,
    1946,  3281,   642,  1699,  2851,  3285,  2185,  3559,   648,  3284,
    3596,  3526,  3525,  3567,   282,  2918,  3146,  1275,   286,  2853,
    3101,  3146,   856,  2428,  1689,   665,  2733,  2289,   225,  2860,
    1261,   228,   175,  1846,   177,   303,   179,  2404,   181,  3634,
    3315,  3386,   310,  3667,  3109,   242,   286,  1065,  2704,  3108,
     290,  2383,  2352,  3574,  3287,  1250,   296,  3508,  3290,    27,
     593,  2918,  2718,   303,   876,  3355,  2862,  3197,  3473,  3150,
     310,  1713,  3417,  2866,  3480,  3576,  3421,  3422,   318,  3663,
    3355,  3622,  3331,  3383,  3666,  1103,   326,  3168,  1626,   639,
      20,  1046,  2845,   856,  2508,  3176,    10,  2141,  1478,   856,
      25,  2150,   657,  1040,  1659,    30,  2164,  3027,  1126,  3190,
    2667,  1658,  1059,  1644,   754,  1620,  2119,   314,  1814,  3200,
    1898,   761,  2778,  2779,  2461,  3198,  1822,   527,    42,  2142,
    2842,  3212,  3213,  2789,   374,   648,  2597,  3218,   378,  2589,
    1831,    55,  3388,  3553,  3557,  3048,  3554,  2153,    62,  1485,
    2806,  2087,  1998,    67,  2085,    -1,  3059,  1966,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   806,   807,   808,  1865,
    1188,    -1,   812,    87,    -1,    -1,    -1,    -1,  3453,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1205,    -1,    -1,
      -1,    -1,  1888,   118,   108,    -1,    -1,    -1,  3473,    -1,
      -1,    -1,    -1,    -1,  3285,    -1,  1224,   404,    -1,    -1,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
      -1,  3074,    -1,    -1,  3305,   422,   140,    -1,   153,  1247,
      -1,    -1,   157,    -1,   874,    -1,    -1,    -1,    -1,    -1,
      -1,  1937,    -1,    -1,    -1,    -1,   160,    -1,    -1,  3330,
    2026,  2027,   177,   178,    -1,  2031,   896,    -1,    -1,  2915,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,    -1,
     184,    -1,    -1,  3354,  3355,    -1,    -1,    -1,  3359,  3360,
      -1,  1299,    -1,    -1,    -1,  3560,    -1,    -1,  3072,  3073,
    3371,  3075,    -1,    -1,  2070,  2071,    -1,    -1,    -1,    -1,
      -1,  2553,    -1,   228,  2556,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,    -1,  2566,  3218,    -1,   242,    -1,    -1,
      -1,    -1,  3403,    -1,    -1,    -1,    -1,  1707,   242,    -1,
      -1,    -1,  1712,  1713,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3424,  3425,  3426,  3427,  3428,    -1,    -1,
      -1,   494,    -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,
      17,    -1,  2614,  2615,    -1,   508,   509,  3448,    25,    -1,
     513,  3027,  3028,    30,  3649,    -1,    -1,    -1,    -1,   293,
      -1,   524,  1022,   297,    -1,   299,  3042,    -1,    -1,   314,
     533,   305,  3473,  3474,  3050,  3051,    -1,    -1,    -1,  3055,
    3056,    -1,   545,    -1,    -1,   548,  3190,   550,    -1,   552,
      -1,    -1,    -1,    -1,    -1,    -1,  3200,    -1,    -1,   333,
     334,    -1,     7,    -1,   338,    -1,    -1,    -1,    13,    -1,
      17,    -1,   346,    20,    -1,    38,  2132,   351,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,  3527,    -1,  3529,    -1,
      -1,    -1,  1832,    -1,    -1,    -1,   599,  3538,   601,   373,
    1478,    -1,  3118,  3639,    -1,    -1,    69,    52,    -1,    -1,
      -1,    -1,  3553,    -1,    -1,  1115,    -1,    -1,    -1,   404,
      -1,    -1,    -1,  3564,  2180,    -1,   411,   412,   413,   414,
     415,   416,  3622,     7,  3575,    -1,   153,   422,    -1,    13,
     157,  3354,    -1,    -1,    -1,    -1,  3359,  3360,    -1,  3639,
      -1,  1891,    -1,    -1,   657,    -1,    -1,    -1,   103,    -1,
     177,   178,   125,    -1,    -1,   110,    -1,  1167,   113,    -1,
      -1,    -1,    -1,    -1,    -1,   192,  3666,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1186,    -1,    -1,    -1,
      -1,    -1,   155,  3634,  3635,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2815,    -1,    -1,   153,    -1,   225,    -1,
     157,   228,  3425,    -1,  3427,    -1,  2272,   162,    -1,    -1,
      -1,    -1,  3663,    -1,    -1,   242,  3667,  3371,   245,   103,
     177,   178,    -1,    -1,    -1,    -1,   110,  1977,  2294,   113,
      -1,    -1,   745,    -1,    -1,   192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   757,    -1,    -1,    -1,    -1,    -1,
      -1,  3474,    -1,   766,    -1,  3281,    -1,    -1,    -1,   772,
    2326,    -1,   217,  2329,  2330,    -1,    -1,  2333,   225,    -1,
     783,   228,    -1,    -1,  3428,    -1,    -1,  2343,   162,    -1,
     253,  1291,  2348,  1293,  2350,   242,    -1,   314,   245,    -1,
      -1,    -1,  1302,    -1,    -1,    -1,    -1,    -1,   253,    -1,
     813,    -1,   177,    -1,    -1,  1315,  3529,    -1,   157,   282,
      -1,    -1,    -1,   286,  1324,  3538,    -1,   290,  2384,  1707,
      -1,  2387,    -1,   296,  1712,  1713,    -1,   282,   177,    -1,
     303,   286,    -1,   217,    -1,    -1,    -1,   310,    -1,  2405,
      -1,  3564,  1352,    -1,    -1,   318,  1356,  1357,    -1,    -1,
      -1,    -1,    -1,   326,   867,   310,    -1,   314,  1368,    -1,
    2982,  2983,    -1,    -1,    -1,    -1,    -1,   242,   881,   253,
    2436,  2437,    -1,    -1,    -1,    -1,    -1,   404,    25,    -1,
     407,   408,   409,    30,   411,   412,   413,   414,   415,   416,
      -1,   170,    -1,   242,    -1,   422,    -1,   176,   425,    -1,
      -1,   374,   286,    -1,    -1,   184,    -1,  2553,    -1,    -1,
    2556,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,    -1,
    2566,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   399,    -1,  1832,    -1,    -1,   404,    -1,    -1,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
    2210,  2211,    -1,  2213,    -1,   422,    -1,    -1,  2614,  2615,
    2220,    -1,    -1,    -1,  1484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2252,  1891,  2254,    -1,   153,    -1,    -1,    -1,
     157,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,  1040,    -1,   404,
     177,   178,  2598,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,    -1,    -1,    -1,   192,    -1,   422,    -1,  3575,
      -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,    -1,    -1,
      -1,    -1,  1085,   422,  2640,    -1,    -1,  2327,    -1,    -1,
      -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1977,
      -1,    -1,    -1,    -1,    -1,   242,    -1,   163,    -1,    -1,
    2350,  3223,   168,    -1,    -1,    -1,    -1,    -1,  3634,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1626,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3247,  3248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2384,    -1,    -1,    -1,  2704,    -1,
     177,  3667,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,
      -1,   157,    10,  2719,    -1,    -1,    -1,    -1,  2408,    -1,
    2726,    -1,  2728,    -1,    -1,    -1,    -1,   314,    -1,  2815,
      -1,   177,   178,  2423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   192,  2753,  2438,    -1,
      -1,    -1,    -1,  2759,  2760,  2761,  2762,  2763,  2764,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,   486,    -1,    67,
      -1,    -1,   491,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,   228,  1733,  2474,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,  1248,   242,    -1,    -1,   245,
    2806,  2807,  2808,  2809,    -1,    -1,    -1,    -1,    -1,  1262,
     108,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,
      -1,   408,   409,  3385,   411,   412,   413,   414,   415,   416,
      -1,    -1,    -1,    -1,    -1,   422,    -1,   135,    -1,    -1,
      -1,    -1,   140,    -1,  2534,    -1,    -1,   145,  1301,    -1,
      -1,    -1,  1305,    -1,    -1,  2861,    -1,    -1,    -1,    -1,
      -1,  1314,   160,  1316,    -1,  1318,    -1,   586,   314,    -1,
    1323,    -1,    -1,    -1,    -1,  2565,    -1,    -1,    -1,    -1,
      -1,    -1,  2210,  2211,   603,  2213,   184,    -1,  2578,    -1,
      -1,    -1,  2220,    -1,    -1,    -1,  2982,  2983,    -1,    -1,
      -1,    -1,    -1,    -1,   623,    -1,  1856,    -1,    -1,    -1,
      -1,    -1,     7,    -1,    -1,    -1,    -1,    -1,    13,    -1,
      -1,    -1,  2612,   642,  2252,    -1,  2254,   404,    -1,    -1,
     407,   408,   409,  1883,   411,   412,   413,   414,   415,   416,
    1890,    -1,    37,    -1,   242,   422,   665,    -1,  1898,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,   404,    -1,
      -1,   407,   408,   409,    -1,   411,   412,   413,   414,   415,
     416,   269,    -1,    -1,    -1,    -1,   422,    -1,    -1,   425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,    -1,    -1,
      85,    -1,    17,    -1,    -1,   293,    21,    -1,    -1,  2327,
      25,   299,    -1,    -1,    -1,    30,    -1,   305,   103,   307,
      -1,    -1,  3018,    -1,  2704,   110,    -1,    -1,   113,    25,
      -1,    -1,  2350,    -1,    30,    -1,   532,    -1,    -1,    -1,
      -1,    -1,    -1,   539,    -1,   333,   334,    -1,    -1,    -1,
     338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,
      -1,    -1,    -1,   351,    -1,    -1,  2384,    -1,    -1,    -1,
      -1,    -1,    -1,   361,   159,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   373,   101,    -1,    -1,    -1,
    2408,  3087,  3088,    -1,    -1,    -1,    -1,   806,   807,   808,
      -1,    -1,  3098,  3099,    -1,  2423,  3102,  3103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   204,
    2438,   206,   118,    -1,    -1,   621,    -1,    -1,    -1,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,   153,    -1,
      -1,    -1,   157,    -1,    -1,    -1,    -1,  3223,  2828,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2474,   153,  3154,   655,
      -1,   157,   177,   178,    -1,   874,    -1,   252,   253,    -1,
      -1,  3247,  3248,  2113,    -1,    -1,    -1,   192,    -1,  2119,
      -1,   177,   178,    -1,  3180,    -1,  2866,   896,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   192,   282,    -1,    -1,
      -1,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     225,    -1,    -1,   228,    -1,    -1,  2534,    -1,    -1,  2159,
      -1,    -1,    -1,  1666,    -1,   310,    -1,   242,    -1,  1672,
     245,    -1,   228,  1676,    -1,   320,    -1,    -1,    25,  1682,
      -1,    -1,    -1,    30,    -1,  1688,   242,  2565,    -1,    -1,
      -1,  1694,    -1,    -1,    -1,    -1,  1699,    -1,   754,    -1,
    2578,    -1,    -1,    -1,    -1,   761,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1723,  1724,  1725,  1726,    -1,  3281,   782,  1730,  1731,    -1,
      -1,    -1,  1735,    -1,  2612,  1738,    -1,  2977,    -1,   314,
      -1,    -1,  3298,    -1,    -1,    -1,  3302,    -1,  2988,  3385,
      -1,  1754,    -1,  1022,    -1,    -1,   812,    -1,   314,    -1,
      -1,  1764,    -1,  1766,    -1,    -1,    -1,    -1,   413,    -1,
      -1,   118,    -1,  1776,  1777,  1778,    -1,  1780,    -1,    -1,
      -1,    -1,    -1,    -1,  1787,  1788,    -1,   362,    -1,    -1,
      -1,    -1,  1795,  1796,    -1,    -1,  3352,    -1,   854,    -1,
      -1,    -1,    -1,    -1,  3044,    -1,   153,    -1,    -1,    -1,
     157,    -1,  3052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2704,   883,    -1,   404,
     177,   178,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,    -1,    -1,    -1,   192,  1115,   422,   404,   905,
      -1,    -1,    -1,    -1,    -1,   411,   412,   413,   414,   415,
     416,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    -1,   933,    -1,    -1,
      -1,   228,    -1,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,  1167,    -1,
      -1,    -1,    -1,  2403,    -1,    -1,    -1,    -1,    -1,   965,
     966,    -1,   968,    -1,  2414,    -1,    -1,  1186,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   985,
    2430,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2828,    -1,    -1,    -1,    -1,  2455,    -1,    -1,    -1,  2459,
      -1,    -1,  3202,    -1,    -1,    -1,    -1,   314,  1024,  1025,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
    1983,    -1,    -1,  2483,    -1,    -1,  2486,  3227,  2866,    -1,
      -1,   133,    -1,  2493,    -1,  1051,   138,    -1,  2498,  1055,
    1056,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1065,
      -1,   153,    -1,  1069,    -1,   157,    -1,    -1,    -1,  3575,
      -1,  2521,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   177,   178,    71,    72,    73,
      -1,  3281,    -1,    -1,    -1,    -1,  1315,  1103,    -1,    -1,
     192,    -1,    -1,    -1,    -1,  1324,    -1,   404,    -1,    -1,
      -1,    -1,    -1,    -1,   411,   412,   413,   414,   415,   416,
    1126,    -1,    -1,    -1,    -1,   422,    -1,    -1,  3634,  3635,
      -1,   115,    -1,   225,    -1,    -1,   228,  1356,  1357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2977,
     242,    -1,    -1,   245,    -1,    -1,    -1,  3663,  3664,    -1,
    2988,  3667,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3362,   157,    -1,    -1,    -1,    -1,   162,  2629,
    2630,    -1,  1188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3386,    -1,    -1,  1205,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,  3044,   201,  1224,    -1,
    2173,  2174,   314,    25,  3052,    -1,    -1,  3417,    30,    -1,
      -1,  3421,  3422,    -1,   218,   219,   220,   221,   222,    -1,
     224,  1247,    -1,   782,  2197,    -1,  1252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   257,  1493,    -1,  2229,  2230,  2231,  2232,
      -1,    -1,    -1,    -1,    -1,  1291,    -1,  1293,    -1,    -1,
    3480,    -1,    -1,  1299,    -1,    -1,  1302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,
      -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,    -1,    -1,    -1,    -1,    -1,
     422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   883,   329,  1352,   331,    -1,    -1,
      -1,   153,    -1,  2803,    -1,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2317,    -1,    -1,    -1,    -1,  2322,
     354,  2821,    -1,    -1,  3202,   177,   178,   361,    -1,    -1,
     364,  1387,  1388,    -1,    -1,    -1,    -1,    -1,    -1,  1395,
     192,    -1,  1398,    -1,    -1,  1401,    -1,    -1,    -1,  3227,
      -1,    -1,    -1,  1409,  1410,    -1,    -1,  1626,    -1,    -1,
      -1,  1417,    -1,    -1,  1420,  1421,  1422,  1423,    -1,    -1,
      -1,    -1,    -1,   225,  1430,  1431,   228,  1433,    -1,  1435,
      -1,    -1,  1438,    -1,  2884,    -1,    -1,    -1,    -1,  2889,
     242,    -1,  2892,   245,    -1,    -1,    -1,  1453,  1454,    -1,
      -1,  1457,    -1,  3281,    -1,  1461,  2409,    -1,  2411,  1465,
      -1,   263,    -1,  1469,  1470,  1471,  1472,  1473,  1474,  1475,
    1476,  1477,  1478,  1012,  1480,  2428,    -1,    -1,    -1,  1485,
      -1,    -1,  1488,    -1,    -1,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   314,    -1,  1733,    -1,    17,    -1,    -1,    20,
      -1,    -1,  2475,    -1,    25,   327,  1065,    -1,    -1,    30,
      -1,    -1,    -1,    -1,  3362,  2488,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2999,
    3000,  3001,  3002,    -1,    -1,    -1,    -1,    -1,  3386,    -1,
      -1,    -1,    25,    -1,  1103,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1126,    -1,  3417,
      -1,    -1,    -1,  3421,  3422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,    -1,    -1,    -1,    -1,    -1,
     422,   153,  1628,    -1,    -1,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1856,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   177,   178,    -1,    -1,  1188,
      -1,    -1,   153,    -1,    -1,   118,   157,    -1,    -1,    -1,
     192,    -1,  1668,    -1,  1883,    -1,  1205,    -1,    -1,    -1,
      -1,  1890,    -1,    -1,    -1,    -1,   177,   178,    -1,    -1,
    1686,    -1,    -1,    -1,    -1,  1224,    -1,    -1,    -1,    -1,
     153,   192,    -1,   225,   157,    -1,   228,    -1,    -1,  3149,
      -1,  1707,    -1,    20,    -1,    -1,  1712,  1713,  1247,    -1,
     242,    -1,    -1,   245,   177,   178,    -1,    -1,    -1,    -1,
      -1,    38,    -1,    -1,   225,    -1,  3176,   228,    -1,   192,
    1736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,   245,    -1,    -1,  3197,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1299,    -1,    -1,    -1,  1770,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,   314,    -1,  2737,    -1,    -1,    -1,    -1,  2742,
      -1,  2744,  2745,  2746,  2747,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,    -1,
      -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1830,    -1,  1832,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3284,    -1,    -1,    -1,   155,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   314,    -1,    -1,    -1,    -1,    -1,  2810,  2811,  2812,
      -1,  2814,    -1,    -1,    -1,  3315,   183,    -1,  3318,    -1,
      -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,  1891,    -1,    -1,    -1,   421,
     422,    -1,  1898,  3343,  2113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1908,   404,    -1,  3355,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,    -1,  3367,    -1,    -1,
      -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1942,    -1,    -1,  1478,
    2159,   404,    -1,    -1,  2897,    -1,    -1,    -1,   411,   412,
     413,   414,   415,   416,    -1,    -1,    -1,    -1,    -1,   422,
    1966,  3411,    -1,    -1,    17,    -1,    -1,    20,    -1,   286,
      -1,  1977,    25,   290,    -1,    -1,    -1,    30,    -1,   296,
      -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,
    1996,  1997,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   318,    17,  3453,    -1,    -1,    -1,    -1,    -1,   326,
      25,    -1,    -1,   782,    -1,    30,    -1,    -1,    -1,    -1,
    2026,  2027,    -1,  3473,    -1,  2031,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2043,  2044,  2045,
    2046,   621,    -1,    -1,    -1,  2051,    -1,    -1,    -1,  2055,
    2056,    -1,  2058,    -1,    -1,  2061,    -1,   374,    -1,    -1,
      -1,   378,    -1,    -1,  2070,  2071,    -1,  2073,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   655,    -1,    -1,    -1,    -1,
    2086,    -1,  2088,    -1,    -1,    -1,  2092,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3049,    -1,    -1,    -1,
     153,    -1,    -1,  2109,   157,    -1,    -1,  3060,    -1,    -1,
    3560,    -1,    -1,  2119,   883,  2121,  2122,  2123,    -1,    -1,
      -1,    -1,    -1,    -1,   177,   178,    -1,    -1,    -1,  2135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2143,   153,   192,
      -1,    -1,   157,    -1,  2150,    -1,    -1,    -1,    -1,  2155,
      -1,    -1,    -1,    -1,    -1,    -1,  2162,  2163,  2164,    -1,
      -1,    -1,   177,   178,    -1,    -1,    -1,    -1,  1707,    -1,
      -1,    -1,   225,  1712,  1713,   228,    -1,   192,  2184,    -1,
      -1,    -1,    -1,    -1,  2403,    -1,    -1,    -1,    -1,   242,
      -1,    -1,   245,    -1,    -1,  2414,    -1,  3150,    -1,  3649,
      -1,    -1,    -1,    -1,  2210,  2211,    -1,  2213,    -1,    -1,
     225,  2430,    -1,   228,  2220,  3168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
     245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   258,    -1,    -1,  2252,    -1,  2254,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3212,
      -1,   314,    -1,    -1,  2483,    -1,    -1,  2486,    -1,    -1,
      -1,    -1,    -1,    -1,  2493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2288,  2289,  2290,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1832,    -1,    -1,  1065,    -1,    -1,   314,
      -1,    -1,  2521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2327,    -1,    -1,    -1,   905,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2350,    -1,    -1,    -1,    -1,    -1,
      -1,   404,  1891,   933,   407,   408,   409,  1126,   411,   412,
     413,   414,   415,   416,    -1,    -1,    -1,    -1,    -1,   422,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2383,  2384,    -1,
      -1,    -1,    -1,    -1,    -1,   965,   966,    -1,   968,   404,
      -1,    -1,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,  2408,    -1,    -1,   985,    -1,   422,    -1,    -1,
    2629,  2630,    -1,    -1,    -1,    -1,    -1,  2423,    -1,  1188,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2438,    -1,    -1,    -1,  1205,    -1,  1977,    -1,
      -1,    -1,    -1,    -1,  1024,    -1,    -1,    -1,    -1,  2455,
      -1,    -1,    -1,  2459,    -1,  1224,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2469,    -1,    -1,    -1,    -1,  2474,    10,
      -1,  1051,    -1,    -1,    -1,  1055,  1056,    -1,  1247,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2498,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2531,    67,    -1,  2534,    -1,
    1299,    -1,    -1,    -1,  2540,    -1,    -1,    -1,    -1,    -1,
    2546,    -1,  2548,    -1,    -1,    -1,    87,  2553,    -1,    -1,
    2556,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,
    2566,    -1,    -1,    -1,  2570,  2571,   782,   108,    -1,    -1,
      -1,    -1,  2578,    -1,  3527,    -1,    -1,  2583,    -1,    -1,
      -1,  2587,    -1,  2589,  2803,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   782,  2599,   135,    -1,  2602,    -1,  2604,   140,
      -1,    -1,  2821,    -1,   145,    -1,  2612,  2613,  2614,  2615,
      -1,    -1,    -1,  2619,    -1,    -1,  2622,    -1,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,  2632,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2641,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   883,    -1,    -1,
      -1,  2210,  2211,    -1,  2213,    -1,    -1,    -1,    -1,    -1,
      -1,  2220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   883,    -1,    -1,    -1,  2703,  2704,  2705,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1478,
      -1,   252,    -1,  2252,    -1,  2254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2733,   269,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   293,    -1,    -1,    -1,   297,    -1,   299,    -1,
      -1,    -1,    -1,    -1,   305,    -1,   307,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2999,  3000,  3001,  3002,    -1,    -1,    -1,    -1,  2327,    -1,
      -1,    -1,   333,   334,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   346,    -1,    -1,    -1,  2815,
     351,  2350,    -1,    -1,    -1,  1395,    -1,    -1,    -1,    -1,
     361,    -1,  2828,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,    -1,  1417,    -1,    17,
    1420,    -1,    -1,  1423,    -1,  2384,    -1,    25,    -1,  1065,
    1430,  1431,    30,    -1,    -1,  1435,    -1,    -1,  1438,    -1,
    2866,  2867,  2868,    -1,    -1,    -1,    -1,    -1,    -1,  2408,
      -1,    -1,    -1,  1453,    -1,  1065,    -1,  1457,  2884,    -1,
      -1,  1461,    -1,  2889,  2423,  1465,  2892,  1103,    -1,  1469,
    1470,  1471,  1472,  1473,  1474,  1475,  1476,  1477,    -1,  2438,
    1480,    -1,    -1,    -1,    -1,  1485,    -1,    -1,    -1,    -1,
    1126,    -1,    -1,  1103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2931,    -1,    -1,    -1,    -1,
    3149,    -1,    -1,    -1,    -1,  2474,  1126,    -1,  1707,    -1,
      -1,    -1,    -1,  1712,  1713,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,  2967,    -1,    -1,    -1,    -1,    -1,    -1,  2974,  2975,
      -1,  2977,  1188,    -1,    -1,   153,  2982,  2983,    -1,   157,
      -1,  2987,  2988,    -1,    -1,    -1,    -1,  2993,  2994,  1205,
      -1,  2997,    -1,    -1,    -1,  2534,    -1,    -1,  1188,   177,
     178,    -1,    -1,   782,    -1,    -1,    -1,    -1,  1224,    -1,
      -1,  3017,    -1,    -1,   192,  1205,    -1,   782,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2565,    -1,    -1,    -1,
      -1,  1247,    -1,    -1,  1224,    -1,    -1,    -1,  3044,  2578,
      -1,    -1,    -1,    -1,    -1,    -1,  3052,   225,  1628,    -1,
     228,    -1,    -1,    -1,    -1,    -1,    -1,  1247,    -1,    -1,
      -1,    -1,    -1,  1832,   242,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,  2612,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3318,
      -1,    -1,    -1,    -1,   883,    -1,  1686,    -1,    -1,  1299,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   883,    -1,
      -1,    -1,  1891,    -1,  3343,    -1,    -1,    -1,  3134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,  3144,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3367,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2704,    -1,    -1,    -1,    -1,
    3176,    -1,    -1,    -1,    -1,  3181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3193,    -1,    -1,
      -1,  3197,  3411,    -1,    -1,    -1,  3202,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1977,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3223,    -1,    -1,
      -1,  3227,    -1,    -1,    -1,    -1,   404,    -1,    -1,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,    -1,
      -1,  3247,  3248,    -1,   422,  3251,    -1,    -1,    -1,    -1,
    1830,    -1,  3258,  3259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3281,    -1,    -1,  3284,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1065,    -1,  1478,  2828,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1103,    -1,    -1,  2866,  1908,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1103,    -1,
      17,    -1,    -1,    20,    -1,    -1,    -1,  1126,    25,  3355,
    3356,    -1,    -1,    30,    -1,    -1,  3362,    -1,    -1,    -1,
      -1,  1126,  1942,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3385,
    3386,    -1,  3388,    -1,  3390,    17,  1966,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3414,  1188,
      -1,  3417,    -1,    -1,    -1,  3421,  3422,  1997,    -1,    -1,
      -1,    -1,    -1,  1188,    -1,    -1,  1205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2977,  3445,
    1205,  2210,  2211,    -1,  2213,  1224,    -1,  3453,    -1,  2988,
      -1,  2220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,
      -1,    -1,    -1,  2043,    -1,  2045,  2046,  3473,  1247,    -1,
      -1,    -1,    -1,    -1,  3480,  2055,   153,    -1,  2058,    -1,
     157,  2061,  1247,  2252,    -1,  2254,    -1,    -1,    -1,    -1,
    3496,  1707,    -1,    -1,    -1,    -1,  1712,  1713,    -1,    -1,
     177,   178,    -1,    -1,    -1,  3044,  2086,    -1,  2088,    -1,
      -1,    -1,  2092,  3052,    -1,   192,    -1,  1707,    -1,    -1,
    1299,   153,  1712,  1713,    -1,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1299,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2123,    -1,   177,   178,    -1,   225,    -1,
      -1,   228,    -1,    -1,  3560,  2135,    -1,    -1,  2327,    -1,
     192,    -1,    -1,  2143,    -1,   242,    -1,    -1,   245,    -1,
    2150,    -1,    -1,    -1,    -1,  2155,    -1,    -1,    -1,    -1,
      -1,  2350,  2162,  2163,  2164,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,   228,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2184,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,   245,    -1,  2384,  1832,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,  2408,
      -1,    -1,  1832,  3649,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3202,    -1,    -1,    -1,    -1,    -1,  2438,
      -1,    -1,    -1,    -1,    -1,  1891,    -1,    -1,    17,    -1,
      -1,    -1,   314,    -1,    -1,    -1,    25,    -1,  3227,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1478,
      -1,  1891,    -1,    -1,    17,  2474,    -1,    20,    -1,    -1,
      -1,    -1,    25,  1478,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,    -1,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
      -1,    -1,  3281,    -1,    -1,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1977,    -1,    -1,    -1,  2534,    -1,    -1,    -1,    -1,
      -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,    -1,    -1,  1977,    -1,   421,
     422,    -1,    -1,    -1,    -1,    -1,  2565,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2578,
      -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,   157,    -1,
      -1,    -1,    -1,  3362,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,   178,
     153,    -1,    -1,  2612,   157,    -1,    -1,  3386,    -1,    -1,
      -1,    -1,    -1,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   177,   178,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3417,   192,
      -1,    -1,  3421,  3422,    -1,    -1,   225,    -1,    -1,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,   245,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1707,   242,
      -1,    -1,   245,  1712,  1713,  2704,    -1,    -1,    -1,    -1,
      -1,    -1,  1707,    -1,    -1,    -1,    -1,  1712,  1713,    -1,
      -1,  2531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2540,    -1,    -1,    -1,    -1,    -1,  2546,    -1,  2548,    -1,
      -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2570,  2571,    -1,    -1,  2210,  2211,    -1,  2213,    -1,    -1,
     339,   314,    -1,    -1,  2220,    -1,    -1,    -1,    -1,  2589,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2599,
    2210,  2211,  2602,  2213,  2604,    -1,    -1,    -1,    -1,    -1,
    2220,    -1,    -1,  2613,    -1,    -1,  2252,    -1,  2254,  2619,
      -1,    -1,  2622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2632,  1832,    -1,    -1,    -1,    -1,    -1,  2828,
      -1,  2641,  2252,    -1,  2254,   404,    -1,  1832,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,    -1,    -1,
      -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,    -1,    -1,   407,   408,   409,  2866,   411,   412,
     413,   414,   415,   416,    -1,    17,    -1,    -1,    -1,   422,
      -1,  2327,  1891,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1891,    -1,    -1,    -1,
      -1,    17,    -1,    -1,  2350,    -1,    -1,  2327,    -1,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2384,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2408,    -1,  2384,    -1,    -1,    -1,  1977,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2423,  2977,    -1,
      -1,    -1,  1977,    -1,   981,    -1,    -1,    -1,  2408,  2988,
      -1,    -1,  2438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,    -1,    -1,    -1,   157,    -1,    -1,  2438,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2474,    -1,
      -1,    -1,    -1,    -1,    -1,   177,   178,   153,    -1,  1036,
      -1,   157,    -1,    -1,    -1,  3044,    -1,    -1,    -1,    -1,
     192,    -1,    -1,  3052,  2474,    -1,    -1,  2867,  2868,    -1,
      -1,   177,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,    -1,    -1,
      -1,    -1,    -1,   225,    -1,    -1,   228,    -1,  2534,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,   228,    -1,  2534,    17,    -1,    -1,    -1,  2565,
      -1,  2931,    -1,    25,    -1,    -1,   242,    -1,    30,   245,
      -1,    -1,  2578,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2565,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2578,    -1,
      -1,    -1,    -1,    -1,  2974,  2975,  2612,    -1,    -1,    -1,
      -1,    -1,   314,    -1,    -1,    -1,    -1,  2987,    -1,    -1,
      -1,    -1,    -1,  2993,  2994,    -1,    -1,  2997,    -1,    -1,
      -1,    -1,  2612,    -1,    -1,    -1,    -1,    -1,   314,    -1,
      -1,  2210,  2211,  3202,  2213,    -1,    -1,  3017,    -1,    -1,
      -1,  2220,    -1,    -1,    -1,  2210,  2211,    -1,  2213,    -1,
      -1,    -1,    -1,    -1,    -1,  2220,    -1,    -1,  3227,    -1,
      -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,  2252,    30,  2254,    -1,    -1,    -1,    -1,
      -1,   153,    -1,    -1,    -1,   157,    -1,  2252,  2704,  2254,
      -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,   177,   178,    -1,    -1,   421,
     422,    -1,  3281,    -1,  2704,    -1,    -1,    -1,   404,    -1,
     192,   407,   408,   409,    -1,   411,   412,   413,   414,   415,
     416,    -1,    -1,    -1,    -1,   421,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2327,    -1,
      -1,    -1,    -1,   225,  3134,    -1,   228,    -1,    -1,    -1,
      -1,    -1,  2327,    -1,    -1,    -1,  1333,    -1,    -1,    -1,
     242,  2350,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2350,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3362,    -1,    -1,    -1,   153,    -1,    -1,
      -1,   157,    -1,    -1,    -1,  2384,    -1,    -1,    -1,    -1,
      -1,    -1,  2828,  3193,    -1,    -1,    -1,  3386,    -1,  2384,
      -1,   177,   178,    -1,    -1,    -1,  1393,    -1,    -1,  2408,
      -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,  2828,    -1,
      -1,    -1,   314,  2408,  2423,    -1,    -1,    -1,  3417,  1416,
    2866,    -1,  3421,  3422,  1421,    -1,    -1,    -1,  2423,  2438,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,  3251,   228,  2438,  1441,  1442,  2866,    -1,  1445,  3259,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,   245,
      -1,    -1,    -1,    -1,    -1,  2474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2474,
      -1,    -1,    -1,    -1,    -1,    -1,  1483,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,   414,   415,   416,    -1,    -1,   419,    -1,    -1,
     422,    -1,    -1,    -1,    -1,  2534,    -1,    -1,   314,  1526,
      -1,  2977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2534,
      -1,    -1,  2988,    -1,    -1,    -1,  3356,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2565,  2977,    13,    -1,
      15,    16,    -1,    -1,    -1,    -1,    -1,    -1,  2988,  2578,
    2565,    -1,    -1,    -1,    29,    -1,    -1,    -1,  3388,    -1,
      -1,    -1,    -1,  2578,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    -1,    51,    52,  3044,    -1,
      -1,    56,    57,  2612,  3414,    -1,  3052,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    70,    -1,  2612,   404,    -1,
      -1,   407,   408,   409,  3044,   411,   412,   413,   414,   415,
     416,    -1,  3052,    -1,    89,   421,   422,    92,    -1,    -1,
    1637,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,   104,
    1647,    -1,    -1,  1650,    -1,   110,    -1,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,    -1,   124,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2704,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2704,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,    -1,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    17,    -1,    -1,   194,
     195,    -1,    -1,    -1,    25,   200,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    -1,   209,    -1,  3202,    -1,    -1,    -1,
      -1,    -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,   227,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,  3227,  3202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3227,    -1,   264,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2828,
     275,    -1,    -1,    -1,   279,    -1,   281,    -1,    -1,    -1,
      -1,   286,    -1,  2828,    -1,  3281,   291,    -1,    -1,   294,
      -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,   304,
      -1,    -1,    -1,    -1,    -1,   310,   153,  2866,   313,    -1,
     157,  3281,    -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,
      -1,  2866,   153,    -1,    -1,    -1,   157,    -1,   333,    -1,
     177,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   349,   192,   177,   178,   153,    -1,
      -1,    -1,   157,   358,    -1,   360,    -1,    -1,   363,    -1,
      -1,   192,   367,    -1,    -1,    -1,  3362,    -1,    -1,    -1,
      -1,    -1,   177,   178,   379,    -1,    -1,    -1,   225,    -1,
      -1,   228,    -1,    -1,    -1,    -1,    -1,   192,    -1,    -1,
    3386,    -1,  3362,    -1,   225,   242,    -1,   228,   245,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,   245,   420,  3386,    -1,  2977,    -1,
     225,  3417,    -1,   228,    -1,  3421,  3422,    -1,    -1,  2988,
      -1,    -1,  2977,    -1,    -1,    -1,    -1,   242,    -1,    -1,
     245,    -1,    -1,  2988,    -1,    -1,    -1,  3417,    -1,    -1,
      -1,  3421,  3422,  2000,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2022,    -1,  2024,    -1,  2026,
    2027,  2028,    -1,   314,  2031,  3044,    -1,    -1,  2035,    -1,
      -1,    -1,    -1,  3052,    -1,  2042,    -1,    -1,    17,  3044,
    2047,    -1,    -1,    -1,    -1,  2052,    25,  3052,    -1,   314,
    2057,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2066,
      -1,    -1,    -1,  2070,  2071,  2072,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2084,    -1,    -1,
      -1,    -1,    -1,    -1,  2091,    -1,  2093,  2094,  2095,  2096,
    2097,  2098,  2099,  2100,  2101,    -1,  2103,   404,    -1,    -1,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
      -1,    -1,    -1,   404,   421,   422,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,    -1,    -1,    -1,    -1,
     421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
      -1,    -1,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,    -1,    -1,    -1,    -1,   421,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,    -1,    17,    -1,   157,    -1,
      -1,    -1,    -1,  3202,    25,  2192,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3202,   177,   178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3227,    -1,
      -1,    -1,    -1,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3281,   242,    -1,    -1,   245,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      -1,    -1,   153,    -1,    -1,    -1,   157,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   314,   177,   178,    -1,    -1,
      -1,    -1,    -1,  3362,    -1,    -1,  2353,    -1,    -1,    -1,
      -1,   192,    -1,    -1,    -1,    -1,    -1,  3362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3386,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3386,    -1,    -1,   225,    -1,    -1,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3417,    -1,
      -1,   242,  3421,  3422,   245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3417,    -1,    -1,    -1,  3421,  3422,    -1,    -1,
      -1,    -1,    -1,   153,    -1,   404,    -1,   157,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,    -1,    -1,
      -1,    -1,   421,   422,    -1,   153,    -1,   177,   178,   157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   192,    -1,  2471,    -1,    -1,    -1,    -1,   177,
     178,    -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   192,  2492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,   228,    -1,
      -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,   242,    -1,    30,   245,    -1,   225,    -1,    -1,
     228,    -1,    -1,  2530,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,    -1,  2551,  2552,  2553,    -1,    -1,  2556,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,    -1,  2566,
    2567,    -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,    -1,    -1,    -1,    -1,
     421,   422,    -1,  2590,   314,    -1,  2593,    -1,  2595,    -1,
      -1,    -1,    -1,  2600,  2601,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   314,  2614,  2615,  2616,
      -1,  2618,    -1,    -1,  2621,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2636,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,  2646,
      -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,   178,    -1,    -1,    -1,  2673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   404,    -1,   192,   407,   408,   409,
      -1,   411,   412,   413,   414,   415,   416,    -1,    -1,    -1,
      -1,   421,   422,    -1,    -1,    -1,   404,    -1,    -1,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,   225,
      -1,    -1,   228,   421,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    10,   245,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,  2815,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,   140,   141,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,    -1,
      -1,   407,   408,   409,    -1,   411,   412,   413,   414,   415,
     416,   183,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2932,    -1,    -1,  2935,  2936,
    2937,    -1,  2939,    -1,    -1,    -1,    -1,  2944,  2945,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,    -1,  2954,  2955,  2956,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2981,  2982,  2983,  2984,    -1,  2986,
      -1,    -1,    -1,  2990,  2991,  2992,    -1,   269,  2995,    -1,
      -1,  2998,    -1,    -1,    -1,    -1,    -1,    -1,  3005,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   293,    -1,    -1,    -1,   297,    -1,   299,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   334,   335,    -1,   337,   338,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   346,    -1,    -1,    -1,   350,   351,
      -1,    -1,    -1,    -1,   356,    -1,    -1,    -1,    -1,   361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3178,  3179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3219,    -1,    -1,    -1,  3223,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,
    3237,    -1,    -1,    -1,    -1,  3242,  3243,  3244,    -1,    -1,
    3247,  3248,  3249,  3250,    -1,  3252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3321,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3370,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3384,  3385,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3398,  3399,  3400,    -1,  3402,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3471,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,  3486,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,  3503,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,   418,    -1,    -1,    19,    -1,   423,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,   137,    -1,   139,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,   153,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,    -1,   356,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,    -1,   411,   412,   413,
      -1,    -1,    -1,    -1,    -1,    -1,   420,   421,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,   137,    -1,   139,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
      -1,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,   411,   412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,   421,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    20,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,   139,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,   421,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    -1,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,    -1,   124,   125,    -1,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,   137,    -1,
     139,   140,   141,    -1,   143,    -1,    -1,   146,    -1,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
      -1,   190,   191,   192,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,    -1,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,   261,    -1,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,    -1,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,    -1,   346,    -1,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,    -1,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,   421,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    -1,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,    -1,   124,   125,    -1,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,   137,    -1,   139,   140,   141,
      -1,   143,    -1,    -1,   146,    -1,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,    -1,   190,   191,
     192,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,    -1,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,   261,
      -1,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,    -1,   346,    -1,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,   421,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
      -1,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,   411,   412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
     137,    -1,   139,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,    -1,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,    -1,    -1,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   420,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,   137,    -1,
     139,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,    -1,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,    -1,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
      -1,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,   418,
     419,   420,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,   137,    -1,   139,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,    -1,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,    -1,    -1,
     411,   412,   413,    -1,    -1,    -1,    -1,    -1,    -1,   420,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,   137,    -1,   139,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,    -1,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,    -1,   411,   412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,   137,    -1,   139,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
      -1,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,   411,   412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,    -1,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   420,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,   137,    -1,
     139,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,    -1,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,    -1,   356,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
      -1,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   420,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,   137,    -1,   139,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,    -1,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,    -1,    -1,
     411,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,   137,    -1,   139,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,    -1,   356,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,    -1,   411,   412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,   137,    -1,   139,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
      -1,   356,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,   411,   412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
     137,    -1,   139,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,    -1,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,   411,   412,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   420,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,   137,    -1,
     139,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,    -1,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
      -1,    -1,   411,   412,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   420,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,    -1,    -1,   120,
     121,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,   137,    -1,   139,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,    -1,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,    -1,   356,   357,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,    -1,    -1,
     411,   412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,    -1,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,   137,    -1,   139,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,   190,   191,    -1,
      -1,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,   400,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,    -1,   411,   412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,   137,    -1,   139,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   420,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,   137,    -1,   139,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   420,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
     137,    -1,   139,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,   420,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,   137,
      -1,   139,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   420,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,   141,    -1,   143,   144,    -1,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
      -1,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
     370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,    -1,   399,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
     420,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
      -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   420,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,
      -1,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,    -1,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,    -1,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,   370,    -1,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   420,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,    -1,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
      -1,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,    -1,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,   394,
     395,    -1,    -1,    -1,   399,   400,   401,    -1,    -1,   404,
     405,    -1,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
      -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,    -1,
      -1,    -1,    -1,   404,    -1,    -1,   407,   408,   409,    -1,
     411,   412,   413,   414,   415,   416,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,    -1,    -1,    -1,    -1,   404,    -1,    -1,
     407,   408,   409,    -1,   411,   412,   413,   414,   415,   416,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,   404,    -1,    -1,   407,   408,   409,    -1,   411,   412,
     413,   414,   415,   416,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,    -1,    -1,    -1,    -1,   404,    -1,    -1,   407,   408,
     409,    -1,   411,   412,   413,   414,   415,   416,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,   404,
      -1,    -1,   407,   408,   409,    -1,   411,   412,   413,   414,
     415,   416,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,   413,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,   413,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    -1,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,    -1,   124,   125,    -1,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
     137,    -1,   139,   140,   141,    -1,   143,    -1,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,   165,    -1,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,    -1,   190,   191,   192,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,    -1,   224,    -1,   226,
     227,   228,   229,    -1,    -1,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
      -1,   248,   249,   250,    -1,   252,   253,   254,   255,   256,
     257,    -1,   259,    -1,   261,    -1,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,    -1,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,    -1,   346,
      -1,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
      -1,   368,    -1,   370,   371,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,   413,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,    -1,   124,   125,    -1,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,   137,    -1,   139,
     140,   141,    -1,   143,    -1,    -1,   146,    -1,   148,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,    -1,
     190,   191,   192,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
      -1,    -1,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,    -1,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,   261,    -1,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,    -1,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,    -1,   346,    -1,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,    -1,   368,    -1,
     370,   371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,   413,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,   240,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,   400,   401,    -1,
      -1,    -1,   405,    -1,    -1,    -1,    -1,    -1,   411,   412,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,   240,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,   400,   401,    -1,
      -1,    -1,   405,    -1,    -1,    -1,    -1,    -1,   411,   412,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,   236,    -1,   238,    -1,   240,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,   400,   401,    -1,
      -1,    -1,   405,    -1,    -1,    -1,    -1,    -1,   411,   412,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,    -1,   405,    -1,    -1,    -1,    -1,    -1,   411,   412,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,    -1,    -1,    -1,
      -1,    -1,    -1,   406,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,   400,   401,   402,   403,    -1,   405,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,    -1,   401,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,    -1,   401,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
      -1,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,    -1,   401,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,   137,    -1,   139,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,   190,   191,   192,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,   137,
      -1,   139,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,   190,   191,   192,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
     228,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,   137,    -1,   139,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,   190,
     191,   192,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,   135,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,   356,   357,   358,   359,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,   142,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,   141,    -1,   143,   144,    -1,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
      -1,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
     370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,   135,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,
      -1,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,    -1,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,   370,    -1,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
      -1,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
      -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,    -1,   357,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,   141,    -1,   143,   144,    -1,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
      -1,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
     370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,
      -1,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,    -1,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,    -1,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,   370,    -1,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
      -1,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    -1,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,    -1,   124,   125,    -1,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,   137,    -1,   139,   140,
     141,    -1,   143,    -1,    -1,   146,    -1,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,    -1,   190,
     191,   192,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
      -1,   232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
     261,    -1,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,    -1,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,    -1,   346,    -1,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,    -1,   368,   369,   370,
     371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    20,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    20,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
      -1,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
     370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,
      -1,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,    -1,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,    -1,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,    -1,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
      -1,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
      -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,   141,    -1,   143,   144,    -1,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
      -1,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
     370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,
      -1,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,    -1,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,    -1,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,   370,    -1,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
      -1,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
      -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,   123,   124,   125,   126,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,
     140,   141,    -1,   143,   144,    -1,   146,    -1,   148,   149,
     150,   151,   152,    -1,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,    -1,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,    -1,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
      -1,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,    -1,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,   345,   346,   347,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
     370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,    -1,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,    -1,   231,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,   345,   346,   347,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,   370,    -1,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,    -1,    -1,   399,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    20,    -1,    22,    23,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,
     146,    -1,   148,   149,   150,   151,   152,    -1,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,    -1,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,    -1,   231,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,    -1,   311,   312,   313,    -1,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,   345,
     346,   347,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,    -1,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,   123,   124,   125,   126,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,   148,
     149,   150,   151,   152,    -1,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,    -1,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,    -1,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,    -1,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,    -1,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,    -1,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,    -1,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,   345,   346,   347,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    -1,    27,    28,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,   123,   124,   125,   126,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,   141,
      -1,   143,   144,    -1,   146,    -1,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,    -1,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,    -1,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,    -1,   231,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,   345,   346,   347,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,   367,   368,    -1,   370,    -1,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,    27,
      28,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,   123,   124,   125,   126,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,    -1,
      -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,    -1,
     148,   149,   150,   151,   152,    -1,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,    -1,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,    -1,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,    -1,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,    -1,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,   247,
      -1,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,   345,   346,   347,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    -1,    27,    28,    29,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,   123,   124,   125,   126,    -1,   128,    -1,   130,
     131,   132,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
     141,    -1,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,    -1,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,    -1,   176,    -1,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,    -1,
     231,   232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,   247,    -1,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,    -1,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,   340,
     341,    -1,    -1,   344,   345,   346,   347,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,   367,   368,    -1,   370,
      -1,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,    -1,    -1,   399,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    -1,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    -1,    63,
      64,    65,    66,    67,    68,    69,    -1,    71,    72,    73,
      -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      94,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,    -1,   128,    -1,   130,   131,   132,    -1,
     134,    -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,
     144,    -1,   146,    -1,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,    -1,   158,   159,   160,   161,   162,   163,
      -1,    -1,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,    -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,   195,   196,    -1,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,    -1,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,
     244,    -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,    -1,
     334,   335,   336,   337,   338,    -1,   340,   341,    -1,    -1,
     344,   345,   346,   347,    -1,   349,   350,   351,   352,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,   370,    -1,   372,   373,
     374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,    -1,    -1,   399,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    72,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    94,    -1,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
     117,   118,    -1,   120,   121,   122,   123,   124,   125,   126,
      -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,   136,
      -1,    -1,    -1,   140,   141,    -1,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,    -1,   154,   155,   156,
      -1,   158,   159,   160,   161,   162,   163,    -1,    -1,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,    -1,   176,
      -1,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,
      -1,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,    -1,   214,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,    -1,   226,
     227,    -1,   229,    -1,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,
     247,    -1,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,    -1,    -1,   344,   345,   346,
     347,    -1,   349,   350,   351,   352,   353,   354,    -1,    -1,
     357,   358,   359,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,   370,    -1,   372,   373,   374,    -1,    -1,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
      -1,    -1,   399,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    -1,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    64,    65,    66,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    94,    -1,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,    -1,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,   117,   118,    -1,
     120,   121,   122,    -1,   124,   125,    -1,    -1,   128,    -1,
     130,   131,   132,    -1,   134,    -1,   136,   137,    -1,   139,
     140,   141,    -1,   143,    -1,    -1,   146,    -1,   148,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,    -1,   165,    -1,   167,   168,   169,
     170,   171,   172,    -1,   174,    -1,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,    -1,
     190,   191,   192,    -1,   194,   195,   196,    -1,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,    -1,   216,   217,   218,   219,
     220,   221,   222,    -1,   224,    -1,   226,   227,   228,   229,
     230,    -1,   232,   233,   234,   235,    -1,    -1,   238,    -1,
      -1,    -1,   242,   243,   244,    -1,    -1,    -1,   248,   249,
     250,    -1,   252,   253,   254,   255,   256,   257,    -1,   259,
      -1,   261,    -1,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,    -1,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,    -1,    -1,   344,    -1,   346,    -1,    -1,   349,
     350,   351,   352,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,    -1,   363,   364,   365,   366,    -1,   368,    -1,
     370,   371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,
     380,   381,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   393,   394,   395,    -1,    -1,    -1,   399,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      -1,    -1,    -1,    56,    57,    58,    59,    60,    61,    -1,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,   117,   118,    -1,   120,   121,   122,
      -1,   124,   125,    -1,    -1,   128,    -1,   130,   131,   132,
      -1,   134,    -1,   136,   137,    -1,   139,   140,   141,    -1,
     143,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,    -1,   165,    -1,   167,   168,   169,   170,   171,   172,
      -1,   174,    -1,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,    -1,   190,   191,   192,
      -1,   194,   195,   196,    -1,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,   228,   229,    -1,    -1,   232,
     233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,   242,
     243,   244,    -1,    -1,    -1,   248,   249,   250,    -1,   252,
     253,   254,   255,   256,   257,    -1,   259,    -1,   261,    -1,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,    -1,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,    -1,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,    -1,   331,   332,
      -1,   334,   335,   336,   337,   338,    -1,   340,   341,    -1,
      -1,   344,    -1,   346,    -1,    -1,   349,   350,   351,   352,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,    -1,
     363,   364,   365,   366,    -1,   368,    -1,   370,   371,   372,
     373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,   382,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     393,   394,   395,    -1,    -1,    -1,   399,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    -1,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    59,    60,    61,    -1,    63,    64,    65,
      66,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    94,    -1,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,   117,   118,    -1,   120,   121,   122,    -1,   124,   125,
      -1,    -1,   128,    -1,   130,   131,   132,    -1,   134,    -1,
     136,   137,    -1,   139,   140,   141,    -1,   143,    -1,    -1,
     146,    -1,   148,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,    -1,   165,
      -1,   167,   168,   169,   170,   171,   172,    -1,   174,    -1,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,    -1,   190,   191,   192,    -1,   194,   195,
     196,    -1,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,   228,   229,    -1,    -1,   232,   233,   234,   235,
      -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,    -1,
      -1,    -1,   248,   249,   250,    -1,   252,   253,   254,   255,
     256,   257,    -1,   259,    -1,   261,    -1,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,    -1,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,    -1,   331,   332,    -1,   334,   335,
     336,   337,   338,    -1,   340,   341,    -1,    -1,   344,    -1,
     346,    -1,    -1,   349,   350,   351,   352,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,    -1,   363,   364,   365,
     366,    -1,   368,    -1,   370,   371,   372,   373,   374,    -1,
      -1,   377,    -1,    -1,   380,   381,   382,   383,   384,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,   394,   395,
      -1,    -1,    -1,   399,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    -1,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    -1,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    63,    64,    65,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    94,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,   117,   118,
      -1,   120,   121,   122,    -1,   124,   125,    -1,    -1,   128,
      -1,   130,   131,   132,    -1,   134,    -1,   136,   137,    -1,
     139,   140,   141,    -1,   143,    -1,    -1,   146,    -1,   148,
     149,   150,   151,   152,   153,   154,   155,   156,    -1,   158,
     159,   160,   161,   162,   163,    -1,   165,    -1,   167,   168,
     169,   170,   171,   172,    -1,   174,    -1,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
      -1,   190,   191,   192,    -1,   194,   195,   196,    -1,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,   220,   221,   222,    -1,   224,    -1,   226,   227,   228,
     229,    -1,    -1,   232,   233,   234,   235,    -1,    -1,   238,
      -1,    -1,    -1,   242,   243,   244,    -1,    -1,    -1,   248,
     249,   250,    -1,   252,   253,   254,   255,   256,   257,    -1,
     259,    -1,   261,    -1,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,    -1,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
      -1,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,    -1,   331,   332,    -1,   334,   335,   336,   337,   338,
      -1,   340,   341,    -1,    -1,   344,    -1,   346,    -1,    -1,
     349,   350,   351,   352,   353,   354,    -1,    -1,   357,   358,
     359,   360,    -1,    -1,   363,   364,   365,   366,    -1,   368,
      -1,   370,   371,   372,   373,   374,    -1,    -1,   377,    -1,
      -1,   380,   381,   382,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   393,   394,   395,    -1,    -1,    -1,
     399,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    -1,    -1,    -1,    56,    57,    58,    59,    60,    61,
      -1,    63,    64,    65,    66,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    -1,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    94,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,   117,   118,    -1,   120,   121,
     122,    -1,   124,   125,    -1,    -1,   128,    -1,   130,   131,
     132,    -1,   134,    -1,   136,   137,    -1,   139,   140,   141,
      -1,   143,    -1,    -1,   146,    -1,   148,   149,   150,   151,
     152,   153,   154,   155,   156,    -1,   158,   159,   160,   161,
     162,   163,    -1,   165,    -1,   167,   168,   169,   170,   171,
     172,    -1,   174,    -1,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,    -1,   190,   191,
     192,    -1,   194,   195,   196,    -1,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,   216,   217,   218,   219,   220,   221,
     222,    -1,   224,    -1,   226,   227,   228,   229,    -1,    -1,
     232,   233,   234,   235,    -1,    -1,   238,    -1,    -1,    -1,
     242,   243,   244,    -1,    -1,    -1,   248,   249,   250,    -1,
     252,   253,   254,   255,   256,   257,    -1,   259,    -1,   261,
      -1,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,    -1,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,    -1,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,    -1,   331,
     332,    -1,   334,   335,   336,   337,   338,    -1,   340,   341,
      -1,    -1,   344,    -1,   346,    -1,    -1,   349,   350,   351,
     352,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
      -1,   363,   364,   365,   366,    -1,   368,    -1,   370,   371,
     372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,   381,
     382,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   393,   394,   395,    -1,    -1,    -1,   399,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    -1,    27,    28,    29,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    -1,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    61,    -1,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    72,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    94,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,    -1,   128,    -1,   130,   131,   132,    -1,   134,
      -1,   136,    -1,    -1,    -1,   140,   141,    -1,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,    -1,   158,   159,   160,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
      -1,   176,    -1,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
     195,   196,    -1,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,    -1,   214,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,    -1,   231,   232,   233,   234,
     235,    -1,    -1,   238,    -1,    -1,    -1,   242,   243,   244,
      -1,    -1,   247,    -1,    -1,    -1,   251,   252,   253,   254,
     255,    -1,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,    -1,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,    -1,   334,
     335,   336,   337,   338,    -1,   340,   341,    -1,    -1,   344,
     345,   346,   347,    -1,   349,   350,   351,   352,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,   370,    -1,   372,   373,   374,
      -1,    -1,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,    -1,    -1,   399,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    -1,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    -1,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    64,    65,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    94,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,    -1,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,   117,
     118,    -1,   120,   121,   122,    -1,   124,   125,    -1,    -1,
     128,    -1,   130,   131,   132,    -1,   134,    -1,   136,   137,
      -1,   139,   140,   141,    -1,   143,    -1,    -1,   146,    -1,
     148,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,   162,   163,    -1,   165,    -1,   167,
     168,   169,   170,   171,   172,    -1,   174,    -1,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,    -1,   190,   191,   192,    -1,   194,   195,   196,    -1,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,    -1,   216,   217,
     218,   219,   220,   221,   222,    -1,   224,    -1,   226,   227,
     228,   229,    -1,    -1,   232,   233,   234,   235,    -1,    -1,
     238,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,    -1,
     248,   249,   250,    -1,   252,   253,   254,   255,   256,   257,
      -1,   259,    -1,   261,    -1,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,    -1,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,    -1,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,    -1,   331,   332,    -1,   334,   335,   336,   337,
     338,    -1,   340,   341,    -1,    -1,   344,    -1,   346,    -1,
      -1,   349,   350,   351,   352,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,    -1,   363,   364,   365,   366,    -1,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
      -1,    -1,   380,   381,   382,   383,   384,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   393,   394,   395,    -1,    -1,
      -1,   399,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    36,    37,    38,    39,    40,
      -1,    -1,    43,    44,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    -1,    -1,    -1,    56,    57,    58,    59,    60,
      61,    -1,    63,    64,    65,    66,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    84,    85,    86,    87,    88,    89,    -1,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,   117,   118,    -1,   120,
     121,   122,    -1,   124,   125,    -1,    -1,   128,    -1,   130,
      -1,   132,    -1,   134,    -1,   136,   137,    -1,   139,   140,
     141,    -1,   143,    -1,    -1,   146,    -1,   148,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,   162,   163,    -1,   165,    -1,   167,   168,   169,   170,
      -1,    -1,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,    -1,   190,
     191,   192,    -1,   194,   195,   196,    -1,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,    -1,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,    -1,   224,    -1,   226,   227,   228,   229,    -1,
      -1,   232,    -1,   234,   235,    -1,    -1,   238,    -1,    -1,
      -1,   242,   243,   244,    -1,    -1,    -1,   248,   249,   250,
      -1,   252,   253,   254,   255,   256,   257,    -1,   259,    -1,
     261,    -1,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,    -1,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,    -1,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,    -1,   310,
      -1,   312,   313,   314,   315,    -1,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,    -1,
     331,   332,    -1,   334,   335,   336,   337,   338,    -1,    -1,
      -1,    -1,    -1,   344,    -1,   346,    -1,    -1,   349,   350,
     351,   352,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,    -1,   363,   364,   365,   366,    -1,    -1,    -1,   370,
     371,   372,   373,   374,    -1,    -1,   377,    -1,    -1,   380,
     381,   382,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   393,   394,   395,    -1,    -1,    -1,   399
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     3,    13,    15,    16,    29,    49,    51,    52,    56,
      57,    68,    70,    89,    92,    98,   104,   110,   116,   122,
     124,   129,   142,   169,   194,   195,   200,   209,   227,   264,
     275,   279,   281,   286,   291,   294,   298,   304,   310,   313,
     320,   333,   349,   358,   360,   363,   367,   379,   420,   428,
     429,   430,   431,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   445,   446,   450,   460,   462,   463,   466,   467,
     468,   478,   479,   488,   516,   522,   523,   529,   535,   537,
     539,   540,   541,   542,   551,   555,   556,   557,   559,   560,
     561,   574,   575,   576,   577,   587,   593,   594,   597,   598,
     599,   600,   601,   606,   608,   611,   614,   615,   625,   626,
     629,   637,   656,   659,   660,   661,   664,   666,   668,   671,
     674,   675,   676,   683,   691,   692,   693,   694,   695,   700,
     702,   703,   707,   708,   711,   712,   713,   715,   716,   717,
     718,   720,   721,   722,   727,   730,   733,   735,   736,   741,
     743,   747,   754,   757,   758,   759,   760,   761,   762,   789,
     344,   381,   696,    10,    67,    87,   108,   135,   140,   145,
     160,   184,   242,   269,   293,   299,   305,   307,   333,   334,
     338,   346,   351,   361,   373,   536,   696,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    22,
      23,    25,    27,    28,    29,    31,    33,    34,    36,    37,
      38,    39,    40,    43,    44,    45,    46,    47,    49,    50,
      51,    52,    53,    56,    57,    58,    59,    60,    61,    63,
      64,    65,    66,    67,    68,    69,    71,    72,    73,    75,
      76,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      94,    96,    97,    98,    99,   100,   102,   103,   104,   107,
     108,   109,   110,   111,   113,   114,   115,   117,   118,   120,
     121,   122,   123,   124,   125,   126,   128,   130,   131,   132,
     134,   136,   140,   141,   143,   144,   146,   148,   149,   150,
     151,   152,   154,   155,   156,   158,   159,   160,   161,   162,
     163,   166,   167,   168,   169,   170,   171,   172,   174,   176,
     179,   181,   182,   183,   184,   185,   186,   187,   189,   191,
     194,   195,   196,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   214,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   226,   227,   229,
     231,   232,   233,   234,   235,   238,   242,   243,   244,   247,
     251,   252,   253,   254,   255,   256,   257,   259,   260,   261,
     262,   263,   264,   265,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   290,   291,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   305,   306,
     307,   308,   310,   311,   312,   313,   315,   316,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     331,   332,   334,   335,   336,   337,   338,   340,   341,   344,
     345,   346,   347,   349,   350,   351,   352,   353,   354,   357,
     358,   359,   360,   363,   364,   365,   366,   367,   368,   370,
     372,   373,   374,   377,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     399,   891,   904,   907,   908,   371,   723,   240,   265,   696,
      32,   484,   758,    10,    22,    42,    62,    87,    93,   108,
     135,   141,   145,   196,   242,   245,   293,   299,   307,   334,
     335,   337,   338,   346,   350,   351,   356,   361,   489,   530,
     590,   630,   638,    11,   264,   891,   891,   138,    11,   259,
     335,   337,    10,    22,    42,    67,    87,   108,   135,   140,
     145,   160,   242,   252,   293,   297,   299,   305,   307,   333,
     334,   338,   346,   351,   361,   373,   536,   602,   696,   891,
     722,   729,     4,    11,    27,   130,   136,   185,   216,   267,
     280,   405,   411,   412,   612,   891,   899,   902,    11,    70,
     278,   304,   616,   617,   618,   904,   175,   904,   401,   896,
     900,   333,   767,   612,   891,   904,   344,   891,   252,    87,
     160,   332,   333,   669,   298,   904,    11,   308,   340,   344,
     452,   904,     8,   142,   616,   617,   265,   696,   904,    11,
     105,   769,    43,    63,   196,   211,   293,   299,   308,   340,
     344,   384,   451,   452,    11,   308,   340,   344,   452,   344,
     215,   239,   241,   798,   887,   889,   904,   911,   767,   413,
     904,   798,   800,   139,   724,   420,   884,   277,   763,   764,
     891,   758,   759,     0,   424,   723,   119,   173,   246,   355,
     770,   771,   758,   760,   761,   425,    26,    30,    32,    74,
      80,   137,   139,   153,   165,   177,   178,   180,   190,   192,
     213,   228,   248,   249,   250,   292,   314,   371,   399,   887,
     897,   905,   907,   909,   604,   904,   892,   904,   604,    86,
     624,   897,   901,   904,   889,   234,    50,   128,   404,   407,
     408,   409,   411,   412,   413,   414,   415,   416,   663,   853,
     854,   904,   901,   891,   798,   889,   891,   798,   891,   301,
     891,   604,   202,   901,   889,   183,   179,   273,   697,   698,
     699,   889,   895,   904,    10,    42,    55,    62,    67,    87,
     108,   140,   160,   184,   242,   293,   297,   299,   305,   333,
     334,   338,   346,   351,   373,   536,   609,   900,   889,   342,
     897,   891,   420,   346,   892,   604,    86,   335,   337,   901,
     335,   337,    50,   128,   663,   284,   901,   447,   904,   891,
     891,   301,   891,   604,   202,   901,   305,   333,   373,   536,
      67,   160,   140,   297,    11,   891,   755,   800,   152,   897,
     891,   152,   667,   152,   892,    86,   152,   897,   152,   890,
     891,    50,   128,   152,   663,    36,   152,   890,   152,   891,
     152,   891,   152,   891,   301,   152,   891,   152,   202,   890,
     183,   152,   603,   604,   420,   734,   723,   902,    11,   902,
      11,   902,   902,   899,   899,   138,   157,   613,   268,   420,
     420,   503,   503,   503,   240,   342,   425,   503,   889,   798,
     799,   613,   900,   420,   731,    36,   891,   891,   889,   904,
      26,   395,   179,   423,   243,   243,   240,   138,   900,   342,
     240,    19,    31,    33,    34,    41,    42,    45,    46,    53,
      77,    78,    79,    80,    81,    82,    83,    90,    91,   109,
     123,   126,   127,   131,   144,   171,   172,   174,   189,   197,
     198,   212,   214,   225,   230,   231,   233,   242,   251,   260,
     274,   295,   309,   316,   328,   340,   341,   345,   347,   348,
     356,   361,   368,   386,   387,   388,   389,   390,   391,   392,
     400,   402,   403,   404,   406,   411,   412,   413,   420,   758,
     809,   812,   815,   816,   817,   819,   820,   821,   822,   825,
     826,   830,   832,   833,   851,   855,   872,   877,   885,   886,
     887,   897,   898,   899,   900,   900,    11,   464,   888,   889,
     308,   451,    93,   458,   900,   459,   900,   904,   900,    26,
      47,   451,   395,   698,   243,   138,   342,   407,    26,   395,
     179,   699,   420,   889,   418,   423,   878,   879,   413,   799,
      20,   904,   310,   137,   725,    93,   830,   882,   883,   763,
     425,   420,   726,   421,   421,   430,   889,    11,   105,   768,
     768,    36,   768,   129,   133,   193,   237,   774,   784,   786,
     787,   770,   771,   884,   879,   420,   582,   253,   282,   423,
     605,   253,   282,   303,   310,   379,   432,   460,   461,   682,
       7,   110,   253,   310,   471,   382,    38,    69,   125,   155,
     253,   282,   290,   296,   303,   310,   318,   326,   374,   461,
     650,   657,   682,   420,   639,     7,   110,   282,   444,     7,
      13,    52,   103,   110,   113,   162,   217,   253,   282,   286,
     310,   469,   470,   899,   604,   604,   420,   662,   423,   282,
     310,   432,   461,   253,   282,   682,   682,    37,    85,   159,
     204,   206,   217,   252,   282,   287,   310,   320,   469,   525,
     526,   244,   253,   372,   545,   553,    13,   282,   310,   469,
     682,   253,   282,    60,   102,   254,   336,   240,   253,   282,
     310,   133,   282,   432,   461,   282,   310,   469,   891,   191,
     241,   383,   425,   697,   362,   719,   240,   897,   420,   891,
     897,   234,    50,   128,   663,   891,   301,   891,   183,   604,
     503,   323,   324,   481,   900,   420,   582,   583,    48,    31,
      33,    34,    45,    46,    90,    91,   131,   171,   172,   174,
     212,   214,   233,   274,   311,   316,   340,   341,   368,   399,
     806,   808,   810,   812,   814,   816,   817,   818,   820,   821,
     825,   826,   905,   907,   891,   432,    20,   714,   382,   432,
     604,   604,   420,   578,   489,   432,    26,   303,   680,   681,
     351,   552,   253,   538,    60,   102,   254,   336,     9,    28,
     562,    20,   578,   133,   432,   889,   517,   889,   889,   183,
     604,    59,   895,   904,   897,   891,    32,    84,   168,   217,
     300,   362,   742,   123,   582,    39,   288,   472,   123,   420,
     123,   382,   123,   639,   123,   425,   152,   604,   152,   604,
     123,   662,   890,   123,   123,   240,   123,   472,   123,    60,
     102,   254,   336,   123,   240,   123,   133,   152,   152,   459,
     123,   425,   472,   830,   858,    70,   516,   728,   733,   736,
     741,   747,   754,   757,   891,   420,   504,   505,   904,   504,
      87,   135,   140,   183,   184,   299,   305,   333,   334,   619,
     888,   890,   618,    93,   420,   737,   757,   157,   425,   744,
     891,   806,   859,    20,   890,   134,   670,   670,   670,   191,
     904,   133,   133,   619,   890,   298,   904,   420,   418,   758,
     860,   370,   823,   830,   876,   420,   823,   823,   420,   420,
     420,   420,   811,   811,   262,   758,   420,   420,   813,   420,
     420,   420,   420,    45,    46,   823,   830,   420,   811,   420,
     420,   420,   420,   420,   380,   398,   420,   827,   420,   827,
     420,   420,   758,   420,   420,   420,   420,   420,   420,   420,
     880,   830,   830,   367,   758,   830,   858,   900,    46,   420,
     824,   420,   900,    17,    20,    25,    30,   153,   157,   177,
     178,   192,   225,   228,   242,   245,   314,   399,   404,   407,
     408,   409,   411,   412,   413,   414,   415,   416,   422,   853,
     855,   857,   250,   830,   175,   425,   765,   879,   420,   900,
      96,   154,   465,   425,    47,    93,   459,    20,    93,   196,
     399,   400,   412,   457,   528,   826,   900,   902,    64,   107,
     839,    76,    93,   127,   236,   240,   348,   453,   454,   456,
     459,   528,    93,   453,   191,   889,   830,    11,    15,    16,
      17,    18,    19,    20,    21,    24,    35,    41,    42,    48,
      54,    55,    62,    70,    77,    78,    79,    81,    82,    83,
      93,    95,   101,   105,   106,   112,   116,   119,   127,   129,
     133,   135,   138,   142,   145,   147,   157,   164,   173,   175,
     188,   193,   197,   198,   215,   225,   230,   236,   237,   239,
     240,   241,   245,   246,   258,   266,   278,   289,   304,   309,
     317,   330,   333,   339,   342,   343,   348,   355,   356,   361,
     362,   369,   375,   376,   378,   379,   399,   413,   894,   906,
     907,   908,   909,   910,   878,    66,   287,   607,   904,   420,
     748,   749,   750,   751,   752,   904,   723,   421,   425,   764,
     890,    20,   726,   760,   760,   772,   773,   830,   760,   130,
     216,   781,   273,   312,   360,    11,   776,   830,   778,   779,
     830,   832,   784,   785,   774,   775,   133,   787,   774,   784,
     413,   859,   253,   282,   310,   342,   342,   894,   423,   342,
     342,    65,   334,   451,   709,    48,    62,   135,   266,   356,
     501,   502,    62,    93,   225,   342,    93,   225,   299,   891,
     240,   528,   303,   342,   342,   230,   528,    97,   176,   299,
     288,   303,   650,   658,   157,   166,   247,   311,   369,   421,
     640,   643,   644,   645,   647,   806,   905,   342,   361,    55,
     501,   672,   672,   240,   297,   346,    62,   672,    14,   285,
     297,   346,   889,   162,   342,   342,   420,   474,   334,   379,
     380,   474,   425,   253,   682,   362,   362,   223,   806,   253,
     663,   342,   433,   342,   342,   528,    36,   527,   528,   528,
      85,   204,   206,    36,   342,   432,   299,   432,   217,   526,
     420,   342,   230,   900,   545,   672,   342,   672,   299,   342,
     342,   604,   604,   604,   604,   889,   342,   342,   299,    83,
     361,   558,   901,   342,   433,   342,   299,   253,   282,   273,
     283,   306,   455,   697,   895,   889,   582,   806,   240,   639,
     528,   604,   604,   662,   177,   240,    60,   102,   254,   336,
     240,   604,   177,   379,   485,   432,   399,   584,   585,   578,
     420,   808,    20,    19,   807,    88,   150,   205,   208,   302,
     393,   420,   828,   829,   605,   811,     9,   704,   806,   891,
     433,   590,   362,   579,   580,   906,   373,   433,   901,    65,
     448,   900,   553,   554,   891,   199,   604,   604,   604,   604,
      98,   169,   349,   360,   563,   564,   117,   420,   558,   433,
     524,   525,    20,   235,   420,   518,   503,   459,   133,   895,
     240,   420,   641,    20,   379,   380,   756,   300,   420,   758,
     791,   792,   793,   798,   801,   833,   887,   897,   376,   803,
     897,   472,   806,   892,   152,   891,   897,   472,   890,   891,
     123,   362,   123,   362,   663,   472,   472,   890,   891,   889,
     891,   891,   891,   889,   890,   558,   123,   123,   472,   603,
     604,   421,   425,   489,   504,   421,   425,   421,   890,    86,
     307,   623,   624,   890,   234,   890,   888,   888,   890,   342,
     379,   627,   367,   738,   739,   904,   289,   740,     5,   121,
     295,   312,   745,   798,   229,   746,   421,   425,   732,   736,
     741,   747,   757,   342,   617,   616,   617,   138,   143,   628,
     904,   858,   419,   858,   860,   861,   420,   375,   873,   874,
     830,   858,   899,   899,   858,    88,   150,   205,   208,   302,
     393,   399,   862,   863,   900,   899,   858,   858,   899,   899,
     823,   823,   830,   663,   830,   864,   411,   412,   831,   832,
     851,   855,   866,   421,   858,   830,   858,   867,   340,   395,
     899,   899,   830,    35,   138,   188,   343,   830,   858,   870,
     858,   210,   830,   837,   838,   839,   210,   830,   839,   878,
     421,   425,   310,   899,   899,   828,   830,   906,   340,    24,
     330,   881,   830,   420,   758,   871,   105,   107,   127,   225,
     230,   235,   348,   357,   830,    30,   153,   157,   192,   314,
     420,   830,   342,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   806,   830,    11,    18,   317,   852,   295,   420,
     851,   141,   196,   333,   335,   337,   766,   889,   886,   138,
     790,    11,   105,   369,   413,   421,   858,   889,   344,   400,
     420,   900,   425,   421,   419,   426,   151,   151,   472,   752,
     753,   425,   790,   407,   880,   721,   889,   882,   421,   758,
     425,    21,   101,   362,   635,   420,   777,   902,   241,   235,
     788,   788,   237,   425,   193,   295,   296,   780,   785,   775,
     421,   421,   342,   342,   299,   901,   891,   894,   901,   892,
     342,   891,    61,   710,   420,   891,   181,   181,   420,   891,
     230,   901,   830,   230,   891,   217,   253,   365,   532,   545,
     230,    97,   176,   901,   891,   240,   891,   247,   905,   421,
     425,   645,   647,   644,   647,   905,   605,   901,   890,   493,
     904,   904,   891,   891,    11,   361,   891,   891,   904,   297,
     346,   297,   346,   891,    11,   361,   891,   889,   901,   891,
     476,   477,   906,   891,   238,    52,   238,   470,   342,   893,
     904,   893,   425,   421,   425,   342,   901,     8,    61,    71,
      72,    73,   115,   157,   162,   201,   218,   219,   220,   221,
     222,   224,   257,   293,   329,   331,   354,   361,   364,   434,
     901,   891,   528,   604,   891,   528,   891,   528,     7,   110,
     310,   546,   547,   548,   549,   906,   901,   904,   891,   891,
     891,   901,   891,     7,    13,   110,   253,   282,   253,   282,
     578,   282,   282,   282,   901,   891,   891,   307,   901,   891,
     891,   342,   342,    58,   353,   273,   177,    20,   604,   177,
     177,   362,   362,   177,   230,   610,   900,   604,   604,   604,
     604,   604,   604,   177,   610,   238,   138,   342,   480,   482,
     407,   421,   425,   830,    19,   807,   806,   418,   418,   342,
     342,   342,   420,   342,   899,   811,   563,    61,   114,   186,
     187,   199,   253,   334,   336,   681,   705,   494,   532,   533,
     133,   893,   421,   425,   407,   889,   680,   420,    70,   142,
     449,   488,   522,   561,   614,   629,   700,   135,   900,   578,
     578,   578,   578,   240,   245,   420,   804,   805,   904,   307,
     680,   122,   757,   889,   192,   490,   491,   492,   493,   498,
     501,   519,   520,   904,   379,   380,   512,    20,   146,   900,
     240,   889,   421,   642,   643,   648,    20,   183,   290,   303,
     378,   649,   650,   651,   681,   684,   149,   149,   133,   758,
     792,   793,    20,   794,   904,   425,    74,   139,   165,   180,
     190,   213,   292,   795,   794,    20,   794,   904,   879,   420,
      76,   830,   740,   582,    20,   123,   472,   639,   604,   893,
     604,   893,   662,   240,   472,   472,   240,   472,   307,   133,
     459,   472,   830,   333,   421,   505,   382,   890,   425,   899,
     903,   145,   620,   621,   901,     8,   628,   421,   425,   880,
     885,   121,   312,   121,   312,   295,   360,   207,   806,   891,
     138,   240,   620,    36,   472,   421,   419,   419,   425,   858,
     830,   112,   874,   875,    20,   421,   421,   421,   421,   421,
     138,   421,   421,   421,   421,   421,   425,   421,   258,   865,
     421,   831,   831,   157,   177,   242,   407,   408,   409,   411,
     412,   413,   414,   415,   416,   422,   855,   831,   421,   421,
     133,   138,   868,   869,   421,   395,   421,   421,    20,   870,
     858,   870,   870,   138,   421,   421,   906,    20,   421,   425,
     830,   906,   425,   830,   880,   830,   904,   421,   421,   395,
     831,   831,   118,   858,   138,   105,   107,   127,   230,   235,
     348,   357,   420,   118,   330,   881,   830,   871,   830,   342,
     663,   830,   420,   758,   335,   337,   335,   337,   889,   767,
     767,   791,   376,   802,   858,   858,   830,   421,   249,   844,
     421,   425,   698,   899,   828,   454,   830,   421,   425,   749,
     803,   882,   773,   242,   853,   856,   396,   397,   636,   830,
     780,   888,   746,   746,   778,   778,   776,   129,   901,   891,
     891,   900,   193,   830,   502,   420,   420,   504,   472,   365,
     342,   531,   891,   545,   167,   230,   605,   643,   647,   647,
     415,   806,   110,   310,   471,   673,   472,   472,   891,   891,
     891,   891,   421,   425,   407,   423,   901,   253,   282,     7,
     110,   253,   282,   806,   223,   806,   901,   890,   193,   257,
     145,   293,   230,   900,   890,   899,   257,   890,   359,   548,
     549,   548,   421,   425,   550,   900,   682,   342,   202,   202,
     202,   342,   342,   342,   342,   342,   342,   342,   891,   901,
     891,   610,   806,   177,   610,   610,   893,   893,   610,   177,
     177,   177,   177,   177,   177,   610,   481,    32,    75,    99,
     118,   134,   148,   230,   238,   271,   483,   242,   411,   412,
     528,   581,   647,   856,   900,   910,   399,   585,   421,   418,
     421,   899,   419,   899,   150,   205,   829,   205,   829,   829,
     899,   208,   421,   240,   193,   407,   706,   706,   706,   706,
     706,   706,   706,    48,    62,    93,    95,   164,   225,   230,
     266,   278,   356,   495,   496,   497,   244,   543,   351,   580,
     581,   503,   448,   900,   245,   489,    86,   889,   564,   586,
     900,   421,   425,   806,   891,   891,   379,   521,   420,   889,
     421,   425,   421,   425,   238,   474,   238,   240,   513,   757,
     531,   342,   889,   362,   631,   421,   425,    93,   407,   652,
     900,   459,   333,   646,   647,   379,   651,   653,   240,   757,
     421,   904,   420,   792,   180,   248,   796,   792,   796,   180,
     795,   796,   180,   420,   904,   420,   858,   235,   472,   806,
     891,   472,   362,   472,   362,   472,   472,   889,   889,   891,
     558,   472,   889,   890,   624,   425,   901,   379,   425,   622,
     243,   757,   739,   121,   121,   890,   619,   472,   901,   860,
     421,   339,   830,   116,   806,   830,   830,   830,   868,   831,
     105,   107,   225,   235,   831,   831,   831,   831,   831,   831,
     831,   831,   831,   806,   831,   830,   830,   869,   868,   827,
     827,   806,   421,   421,   421,   858,   421,   425,   906,   838,
     263,   327,   840,   421,   425,   372,   834,    20,   421,   824,
     900,   830,    17,    17,   830,   421,   830,   138,   420,   859,
     830,   831,   831,   118,   118,   830,   421,   118,   830,   767,
     767,   767,   767,   889,   889,   830,   145,   782,   421,   421,
     421,   844,   420,   845,   904,   844,   900,   369,   421,   419,
     407,   752,   740,   420,   636,   421,   241,   781,   706,   421,
     504,   504,   421,   901,   605,   167,   415,   351,   494,   225,
      86,   225,   322,   325,   351,   477,   581,   906,   342,   342,
     140,   242,   325,   588,   589,   140,   242,   595,   596,   342,
     342,   421,   421,   421,   902,   900,   890,   890,   900,   900,
     547,   891,   133,   133,   284,   133,   152,   901,   891,   901,
     891,   891,   891,   891,   545,   421,   610,   177,   177,   610,
     610,   610,   610,   610,   610,   362,   486,   487,   714,   714,
     225,   271,   714,   714,    95,   164,   225,   571,   572,   573,
     899,   379,   380,   419,   419,   421,   828,   889,   706,    93,
     899,   900,    93,   900,    93,   900,    93,   900,    93,   891,
      93,   891,    93,   891,   420,   891,   831,    96,   154,    95,
     230,   181,   889,   653,   420,   806,    20,   421,   284,   333,
     382,   133,   565,   421,   425,   805,   543,   734,    86,   217,
     490,   499,   163,   511,   492,   520,   904,    57,   334,   514,
     379,   701,   533,   900,   631,   893,   420,   648,   830,   830,
     425,   420,   649,   578,    98,   169,   304,   360,   689,   794,
     420,   890,   792,   240,   362,   797,   792,   180,   792,   804,
     420,   804,   904,   421,   406,   891,   421,   472,   893,   893,
     472,   472,   307,   420,   899,   142,   621,   628,   138,   830,
     421,   421,   869,   138,   105,   107,   235,   420,   421,   385,
     836,   858,   377,   377,   421,   830,   217,   830,   425,   835,
     808,   828,   831,   831,   830,   859,   421,    17,    17,   830,
     830,   118,   830,   421,   889,   889,   889,   889,    36,   147,
     783,   844,   844,   844,   846,   904,   830,   900,   884,   663,
     777,   902,   421,   421,   653,   351,   230,   230,   902,   904,
     806,   407,   901,   891,   899,   899,   806,   425,   899,   899,
     425,   901,   891,   890,   890,   604,   890,   123,   177,   610,
     610,   432,   100,   900,   900,   230,   504,   900,   900,    96,
     154,    95,   573,   572,   419,   140,   166,   140,   138,   570,
     902,   830,   225,   496,   653,   503,   362,   515,   544,   548,
     362,   757,   889,   891,   111,   566,   122,   900,    86,   421,
     120,   158,   500,   420,   512,    98,   110,   263,   891,    40,
      48,   196,   182,   534,   138,   420,   420,   632,   633,   833,
     904,   900,   645,   654,   655,   905,   653,   342,   890,   421,
     830,   420,   792,   797,   421,   804,   421,   472,   472,   472,
     891,   243,   472,   620,   831,   138,   420,   859,   420,   421,
     425,   421,   421,   366,   319,   421,   421,   421,   831,   831,
     830,   858,   830,   378,   841,   256,   847,   421,   828,   421,
     780,   278,   653,   515,   362,   473,   581,   420,   897,   663,
     589,   420,   420,   596,   379,   284,   379,   379,   133,   610,
     482,   900,   504,   624,    20,   665,   665,   889,   571,   421,
     515,   203,   506,   160,   421,   425,   893,   701,   420,   543,
     295,   321,   567,   270,   512,    63,    94,   161,    63,    94,
     161,   888,   513,   296,   296,    48,   243,    48,   900,   604,
     632,   830,   421,   425,   362,   604,   634,   634,   647,   421,
     425,   889,   421,   890,   421,   472,   831,   859,   421,   837,
     858,   217,   394,   842,   843,   904,    36,   770,   771,   844,
     241,   889,   515,   830,   859,   639,   276,   592,   662,   859,
     859,   603,   604,   603,   604,   890,   665,    23,   156,   133,
     139,   255,   315,   240,   507,   508,   509,   334,   548,   128,
     591,   897,   513,   421,   514,   243,   243,   421,   421,   379,
     475,   633,   604,   635,   635,   649,   654,   802,   421,   421,
     421,   421,   366,   425,    20,   858,   272,   296,   848,   503,
     421,   592,   421,   421,   379,   111,    98,   360,   240,   509,
     240,   508,   891,   604,    20,   420,   514,   303,   677,   475,
     634,   474,   514,   636,   636,   653,   106,   843,   845,    30,
      76,   352,   849,   850,   849,   421,   506,   897,   604,   295,
      39,   217,   288,   310,   510,   510,   588,   400,   402,   403,
     568,   569,   899,   900,   904,   677,    65,   514,   635,   802,
      12,   170,   690,   850,   295,   132,   261,   507,   639,   122,
       6,    93,   230,   421,   425,   420,   802,   636,   226,   420,
     685,   687,   692,   736,   741,   747,   757,    17,   571,   270,
     569,   678,   679,   900,   904,   686,   687,   688,   758,   759,
     850,   897,   421,   425,   407,   421,   424,   420,   679,   900,
     688,   568,   421
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 588 "gram.y"
    { parsetree = (yyvsp[(1) - (1)].list); ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 593 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 599 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					  else
						(yyval.list) = NIL;
					;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 709 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 720 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 730 "gram.y"
    {;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 731 "gram.y"
    {;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 740 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 741 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 746 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 751 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 755 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 760 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 765 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 769 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 773 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 777 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 781 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 785 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 789 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 793 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 797 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 802 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 806 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 810 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 814 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 818 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 823 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 828 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 832 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 836 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 840 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 844 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 858 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 876 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 887 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 904 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 916 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 936 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 943 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 962 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 969 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 986 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1004 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1014 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1015 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1028 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1035 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1052 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (7)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (7)].str);
					else
						n->schemaname = (yyvsp[(5) - (7)].str);
					n->authid = (yyvsp[(5) - (7)].str);
					n->secLabel = (yyvsp[(6) - (7)].node);
					n->schemaElts = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1065 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (5)].str);
					n->authid = NULL;
					n->secLabel = (yyvsp[(4) - (5)].node);
					n->schemaElts = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1077 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1078 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1082 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1083 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1111 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1117 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1123 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1132 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1140 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1148 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1155 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1162 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1170 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1181 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1189 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1197 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 scanner_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1205 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1213 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1224 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1232 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1240 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1247 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1256 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1258 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1264 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1265 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1269 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1271 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1273 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1276 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1277 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1278 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1279 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1283 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1284 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1285 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1286 "gram.y"
    { (yyval.str) = "off"; ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1299 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1303 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1307 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 scanner_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1322 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 scanner_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 scanner_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1344 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1345 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1346 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1350 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1351 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1352 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1356 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1357 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1362 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1369 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1376 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1383 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1390 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1399 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1400 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1406 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1412 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1418 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1424 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1430 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1440 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1449 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1450 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1454 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1455 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1464 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1479 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1485 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1491 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1497 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1515 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1523 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1531 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1539 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1549 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1550 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1556 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1564 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1573 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1581 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1589 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1598 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1607 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1619 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (7)].str);
					n->def = (Node *) (yyvsp[(6) - (7)].typnam);
					n->transform = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1629 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1637 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1646 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1653 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1660 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1668 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1676 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1684 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1692 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1700 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1707 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1714 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1722 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1729 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1736 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1744 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1752 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1760 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1768 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1776 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1784 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1792 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1800 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1808 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1817 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1818 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1822 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1823 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1824 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1828 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1829 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1833 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1836 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1837 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1841 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1842 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1848 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1852 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1856 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1861 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1876 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1882 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1906 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1928 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1941 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1942 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1951 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1952 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1953 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1959 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1960 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1966 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1970 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1974 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1978 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1982 "gram.y"
    {
					(yyval.defelt) = makeDefElem("csv", (Node *)makeInteger(TRUE));
				;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1986 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1990 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1994 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1998 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2002 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_notnull", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2011 "gram.y"
    {
					(yyval.defelt) = makeDefElem("binary", (Node *)makeInteger(TRUE));
				;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2014 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2019 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2022 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2028 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2031 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2035 "gram.y"
    {;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2036 "gram.y"
    {;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2049 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (12)].range)->istemp = (yyvsp[(2) - (12)].boolean);
					n->relation = (yyvsp[(4) - (12)].range);
					n->tableElts = (yyvsp[(6) - (12)].list);
					n->inhRelations = (yyvsp[(8) - (12)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (12)].list);
					n->oncommit = (yyvsp[(10) - (12)].oncommit);
					n->tablespacename = (yyvsp[(11) - (12)].str);
					n->secLabel = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2064 "gram.y"
    {
					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
					 * by our inheritance capabilities. Let's try it...
					 */
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (13)].range)->istemp = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(4) - (13)].range);
					n->tableElts = (yyvsp[(8) - (13)].list);
					n->inhRelations = list_make1((yyvsp[(6) - (13)].range));
					n->constraints = NIL;
					n->options = (yyvsp[(10) - (13)].list);
					n->oncommit = (yyvsp[(11) - (13)].oncommit);
					n->tablespacename = (yyvsp[(12) - (13)].str);
					n->secLabel = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2089 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2090 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2091 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2092 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2093 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2094 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2095 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2099 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2100 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2105 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2109 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2115 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2116 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2117 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2121 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typename = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					n->secLabel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2133 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2134 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2139 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2159 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2160 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2180 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2191 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2202 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2214 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2226 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2237 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->name = NULL;
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					n->keys = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2248 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->deferrable		= FALSE;
					n->initdeferred		= FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2277 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2283 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2289 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2295 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2313 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2322 "gram.y"
    { (yyval.list) = lappend_int((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].ival)); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2323 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2327 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_DEFAULTS; ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2328 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_DEFAULTS; ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2329 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_CONSTRAINTS; ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2330 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_CONSTRAINTS; ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2331 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_INCLUDING_INDEXES; ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2332 "gram.y"
    { (yyval.ival) = 	CREATE_TABLE_LIKE_EXCLUDING_INDEXES; ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2342 "gram.y"
    {
					switch (nodeTag((yyvsp[(3) - (3)].node)))
					{
						case T_Constraint:
							{
								Constraint *n = (Constraint *)(yyvsp[(3) - (3)].node);
								n->name = (yyvsp[(2) - (3)].str);
							}
							break;
						case T_FkConstraint:
							{
								FkConstraint *n = (FkConstraint *)(yyvsp[(3) - (3)].node);
								n->constr_name = (yyvsp[(2) - (3)].str);
							}
							break;
						default:
							break;
					}
					(yyval.node) = (yyvsp[(3) - (3)].node);
				;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2362 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2367 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->name = NULL;
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					n->indexspace = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2377 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(3) - (6)].list);
					n->options = (yyvsp[(5) - (6)].list);
					n->indexspace = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2389 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->name = NULL;
					n->raw_expr = NULL;
					n->cooked_expr = NULL;
					n->keys = (yyvsp[(4) - (7)].list);
					n->options = (yyvsp[(6) - (7)].list);
					n->indexspace = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2402 "gram.y"
    {
					FkConstraint *n = makeNode(FkConstraint);
					n->constr_name		= NULL;
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2418 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2419 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2423 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2424 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2428 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2434 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2438 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 scanner_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2446 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2450 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2463 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2465 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2467 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2469 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2471 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2474 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2477 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2481 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2482 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2483 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2484 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2485 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2488 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2489 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2494 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2495 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2496 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2497 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2500 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2501 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2502 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2503 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2506 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2507 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2510 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2511 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2522 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (7)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 scanner_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[(4) - (7)].into)->rel->istemp = (yyvsp[(2) - (7)].boolean);
					n->intoClause = (yyvsp[(4) - (7)].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[(7) - (7)].boolean))
						((SelectStmt *) (yyvsp[(6) - (7)].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[(6) - (7)].node);
				;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2547 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2558 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2559 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2563 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2564 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2569 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typename = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2584 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2585 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2586 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2600 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (6)].range)->istemp = (yyvsp[(2) - (6)].boolean);
					n->sequence = (yyvsp[(4) - (6)].range);
					n->options = (yyvsp[(5) - (6)].list);
					n->secLabel = (yyvsp[(6) - (6)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2612 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2620 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2621 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2624 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2625 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2629 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2633 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2637 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2641 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2645 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2649 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2653 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2657 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2661 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2665 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2669 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2673 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2678 "gram.y"
    {;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2679 "gram.y"
    {;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2683 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2685 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2689 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2702 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (5)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2713 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->plname = (yyvsp[(5) - (9)].str);
				n->plhandler = (yyvsp[(7) - (9)].list);
				n->plvalidator = (yyvsp[(8) - (9)].list);
				n->pltrusted = (yyvsp[(2) - (9)].boolean);
				/* LANCOMPILER is now ignored entirely */
				(yyval.node) = (Node *)n;
			;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2725 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2726 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2734 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2735 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2739 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2740 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2744 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2745 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2749 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2750 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2755 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2763 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2773 "gram.y"
    {;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2774 "gram.y"
    {;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2785 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2794 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2795 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2809 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2816 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2832 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2849 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2857 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(7) - (8)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2874 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->change_validator = true;
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2883 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->validator = (yyvsp[(6) - (6)].list);
					n->change_validator = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2891 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2901 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2902 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2907 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2911 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2918 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2923 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2927 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2934 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2938 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2943 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2948 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2955 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2961 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2966 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2978 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2990 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2991 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2996 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2997 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3001 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3002 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3013 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3021 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(5) - (6)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3038 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3047 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3055 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3071 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3082 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3083 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3084 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3095 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3103 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3120 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3141 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->funcname = (yyvsp[(11) - (14)].list);
					n->args = (yyvsp[(13) - (14)].list);
					n->before = (yyvsp[(4) - (14)].boolean);
					n->row = (yyvsp[(8) - (14)].boolean);
					n->events = (yyvsp[(5) - (14)].ival);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3161 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (19)].str);
					n->relation = (yyvsp[(8) - (19)].range);
					n->funcname = (yyvsp[(16) - (19)].list);
					n->args = (yyvsp[(18) - (19)].list);
					n->before = FALSE;
					n->row = TRUE;
					n->events = (yyvsp[(6) - (19)].ival);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (19)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (19)].ival) & 2) != 0;
					n->constrrel = (yyvsp[(9) - (19)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3179 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3180 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3185 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3187 "gram.y"
    {
					if ((yyvsp[(1) - (3)].ival) & (yyvsp[(3) - (3)].ival))
						yyerror("duplicate trigger events specified");
					(yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival);
				;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3195 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSERT; ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3196 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_DELETE; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3197 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_UPDATE; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3198 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_TRUNCATE; ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3203 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3207 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3217 "gram.y"
    {;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3218 "gram.y"
    {;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3222 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3223 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3227 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3228 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3229 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3234 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3239 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3240 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3241 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3242 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3243 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3247 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3248 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3253 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3255 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 scanner_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3264 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3271 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 scanner_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3280 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3284 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3285 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3289 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3290 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3296 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3306 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3329 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3347 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3370 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3380 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3391 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3401 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3411 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3422 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list))),
											scanner_errposition((yylsp[(3) - (7)]))));
							break;
					}
					r->location = (yylsp[(3) - (7)]);
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3458 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typename = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3465 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3474 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3483 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3492 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3502 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3505 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3506 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3510 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3514 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3520 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3521 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3522 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3523 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3524 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3527 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3528 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3531 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3534 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3535 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3544 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3550 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3552 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3570 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3583 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3584 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3589 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3598 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->number = (yyvsp[(2) - (5)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3607 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3616 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3626 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3634 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3635 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3638 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3639 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3643 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 scanner_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3656 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3662 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3672 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3681 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3692 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3693 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3698 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3706 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3718 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3727 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3739 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3748 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3769 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3779 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3797 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3806 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3817 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3818 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3819 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3820 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3821 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3822 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3823 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3824 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3825 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3826 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3827 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3828 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3832 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3833 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3836 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3837 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3841 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3843 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3856 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3866 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3867 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3868 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3894 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3903 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3912 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3921 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3930 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3939 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3948 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3958 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3967 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3976 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3985 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3994 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 4003 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 4012 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 4020 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 4028 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 4036 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 4046 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 4047 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 4048 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4049 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4050 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4051 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4052 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4053 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4054 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4055 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4056 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4057 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4061 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4062 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4073 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4080 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4089 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (4)].node);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4096 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					n->portalname = (yyvsp[(2) - (2)].str);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4108 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4115 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4122 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4129 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4136 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4143 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4150 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4157 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (1)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4164 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4171 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4178 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4185 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4192 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4199 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (2)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4206 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4214 "gram.y"
    {;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4215 "gram.y"
    {;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4227 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4242 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4255 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4279 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4281 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4283 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4285 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4292 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4300 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); ;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4301 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4305 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4312 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4319 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4326 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4340 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4347 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4354 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4361 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4368 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4375 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4382 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4389 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4396 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4403 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4410 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4420 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4421 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4425 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4435 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4448 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4449 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4453 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4455 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4460 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4476 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4489 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4499 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4510 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4511 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4514 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4515 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4533 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (13)].boolean);
					n->concurrent = false;
					n->idxname = (yyvsp[(4) - (13)].str);
					n->relation = (yyvsp[(6) - (13)].range);
					n->accessMethod = (yyvsp[(7) - (13)].str);
					n->indexParams = (yyvsp[(9) - (13)].list);
					n->options = (yyvsp[(11) - (13)].list);
					n->tableSpace = (yyvsp[(12) - (13)].str);
					n->whereClause = (yyvsp[(13) - (13)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4549 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = true;
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4565 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4566 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4570 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4571 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4574 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4575 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4584 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4593 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4602 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4612 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4613 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4614 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4617 "gram.y"
    { (yyval.ival) = SORTBY_ASC; ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4618 "gram.y"
    { (yyval.ival) = SORTBY_DESC; ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4619 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4622 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4623 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4624 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; ;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4642 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4654 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 4667 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4680 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 4681 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4684 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4685 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4689 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 4690 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 4698 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 4699 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 4703 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 4705 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 4720 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 4729 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 4738 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 4747 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 4756 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 4767 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 4768 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 4769 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 4770 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 4771 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; ;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 4782 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 4796 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 4798 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 4804 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 4814 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
			    ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 4818 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 4823 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 4832 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 4833 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 4841 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 4845 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 4849 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 4853 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 4857 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 4861 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 4865 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 4869 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 4873 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 4877 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 4881 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 4885 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 4889 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 4897 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 4901 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 4905 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 4909 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security_context", (yyvsp[(1) - (1)].node));
				;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 4913 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 4918 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 4920 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 4926 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 4927 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 4931 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 4943 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 4947 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 4962 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 4972 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 4973 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 4995 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 5005 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5018 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5028 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5041 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5051 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5064 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							scanner_errposition((yylsp[(3) - (3)]))));
				;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5072 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5074 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5076 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); ;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5081 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5083 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5095 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5106 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5117 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5128 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5129 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5130 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5135 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5145 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5146 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5161 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5169 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5179 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5191 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 5192 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5195 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5196 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5207 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5216 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5224 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 5232 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 5241 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 5249 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 5257 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5266 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5275 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5283 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5292 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5301 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5310 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5319 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5328 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5337 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5345 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5353 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5361 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5369 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5377 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5385 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5393 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5402 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5403 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5406 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5407 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5418 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5427 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5435 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5444 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5452 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5460 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5468 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5484 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5493 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5501 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5509 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5517 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5526 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5534 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1(makeInteger((yyvsp[(4) - (7)].ival)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5542 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5551 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5560 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5569 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5577 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5585 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5593 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5601 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5609 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5617 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5633 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5641 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5649 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5657 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (7)].range);
					n->subname = (yyvsp[(6) - (7)].str);
					n->secLabel = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5666 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5674 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (4)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (4)].funwithargs)->funcargs;
					n->secLabel = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5683 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
					n->secLabel = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5692 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5693 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5696 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5697 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5701 "gram.y"
    { (yyval.defelt) = makeDefElem(NULL, (Node *)makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5703 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5706 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5707 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5711 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(4) - (5)].str));
				;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5717 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(4) - (4)].str));
				;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5729 "gram.y"
    { QueryIsRule=TRUE; ;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 5732 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (14)].boolean);
					n->relation = (yyvsp[(10) - (14)].range);
					n->rulename = (yyvsp[(4) - (14)].str);
					n->whereClause = (yyvsp[(11) - (14)].node);
					n->event = (yyvsp[(8) - (14)].ival);
					n->instead = (yyvsp[(13) - (14)].boolean);
					n->actions = (yyvsp[(14) - (14)].list);
					(yyval.node) = (Node *)n;
					QueryIsRule=FALSE;
				;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5747 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5748 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5749 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5755 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5761 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5777 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5778 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5781 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5782 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5783 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5784 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5788 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5789 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5790 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5796 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 5806 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 5827 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 5835 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 5844 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 5850 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 5869 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 5876 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 5883 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 5890 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 5897 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 5904 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 5911 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 5919 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 5927 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 5935 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 5943 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 5951 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 5958 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 5965 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 5973 "gram.y"
    {;}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 5974 "gram.y"
    {;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 5975 "gram.y"
    {;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 5980 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); ;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 5983 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); ;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 5986 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); ;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 5993 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 5995 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 5997 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 6003 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 6017 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 6028 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 6041 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 6047 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 6053 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 6058 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 6069 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 6085 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 6094 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 6095 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 6100 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 6104 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 6108 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 6112 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 6116 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 6120 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 6124 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 6128 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 6132 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 6136 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6140 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6144 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 6148 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 6152 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6156 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6160 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6164 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security_context", (yyvsp[(1) - (1)].node));
				;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6173 "gram.y"
    {;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6174 "gram.y"
    {;}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6186 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6193 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6204 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6214 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6215 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6220 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6234 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6241 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6258 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typename = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6270 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typename = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6279 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6287 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typename = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6295 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typename = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6304 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typename = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6314 "gram.y"
    {;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6315 "gram.y"
    {;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6327 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6337 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6347 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6357 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6367 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6377 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6385 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6407 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 6429 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(3) - (4)].range);
				   n->indexname = (yyvsp[(4) - (4)].str);
				   n->verbose = (yyvsp[(2) - (4)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6437 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[(2) - (2)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6446 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(5) - (5)].range);
				   n->indexname = (yyvsp[(3) - (5)].str);
				   n->verbose = (yyvsp[(2) - (5)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6456 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6457 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6470 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (4)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (4)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6483 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = true;
					n->analyze = false;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose = (yyvsp[(4) - (5)].boolean);
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6496 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->vacuum = true;
					n->full = (yyvsp[(2) - (5)].boolean);
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->verbose |= (yyvsp[(4) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6509 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6522 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->vacuum = false;
					n->analyze = true;
					n->full = false;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->verbose = (yyvsp[(2) - (4)].boolean);
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6537 "gram.y"
    {;}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 6538 "gram.y"
    {;}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 6542 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 6543 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 6546 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 6547 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 6550 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 6551 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6555 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6556 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6568 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->analyze = (yyvsp[(2) - (4)].boolean);
					n->verbose = (yyvsp[(3) - (4)].boolean);
					n->query = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6588 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6589 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6600 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6609 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6610 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6628 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6637 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6652 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6653 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6664 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6670 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6676 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6682 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6698 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6707 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6713 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6719 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6728 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6730 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6735 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list));
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6745 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6746 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6759 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6770 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6771 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6783 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6793 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6794 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6797 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6798 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6799 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6800 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6801 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6802 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6803 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6804 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6807 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6808 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6824 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6836 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6837 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6841 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6842 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6847 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6855 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 scanner_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6883 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list));
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6893 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 6894 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 6905 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6915 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6916 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6917 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6918 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6919 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6922 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6923 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; ;}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6924 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 6977 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 6978 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6992 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6994 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 7000 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 7007 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 7014 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with));
					(yyval.node) = (yyvsp[(2) - (2)].node);
				;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 7021 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with));
					(yyval.node) = (yyvsp[(2) - (3)].node);
				;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 7028 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with));
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 7035 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with));
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 7044 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 7045 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 7075 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 7087 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 7089 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 7108 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 7112 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 7116 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 7131 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			;}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 7138 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			;}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 7147 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 7148 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 7152 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (4)].str);
				n->aliascolnames = (yyvsp[(2) - (4)].list);
				n->ctequery = (yyvsp[(4) - (4)].node);
				n->location = (yylsp[(1) - (4)]);
				(yyval.node) = (Node *) n;
			;}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 7164 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				;}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 7173 "gram.y"
    { (yyval.into) = NULL; ;}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 7182 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 7187 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 7192 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 7197 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 7202 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 7207 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7212 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7217 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7223 "gram.y"
    {;}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7224 "gram.y"
    {;}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7227 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7228 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7229 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7236 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7237 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7238 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7239 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7243 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7244 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7248 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7252 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7253 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7257 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				;}
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7266 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7279 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(4) - (4)].node), (yyvsp[(2) - (4)].node)); ;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7281 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].node)); ;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7283 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7285 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), NULL); ;}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7287 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 scanner_errposition((yylsp[(1) - (4)]))));
				;}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7297 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (3)].node), NULL); ;}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7299 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(3) - (5)].node)); ;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7301 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (8)].node), (yyvsp[(6) - (8)].node)); ;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7305 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7307 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7311 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7313 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7325 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); ;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7326 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7327 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); ;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7331 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7339 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7344 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7345 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7350 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7351 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7355 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 7356 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 7360 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7361 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7365 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7366 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7370 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7371 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7375 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7376 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7381 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7389 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7399 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7400 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7406 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7412 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7429 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7430 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7434 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7435 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7446 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7450 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7455 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7462 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7470 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7477 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7487 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7497 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 scanner_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 scanner_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				;}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7525 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7532 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7536 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7562 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7566 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7578 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->using = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7591 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->using = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7605 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7616 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->using = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7631 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7637 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7642 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7648 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7654 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7655 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7656 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7657 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7661 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7662 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7674 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7675 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7681 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7688 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7695 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7702 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7712 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7713 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7727 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7731 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7738 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7747 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7752 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7753 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7758 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7760 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7768 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = NULL;
					n->cursor_param = (yyvsp[(4) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7775 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7781 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7785 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7791 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typename = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7812 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7817 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7824 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7829 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7835 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7840 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7849 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7851 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7853 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7857 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7858 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7859 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7860 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7861 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7863 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7868 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 scanner_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7897 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7898 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7899 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 7900 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 7912 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 7918 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 7925 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 7926 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 7933 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 7938 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 7943 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 7948 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 7953 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 7958 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 7963 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 7968 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 7974 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 7980 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 7986 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 7993 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 scanner_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 scanner_errposition((yylsp[(2) - (3)]))));
				;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 8014 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 8024 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 8028 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 8036 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 8040 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 8048 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 8060 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 8081 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 8085 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 8091 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 8095 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 8108 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 8127 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 8150 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 8152 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 8154 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 8156 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 8158 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 8160 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 8164 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 8165 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 8169 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 8170 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 8178 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8187 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8195 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8204 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8215 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8222 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8223 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8224 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8229 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8231 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); ;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8233 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); ;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8235 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8237 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); ;}
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8239 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8241 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				;}
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8246 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				;}
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8251 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8257 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8265 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1293:

/* Line 1455 of yacc.c  */
#line 8270 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 8277 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8283 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8288 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8292 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8321 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8323 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8325 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8346 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8348 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8350 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8352 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8354 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8356 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8358 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8360 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8362 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8364 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8366 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8369 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8371 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8373 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8376 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8378 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8380 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8383 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8385 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8397 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8399 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8411 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8413 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(4) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8425 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8427 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8440 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8452 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8464 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(5) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8476 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(6) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8498 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8505 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8512 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8519 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8526 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]));
				;}
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8530 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8537 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8544 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8551 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8558 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8565 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8572 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8576 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8584 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8588 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8597 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8604 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8611 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8624 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8637 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1350:

/* Line 1455 of yacc.c  */
#line 8656 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1351:

/* Line 1455 of yacc.c  */
#line 8677 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1352:

/* Line 1455 of yacc.c  */
#line 8687 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1353:

/* Line 1455 of yacc.c  */
#line 8694 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 scanner_errposition((yylsp[(1) - (2)]))));
				;}
    break;

  case 1354:

/* Line 1455 of yacc.c  */
#line 8710 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1355:

/* Line 1455 of yacc.c  */
#line 8715 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1356:

/* Line 1455 of yacc.c  */
#line 8733 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1357:

/* Line 1455 of yacc.c  */
#line 8735 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1358:

/* Line 1455 of yacc.c  */
#line 8737 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1359:

/* Line 1455 of yacc.c  */
#line 8739 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1360:

/* Line 1455 of yacc.c  */
#line 8741 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1361:

/* Line 1455 of yacc.c  */
#line 8743 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1362:

/* Line 1455 of yacc.c  */
#line 8745 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1363:

/* Line 1455 of yacc.c  */
#line 8747 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1364:

/* Line 1455 of yacc.c  */
#line 8749 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1365:

/* Line 1455 of yacc.c  */
#line 8751 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1366:

/* Line 1455 of yacc.c  */
#line 8753 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1367:

/* Line 1455 of yacc.c  */
#line 8755 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1368:

/* Line 1455 of yacc.c  */
#line 8757 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1369:

/* Line 1455 of yacc.c  */
#line 8759 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1370:

/* Line 1455 of yacc.c  */
#line 8761 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1371:

/* Line 1455 of yacc.c  */
#line 8763 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1372:

/* Line 1455 of yacc.c  */
#line 8765 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1373:

/* Line 1455 of yacc.c  */
#line 8769 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1374:

/* Line 1455 of yacc.c  */
#line 8774 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1375:

/* Line 1455 of yacc.c  */
#line 8778 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1376:

/* Line 1455 of yacc.c  */
#line 8782 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1377:

/* Line 1455 of yacc.c  */
#line 8787 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1378:

/* Line 1455 of yacc.c  */
#line 8803 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1379:

/* Line 1455 of yacc.c  */
#line 8804 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1380:

/* Line 1455 of yacc.c  */
#line 8806 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list));
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1381:

/* Line 1455 of yacc.c  */
#line 8821 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list));
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1382:

/* Line 1455 of yacc.c  */
#line 8833 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1383:

/* Line 1455 of yacc.c  */
#line 8835 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1384:

/* Line 1455 of yacc.c  */
#line 8837 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1385:

/* Line 1455 of yacc.c  */
#line 8847 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1386:

/* Line 1455 of yacc.c  */
#line 8857 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1387:

/* Line 1455 of yacc.c  */
#line 8867 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1388:

/* Line 1455 of yacc.c  */
#line 8875 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1389:

/* Line 1455 of yacc.c  */
#line 8893 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1390:

/* Line 1455 of yacc.c  */
#line 8905 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1391:

/* Line 1455 of yacc.c  */
#line 8917 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1392:

/* Line 1455 of yacc.c  */
#line 8929 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1393:

/* Line 1455 of yacc.c  */
#line 8941 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1394:

/* Line 1455 of yacc.c  */
#line 8957 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1395:

/* Line 1455 of yacc.c  */
#line 8969 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1396:

/* Line 1455 of yacc.c  */
#line 8991 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				;}
    break;

  case 1397:

/* Line 1455 of yacc.c  */
#line 9012 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				;}
    break;

  case 1398:

/* Line 1455 of yacc.c  */
#line 9022 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1399:

/* Line 1455 of yacc.c  */
#line 9035 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1400:

/* Line 1455 of yacc.c  */
#line 9051 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1401:

/* Line 1455 of yacc.c  */
#line 9064 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				;}
    break;

  case 1402:

/* Line 1455 of yacc.c  */
#line 9074 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				;}
    break;

  case 1403:

/* Line 1455 of yacc.c  */
#line 9087 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				;}
    break;

  case 1404:

/* Line 1455 of yacc.c  */
#line 9097 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1405:

/* Line 1455 of yacc.c  */
#line 9110 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1406:

/* Line 1455 of yacc.c  */
#line 9122 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1407:

/* Line 1455 of yacc.c  */
#line 9134 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1408:

/* Line 1455 of yacc.c  */
#line 9146 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1409:

/* Line 1455 of yacc.c  */
#line 9158 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1410:

/* Line 1455 of yacc.c  */
#line 9170 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1411:

/* Line 1455 of yacc.c  */
#line 9182 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); ;}
    break;

  case 1412:

/* Line 1455 of yacc.c  */
#line 9184 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1413:

/* Line 1455 of yacc.c  */
#line 9196 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+D)
					 * overlay(A PLACING B FROM C) is converted to
					 * substring(A, 1, C-1) || B || substring(A, C+1, C+char_length(B))
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1414:

/* Line 1455 of yacc.c  */
#line 9213 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1415:

/* Line 1455 of yacc.c  */
#line 9226 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1416:

/* Line 1455 of yacc.c  */
#line 9241 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1417:

/* Line 1455 of yacc.c  */
#line 9262 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1418:

/* Line 1455 of yacc.c  */
#line 9277 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1419:

/* Line 1455 of yacc.c  */
#line 9289 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1420:

/* Line 1455 of yacc.c  */
#line 9301 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1421:

/* Line 1455 of yacc.c  */
#line 9313 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1422:

/* Line 1455 of yacc.c  */
#line 9317 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1423:

/* Line 1455 of yacc.c  */
#line 9324 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1424:

/* Line 1455 of yacc.c  */
#line 9332 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1425:

/* Line 1455 of yacc.c  */
#line 9340 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				;}
    break;

  case 1426:

/* Line 1455 of yacc.c  */
#line 9344 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1427:

/* Line 1455 of yacc.c  */
#line 9348 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				;}
    break;

  case 1428:

/* Line 1455 of yacc.c  */
#line 9352 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				;}
    break;

  case 1429:

/* Line 1455 of yacc.c  */
#line 9356 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				;}
    break;

  case 1430:

/* Line 1455 of yacc.c  */
#line 9360 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				;}
    break;

  case 1431:

/* Line 1455 of yacc.c  */
#line 9364 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				;}
    break;

  case 1432:

/* Line 1455 of yacc.c  */
#line 9373 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1433:

/* Line 1455 of yacc.c  */
#line 9377 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1434:

/* Line 1455 of yacc.c  */
#line 9381 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1435:

/* Line 1455 of yacc.c  */
#line 9386 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typename = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1436:

/* Line 1455 of yacc.c  */
#line 9400 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1437:

/* Line 1455 of yacc.c  */
#line 9402 "gram.y"
    { (yyval.node) = makeNullAConst(-1); ;}
    break;

  case 1438:

/* Line 1455 of yacc.c  */
#line 9406 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); ;}
    break;

  case 1439:

/* Line 1455 of yacc.c  */
#line 9408 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); ;}
    break;

  case 1440:

/* Line 1455 of yacc.c  */
#line 9410 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); ;}
    break;

  case 1441:

/* Line 1455 of yacc.c  */
#line 9412 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); ;}
    break;

  case 1442:

/* Line 1455 of yacc.c  */
#line 9415 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1443:

/* Line 1455 of yacc.c  */
#line 9418 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1444:

/* Line 1455 of yacc.c  */
#line 9419 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1445:

/* Line 1455 of yacc.c  */
#line 9423 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1446:

/* Line 1455 of yacc.c  */
#line 9431 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1447:

/* Line 1455 of yacc.c  */
#line 9440 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; ;}
    break;

  case 1448:

/* Line 1455 of yacc.c  */
#line 9441 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; ;}
    break;

  case 1449:

/* Line 1455 of yacc.c  */
#line 9444 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1450:

/* Line 1455 of yacc.c  */
#line 9445 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1451:

/* Line 1455 of yacc.c  */
#line 9446 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1452:

/* Line 1455 of yacc.c  */
#line 9453 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1453:

/* Line 1455 of yacc.c  */
#line 9454 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1454:

/* Line 1455 of yacc.c  */
#line 9458 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); ;}
    break;

  case 1455:

/* Line 1455 of yacc.c  */
#line 9460 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); ;}
    break;

  case 1456:

/* Line 1455 of yacc.c  */
#line 9465 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				;}
    break;

  case 1457:

/* Line 1455 of yacc.c  */
#line 9473 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); ;}
    break;

  case 1458:

/* Line 1455 of yacc.c  */
#line 9475 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				;}
    break;

  case 1459:

/* Line 1455 of yacc.c  */
#line 9486 "gram.y"
    { (yyval.windef) = NULL; ;}
    break;

  case 1460:

/* Line 1455 of yacc.c  */
#line 9491 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					n->frameOptions = (yyvsp[(5) - (6)].ival);
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				;}
    break;

  case 1461:

/* Line 1455 of yacc.c  */
#line 9513 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1462:

/* Line 1455 of yacc.c  */
#line 9514 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1463:

/* Line 1455 of yacc.c  */
#line 9517 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1464:

/* Line 1455 of yacc.c  */
#line 9518 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1465:

/* Line 1455 of yacc.c  */
#line 9528 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1466:

/* Line 1455 of yacc.c  */
#line 9532 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 1467:

/* Line 1455 of yacc.c  */
#line 9536 "gram.y"
    { (yyval.ival) = FRAMEOPTION_DEFAULTS; ;}
    break;

  case 1468:

/* Line 1455 of yacc.c  */
#line 9540 "gram.y"
    {
					/* reject invalid cases */
					if ((yyvsp[(1) - (1)].ival) & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 scanner_errposition((yylsp[(1) - (1)]))));
					if ((yyvsp[(1) - (1)].ival) & FRAMEOPTION_START_CURRENT_ROW)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("frame start at CURRENT ROW is not implemented"),
								 scanner_errposition((yylsp[(1) - (1)]))));
					(yyval.ival) = (yyvsp[(1) - (1)].ival) | FRAMEOPTION_END_CURRENT_ROW;
				;}
    break;

  case 1469:

/* Line 1455 of yacc.c  */
#line 9555 "gram.y"
    {
					/* reject invalid cases */
					if ((yyvsp[(2) - (4)].ival) & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 scanner_errposition((yylsp[(2) - (4)]))));
					if ((yyvsp[(2) - (4)].ival) & FRAMEOPTION_START_CURRENT_ROW)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("frame start at CURRENT ROW is not implemented"),
								 scanner_errposition((yylsp[(2) - (4)]))));
					if ((yyvsp[(4) - (4)].ival) & FRAMEOPTION_START_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 scanner_errposition((yylsp[(4) - (4)]))));
					/* shift converts START_ options to END_ options */
					(yyval.ival) = FRAMEOPTION_BETWEEN | (yyvsp[(2) - (4)].ival) | ((yyvsp[(4) - (4)].ival) << 1);
				;}
    break;

  case 1470:

/* Line 1455 of yacc.c  */
#line 9584 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
				;}
    break;

  case 1471:

/* Line 1455 of yacc.c  */
#line 9588 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
				;}
    break;

  case 1472:

/* Line 1455 of yacc.c  */
#line 9592 "gram.y"
    {
					(yyval.ival) = FRAMEOPTION_START_CURRENT_ROW;
				;}
    break;

  case 1473:

/* Line 1455 of yacc.c  */
#line 9608 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1474:

/* Line 1455 of yacc.c  */
#line 9609 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1475:

/* Line 1455 of yacc.c  */
#line 9610 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1476:

/* Line 1455 of yacc.c  */
#line 9613 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1477:

/* Line 1455 of yacc.c  */
#line 9614 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1478:

/* Line 1455 of yacc.c  */
#line 9615 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1479:

/* Line 1455 of yacc.c  */
#line 9618 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1480:

/* Line 1455 of yacc.c  */
#line 9619 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1481:

/* Line 1455 of yacc.c  */
#line 9622 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1482:

/* Line 1455 of yacc.c  */
#line 9623 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1483:

/* Line 1455 of yacc.c  */
#line 9624 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1484:

/* Line 1455 of yacc.c  */
#line 9625 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1485:

/* Line 1455 of yacc.c  */
#line 9626 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1486:

/* Line 1455 of yacc.c  */
#line 9627 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1487:

/* Line 1455 of yacc.c  */
#line 9628 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1488:

/* Line 1455 of yacc.c  */
#line 9629 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1489:

/* Line 1455 of yacc.c  */
#line 9630 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1490:

/* Line 1455 of yacc.c  */
#line 9634 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1491:

/* Line 1455 of yacc.c  */
#line 9636 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1492:

/* Line 1455 of yacc.c  */
#line 9641 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1493:

/* Line 1455 of yacc.c  */
#line 9643 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1494:

/* Line 1455 of yacc.c  */
#line 9648 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1495:

/* Line 1455 of yacc.c  */
#line 9650 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1496:

/* Line 1455 of yacc.c  */
#line 9652 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1497:

/* Line 1455 of yacc.c  */
#line 9654 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1498:

/* Line 1455 of yacc.c  */
#line 9656 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1499:

/* Line 1455 of yacc.c  */
#line 9658 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1500:

/* Line 1455 of yacc.c  */
#line 9670 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1501:

/* Line 1455 of yacc.c  */
#line 9674 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1502:

/* Line 1455 of yacc.c  */
#line 9679 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 1503:

/* Line 1455 of yacc.c  */
#line 9680 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1504:

/* Line 1455 of yacc.c  */
#line 9684 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1505:

/* Line 1455 of yacc.c  */
#line 9688 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1506:

/* Line 1455 of yacc.c  */
#line 9692 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				;}
    break;

  case 1507:

/* Line 1455 of yacc.c  */
#line 9697 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1508:

/* Line 1455 of yacc.c  */
#line 9698 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1509:

/* Line 1455 of yacc.c  */
#line 9704 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1510:

/* Line 1455 of yacc.c  */
#line 9707 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1511:

/* Line 1455 of yacc.c  */
#line 9714 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1512:

/* Line 1455 of yacc.c  */
#line 9715 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1513:

/* Line 1455 of yacc.c  */
#line 9716 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1514:

/* Line 1455 of yacc.c  */
#line 9717 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1515:

/* Line 1455 of yacc.c  */
#line 9718 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1516:

/* Line 1455 of yacc.c  */
#line 9719 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1517:

/* Line 1455 of yacc.c  */
#line 9720 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1518:

/* Line 1455 of yacc.c  */
#line 9721 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1519:

/* Line 1455 of yacc.c  */
#line 9731 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1520:

/* Line 1455 of yacc.c  */
#line 9735 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1521:

/* Line 1455 of yacc.c  */
#line 9742 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1522:

/* Line 1455 of yacc.c  */
#line 9748 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1523:

/* Line 1455 of yacc.c  */
#line 9749 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1524:

/* Line 1455 of yacc.c  */
#line 9766 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1525:

/* Line 1455 of yacc.c  */
#line 9770 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1526:

/* Line 1455 of yacc.c  */
#line 9775 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1527:

/* Line 1455 of yacc.c  */
#line 9779 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				;}
    break;

  case 1528:

/* Line 1455 of yacc.c  */
#line 9794 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1529:

/* Line 1455 of yacc.c  */
#line 9798 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1530:

/* Line 1455 of yacc.c  */
#line 9802 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1531:

/* Line 1455 of yacc.c  */
#line 9805 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1532:

/* Line 1455 of yacc.c  */
#line 9808 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1533:

/* Line 1455 of yacc.c  */
#line 9809 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1534:

/* Line 1455 of yacc.c  */
#line 9810 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1535:

/* Line 1455 of yacc.c  */
#line 9814 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1536:

/* Line 1455 of yacc.c  */
#line 9820 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1537:

/* Line 1455 of yacc.c  */
#line 9831 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1538:

/* Line 1455 of yacc.c  */
#line 9844 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1539:

/* Line 1455 of yacc.c  */
#line 9845 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1540:

/* Line 1455 of yacc.c  */
#line 9850 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1541:

/* Line 1455 of yacc.c  */
#line 9860 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1542:

/* Line 1455 of yacc.c  */
#line 9861 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1543:

/* Line 1455 of yacc.c  */
#line 9864 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1544:

/* Line 1455 of yacc.c  */
#line 9865 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1545:

/* Line 1455 of yacc.c  */
#line 9874 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]));
				;}
    break;

  case 1546:

/* Line 1455 of yacc.c  */
#line 9878 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]));
				;}
    break;

  case 1547:

/* Line 1455 of yacc.c  */
#line 9885 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1548:

/* Line 1455 of yacc.c  */
#line 9889 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				;}
    break;

  case 1549:

/* Line 1455 of yacc.c  */
#line 9893 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1550:

/* Line 1455 of yacc.c  */
#line 9900 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1551:

/* Line 1455 of yacc.c  */
#line 9909 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1552:

/* Line 1455 of yacc.c  */
#line 9910 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1553:

/* Line 1455 of yacc.c  */
#line 9914 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1554:

/* Line 1455 of yacc.c  */
#line 9915 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1557:

/* Line 1455 of yacc.c  */
#line 9930 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1558:

/* Line 1455 of yacc.c  */
#line 9932 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1559:

/* Line 1455 of yacc.c  */
#line 9940 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1560:

/* Line 1455 of yacc.c  */
#line 9941 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1561:

/* Line 1455 of yacc.c  */
#line 9949 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1562:

/* Line 1455 of yacc.c  */
#line 9960 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1563:

/* Line 1455 of yacc.c  */
#line 9961 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1564:

/* Line 1455 of yacc.c  */
#line 9965 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1565:

/* Line 1455 of yacc.c  */
#line 9981 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1566:

/* Line 1455 of yacc.c  */
#line 9989 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1567:

/* Line 1455 of yacc.c  */
#line 9997 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1568:

/* Line 1455 of yacc.c  */
#line 10018 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1569:

/* Line 1455 of yacc.c  */
#line 10019 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1570:

/* Line 1455 of yacc.c  */
#line 10023 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1571:

/* Line 1455 of yacc.c  */
#line 10024 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1572:

/* Line 1455 of yacc.c  */
#line 10036 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
					(yyval.range)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1573:

/* Line 1455 of yacc.c  */
#line 10044 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list));
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 scanner_errposition((yylsp[(1) - (2)]))));
							break;
					}
					(yyval.range)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1574:

/* Line 1455 of yacc.c  */
#line 10072 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1575:

/* Line 1455 of yacc.c  */
#line 10074 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1576:

/* Line 1455 of yacc.c  */
#line 10078 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1577:

/* Line 1455 of yacc.c  */
#line 10081 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1578:

/* Line 1455 of yacc.c  */
#line 10084 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1579:

/* Line 1455 of yacc.c  */
#line 10086 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1580:

/* Line 1455 of yacc.c  */
#line 10088 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1581:

/* Line 1455 of yacc.c  */
#line 10090 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1582:

/* Line 1455 of yacc.c  */
#line 10101 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1583:

/* Line 1455 of yacc.c  */
#line 10103 "gram.y"
    { (yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list))); ;}
    break;

  case 1584:

/* Line 1455 of yacc.c  */
#line 10111 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				;}
    break;

  case 1585:

/* Line 1455 of yacc.c  */
#line 10115 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1586:

/* Line 1455 of yacc.c  */
#line 10119 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1587:

/* Line 1455 of yacc.c  */
#line 10123 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1588:

/* Line 1455 of yacc.c  */
#line 10127 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1589:

/* Line 1455 of yacc.c  */
#line 10136 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				;}
    break;

  case 1590:

/* Line 1455 of yacc.c  */
#line 10143 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				;}
    break;

  case 1591:

/* Line 1455 of yacc.c  */
#line 10151 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				;}
    break;

  case 1592:

/* Line 1455 of yacc.c  */
#line 10155 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 1593:

/* Line 1455 of yacc.c  */
#line 10161 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 scanner_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 1594:

/* Line 1455 of yacc.c  */
#line 10178 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1595:

/* Line 1455 of yacc.c  */
#line 10182 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1596:

/* Line 1455 of yacc.c  */
#line 10186 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1597:

/* Line 1455 of yacc.c  */
#line 10191 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1598:

/* Line 1455 of yacc.c  */
#line 10192 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1599:

/* Line 1455 of yacc.c  */
#line 10193 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1600:

/* Line 1455 of yacc.c  */
#line 10195 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1601:

/* Line 1455 of yacc.c  */
#line 10196 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1602:

/* Line 1455 of yacc.c  */
#line 10197 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1603:

/* Line 1455 of yacc.c  */
#line 10200 "gram.y"
    { (yyval.list) = list_make1(makeInteger((yyvsp[(1) - (1)].ival))); ;}
    break;

  case 1604:

/* Line 1455 of yacc.c  */
#line 10201 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger((yyvsp[(3) - (3)].ival))); ;}
    break;

  case 1605:

/* Line 1455 of yacc.c  */
#line 10217 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1606:

/* Line 1455 of yacc.c  */
#line 10218 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1607:

/* Line 1455 of yacc.c  */
#line 10219 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1608:

/* Line 1455 of yacc.c  */
#line 10224 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1609:

/* Line 1455 of yacc.c  */
#line 10225 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1610:

/* Line 1455 of yacc.c  */
#line 10226 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1611:

/* Line 1455 of yacc.c  */
#line 10232 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1612:

/* Line 1455 of yacc.c  */
#line 10233 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1613:

/* Line 1455 of yacc.c  */
#line 10234 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1614:

/* Line 1455 of yacc.c  */
#line 10235 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1615:

/* Line 1455 of yacc.c  */
#line 10236 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 2009:

/* Line 1455 of yacc.c  */
#line 10689 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*OLD*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("OLD used in query that is not in a rule"),
								 scanner_errposition((yylsp[(1) - (1)]))));
				;}
    break;

  case 2010:

/* Line 1455 of yacc.c  */
#line 10699 "gram.y"
    {
					if (QueryIsRule)
						(yyval.str) = "*NEW*";
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("NEW used in query that is not in a rule"),
								 scanner_errposition((yylsp[(1) - (1)]))));
				;}
    break;



/* Line 1455 of yacc.c  */
#line 31179 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 10710 "gram.y"


static Node *
makeColumnRef(char *colname, List *indirection, int location)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields));
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typename = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 scanner_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 scanner_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 scanner_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 scanner_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 scanner_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 scanner_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->location = location;
	return (Node *) x;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(void)
{
	QueryIsRule = FALSE;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Must undefine base_yylex before including scan.c, since we want it
 * to create the function base_yylex not filtered_base_yylex.
 */
#undef base_yylex

#include "scan.c"

